subroutine sub_mrc(rname,method,hdirty,hresid,hclean,   &
     &    hbeam,hprim,mask,error, plot_routine)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_mrc
  use clean_def
  use image_def
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  CLEAN Internal routine
  !   Implementation of Multi-Resolution CLEAN deconvolution algorithm.
  !   A smooth and a difference map are deconvolved using Clark CLEAN
  !   with smooth and difference dirty beams.
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: hdirty, hbeam, hclean, hresid, hprim
  logical, target, intent(in) :: mask(:,:)
  logical, intent(out) :: error
  external :: plot_routine
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  !
  ! Local
  type (clean_par) :: s_method, d_method
  type(gildas) :: s_hclean
  integer n_comp, n_fft, ier
  real, pointer :: dprim(:,:,:)    ! Primary beam
  real, pointer :: atten(:,:)      ! Mosaic weight
  real, pointer :: f_beam(:,:), p_beam(:,:)
  real, pointer :: f_dirty(:,:), f_resid(:,:), f_clean(:,:)
  real, allocatable :: s_clean(:,:), e_clean(:,:)
  logical, allocatable :: s_mask(:,:)
  real, allocatable :: w_fft(:)
  type(cct_par), allocatable :: w_comp(:)
  complex, allocatable :: s_work(:,:)
  real, allocatable :: s_resid(:,:), s_beam(:,:)
  complex, allocatable :: d_work(:,:)
  real, allocatable :: d_beam(:,:)
  real, allocatable, target:: d_resid(:,:)
  real, allocatable :: s_beam_fft(:,:), s_clean_fft(:,:)
  real, allocatable :: d_beam_fft(:,:), d_clean_fft(:,:)
  real, dimension(1,1,1), target ::dummy3d
  real, dimension(1,1), target   ::dummy2d
  integer, allocatable :: s_list(:), i_list(:)
  !
  type (cct_par), allocatable :: tcc(:)
  !
  integer box(4), ix_min, iy_min, nx, ny, mx, my, irat, nclean,   &
     &    s_ix_beam, s_iy_beam, s_ix_patch, s_iy_patch,   &
     &    d_ix_beam, d_iy_beam, d_ix_patch, d_iy_patch,   &
     &    s_ix_clean, s_iy_clean, d_ix_clean, d_iy_clean, nk, nl
  real d_beam_max, s_beam_max, d_clean_max, s_clean_max,   &
     &    scale, scale_dirty, scale_clean, beam_min, beam_max
  integer ix_beam, iy_beam
  real(4) old_r1,old_r2,xinc,yinc
  character(len=message_length) :: chain
  character voc1(2)*8
  integer iplane
  !
  save old_r1,old_r2
  data old_r1/-1./,old_r2/+1./
  data voc1/'CLEAN','RESIDUAL'/
  !
  ! --------------------------------------------------------------------
  !
  irat = nint(method%ratio)
  write(chain,102) 'Smoothing ratio = ',irat
  call map_message(seve%i,rname,chain)
  !
  ! Local variables
  nx = hclean%gil%dim(1)
  ny = hclean%gil%dim(2)
  nl = method%nlist
  mx = nx/irat
  my = ny/irat
  call gildas_null(s_hclean)  ! Was not done ...
  call gdf_copy_header(hclean, s_hclean, error)
  !
  s_hclean%gil%dim(1) = mx
  s_hclean%gil%dim(2) = my
  s_hclean%gil%ref(1) = hclean%gil%ref(1)/irat
  s_hclean%gil%ref(1) = hclean%gil%ref(1)/irat
  ! Transform coordinates (1,1) ---> (1,1)
  s_hclean%gil%inc(1:2) = hclean%gil%inc(1:2)*irat
  s_hclean%gil%ref(1:2) = 1.0d0
  s_hclean%gil%val(1:2) = (s_hclean%gil%ref(1:2)-hclean%gil%ref(1:2)) &
                          * hclean%gil%inc(1:2)+hclean%gil%val(1:2)
  !
  ! Transform back
  s_hclean%gil%ref(1:2) = (hclean%gil%val(1:2) - s_hclean%gil%val(1:2)) &
                          / s_hclean%gil%inc(1:2) + s_hclean%gil%ref(1:2)
  !
  !
  ! Get the numerous work spaces
  nclean = nx*ny
  n_comp = 4*nclean
  allocate(w_comp(nclean),stat=ier)
  !
  allocate(d_work(nx,ny),stat=ier)     !   Work space for large FFTs
  allocate(d_beam_fft(nx,ny),stat=ier) !   Difference beam FFT
  allocate(d_resid(nx,ny),stat=ier)    !   Difference residual
  allocate(d_beam(nx,ny),stat=ier) !   Difference dirty beam
  allocate(d_clean_fft(nx,ny),stat=ier)
  !
  allocate(s_beam(mx,my),stat=ier) !   Smooth dirty beam
  allocate(s_resid(mx,my),stat=ier)    !   Smooth residual
  allocate(s_clean(mx,my),stat=ier)    !    Smooth Clean
  allocate(s_beam_fft(mx,my),stat=ier) !   Smooth beam FFT
  allocate(s_clean_fft(mx,my),stat=ier)
  !
  allocate(e_clean(nx,ny),stat=ier)    !    Expanded Smooth Clean
  allocate(s_work(mx,my),stat=ier)
  !
  n_fft = 2*max(nx,ny)
  allocate(w_fft(n_fft),stat=ier)
  !
  ! Clean component work array
  allocate(tcc(method%m_iter),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error for TCC')
    error = .true.
    return
  endif
  !
  ! Mask for the smooth case
  allocate (s_mask(mx,my),s_list(mx*my),i_list(nx*ny),stat=ier)
  call cmpmsk (s_mask,mx,my,mask,nx,ny,irat)
  !
  ! Find components of SMOOTH map
  call lmask_to_list(s_mask,mx*my,s_list,nk)
  ! Find components of DIFFERENCE map
  call lmask_to_list(mask,nx*ny,i_list,nl)
  !
  ! Loop here if needed
  do iplane = method%first, method%last
    !
    method%iplane = iplane
    method%iplane = iplane
    call beam_plane(method,hbeam,hdirty)
    !
    ! Find residual and clean areas
    f_dirty => hdirty%r3d(:,:,iplane)
    f_resid => hresid%r3d(:,:,iplane)
    f_clean => hclean%r3d(:,:,iplane)
    p_beam  => hbeam%r4d(:,:,1,method%ibeam) ! Only this one is defined
    if (method%mosaic) then
      dprim => hprim%r3d
      atten=> method%atten(:,:,1)
    else
      dprim => dummy3d
      atten=> dummy2d
    endif
    !
    ! Initialize to Dirty map
    f_resid = f_dirty
    !
    ! Initialize plot
    call plot_routine(method,hdirty,f_resid,0)
    !
    call get_clean (method, hclean, p_beam, error)
    if (error) return
    !
    ! ------------------------- Now doing MRC ----------------------------------
    f_clean = 0.0
    !
    !
    ! Compute the clean beams theoretical ratio
    scale_clean = method%ratio*   &
     &    sqrt((method%ratio**2-1.0)*(method%minor/method%major)**2+1.0)
    write(chain,100) 'Theoretical Clean beam ratio ',scale_clean
    call map_message(seve%i,rname,chain)
    !
    ! Conpute the final clean beam
    xinc = hdirty%gil%convert(3,1)
    yinc = hdirty%gil%convert(3,2)
    call mrc_make_clean (nx,ny,d_resid,   &
     &    method%major,method%minor,method%angle,xinc,yinc)
    !
    ! Compute smooth and difference clean beams and their FT
    ! D_BEAM and S_BEAM hold temporarily difference and smooth CLEAN beams
    call mrc_setup (   &
     &    method%ratio,d_resid,method%minor,xinc,yinc,   &
     &    nx,ny,d_beam,d_clean_fft,d_work,   &
     &    d_clean_max,d_ix_clean,d_iy_clean,   &
     &    mx,my,s_beam,s_clean_fft,s_work,   &
     &    s_clean_max,s_ix_clean,s_iy_clean,   &
     &    'CLEAN',w_fft)
    !
    d_method = method
    s_method = method
    !
    scale_clean = 1.0/s_clean_max
    write(chain,100) 'Clean beam ratio R = ',scale_clean
    call map_message(seve%i,rname,chain)
    !
    ! Find DIRTY beam maximum once, and scale to 1.0 values
    box(1) = 1
    box(2) = 1
    box(3) = nx
    box(4) = ny
    call maxmap(p_beam,nx,ny,box,   &
     &    beam_max,ix_beam,iy_beam,beam_min,ix_min,iy_min)
    write(chain,101) 'Dirty beam maximum ',beam_max,' at ',ix_beam,iy_beam
    call map_message(seve%i,rname,chain)
    f_beam => d_resid
    f_beam(:,:) = p_beam/beam_max
    !
    ! Compute smooth and difference DIRTY beams once and their FT
    call mrc_setup (   &
     &    method%ratio,f_beam,method%minor,xinc,yinc,   &
     &    nx,ny,d_beam,d_beam_fft,d_work,   &
     &    d_beam_max,d_ix_beam,d_iy_beam,   &
     &    mx,my,s_beam,s_beam_fft,s_work,   &
     &    s_beam_max,s_ix_beam,s_iy_beam,   &
     &    'DIRTY',w_fft)
    !
    scale_dirty = 1.0/s_beam_max
    write(chain,100) 'Dirty beam ratio S = ',scale_dirty
    call map_message(seve%i,rname,chain)
    !
    ! Initialise : find beams maximum sidelobe
    d_method = method
    s_method = method
    s_ix_patch = method%patch(1)
    s_iy_patch = method%patch(2)
    d_ix_patch = method%patch(1)
    d_iy_patch = method%patch(2)
    call find_sidelobe (d_beam,nx,ny,   &
     &    d_ix_beam,d_iy_beam,d_ix_patch,d_iy_patch,   &
     &    d_method%bgain)
    write(chain,100) 'Difference beam sidelobe ',   &
     &    d_method%bgain
    call map_message(seve%i,rname,chain)
    call find_sidelobe (s_beam,mx,my,   &
     &    s_ix_beam,s_iy_beam,s_ix_patch,s_iy_patch,   &
     &    s_method%bgain)
    write(chain,100) 'Smooth beam sidelobe ',s_method%bgain
    call map_message(seve%i,rname,chain)
    !
    ! Define cleaning boxes
    d_method%box = (/d_method%blc(1),d_method%blc(2),   &
     &    d_method%trc(1),d_method%trc(2)/)
    s_method%blc = max(s_method%blc/irat,1)
    s_method%trc = s_method%trc/irat
    s_method%box = (/s_method%blc(1),s_method%blc(2),   &
     &    s_method%trc(1),s_method%trc(2)/)
    !
    !
    ! Compute smooth and difference maps
    call mrc_maps (   &
     &    nx,ny,f_resid,d_resid,d_work,   &
     &    mx,my,s_resid,s_work,method%ratio,   &
     &    method%minor,xinc,yinc,w_fft)
    call map_message(seve%i,rname,'Smooth and Difference maps done')
    !
    d_method%p_iter = -1
    !
    ! Frac. and abs. residual limits
    d_method%ares = d_method%ares*(scale_dirty-1.0)/scale_dirty
    s_method%ares = s_method%ares/scale_dirty
    !
    ! --------------------------- DIFFERENCE MAP ----------------------------
    !
    call map_message(seve%i,rname,'Cleaning now the difference map')
    write (chain,104) 'Abs.Res = ',d_method%ares,   &
     &    ' Frac.Res = ',d_method%fres
    call map_message(seve%i,rname,chain)
    !!      read(5,*) i
    !
    call major_cycle90 (rname,d_method,hclean,   &
     &    f_clean,   &         ! Final CLEAN image
     &    d_beam,   &          ! Dirty beams
     &    d_resid,nx,ny,   &   ! Residual and size
     &    d_beam_fft, d_work,   &  ! FT of dirty beam + Work area
     &    w_comp, nclean,       &  ! Component storage + Size
     &    d_ix_beam, d_iy_beam, d_ix_patch, d_iy_patch,   &
     &    d_method%bgain, d_method%box,   &
     &    w_fft,   &           ! Work space for FFTs
     &    tcc,   &             ! Component table
     &    i_list, nl,        & ! Search list (truncated...)
     &    1,                 & ! Number of fields
     &    dprim,             & ! Primary beams
     &    atten,             & ! Dummry weight
     &    no_major_plot,     & ! Plotting routine
     &    no_next_flux)
    !
    ! Add clean components to Final clean map
    scale = ( scale_dirty*(scale_clean-1.0) ) /   &
     &    ( scale_clean*(scale_dirty-1.0) )
    write(chain,100)   &
     &    'Difference scaling ratio S/R*(R-1)/(S-1) = ',scale
    call map_message(seve%i,rname,chain)
    !
    if (d_method%n_iter.ne.0) then
      call restore_clean90 (d_method,   &
     &      f_clean,nx,ny,   &
     &      d_work,d_clean_fft,scale,   &
     &      w_fft,tcc,d_method%n_iter)
      !
      ! Add Difference residual to Final clean map
      f_clean = f_clean+d_resid
    else
      f_clean = d_resid
    endif
    !
    ! Put Difference residual in Final residual
    f_resid = d_resid
    !
    ! Plot the clean difference image
    call plot_routine(method,hclean,f_clean,1)
    !     !
    ! -------------------------- SMOOTH MAP ----------------------------
    !
    call map_message(seve%i,rname,'Cleaning now the smooth map')
    write (chain,104) 'Abs.Res = ',s_method%ares,   &
     &    ' Frac.Res = ',s_method%fres
    call map_message(seve%i,rname,chain)
    !!      read(5,*) i
    !
    call major_cycle90 (rname,s_method,s_hclean,   &
     &    s_clean,   &         ! Smooth CLEAN image
     &    s_beam,   &          ! Smooth Dirty beams
     &    s_resid,mx,my,   &   ! Residual and size
     &    s_beam_fft, d_work,   &  ! FT of dirty beam + Work area
     &    w_comp, nclean,       &  ! Component storage + Size
     &    s_ix_beam, s_iy_beam, s_ix_patch, s_iy_patch,   &
     &    s_method%bgain, s_method%box,   &
     &    w_fft,   &           ! Work space for FFTs
     &    tcc,   &             ! Component table
     &    s_list, nk,        & ! Search list (truncated...)
     &    1,                 & ! Number of fields
     &    dprim,             & ! Primary beams
     &    atten,             & ! Dummry weight
     &    no_major_plot,     & ! Plotting routine
     &    no_next_flux)
    !
    ! Compute smooth clean map
    scale = scale_dirty / scale_clean
    write(chain,100) 'Smooth scaling ratio S/R = ',scale
    call map_message(seve%i,rname,chain)
    if (s_method%n_iter.ne.0) then
      call restore_clean90 (method,   &
     &      s_clean,mx,my,   &
     &      s_work,s_clean_fft,scale,   &
     &      w_fft,tcc,s_method%n_iter)
      !
      ! Expand smooth clean and residual maps
      call expand (nx,ny,e_clean,d_work,   &
       &      mx,my,s_clean,s_work,w_fft)
      f_clean = f_clean + e_clean
    else
      e_clean = 0
    endif
    call expand (nx,ny,d_resid,d_work,   &
     &    mx,my,s_resid,s_work,w_fft)
    f_clean = f_clean + d_resid
    f_resid = f_resid + d_resid
    e_clean(:,:) = e_clean + d_resid
    !
    ! Plot smooth clean image and final clean image
    call plot_routine(method,hclean,e_clean,2)
    call plot_routine(method,hclean,f_clean,3)
    !
    ! --------------------------------- END --------------------------------
  enddo
  !
  deallocate (s_mask,s_list,i_list,stat=ier)
  !
  ! Free all work spaces
  deallocate(w_comp)           !   Clean components search list
  deallocate(d_work)           !   Work space for large FFTs
  deallocate(d_beam_fft)       !   Difference beam FFT
  deallocate(d_resid)          !   Difference residual
  deallocate(d_beam)           !   Difference dirty beam
  deallocate(d_clean_fft)      !   Difference Clean Beam FFT
  deallocate(s_beam)           !   Smooth dirty beam
  deallocate(s_resid)          !   Smooth residual
  deallocate(s_clean)          !    Smooth Clean
  deallocate(s_beam_fft)       !   Smooth beam FFT
  deallocate(s_clean_fft)      !   Smooth Clean Beam FFT
  deallocate(e_clean)          !    Expanded Smooth Clean
  deallocate(s_work)           !   Work space for Compress/Expand
  deallocate(w_fft)            ! Work space for FFT
  return
  !
  ! Formats
  100   format(a,f9.4)
  101   format(a,1pg11.4,a,i5,i5)
  102   format(a,i4)
  104   format(a,1pg11.4,a,1pg11.4)
end subroutine sub_mrc
!
subroutine mrc_maps (nx,ny,full,diff,wl,mx,my,smooth,ws,ratio,   &
     &    bmin,xinc,yinc,wfft)
  use imager_interfaces, except_this=>mrc_maps
  use gkernel_interfaces, only : fourt
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING CLEAN
  !   Multi-Resolution Clean
  !   Compute smooth and difference maps.
  !   Smoothing is done in UV plane, by Gauss convolution and
  !   Fourier truncation. Smooth map is smaller than original map
  !----------------------------------------------------------------------
  integer, intent(in) :: nx,ny,mx,my
  real, intent(in) :: full(nx,ny)
  real, intent(inout) :: diff(nx,ny),smooth(mx,my)
  real, intent(inout) :: wfft(*)
  real, intent(in) :: ratio,bmin,xinc,yinc
  complex, intent(inout) :: ws(mx,my),wl(nx,ny)
  !
  integer i,j,ndim,dim(2)
  real fact,cx,cy,seuil
  real(8), parameter :: pi=3.141592653589793d0
  !
  seuil = -80
  wl = cmplx(full,0.0)
  !
  ndim = 2
  dim(1) = nx
  dim(2) = ny
  call fourt(wl,dim,ndim,-1,0,wfft)
  !
  ! Extract inner part, convolve it by a Gaussian to avoid sharp edges
  ! and subtract it from the FT of original map to get the difference
  !
  fact = sqrt(ratio**2-1.0)*pi/(2.*sqrt(log(2.)))
  cx = fact/nx * bmin/xinc
  cy = fact/ny * bmin/yinc
  do j=1,my/2
    do i=1,mx/2
      fact =  -(float(j-1)*cy)**2 -(float(i-1)*cx)**2
      if (fact.gt.seuil) then
        fact = exp (fact)
        ws(i,j) = wl(i,j)*fact
        wl(i,j) = wl(i,j)-ws(i,j)
      else
        ws(i,j) = 0.
      endif
    enddo
    do i=nx-mx/2+1,nx
      fact =  -(float(j-1)*cy)**2 -(float(i-nx-1)*cx )**2
      if (fact.gt.seuil) then
        fact = exp (fact)
        ws(i-nx+mx,j) = wl(i,j)*fact
        wl(i,j) = wl(i,j)-ws(i-nx+mx,j)
      else
        ws(i-nx+mx,j) = 0.0
      endif
    enddo
  enddo
  do j=ny-my/2+1,ny
    do i=1,mx/2
      fact =  -( float(j-ny-1)*cy)**2 -( float(i-1)*cx)**2
      if (fact.gt.seuil) then
        fact = exp (fact)
        ws(i,j+my-ny) = wl(i,j)*fact
        wl(i,j) = wl(i,j)-ws(i,j+my-ny)
      else
        ws(i,j+my-ny) = 0.0
      endif
    enddo
    do i=nx-mx/2+1,nx
      fact =  -(float(j-ny-1)*cy)**2 -(float(i-nx-1)*cx)**2
      if (fact.gt.seuil) then
        fact = exp (fact)
        ws(i-nx+mx,j-ny+my) = wl(i,j)*fact
        wl(i,j) = wl(i,j)-ws(i-nx+mx,j-ny+my)
      else
        ws(i-nx+mx,j-ny+my) = 0.0
      endif
    enddo
  enddo
  !
  ! Compute difference map
  call fourt(wl,dim,ndim,1,1,wfft)
  fact = 1.0/(nx*ny)
  diff = real(wl)*fact
  !
  ! Compute smooth map
  dim(1) = mx
  dim(2) = my
  call fourt(ws,dim,ndim,1,1,wfft)
  fact = 1.0/(nx*ny)
  smooth = real(ws)*fact
end subroutine mrc_maps
!
subroutine maxcmp(nx,ny,wl,a)
  integer, intent(in) :: nx,ny
  real, intent(in) :: wl(2,nx,ny)
  real, intent(out) :: a
  !
  integer i,j
  !
  a = wl(1,1,1)
  do j=1,ny
    do i=1,nx
      if (wl(1,i,j).gt.a) then
        a = wl(1,i,j)
      endif
    enddo
  enddo
end subroutine maxcmp
!
subroutine mrc_make_clean (nx,ny,beam,bmaj,bmin,pa,xinc,yinc)
  !--------------------------------------------------------------------
  ! @ private
  !
  ! MRC
  !     Make Clean Beam
  !--------------------------------------------------------------------
  integer, intent(in) :: nx,ny
  real, intent(out) :: beam(nx,ny)
  real, intent(in) :: bmaj,bmin,pa,xinc,yinc
  !
  integer i,j
  real amaj,amin,cx,cy,sx,sy
  real seuil,fact
  ! PI is defined with more digits than necessary to avoid losing
  ! the last few bits in the decimal to binary conversion
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  ! Compute the clean beam
  seuil = -100.
  amaj = bmaj/2.0/sqrt(log(2.))
  amin = bmin/2.0/sqrt(log(2.))
  cx = xinc*cos(pa*pi/180.0d0)/amin
  cy = yinc*cos(pa*pi/180.0d0)/amaj
  sx = xinc*sin(pa*pi/180.0d0)/amaj
  sy = yinc*sin(pa*pi/180.0d0)/amin
  ! gain = amaj*amin/abs(pi*xinc*yinc)
  !
  do j=1,ny
    do i=1,nx
      fact =   &
     &        ( -( (float(i-nx/2-1)*sx + float(j-ny/2-1)*cy)**2 +   &
     &        ( -float(i-nx/2-1)*cx + float(j-ny/2-1)*sy)**2 ) )
      if (fact.gt.seuil) then
        beam(i,j) = exp(fact)
      else
        beam(i,j) = 0.0
      endif
    enddo
  enddo
end subroutine mrc_make_clean
!
subroutine mrc_setup (ratio,beam,bmin,xinc,yinc,   &
     &    nx,ny,dbeam,dbeam_fft,dwork,dmax,dxmax,dymax,   &
     &    mx,my,sbeam,sbeam_fft,swork,smax,sxmax,symax,   &
     &    type,work)
  use imager_interfaces, except_this=>mrc_setup
  use gbl_message
  !------------------------------------------------------------------
  ! @ private
  !
  ! MRC
  !     Compute Smooth and Difference BEAMS (dirty or clean) ie
  !        CALL MRC_MAPS + normalisations + TF
  !------------------------------------------------------------------
  character(len=*), intent(in) :: type
  integer, intent(in) :: nx,ny,mx,my
  real, intent(in) :: ratio,beam(nx,ny)
  real, intent(in) :: bmin,xinc,yinc
  real, intent(inout) :: dbeam(nx,ny),dmax
  integer, intent(inout) :: dxmax,dymax
  real, intent(inout) :: dbeam_fft(nx,ny)
  complex, intent(inout) :: dwork(nx,ny)
  real, intent(inout) :: sbeam(mx,my),smax
  integer, intent(inout) :: sxmax,symax
  real, intent(inout) :: sbeam_fft(mx,my)
  complex, intent(inout) :: swork(mx,my)
  real, intent(inout) :: work(*)
  !
  integer box(4),ixmin,iymin
  real rmin,area,tmp
  character(len=message_length) :: chain
  character(len=3) :: rname = 'MRC'
  !
  call mrc_maps (nx,ny,beam,dbeam,dwork,   &
     &    mx,my,sbeam,swork,ratio,   &
     &    bmin,xinc,yinc,work)
  !
  box = (/1,1,nx,ny/)
  call maxmap (dbeam,nx,ny,box,dmax,dxmax,dymax,rmin,ixmin,iymin)
  write(chain,100) 'Difference '//type//' maximum ',dmax,   &
     &    ' at ',dxmax,dymax
  call map_message(seve%i,rname,chain)
  tmp = 1.0/dmax
  dbeam = dbeam*tmp
  call init_convolve (dxmax,dymax,nx,ny,dbeam,dwork,area,work)
  dbeam_fft = real(dwork)
  !
  box = (/1,1,mx,my/)
  call maxmap (sbeam,mx,my,box,smax,sxmax,symax,rmin,ixmin,iymin)
  write(chain,100) 'Smooth '//type//' maximum ',smax,   &
     &    ' at ',sxmax,symax
  call map_message(seve%i,rname,chain)
  !
  tmp = 1.0/smax
  sbeam = sbeam*tmp
  call init_convolve (sxmax,symax,mx,my,sbeam,swork,area,work)
  sbeam_fft = real(swork)
  !
  100   format (a,1pg11.4,a,i5,i5)
end subroutine mrc_setup
!
subroutine cmpmsk (s,mx,my,d,nx,ny,irat)
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MRC
  !     Convert difference (ie initial) mask in smooth mask
  !-----------------------------------------------------------------
  integer, intent(in) ::  nx,ny,mx,my,irat
  logical, intent(out) :: s(mx,my)
  logical, intent(in) :: d(nx,ny)
  !
  integer i,j,k,l
  do j=1,my
    do i=1,mx
      s(i,j) = .false.
      do l=irat*(j-1)+1,irat*j
        do k=irat*(i-1)+1,irat*i
          if (d(k,l)) then
            s(i,j) = .true.
            goto 100
          endif
        enddo
      enddo
      100         continue
    enddo
  enddo
end subroutine cmpmsk
!
subroutine restore_clean90 (method,clean,nx,ny,ft,   &
     &    tfbeam,scale,wfft,tcc,nc)
  use gkernel_interfaces, only : fourt
  !-----------------------------------------------------------------
  ! @ private
  !
  ! GILDAS: CLEAN   Internal routine
  ! Convolve source list into residual map using the Fourier method.
  ! The normalisation should be correct for flux or brightness maps,
  ! depending on value of SCALE.
  !-----------------------------------------------------------------
  use clean_def
  type (clean_par), intent(in) :: method
  integer, intent(in) :: nx, ny, nc
  real, intent(inout) :: clean(nx,ny),wfft(*)
  complex, intent(inout) :: ft(nx,ny)
  real, intent(in) :: tfbeam(nx,ny)
  real, intent(in) :: scale
  type (cct_par), intent(in) :: tcc(nc)
  !
  real(8), parameter :: pi=3.141592653589793d0
  real flux
  integer ix, iy, ic, ndim, dim(2)
  !
  ft = 0.0
  !
  ! Convolve source list into residual map ---
  if (method%bshift(3).eq.0) then
    do ic=1,nc
      ix = tcc(ic)%ix
      iy = tcc(ic)%iy
      ft(ix,iy) = ft(ix,iy) + tcc(ic)%value
    enddo
  else
    do ic=1,nc
      flux = 0.5*tcc(ic)%value
      ix = tcc(ic)%ix
      iy = tcc(ic)%iy
      ft(ix,iy) = ft(ix,iy) + flux
      ix = ix+method%bshift(1)
      iy = iy+method%bshift(2)
      ft(ix,iy) = ft(ix,iy) + flux
    enddo
  endif
  !
  ndim = 2
  dim(1) = nx
  dim(2) = ny
  call fourt(ft,dim,ndim,-1,0,wfft)
  ft = ft*tfbeam
  call fourt(ft,dim,ndim,1,1,wfft)
  clean = real(ft)*scale
end subroutine restore_clean90

module mapping_interfaces_none
  interface
    subroutine compact_data(error)
      use clean_def
      use clean_arrays
      use gbl_message
      logical error
    end subroutine compact_data
  end interface
  !
  interface
    subroutine new_dirty_beam
      use clean_def
      use clean_arrays
      !---------------------------------------------------------------------------
      ! Needed when a new dirty map is computed by command uv_map
      !---------------------------------------------------------------------------
      !
    end subroutine new_dirty_beam
  end interface
  !
  interface
    subroutine save_result(error)
      use gildas_def
      use clean_types
      use gbl_message
      logical error
    end subroutine save_result
  end interface
  !
  interface
    subroutine define_var (error)
      use gildas_def
      use clean_def
      use clean_arrays
      use clean_types
      use clean_default
      use clean_support
      !
      logical :: error  ! Logical error flag
    end subroutine define_var
  end interface
  !
  interface
    subroutine big_wait(n,b)
      real, intent(inout) :: b
      integer, intent(in) :: n
    end subroutine big_wait
  end interface
  !
  interface
    subroutine map_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine map_message_set_id
  end interface
  !
  interface
    subroutine mapping_pack_set(pack)
      use gpack_def
      !
      type(gpack_info_t), intent(out) :: pack
    end subroutine mapping_pack_set
  end interface
  !
  interface
    subroutine mapping_pack_init(gpack_id,error)
      use sic_def
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      integer :: gpack_id
      logical :: error
    end subroutine mapping_pack_init
  end interface
  !
  interface
    subroutine mapping_pack_on_exit(error)
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      logical :: error
    end subroutine mapping_pack_on_exit
  end interface
  !
  interface
    subroutine cossin(phase,rcos,rsin)
      !-------------------------------------------------------
      ! Semi-Fast,  Semi-accurate Sin/Cos pair computation
      ! using (not yet clever) interpolation from a precise
      ! loop-up table
      !
      ! A solution using Taylor expansion and symmetries
      ! would be faster and more accurate
      !-------------------------------------------------------
      real(8), intent(inout) :: phase
      real(8), intent(out) :: rcos
      real(8), intent(out) :: rsin
    end subroutine cossin
  end interface
  !
  interface
    subroutine get_stopping(miter,ares,iplane)
      use clean_arrays
      !
      integer, intent(inout) :: miter
      real, intent(inout) :: ares
      integer, intent(in) :: iplane
    end subroutine get_stopping
  end interface
  !
  interface
    subroutine maxcmp(nx,ny,wl,a)
      integer, intent(in) :: nx,ny
      real, intent(in) :: wl(2,nx,ny)
      real, intent(out) :: a
    end subroutine maxcmp
  end interface
  !
  interface
    subroutine map_minmax(hmap)
      use image_def
      !
      type(gildas), intent(inout) :: hmap
    end subroutine map_minmax
  end interface
  !
  interface
    subroutine userc (nv,coords,xref,xval,xinc,yref,yval,yinc)
      integer, intent(in) :: nv                     !
      real(4), intent(out) :: coords(2,nv)          !
      real(8), intent(in) :: xref                   !
      real(8), intent(in) :: xval                   !
      real(8), intent(in) :: xinc                   !
      real(8), intent(in) :: yref                   !
      real(8), intent(in) :: yval                   !
      real(8), intent(in) :: yinc                   !
    end subroutine userc
  end interface
  !
  interface
    subroutine mos_primary (prim,primary,bsize)
      !
      ! Mosaic and Primary beam support
      ! Compute a Gaussian primary beam
      !
      use image_def
      use gkernel_types
      type(gildas), intent(in) :: prim         ! Primary beam header
      real, intent(inout) :: primary(prim%gil%dim(1),prim%gil%dim(2)) ! Values
      real, intent(in) :: bsize                ! Primary beam size in radian
    end subroutine mos_primary
  end interface
  !
  interface
    subroutine mos_inverse (n,weight,thre)
      integer, intent(in) :: n
      real, intent(inout) :: weight(n)
      real, intent(in) :: thre
    end subroutine mos_inverse
  end interface
  !
  interface
    subroutine mos_addsq (n,nf,weight,lobe)
      integer, intent(in) :: n                      ! Size of arrays
      integer, intent(in) :: nf                     ! Number of fields
      real, intent(inout) :: weight(n)              ! Total weight
      real, intent(in) :: lobe(nf,n)                ! Primary beam array
    end subroutine mos_addsq
  end interface
  !
  interface
    subroutine connect_flux
      !
    end subroutine connect_flux
  end interface
  !
  interface
    subroutine mrc_clear
    end subroutine mrc_clear
  end interface
  !
  interface
    function minimum(n,a)
      integer n,i
      real a(*)
      real minimum
    end function minimum
  end interface
  !
  interface
    subroutine uv_free_buffers
      use clean_def
      use clean_arrays
      !---------------------------------------------------------------------
      ! MAPPING
      !   Deallocate all UV buffers.
      !---------------------------------------------------------------------
    end subroutine uv_free_buffers
  end interface
  !
  interface
    subroutine map_beams(task,map_beam,huv,nx,ny,nb,nc)
      use gbl_message
      use image_def
      !
      character(len=*), intent(in) :: task
      integer, intent(inout) :: map_beam
      type(gildas), intent(in) :: huv
      integer, intent(in) :: nx ! X size
      integer, intent(in) :: ny ! Y size
      integer, intent(in) :: nc ! Number of channels
      integer, intent(out) :: nb ! Number of beams
    end subroutine map_beams
  end interface
  !
end module mapping_interfaces_none

subroutine map_continuum(line,error)
  use image_def
  use clean_def
  use clean_arrays
  use clean_types
  use gkernel_interfaces
  use imager_interfaces, except_this => map_continuum 
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  ! Local
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='MAP_CONTINUUM'
  !! logical :: debug=.false.
  character(len=16) :: name
  character(len=80) :: chain
  integer :: n, nchan, ier
  integer(kind=index_length) :: nhist, mhist, dim(2)
  real :: clip_value 
  type(gildas) :: hmap
  type(gildas), save :: hcont
  real, allocatable, target, save :: dcont(:,:)
  real, allocatable, target, save :: spectrum(:,:)
  real :: xsize, ysize, factor
  integer :: imin,imax,jmin,jmax,i1,i2, box(4), nx,ny
  logical :: do_mask
  !
  call sic_delvariable('CONTINUUM',.false.,error)
  if (allocated(dcont)) deallocate(dcont)
  call sic_delvariable('CLIPPED',.false.,error)
  if (allocated(spectrum)) deallocate(spectrum)
  !
  error = .false.
  call gildas_null(hmap)
  call gildas_null(hcont)
  !
  name = 'CLEAN'
  call sic_ke(line,0,1,name,n,.false.,error)
  select case (name)
  case ('CLEAN')
    if (hclean%loca%size.eq.0) then
      call map_message(seve%e,rname,'No CLEAN data loaded')
      error = .true.
      return
    endif
    call gdf_copy_header(hclean,hmap,error)
    hmap%r3d => dclean
    ! Number of pixels per beam
    factor = abs(pi*hmap%gil%majo*hmap%gil%mino/hmap%gil%inc(1)/hmap%gil%inc(2))
  case ('DIRTY')
    if (hdirty%loca%size.eq.0) then
      call map_message(seve%e,rname,'No DIRTY data loaded')
      error = .true.
      return
    endif
    call gdf_copy_header(hdirty,hmap,error)
    hmap%r3d => ddirty
    factor = 1.0
  case default
    call map_message(seve%e,rname,'Only work on CLEAN or DIRTY images')
    error = .true.
    return
  end select
  !
  call gdf_copy_header(hmap,hcont,error)
  !
  hcont%gil%ndim = 2
  hcont%gil%dim(3) = 1
  allocate(dcont(hcont%gil%dim(1),hcont%gil%dim(2)), &
    &   spectrum(hmap%gil%dim(3),4),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  hcont%r2d => dcont
  !
  clip_value = 2.5
  call sic_r4(line,0,2,clip_value,.false.,error)
  if (clip_value.lt.1.0 .or. clip_value.gt.5.0) then
    call map_message(seve%e,rname,'Clipping value outside of recommended [1-5] range')
    error = .true.
    return
  endif
  !
  nchan = hmap%gil%dim(3)
  !
  mhist = max(8,nint(sqrt(real(nchan))))
  mhist = min(mhist,32)
  nhist = max(8,mhist)
  call sic_i8(line,0,3,nhist,.false.,error) 
  if (nchan.lt.32) then
    write(chain,'(A,I0,A)') 'Too few channels [',nchan,'], display only'
    call map_message(seve%w,rname,chain)
    nhist = 1
  else if (nhist.lt.8 .or. nhist.gt.max(8,nchan/8)) then
    write(chain,'(A,I0,A)') 'Histogram size out of allowed range [8-',nchan/8,']'
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  else if (nhist.gt.mhist)  then
    write(chain,'(A,I0,A)') 'Histogram size out of recommended range [8-',mhist,']'
    call map_message(seve%w,rname,chain)
  endif
  ! 
  !
  ! We should use the mechanics of MASK and SUPPORT as in the
  ! STATISTIC command
  !
  nx = hmap%gil%dim(1)
  ny = hmap%gil%dim(2)
  do_mask = user_method%do_mask
  !
  if (do_mask) then
    call copy_method(user_method,method)
    !
    if (.not.allocated(d_mask)) then
      allocate(d_mask(nx,ny),d_list(nx*ny),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Error getting support memory')
        error = .true.
        return
      endif
      method%do_mask = .true.
      method%nlist = 0
    endif
    box = [nx,ny,1,1] 
    call check_area(method,hmap,.true.) ! Needed ?
    call check_mask(method,hmap)
    box(1) = min(box(1),method%box(1))
    box(2) = min(box(2),method%box(2))
    box(3) = max(box(3),method%box(3))
    box(4) = max(box(4),method%box(4))
    call map_message(seve%i,rname,'Using current support')
    !
    call compute_continuum(hmap,hcont,spectrum,nhist,clip_value,error,box,d_mask)
    if (error) return  
  else
    !
    xsize = 0.
    ysize = 0.
    call sic_get_real('SIZE[1]',xsize,error)
    call sic_get_real('SIZE[2]',ysize,error)
    !
    if (xsize.eq.0. .and. ysize.eq.0.) then
      box = [1,1,nx,ny]
    else
      call map_message(seve%i,rname,'Using current SIZE')
      xsize = xsize*pi/180.d0/3600d0
      ysize = ysize*pi/180.d0/3600d0
      i1 = (-0.5*xsize-hmap%gil%val(1))/hmap%gil%inc(1) + hmap%gil%ref(1)
      i2 = (0.5*xsize-hmap%gil%val(1))/hmap%gil%inc(1) + hmap%gil%ref(1)
      imin = min(i1,i2)
      imax = max(i1,i2)
      imin = max(1,imin)
      i1 = (-0.5*ysize-hmap%gil%val(2))/hmap%gil%inc(2) + hmap%gil%ref(2)
      i2 = (0.5*ysize-hmap%gil%val(2))/hmap%gil%inc(2) + hmap%gil%ref(2)
      jmin = min(i1,i2)
      jmax = max(i1,i2)
      jmin = max(1,jmin)
      !
      imin = min(imin,hmap%gil%dim(1))
      imax = min(imax,hmap%gil%dim(1))
      jmin = min(jmin,hmap%gil%dim(2))
      jmax = min(jmax,hmap%gil%dim(2))
      !
      box(1) = imin
      box(2) = jmin
      box(3) = imax
      box(4) = jmax
    endif
    !
    call compute_continuum(hmap,hcont,spectrum,nhist,clip_value,error,box)
    if (error) return  
  endif
  !
  hcont%loca%addr = locwrd(hcont%r2d) 
  hcont%loca%size = hcont%gil%dim(1) * hcont%gil%dim(2)
  call gdf_get_extrema (hcont,error)
  !
  call sic_mapgildas('CONTINUUM',hcont,error,dcont)
  dim(1) = hmap%gil%dim(3)
  dim(2) = 4
  !
  ! Scale to Jy if possible (CLEAN data)
  Print *,'Normalizing by ',factor
  spectrum(:,2) = spectrum(:,2)/factor
  spectrum(:,3) = spectrum(:,3)/factor
  where(spectrum(:,4).ne.0) 
    spectrum(:,4) = 1.0
  end where
  call sic_def_real('CLIPPED',spectrum,2,dim,.false.,error)
  !
  call exec_program('@ p_continuum')   
  !
end subroutine map_continuum
!
subroutine compute_continuum(hmap,hcont,spectrum,nhist,clip_value,error,box,mask)
  use image_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => compute_continuum
  !
  ! @ public-mandatory
  !
  type(gildas), intent(in) :: hmap
  type(gildas), intent(inout) :: hcont
  real, intent(out) :: spectrum(:,:)
  integer(kind=index_length), intent(in) :: nhist
  real, intent(in) :: clip_value
  logical, intent(out) :: error
  integer(kind=4), intent(in) :: box(4)
  logical, intent(in), optional :: mask(:,:)
  !
  character(len=*), parameter :: rname='MAP_CONTINUUM'
  integer, allocatable :: mylines(:)
  real, pointer :: rmask(:,:)
  real :: blank, val
  integer(kind=index_length) :: nchan,kxy
  integer :: nx,ny,ix,iy,ier,ic,kc,ib,nb
  logical :: debug=.false.
  !
  error = .false.
  !
  nchan = hmap%gil%dim(3)
  nx = hmap%gil%dim(1)
  ny = hmap%gil%dim(2)
  !
  allocate(mylines(nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  spectrum = 0.0
  do ic=1,nchan
    spectrum(ic,1) = (ic-hmap%gil%ref(3))*hmap%gil%vres + hmap%gil%voff
  enddo
  ! 
  if (hcont%gil%blan_words.ne.2 .or. hcont%gil%eval.lt.0) then
    !    
    ! We need to define a Blanking value outside of the range
    blank = minval(hmap%r3d)
    if (blank.gt.0) then
      hcont%gil%bval = -2.0*blank*nchan
      hcont%gil%eval = 0.0
    else if (blank.lt.0) then
      hcont%gil%bval = 3.0*blank*nchan
      hcont%gil%eval = 0.0
    else
      hcont%gil%bval = -1.0
      hcont%gil%eval = 0.0
    endif
  endif
  !
  ! Compute the mean spectrum
  !
  if (present(mask)) then
    !
    if (hmap%gil%eval.ge.0.0) then
      kxy = 0
      do iy=box(2),box(4)
        do ix=box(1),box(3)
          if (mask(ix,iy)) then
            kxy = kxy+1
            do ic=1,nchan
              val = hmap%r3d(ix,iy,ic)
              if (abs(val-hmap%gil%bval).gt.hmap%gil%eval) then
                spectrum(ic,2) = spectrum(ic,2) + val
              endif
            enddo
          endif
        enddo
      enddo
    else
      kxy = 0
      do iy=box(2),box(4)
        do ix=box(1),box(3)
          if (mask(ix,iy)) then
            kxy = kxy+1
            do ic=1,nchan
              spectrum(ic,2) = spectrum(ic,2) + hmap%r3d(ix,iy,ic)
            enddo
          endif
        enddo
      enddo
    endif
  else
    if (all(box.eq.0)) then
      kxy =nx*ny
      !
      do ic = 1,nchan
        call gr4_mean(hmap%r3d(:,:,ic),hmap%gil%dim(1)*hmap%gil%dim(2),  &
          & hmap%gil%bval,hmap%gil%eval,spectrum(ic,2)) 
      enddo
    else
      kxy =(box(4)-box(2)+1)*(box(3)-box(1)+1)
      !
      if (hmap%gil%eval.ge.0.0) then
        do ic=1,nchan
          do iy=box(2),box(4)
            do ix=box(1),box(3)
              val = hmap%r3d(ix,iy,ic)
              if (abs(val-hmap%gil%bval).gt.hmap%gil%eval) then
                spectrum(ic,2) = spectrum(ic,2) + val
              endif
            enddo
          enddo
        enddo
      else
        do ic=1,nchan
          do iy=box(2),box(4)
            do ix=box(1),box(3)
              spectrum(ic,2) = spectrum(ic,2) + hmap%r3d(ix,iy,ic)
            enddo
          enddo
        enddo
      endif
    endif
  endif
  !
  spectrum(:,3) = spectrum(:,2)
  !
  if (nhist.gt.1) then
    !
    ! Find out the line free regions
    call clip_lineregions(rname,spectrum(:,3),nchan,nhist,  &
      & hcont%gil%bval,hcont%gil%eval,clip_value,debug,0.0,1.0)
    nb = 0
    call guess_lineregions(spectrum(:,3),nchan,       &
      & hcont%gil%bval,hcont%gil%eval,            &
      & mylines,nb)
    !
    ! Expand line regions by continuity
    call clip_expand(mylines,hmap%gil%dim(3),nb)
    !
    ! Compute the continuum image 
    do ib=1,nb
      spectrum(mylines(ib),4) = 1
    enddo
    kc = 0
    do ic=1,nchan
      if (spectrum(mylines(ib),4).eq.0) cycle
      kc = kc+1
      if (kc.eq.1) then
        hcont%r2d = hmap%r3d(:,:,ic)
      else
        rmask => hmap%r3d(:,:,ic)
        if (hmap%gil%eval.ge.0) then
          where ( (abs(rmask-hmap%gil%bval).gt.hmap%gil%eval).and. &
            & (abs(hcont%r2d-hmap%gil%bval).gt.hmap%gil%eval) ) &
            & hcont%r2d = hcont%r2d + rmask
        else
          hcont%r2d = hcont%r2d + rmask
        endif
      endif
    enddo
    !
    if (kc.ne.0) then
      where (abs(hcont%r2d-hcont%gil%bval).gt.hcont%gil%eval) hcont%r2d = hcont%r2d/kc
    endif
  endif
  !
  ! Return the number of pixels here. It will serve
  ! to normalize the spectrum after that.
  spectrum(:,4) = kxy*spectrum(:,4)
end subroutine compute_continuum

subroutine exemac(line,error)
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>exemac
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Execute a macro
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  logical,          intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MACRO'
  character(len=filename_length) :: name,fich
  integer :: i,n,ier,ipt,nc
  character(len=message_length) :: mess
  character(len=4) ::ans
  logical :: found
  !
  ! Increase execution level
  if (nlire.ge.maxlev-1) then
    call sic_message(seve%e,rname,'Input level too deep')
    error = .true.
    return
  endif
  !
  ! Find the macro name and setup the arguments
  error = .false.
  call sic_ch (line,0,1,name,nc,.true.,error)
  if (error) return
  call find_procedure(name,fich,found)
  if (.not.found) then
    call sic_message(seve%e,rname,'No such procedure '//name)
    error = .true.
    return
  endif
  !
  ! Check for recursive calls
  do i=1,nmacro
    if (macnam(i).eq.fich) then
      call sic_message(seve%e,rname,'Recursive call to macro '//fich)
      error = .true.
      return
    endif
  enddo
  !
  ! Get LUN
  call sic_lunmac_get(nmacro+1,error)
  if (error) return
  !
  ! Increment levels
  nlire   = nlire + 1
  nmacro  = nmacro + 1
  mlire(nlire) = nmacro
  !
  ! Open the file and proceed
  macnam(nmacro) = fich
  ier = sic_open(lunmac(nmacro),macnam(nmacro),'OLD',.true.)
  if (ier.ne.0) then
    call sic_message(seve%e,rname,'Unable to open macro '//fich)
    call putios('          ',ier)
    goto 70
  endif
  !
  ! Define the macro arguments
  ipt = 1
  macarg(nmacro) = ' '
  if (sic_present(0,maxmacarg+2)) then
    write (mess,'(A,I2,A)') 'Too many macro arguments. Only ',maxmacarg,  &
    ' will be used'
    call sic_message(seve%w,rname,mess)
  endif
  manarg(nmacro) = 0
  do i=1,maxmacarg
    if (sic_present(0,i+1)) then
      mac1(nmacro,i) = ipt
      call sic_ch (line,0,i+1,macarg(nmacro)(ipt:),nc,.true.,error)
      if (error) then
         close(unit=lunmac(nmacro))
         goto 70
      endif
      mac2(nmacro,i) = ipt + nc -1
      if (mac2(nmacro,i).lt.mac1(nmacro,i)) then
        mac2(nmacro,i) = mac1(nmacro,i)+sic_len(0,i+1)
      endif
      ipt = mac2(nmacro,i)+2
      manarg(nmacro) = i
    else
      mac1(nmacro,i) = 0
      mac2(nmacro,i) = 0
    endif
  enddo
  var_level = nmacro
  var_macro(var_level) = var_n
  jmac (nmacro) = 0
  nerr(var_level) = nerr(0)
  errcom(var_level) = errcom(0)
  !
  ! Define the arguments as SIC Variables
  call mac_variables
  !
  if (sic_stepin.ne.0) then
    if (.not.lverif) then
      print *,'---- Executing @ '//trim(macnam(nmacro))
      print *,'----',manarg(nmacro),' arguments'
      print *,'----'//trim(macarg(nmacro))
      if (sic_stepin.lt.0) call sic_wprn('Continue ? ',ans,n)
    endif
  endif
  error = .false.
  return
  !
  ! Error : reset the execution level and number of active macros
  !
70 call sic_lunmac_free(nmacro)
  nmacro = nmacro - 1
  nlire = nlire -1
  error = .true.
end subroutine exemac
!
subroutine endmac
  use sic_interfaces, except_this=>endmac
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! End of macro execution
  !-----------------------------------------------------------------------
  !
  ! Close the unit and reset the active macro number
  close (unit=lunmac(nmacro))
  call sic_lunmac_free(nmacro)
  if (sic_stepin.ne.0) then
    print *,'---- Leaving @ '//trim(macnam(nmacro))
  endif
  errcom(nmacro) = ' '
  nerr  (nmacro) = 0
  nmacro = nmacro - 1
  !
  ! Delete all local variables :
  call erase_variables
  !
  ! Reset Arguments
  call mac_variables
end subroutine endmac
!
subroutine mac_variables
  use sic_interfaces, except_this=>mac_variables
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Define the current macro arguments as SIC Variables
  !---------------------------------------------------------------------
  logical :: error
  integer :: i
  !
  error = .false.
  call sic_delvariable ('PRO',.false.,error)
  if (nmacro.eq.0) return
  !
  ! This is a "Program Defined" structure
  error = .false.
  call sic_defstructure('PRO',.true.,error)
  !
  ! And now the associated program-defined variables.
  !
  call sic_def_char('PRO%NAME',macnam(nmacro),.true.,error)
  call sic_def_inte('PRO%NARG',manarg(nmacro),0,0,.true.,error)
  if (manarg(nmacro) .lt.1) return
  call sic_def_charn('PRO%ARG',macstr,1,manarg(nmacro),.true.,error)
  do i = 1,manarg(nmacro)
    macstr(i) = macarg(nmacro)(mac1(nmacro,i):mac2(nmacro,i))
  enddo
end subroutine mac_variables
!
subroutine macarg_parse(line,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>macarg_parse
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !  SIC\PARSE [/OPT1 [Nargmin [Nargmax]]] [/OPT2 ...] ... [/OPTN ...]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PARSE'
  character(len=varname_length) :: structname,varname1,varname2
  integer(kind=4) :: nc,nopt,iopt,iarg,narg,curr_opt
  character(len=command_length) :: imacstr,option
  character(len=command_length) :: optname(0:maxmacarg)
  integer(kind=4) :: nargmin(0:maxmacarg),nargmax(0:maxmacarg)
  integer(kind=4), save :: optnarg(0:maxmacarg)  ! Support for PRO%PARSE%<OPTNAME>%NARG
  integer(kind=4) :: optfirst(0:maxmacarg)
  logical, parameter :: global=.true.,ro=.true.
  character(len=32) :: mess1,mess2
  character(len=message_length) :: mess
  !
  ! --- The parent structure -------------------------------------------
  structname = 'PRO%PARSE'
  call sic_delvariable (structname,.false.,error)
  if (error)  return
  call sic_defstructure(structname,global,error)
  if (error)  return
  !
  ! --- The options list -----------------------------------------------
  nopt = 0
  optname(nopt) = '/COMMAND'
  nargmin(nopt) = -1  ! No minimum provided yet
  nargmax(nopt) = -1  ! No maximum provided yet
  !
  do iarg=1,sic_narg(0)
    call sic_ch(line,0,iarg,option,nc,.true.,error)
    if (error)  return
    if (option(1:1).eq."/") then
      ! This is a new option declaration
      ! Finish previous option declaring
      if (nargmax(nopt).eq.-1)  nargmax(nopt) = nargmin(nopt)
      ! Start new option declaration
      call sic_upper(option)
      nopt = nopt+1
      optname(nopt) = option
      nargmin(nopt) = -1  ! No minimum provided yet
      nargmax(nopt) = -1  ! No maximum provided yet
      !
    elseif (nargmin(nopt).eq.-1) then
      call sic_i4(line,0,iarg,nargmin(nopt),.true.,error)
      if (error)  return
      if (nargmin(nopt).le.-1) then
        call sic_message(seve%e,rname,'Invalid option declaration, should have 0 <= Nargmin <= Nargmax')
        error = .true.
        return
      endif
      !
    elseif (nargmax(nopt).eq.-1) then
      call sic_i4(line,0,iarg,nargmax(nopt),.true.,error)
      if (error)  return
      if (nargmax(nopt).lt.nargmin(nopt)) then
        call sic_message(seve%e,rname,'Invalid option declaration, should have 0 <= Nargmin <= Nargmax')
        error = .true.
        return
      endif
      !
    else
      call sic_message(seve%e,rname,'Invalid option declaration. Syntax is:')
      call sic_message(seve%e,rname,'SIC\PARSE [Nargmin [Nargmax]] /OPT1  [Nargmin [Nargmax]] /OPT2...')
      error = .true.
      return
    endif
  enddo
  !
  ! --- Parse PRO%ARG --------------------------------------------------
  !
  optnarg(:) = -1  ! i.e. none of the options is present
  optnarg(0) = 0   ! i.e. command is present, with 0 argument yet
  optfirst(:) = 0  !
  optfirst(0) = 1  ! 1st argument of command is 1st element of PRO%ARG[:]
  curr_opt = 0
  do iarg=1,manarg(nmacro)
    if (macstr(iarg)(1:1).eq.'/') then
      imacstr = macstr(iarg)
      call sic_upper(imacstr)
      call sic_ambigs(rname,imacstr,option,curr_opt,optname(1),nopt,error)
      if (error)  return
      optnarg(curr_opt) = 0
      optfirst(curr_opt) = iarg+1
    else
      optnarg(curr_opt) = optnarg(curr_opt)+1
    endif
  enddo
  !
  ! --- Check for correct number of arguments --------------------------
  !
  do iopt=0,nopt
    !
    if (optnarg(iopt).eq.-1)  cycle  ! Option is absent, nothing to check
    !
    if (nargmin(iopt).ne.-1 .and. nargmin(iopt).ne.nargmax(iopt)) then
      ! A minimum number is required
      if (optnarg(iopt).lt.nargmin(iopt)) then
        error = .true.
        mess2 = 'at least'
        narg = nargmin(iopt)
      endif
      !
    elseif (nargmax(iopt).ne.-1 .and. nargmin(iopt).ne.nargmax(iopt)) then
      ! A maximum number required
      if (optnarg(iopt).gt.nargmax(iopt)) then
        error = .true.
        mess2 = 'at most'
        narg = nargmax(iopt)
      endif
      !
    elseif (nargmin(iopt).ne.-1 .and. nargmin(iopt).eq.nargmax(iopt)) then
      ! An exact number is required
      if (optnarg(iopt).ne.nargmin(iopt)) then
        error = .true.
        mess2 = 'exactly'
        narg = nargmin(iopt)
      endif
    endif
    !
    if (error) then
      if (iopt.eq.0) then
        mess1 = 'Command'
      else
        mess1 = 'Option '//optname(iopt)
      endif
      write(mess,10)  trim(mess1),trim(mess2),narg
      call sic_message(seve%e,rname,mess)
      return
    endif
  enddo
  !
10 format(A,' takes ',A,1X,I0,' argument(s)')
  !
  ! --- Fill the PRO%PARSE% structure ----------------------------------
  !
  do iopt=0,nopt
    !
    ! PRO%PARSE%<OPTNAME>%
    write(varname1,'(A,A,A)')  trim(structname),'%',optname(iopt)(2:)  ! Strip the leading /
    call sic_defstructure(varname1,global,error)
    if (error)  return
    !
    ! PRO%PARSE%<OPTNAME>%NARG
    varname2 = trim(varname1)//'%NARG'
    call sic_def_inte(varname2,optnarg(iopt),0,0,ro,error)
    if (error)  return
    !
    ! PRO%PARSE%<OPTNAME>%ARG
    if (optnarg(iopt).gt.0) then
      varname2 = trim(varname1)//'%ARG'
      call sic_def_charn(varname2,macstr(optfirst(iopt)),1,optnarg(iopt),ro,error)
      if (error)  return
    endif
    !
  enddo
  !
end subroutine macarg_parse

subroutine mosaic_restore(line,error)
  use clean_arrays
  use clean_types
  use gbl_message
  use gkernel_interfaces
  use mapping_interfaces, except_this => mosaic_restore
  !---------------------------------------------------------------------
  ! @ private
  !
  ! Restore (like in UV_RESTORE) a mosaic image
  !
  ! Required input
  !   the CCT table
  !   the RESIDUAL image (obtained by imaging the UV table
  !     obtained by UV_RESIDUAL)
  !   the PRIMARY beams
  ! Output 
  !   the restored CLEAN image
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: task='MOSAIC_RESTORE'
  type(gildas) :: huv_save
  real, pointer :: prima(:,:,:)
  real, pointer :: resid(:,:)
  real, pointer :: clean(:,:)
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  real, allocatable :: response(:,:)
  integer :: nx,ny,np,nc,ic,ip,i,j,ier
  real :: wr, wr2, ws2, wmin
  logical :: zero, err
  !
  ! Code
  error = .false.
  ! Compute the primary beams if not done
  if (hprim%loca%size.eq.0) then
    call map_message(seve%e,task,'Primary beams undefined')
    error = .true.
    return
  endif
  !
  call gildas_null(huv_save,type='UVT')
  call gdf_copy_header(huv, huv_save, error)
  !
  ! Compute the UV Residual and the pure CLEAN part
  nullify (duv_previous, duv_next)
  call sub_uv_residual(task,line,duv_previous,duv_next,.true.,error)
  if (error) return
  !
  ! Associate DUV and HUV to the UV Residual
  duv => duv_next
  ! Resize UV data  
  huv%gil%nvisi = ubound(duv,2)
  huv%gil%dim(2) = huv%gil%nvisi
  !
  ! Perform the Imaging
  call mosaic_uvmap(task,line,error)
  !
  ! At this stage : DIRTY is the RESIDUAL...
  call gdf_copy_header(hdirty,hresid,error)
  hresid%r3d => dresid 
  !
  prima => dprim(:,:,:,1)
  np = hprim%gil%dim(1)
  nc = hresid%gil%dim(3)
  ny = hresid%gil%dim(2)
  nx = hresid%gil%dim(1)
  !
  ! Compute the "weight" function 1/N
  wmin = 0.01    ! Hum ?
  ws2 =  0.0     ! Search weight
  wr2 =  0.04    ! Restore weight 20 % level of primary beam
  allocate(response(nx,ny),stat=ier)
  !
  response = 0
  do ip=1,np
    response(:,:) = response(:,:)+prima(ip,:,:)**2
  enddo
  where (response.gt.wr2) 
    response = 1.0/response
  else where
    response = 0.0
  end where
  !
  ! For test, can reset DCLEAN or RESID
  zero = .false.
  call sic_get_logi('ZERO_CLEAN',zero,err)
  if (zero) dclean = 0.0
  zero = .false.
  call sic_get_logi('ZERO_RESID',zero,err)
  if (zero) dresid = 0.0
  !
  ! Loop on channels
  do ic=1,nc
    resid => hresid%r3d(:,:,ic)
    clean => hclean%r3d(:,:,ic)
    ! Mosaic case
    clean = clean + resid*response
    where (response.eq.0) clean = hclean%gil%bval ! Undefined pixel there
  enddo
  !
  call sic_delvariable ('CLEAN',.false.,error)
  ! Redefine CLEAN data set 
  call sic_mapgildas('CLEAN',hclean,error,dclean)! Clean buffers
  hclean%loca%size = hdirty%loca%size
  !
  ! Must clean in some way the intermediate UV_BUFFERS and
  ! re-associate the HUV header - Use a new UV_DISCARD_BUFFER tool
  ! to factorize that.
  !
  zero = .false. 
  call sic_get_logi('ZERO_KEEPUV',zero,err)
  !
  if (.not.zero) then
    !call uv_dump_buffers(task//' before')
    !Print *,'Discarding UV buffers '
    call uv_discard_buffers(duv_previous, duv_next, error)
    !call uv_dump_buffers(task//' after')
    call gdf_copy_header(huv_save,huv,error)
    !
  else
    call map_message(seve%w,task,'Keeping UV residuals')
    call uv_clean_buffers (duv_previous, duv_next,error)
    if (error) return
    !
    if (allocated(duvt)) deallocate (duvt)            ! UV data not plotted
    uv_plotted = .false.
    !
    ! Indicate optimization and save status
    optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
    save_data(code_save_uv) = .true.
    !
    ! Not needed here: weights are unchanged
    ! do_weig = .true.  ! Recompute weight 
    !
    ! Resize UV data and redefine SIC variables 
    huv%gil%nvisi = ubound(duv,2)
    huv%gil%dim(2) = huv%gil%nvisi
    !
    call sic_delvariable ('UV',.false.,error)
    call sic_mapgildas ('UV',huv,error,duv) 
  endif
end subroutine mosaic_restore

!
subroutine many_beams_para (rname,map,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,uvdata,   &
     &    r_weight, w_v, do_weig,    &
     &    wcol,mcol,sblock,cpu0,error,uvmax,jfield)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>many_beams_para
  use clean_def
  use image_def
  use gbl_message
  !$ use omp_lib
  !------------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Compute a map from a CLIC UV Sorted Table
  !   by Gridding and Fast Fourier Transform, with
  !   a different beam per channel.
  !
  ! Input :
  ! a precessed UV table, sorted in V, ordered in
  ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  ! Output :
  ! a beam image
  ! a VLM cube
  ! Work space :
  ! a  VLM complex Fourier cube (first V value is for beam)
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: rname   ! Calling Task name
  type (uvmap_par), intent(inout) :: map  ! Mapping parameters
  type (gildas), intent(inout) :: huv     ! UV data set
  type (gildas), intent(inout) :: hbeam   ! Dirty beam data set
  type (gildas), intent(inout) :: hdirty  ! Dirty image data set
  integer, intent(in) :: nx   ! X size
  integer, intent(in) :: ny   ! Y size
  integer, intent(in) :: nu   ! Size of a visibilities
  integer, intent(in) :: nv   ! Number of visibilities
  real, intent(inout) :: uvdata(nu,nv)
  real, intent(inout), target :: r_weight(nv)    ! Weight of visibilities
  real, intent(inout) :: w_v(nv)         ! V values
  logical, intent(inout) :: do_weig
  integer, intent(in) :: jfield      ! Field number (for mosaic)
  !
  real, intent(inout) :: cpu0        ! CPU
  real, intent(inout) :: uvmax       ! Maximum baseline
  integer, intent(inout) :: sblock   ! Blocking factor
  integer, intent(inout) :: wcol     ! Weight channel
  integer, intent(inout) :: mcol(2)  ! First and last channel
  logical, intent(inout) :: error
  ! Global variables:
  !
  real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
  !
  type (gridding) :: conv
  !
  integer :: nc   ! Number of channels
  integer :: nd   ! Size of data
  integer :: nb   ! Number of beams
  integer :: ns   ! Number of channels per single beam
  integer ier
  real(kind=8) :: freq
  integer ctypx,ctypy
  integer icol,lcol,fcol,imi,ima,iv
  real rmi,rma,wall,cpu1
  real xparm(10),yparm(10)
  real(8) :: vref,voff,vinc
  real(kind=4) :: loff,boff
  integer ndim, nn(2), i, lx, ly, kz1
  integer istart,iblock,nblock,kz,iz,ic,kc,kb,jc,lc
  character(len=message_length) :: chain
  !
  real :: rms, null_taper(4), wold
  complex, allocatable :: ftbeam(:,:)
  complex, allocatable :: tfgrid(:,:,:)
  real, allocatable :: w_xgrid(:),w_ygrid(:), w_w(:),  w_grid(:,:), walls(:)
  real, allocatable :: w_weight(:)
  real, allocatable :: beam(:,:)
  real, allocatable :: w_mapu(:), w_mapv(:)
  real, allocatable :: local_wfft(:)
  integer(kind=8) :: ilong
  real uvcell(2)
  real support(2)
  real(8) local_freq
  !
  integer :: ithread, othread, nthread, ians
  real(8) :: elapsed_s, elapsed_e, elapsed
  !
  real :: toto
  logical :: local_error
  !------------------------------------------------------------------------
  !
  ! Code:
  error = .false.
  nd = nx*ny
  nc = huv%gil%nchan
  nb = hbeam%gil%dim(3)
  !
  ns = map%beam
  null_taper = 0
  !
  if (ns.ne.1 .and. nb.gt.1) then
    write(chain,'(a,i6,a)') 'Processing ',ns,' channels per beam'
    call map_message(seve%w,rname,chain)
  endif
  !
  ! Reset the parameters
  xparm = 0.0
  yparm = 0.0
  !
  vref = huv%gil%ref(1)
  voff = huv%gil%voff
  vinc = huv%gil%vres
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nc))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nc
  else
    mcol(2) = max(1,min(mcol(2),nc))
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  if (wcol.eq.0) then
    wcol = (fcol+lcol)/3
  endif
  wcol = max(1,wcol)
  wcol = min(wcol,nc)
  nc = lcol-fcol+1
  !
  ! Compute observing sky frequency for U,V cell size
  freq = gdf_uv_frequency(huv, 0.5d0*dble(lcol+fcol) )
  !
  ! Compute gridding function
  ctypx = map%ctype
  ctypy = map%ctype
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, conv%ubuff, conv%ubias)
  call convfn (ctypy, yparm, conv%vbuff, conv%vbias)
  map%uvcell = clight/freq/(map%xycell*map%size)
  map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
  map%support(2) = yparm(1)*map%uvcell(2)
  !
  ! Process sorted UV Table according to the type of beam produced
  !
  allocate (w_w(nv),w_weight(nv),walls(nb),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate Weight arrays')
    error = .true.
    return
  endif
  w_v(:) = uvdata(2,1:nv)
  !
  !
  lx = (uvmax+map%support(1))/map%uvcell(1) + 2
  ly = (uvmax+map%support(2))/map%uvcell(2) + 2
  lx = 2*lx
  ly = 2*ly
  if (ly.gt.ny) then
    write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
        &      ' Undersampling ratio ',float(ly)/float(ny)
    call map_message(seve%e,rname,chain)
    ly = min(ly,ny)
    lx = min(lx,nx)
  endif
  !
  ! Get FFT's and beam work spaces
  allocate (tfgrid(ns+1,lx,ly),ftbeam(nx,ny),beam(nx,ny),&
    & w_mapu(lx),w_mapv(ly),local_wfft(2*max(nx,ny)), &
    & w_xgrid(nx),w_ygrid(ny),w_grid(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate TF arrays')
    error = .true.
    return
  endif
  !
  call docoor (lx,-map%uvcell(1),w_mapu)
  call docoor (ly,map%uvcell(2),w_mapv)
  !
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt_plan(ftbeam,nn,ndim,-1,1)
  !
  ! Prepare grid correction,
  call grdtab (ny, conv%vbuff, conv%vbias, w_ygrid)
  call grdtab (nx, conv%ubuff, conv%ubias, w_xgrid)
  !
  ! Make beam, not normalized
  call gdf_copy_header(huv,hbeam,error)
  hbeam%gil%dopp = 0    ! Nullify the Doppler factor
  !
  hbeam%gil%ndim = 3
  hbeam%gil%dim(1) = nx
  hbeam%gil%dim(2) = ny
  hbeam%gil%dim(3) = nb
  hbeam%gil%dim(4) = 1
  hbeam%gil%convert(1,1) = nx/2+1
  hbeam%gil%convert(1,2) = ny/2+1
  hbeam%gil%convert(2,1) = 0
  hbeam%gil%convert(2,2) = 0
  hbeam%gil%convert(3,1) = -map%xycell(1)  ! Assume EQUATORIAL system
  hbeam%gil%convert(3,2) = map%xycell(2)
!    hbeam%gil%convert(1,3) = vref-fcol+1     ! for 1 per channel
! From UV_COMPRESS
!    uvout%gil%inc(1) = uvout%gil%inc(1)*nc
!    uvout%gil%ref(1) = (2.0*uvout%gil%ref(1)+nc-1.0)/2/nc
!    uvout%gil%vres = nc*uvout%gil%vres
!    uvout%gil%fres = nc*uvout%gil%fres
!
  hbeam%gil%convert(1,3) = (2.d0*(vref-fcol)+ns+1.d0)/2/ns ! Correct
  hbeam%gil%convert(2,3) = voff
  hbeam%gil%proj_words = 0
  hbeam%gil%extr_words = 0
  hbeam%gil%reso_words = 0
  hbeam%gil%uvda_words = 0
  hbeam%gil%type_gdf = code_gdf_image
  !
  hbeam%char%code(1) = 'ANGLE'
  hbeam%char%code(2) = 'ANGLE'
  hbeam%char%code(3) = 'VELOCITY'
  hbeam%gil%xaxi = 1
  hbeam%gil%yaxi = 2
  hbeam%gil%faxi = 3
  hbeam%gil%majo = 0.0
  hbeam%loca%size = nx*ny*nb
  !
  ! Prepare the dirty map header
  call gdf_copy_header(hbeam,hdirty,error)
  hdirty%gil%ndim = 3
  hdirty%gil%dim(1) = nx
  hdirty%gil%dim(2) = ny
  hdirty%gil%dim(3) = nc
  hdirty%gil%dim(4) = 1
  hdirty%gil%convert(1,3) = vref-fcol+1
  hdirty%gil%convert(2,3) = voff
  hdirty%gil%convert(3,3) = vinc
  hdirty%gil%proj_words = def_proj_words
  hdirty%gil%uvda_words = 0
  hdirty%gil%type_gdf = code_gdf_image
  hdirty%char%code(1) = 'RA'
  hdirty%char%code(2) = 'DEC'
  hdirty%char%code(3) = 'VELOCITY'
  call equ_to_gal(hdirty%gil%ra,hdirty%gil%dec,0.0,0.0,   &
                  hdirty%gil%epoc,hdirty%gil%lii,hdirty%gil%bii,loff,boff,error)
  if (huv%gil%ptyp.eq.p_none) then
    hdirty%gil%ptyp = p_azimuthal  ! Azimuthal (Sin)
    hdirty%gil%pang = 0.d0     ! Defined in table.
    hdirty%gil%a0 = hdirty%gil%ra
    hdirty%gil%d0 = hdirty%gil%dec
  else
    hdirty%gil%ptyp = p_azimuthal
    hdirty%gil%pang = huv%gil%pang ! Defined in table.
    hdirty%gil%a0 = huv%gil%a0
    hdirty%gil%d0 = huv%gil%d0
  endif
  hdirty%char%syst = 'EQUATORIAL'
  hdirty%gil%xaxi = 1
  hdirty%gil%yaxi = 2
  hdirty%gil%faxi = 3
  hdirty%gil%extr_words = 0          ! extrema not computed
  hdirty%gil%reso_words = 0          ! no beam defined
  hdirty%gil%nois_words = 2
  hdirty%gil%majo = 0
  hdirty%char%unit = 'Jy/beam'
  hdirty%loca%size = nx*ny*nc
  !
  ! Smooth the beam
  hbeam%gil%convert(3,3) = vinc*ns
  hbeam%gil%vres = ns*vinc
  hbeam%gil%fres = ns*hbeam%gil%fres
  !
  error = .false.
  if (nb.gt.1) then
    !$ othread = omp_get_max_threads()
    !$ nthread = min(othread,nb)
    !$ call omp_set_num_threads(nthread)
  else
    nthread = 1
  endif
  !
  ! Loop over blocks
  !
  !$OMP PARALLEL IF (nb.gt.1) DEFAULT(none) &
  !$OMP PRIVATE(tfgrid,ftbeam,beam,w_weight,w_w) &  ! Big arrays
  !$OMP PRIVATE(w_mapu,w_mapv,w_grid) &
  !$OMP PRIVATE(local_wfft,chain) &
  !$OMP PRIVATE(local_freq,support,wall,wold,rms,uvcell,local_error) &
  !$OMP PRIVATE(kz,kb,kc,iz,ic, kz1, toto, jc,lc) &
  !$OMP SHARED(walls,ns,nb) &
  !$OMP SHARED(nu,nv,nx,ny,nc,nd,fcol,lcol,lx,ly, nthread) &
  !$OMP SHARED(map,null_taper,error) &
  !$OMP SHARED(conv,freq,do_weig, r_weight) &
  !$OMP SHARED(nn,ndim,huv,hbeam,hdirty,rname) &
  !$OMP SHARED(w_xgrid,w_ygrid,w_v,uvdata) &
  !$OMP SHARED(cpu0,cpu1) PRIVATE(elapsed_s, elapsed_e, elapsed, ithread)
  !
  kz = 1 ! test for bug below
  !
  ! Print *,'KZ ',kz,' NC ',nc,' nd ',nd
  !$OMP DO
  do ic = fcol,lcol,ns ! ,ns or ,1
    kz = min(ns,lcol-ic+1)
    jc = min(huv%gil%nchan,ic+ns/3)   ! The default weight channel here...
    !!Print *,'IC ',ic,' JC ',jc,'MCOL ',fcol,lcol,' NS ',ns
    ithread = 1
    !$ elapsed_s = omp_get_wtime()
    !$ ithread = omp_get_thread_num()+1
    !Print *,'Thread ',ithread,' IC ',ic,', KZ ',kz,', NS ',ns
    !
    kb = (ic-fcol)/ns+1
    if (kb.gt.nb .or. kb.lt.1) then
      Print *,'Programming error, expected 0 < ',kb,' < ',nb+1
      kb = nb
    endif
    !
    w_w(:) = uvdata(7+3*jc,:)
    wold = sump(nv,w_w)
    !
    ! Search for a non empty weight channel
    if (wold.eq.0) then
      do lc=ic,min(ic+ns,lcol) ! not  ,huv%gil%nchan)
        if (lc.ne.jc) then
          w_w(:) = uvdata(7+3*lc,:)
          wold = sump(nv,w_w)
          if (wold.ne.0) then
            jc = lc
            exit
          endif
        endif
      enddo
    endif
    !
    if (wold.eq.0) then
      write(chain,'(A,I6,A)') 'Channel ',jc, ' has zero weight'
      hbeam%r3d(:,:,kb) = 0
      hdirty%r3d(:,:,kb) = 0
      walls(kb) = 0.0
      if (nb.eq.1) then
        call map_message(seve%e,rname,chain)
        error = .true.
      else
        call map_message(seve%w,rname,chain)
      endif
      cycle
    else
      wall = 1e-3/sqrt(wold)
      !!write(chain,'(a,i6,a)') 'Plane ',ic,' Natural '
      !!call prnoise('UV_MAP',trim(chain),wall,rms)
      walls(kb) = wall
    endif
    !
    ! Compute the weights from this
    if (do_weig) then
      local_error = .false.
      call doweig (nu,nv,   &
         &    uvdata,   &          ! Visibilities
         &    1,2,    &            ! U, V pointers
         &    jc,     &            ! Weight channel
         &    map%uniform(1),   &  ! Uniform UV cell size
         &    w_weight,   &        ! Weight array
         &    map%uniform(2),   &  ! Fraction of weight
         &    w_v,              &  ! V values
         &    local_error)
      if (local_error)  then
        error = .true.
        cycle
      endif
  !    Print *,ic,'doweig',w_v
  !    read(5,*) toto
      !
      ! Should also plug the TAPER here, rather than in DOFFT later  !
      call dotape (nu,nv,   &
         &    uvdata,   &          ! Visibilities
         &    1,2,   &             ! U, V pointers
         &    map%taper,  &        ! Taper
         &    w_weight)            ! Weight array
         !!Print *,ic,'dotape'
    else
      call map_message(seve%i,rname,'Reusing weights')
      w_weight = r_weight
    endif
    !
    ! Re-normalize the weights and re-count the noise
    wall = sump(nv,w_weight)
    if (wall.ne.wold) then
      call scawei (nv,w_weight,w_w,wall)
      wall = 1e-3/sqrt(wall)
      !!write(chain,'(a,i6,a)') 'Plane ',ic,' Expected '
      !!call prnoise('UV_MAP',trim(chain),wall,rms)
      walls(kb) = wall
    endif
    !
    ! Then compute the Dirty Beam
    local_freq = gdf_uv_frequency(huv, dble(ic))
    uvcell = map%uvcell * (freq / local_freq)
    support = map%support * (freq / local_freq)
    call docoor (lx,-uvcell(1),w_mapu)
    call docoor (ly,uvcell(2),w_mapv)
       !!Print *,ic,'docoor'
    !
    ! Compute FFT's
    call dofft (nu,nv,          &   ! Size of visibility array
         &    uvdata,           &   ! Visibilities
         &    1,2,              &   ! U, V pointers
         &    ic,               &   ! First channel to map
         &    kz,lx,ly,         &   ! Cube size
         &    tfgrid,           &   ! FFT cube
         &    w_mapu,w_mapv,    &   ! U and V grid coordinates
         &    support,uvcell,null_taper, &  ! Gridding parameters
         &    w_weight,w_v,     &    ! Weight array + V Visibilities
         &    conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
       !!Print *,ic,'dofft'
    !
    kz1 = kz+1
    call extracs(kz1,nx,ny,kz1,tfgrid,ftbeam,lx,ly)
    call fourt  (ftbeam, nn,ndim,-1,1,local_wfft)
    beam = 0.0
    call cmtore (ftbeam, beam ,nx,ny)
    call chkfft (beam, nx,ny, error)
    !!   Print *,ic,'BEAM ',nx,ny,beam(nx/2+1,ny/2+1)
    !!Print *,'NU,NV ',nu,nv
    !!Print *,'IC ',ic
    !!Print *,'KZ,LX,LY ',kz,lx,ly
    !!Print *,'support ',support,' uvcell ',uvcell, ' null_taper ',null_taper
    !!Print *,'conv%ubias,conv%vbias,map%ctype ',conv%ubias,conv%vbias,map%ctype
    !!Print *, ' '
    if (error) then
      Print *,ic,'BEAM ',nx,ny,beam(nx/2+1,ny/2+1)
      Print *,'Local freq ',local_freq
      Print *,'KZ, LX, LY ', kz,lx,ly, ' nx,ny ',nx,ny, ' NS ',ns
      call gagout('E-UV_MAP,  Inconsistent pixel size')
!      read(5,*) ians
!      if (ians.eq.1) then
!        Print *,tfgrid(kz+1,:,ly/2)
!      endif
      cycle
    endif
    !
    ! Compute grid correction,
    ! Normalization factor is applied to grid correction, for further
    ! use on channel maps.
    !
    ! Make beam, not normalized
    call dogrid (w_grid,w_xgrid,w_ygrid,nx,ny,beam)  ! grid correction
    !
    ! Normalize and Free beam
    call docorr (beam,w_grid,nx*ny)
       !!Print *,ic,'docorr'
    !
    ! Write beam
    hbeam%r3d(:,:,kb) = beam
       !!Print *,ic,'Done Beam ',kc,nc
    ! --- Done beam
    !
    ! Now extracts the Image planes...
    do iz=1,kz
      call extracs(kz+1,nx,ny,iz,tfgrid,ftbeam,lx,ly)
      call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
      call cmtore (ftbeam,beam,nx,ny)
      call docorr (beam,w_grid,nd)
      ! Write the subset
      kc = ic-fcol+iz
      hdirty%r3d(:,:,kc) = beam
    enddo
    !
    !$  elapsed_e = omp_get_wtime()
    elapsed = elapsed_e - elapsed_s
    write(chain,103) 'End plane ',kc,' Time ',elapsed &
      & ,' Thread ',ithread
    call map_message(seve%d,rname,chain)
    if (do_weig .and. nb.eq.1) then
      do_weig = .false.
      r_weight = w_weight
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !$ if (nb.gt.1) call omp_set_num_threads(othread)
  if (error) return
  !
  call gag_cpu(cpu1)
  if (jfield.eq.0) then
    write(chain,102) 'Finished maps ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
  endif
  !
  hdirty%gil%extr_words = def_extr_words  ! extrema computed
  hdirty%gil%minloc = 1
  hdirty%gil%maxloc = 1
  hdirty%gil%minloc(1:3) = minloc(hdirty%r3d)
  hdirty%gil%maxloc(1:3) = maxloc(hdirty%r3d)
  rma = hdirty%r3d(hdirty%gil%maxloc(1),hdirty%gil%maxloc(2),hdirty%gil%maxloc(3))
  rmi = hdirty%r3d(hdirty%gil%minloc(1),hdirty%gil%minloc(2),hdirty%gil%minloc(3))
  hdirty%gil%rmax = rma
  hdirty%gil%rmin = rmi
  !
  wall = maxval(walls(1:nb))
  if (jfield.eq.0) then
    chain = 'Expected'
  else
    write(chain,'(A,I0,A)') 'Field ',jfield,'; Expected'
  endif
  call prnoise(rname,trim(chain),wall,rms)
  hdirty%gil%noise = wall
  !  !
  ! Delete scratch space
  error = .false.
  if (nb.ne.1)  deallocate(w_grid)
  if (allocated(tfgrid)) deallocate(tfgrid)
  if (allocated(ftbeam)) deallocate(ftbeam)
  if (allocated(w_xgrid)) deallocate(w_xgrid)
  if (allocated(w_ygrid)) deallocate(w_ygrid)
  !
  return
  !
101 format(a,i6,a)
102 format(a,f9.2)
103 format(a,i5,a,f9.2,a,i2,a,i2)
end subroutine many_beams_para

subroutine uv_resample_comm(line,comm,error)
  use gbl_message
  use gkernel_types
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_resample_comm
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Resample in velocity UV Tables or compress them
  !   Support for commands
  !     UV_RESAMPLE NC [Ref Val Inc] [/FILE FileIn FileOut]
  !     UV_COMPRESS NC [/FILE FileIn FileOut]
  !     UV_HANNING     [/FILE FileIn FileOut]
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  ! Command line
  character(len=*), intent(in) :: comm  ! Calling command
  logical, intent(out) :: error         ! Error flag
  !
  integer, parameter :: o_file=1
  character(len=filename_length) :: in_file, ou_file
  character(len=120) :: mess
  integer :: n
  type(gildas) :: hiuv, houv
  integer :: nblock
  integer :: nu, nv, ni, nt, nchan, nc, ier
  integer(kind=index_length)  :: ib           ! Blocked visibility counter
  integer(kind=index_length)  :: mvisi        ! Number of blocked visibilities
  integer(kind=index_length)  :: nvisi        ! Number of visibilities
  !
  if (.not.sic_present(o_file,0)) then
    call uv_resample_mem(line,comm,error)
  else
    !
    call sic_ch(line,o_file,1,in_file,n,.true.,error)
    if (error) return
    call sic_ch(line,o_file,2,ou_file,n,.true.,error)
    if (error) return
    !
    call gildas_null(hiuv,type='UVT')
    call gildas_null(houv,type='UVT')
    !
    call sic_parse_file(in_file,' ','.uvt',hiuv%file)
    call gdf_read_header(hiuv,error)
    if (error) return
    !
    call gdf_copy_header(hiuv,houv,error)
    Print *,'Input ',hiuv%gil%dim(1:2), hiuv%gil%ntrail
    call sic_parse_file(ou_file,' ','.uvt',houv%file)
    !
    call uv_resample_args(line,comm,hiuv,houv,error)
    if (error) return
    call gdf_create_image(houv,error)
    if (error) return
    !
    ! Set the Blocking Factor
    nblock = imager_nitems(hiuv,1)
    mvisi = nblock
    !
    allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),houv%r2d(houv%gil%dim(1),mvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,comm,'Memory allocation error')
      error = .true.
      return
    endif
    !
    !! Print *,'Trailings ',hiuv%gil%ntrail, houv%gil%ntrail
    call gdf_print_header(houv)
    !
    do ib=1,hiuv%gil%dim(2),mvisi
      !
      ! Read the data
      write(mess,*) ib,' / ',hiuv%gil%dim(2),mvisi
      call map_message(seve%i,comm,mess)
      hiuv%blc(2) = ib
      hiuv%trc(2) = min(hiuv%gil%dim(2),ib-1+mvisi)
      nvisi = hiuv%trc(2)-hiuv%blc(2)+1
      call gdf_read_data(hiuv,hiuv%r2d,error)
      if (error) return
      !
      ni = hiuv%gil%dim(1)
      nu = houv%gil%dim(1)
      nv = nvisi  ! Not houv%gil%dim(2)
      nt = houv%gil%ntrail
      nc = nint(real(hiuv%gil%nchan)/real(houv%gil%nchan))  ! Compression factor
      nchan = houv%gil%nchan
      !
      ! Now resample
      if (comm.eq.'UV_RESAMPLE') then
        hiuv%gil%nvisi = nvisi
        houv%gil%nvisi = nvisi
        call resample_uv (hiuv,houv,hiuv%r2d,houv%r2d,nt)
      else if (comm.eq.'UV_COMPRESS') then
        call compress_uv (houv%r2d,nu,nv,nchan,hiuv%r2d,ni,nc,nt) 
      else if (comm.eq.'UV_HANNING') then
        call hanning_uv (houv%r2d,nu,nv,nchan,hiuv%r2d,ni,nt)
      endif
      !
      houv%blc = hiuv%blc
      houv%trc = hiuv%trc
      call gdf_write_data (houv,houv%r2d,error)
      if (error) return
    enddo
    !
    deallocate(hiuv%r2d,houv%r2d)  
    call gdf_close_image(hiuv,error)
    call gdf_close_image(houv,error)
    if (error) return
    !
    call map_message(seve%i,comm,'Created '//trim(houv%file))
    !        
  endif
end subroutine uv_resample_comm
!
subroutine uv_resample_args(line,comm,hiuv,houv,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this=>uv_resample_args
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Resample in velocity UV Tables or compress them
  !   Support for commands
  !     UV_RESAMPLE NC [Ref Val Inc] [/FILE FileIn FileOut]
  !     UV_COMPRESS NC [/FILE FileIn FileOut]
  !     UV_HANNING     [/FILE FileIn FileOut]
  !
  !   Decode the arguments and fill the output header accordingly
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  ! Command line
  character(len=*), intent(in) :: comm  ! Calling command
  logical, intent(out) :: error         ! Error flag
  type(gildas), intent(in) :: hiuv
  type(gildas), intent(inout) :: houv
  !
  character(len=4) :: arg(4)
  real(8) :: convert(3), velo
  integer :: nc, na, i
  character(len=120) :: chain
  !
  if (hiuv%gil%nstokes.gt.1) then
    call map_message(seve%e,comm,'Only single polarization data supported')
    error = .true.
    return
  endif
  !
  select case (comm)
  case ('UV_RESAMPLE')
    nc = 0
    !    SIC__CH would complain if argument is too long, SIC_KE is silent
    call sic_ke(line,0,1,arg(1),na,.true.,error)
    error = .false.
    if (arg(1).ne.'*') call sic_i4(line,0,1,nc,.true.,error)
    if (error) return
    !
    ! Set default resampling in Velocity
    convert(1) = hiuv%gil%ref(1)
    convert(2) = hiuv%gil%voff
    convert(3) = hiuv%gil%vres
    ! Get new one
    do i=2,sic_narg(0)
      call sic_ke(line,0,i,arg(i),na,.false.,error)
      error = .false.
      if (arg(i).ne.'*') call sic_r8(line,0,i,convert(i-1),.false.,error)
      if (error) return
    enddo
    !
    ! Fill missing arguments
    if (nc.eq.0) then
      nc = nint(abs(hiuv%gil%nchan*hiuv%gil%vres/convert(3)))
      if (arg(2).eq.'*') then
        ! Keep the middle channel in the middle
        velo = (0.5d0*hiuv%gil%nchan-hiuv%gil%ref(1))*hiuv%gil%vres + hiuv%gil%voff
        convert(1) = 0.5d0*nc - (velo-convert(2))/convert(3)
      endif
    endif
    !
    call getuv_conversion(houv,nc,convert)
    !
  case ('UV_COMPRESS') 
    call sic_i4(line,0,1,nc,.true.,error)
    if (error) return
    if (nc.gt.hiuv%gil%nchan) nc = hiuv%gil%nchan
    write(chain,'(A,I6,A)') 'Averaging by chunks of ',nc,' channels'
    call map_message(seve%i,comm,chain)
    houv%gil%inc(1) = houv%gil%inc(1)*nc
    houv%gil%ref(1) = (2.0d0*houv%gil%ref(1)+nc-1.0)/(2*nc)
    houv%gil%vres = nc*houv%gil%vres
    houv%gil%fres = nc*houv%gil%fres
    ! Change the number of channels
    houv%gil%nchan = houv%gil%nchan/nc
  case ('UV_HANNING')
    ! Drop the edge channels
    houv%gil%ref(1) = houv%gil%ref(1)+1
    houv%gil%nchan = houv%gil%nchan-2
  case default
    call map_message(seve%e,comm,'Unrecognized choice '//comm)
    error = .true.
    return
  end select
  !
  ! Work with complete structure
  houv%gil%dim(1) = 3*houv%gil%nchan + 7 + houv%gil%ntrail ! and nothing more ...
  if (houv%gil%ntrail.ne.0) then
    do i=1,code_uvt_last
      if (houv%gil%column_pointer(i).gt.houv%gil%lcol)  &
        houv%gil%column_pointer(i) =  houv%gil%column_pointer(i) + houv%gil%dim(1) - hiuv%gil%dim(1)
    enddo
  endif
end subroutine uv_resample_args
!
subroutine uv_resample_mem(line,comm,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_resample_mem
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Resample in velocity the UV Table or compress it
  !   Support for commands
  !     UV_RESAMPLE NC [Ref Val Inc] 
  !     UV_COMPRESS [NC] 
  !     UV_HANNING     
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  ! Command line
  character(len=*), intent(in) :: comm  ! Calling command
  logical, intent(out) :: error         ! Error flag
  !
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  character(len=80) :: chain
  character(len=4) :: arg(4)
  real(8) :: convert(3), velo
  integer :: nt, nc, nchan, na
  type (gildas) :: uvout
  integer :: nu, nv, ni, i
  !
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,comm,'No UV data loaded')
    error = .true.
    return
  endif
  if (huv%gil%nstokes.gt.1) then
    call map_message(seve%e,comm,'Only single polarization data supported')
    error = .true.
    return
  endif
  !
  error = .false.
  ! No argument: get back to the original UV data
  if ((sic_narg(0).eq.0).and.(comm.ne.'UV_HANNING')) then
    call uv_reset_buffer(comm)
    call map_uvgildas('UV',huv,error,duv)
    do_weig = .true.
    return
  endif
  !
  ! Compute the Frequency Conversion from the Velocity Conversion
  call gildas_null(uvout, type = 'UVT')
  call gdf_copy_header(huv,uvout,error)
  !
  if (comm.eq.'UV_RESAMPLE') then
    nc = 0
    !    SIC__CH would complain if argument is too long, SIC_KE is silent
    call sic_ke(line,0,1,arg(1),na,.true.,error)
    error = .false.
    if (arg(1).ne.'*') call sic_i4(line,0,1,nc,.true.,error)
    if (error) return
    !
    ! Set default resampling in Velocity
    convert(1) = huv%gil%ref(1)
    convert(2) = huv%gil%voff
    convert(3) = huv%gil%vres
    ! Get new one
    do i=2,sic_narg(0)
      call sic_ke(line,0,i,arg(i),na,.false.,error)
      error = .false.
      if (arg(i).ne.'*') call sic_r8(line,0,i,convert(i-1),.false.,error)
      if (error) return
    enddo
    !
    ! Fill missing arguments
    if (nc.eq.0) then
      nc = nint(abs(huv%gil%nchan*huv%gil%vres/convert(3)))
      if (arg(2).eq.'*') then
        ! Keep the middle channel in the middle
        velo = (0.5d0*huv%gil%nchan-huv%gil%ref(1))*huv%gil%vres + huv%gil%voff
        convert(1) = 0.5d0*nc - (velo-convert(2))/convert(3)
      endif
    endif
    !
    call getuv_conversion(uvout,nc,convert)
    !
  else if (comm.eq.'UV_COMPRESS') then
    call sic_i4(line,0,1,nc,.true.,error)
    if (error) return
    if (nc.gt.huv%gil%nchan) nc = huv%gil%nchan
    write(chain,'(A,I6,A)') 'Averaging by chunks of ',nc,' channels'
    call map_message(seve%i,comm,chain)
    uvout%gil%inc(1) = uvout%gil%inc(1)*nc
    uvout%gil%ref(1) = (2.0d0*uvout%gil%ref(1)+nc-1.0)/(2*nc)
    uvout%gil%vres = nc*uvout%gil%vres
    uvout%gil%fres = nc*uvout%gil%fres
    ! Change the number of channels
    uvout%gil%nchan = uvout%gil%nchan/nc
  else if (comm.eq.'UV_HANNING') then
    ! Drop the edge channels
    uvout%gil%ref(1) = uvout%gil%ref(1)+1
    uvout%gil%nchan = uvout%gil%nchan-2
    continue
  else
    call map_message(seve%e,comm,'Unrecognized choice '//comm)
    error = .true.
    return
  endif
  !
  ! Work with complete structure
  uvout%gil%dim(1) = 3*uvout%gil%nchan + 7 + uvout%gil%ntrail ! and nothing more ...
  if (uvout%gil%ntrail.ne.0) then
    do i=1,code_uvt_last
      if (uvout%gil%column_pointer(i).gt.uvout%gil%lcol) uvout%gil%column_pointer(i) =  &
        & uvout%gil%column_pointer(i) + uvout%gil%dim(1) - huv%gil%dim(1)
    enddo
  endif
  !
  ni = huv%gil%dim(1)
  nu = uvout%gil%dim(1)
  nv = uvout%gil%dim(2)
  nt = uvout%gil%ntrail
  nchan = uvout%gil%nchan
  !
  ! Prepare appropriate array...
  nullify (duv_previous, duv_next)
  call uv_find_buffers (comm,nu,nv,duv_previous, duv_next,error)
  if (error) then
    call map_message(seve%e,comm,'Cannot set buffer pointers')
    return
  endif
  !
  ! Now resample
  if (comm.eq.'UV_RESAMPLE') then
    call resample_uv (huv,uvout,duv_previous,duv_next,nt)
  else if (comm.eq.'UV_COMPRESS') then
    call compress_uv (duv_next,nu,nv,nchan,duv_previous,ni,nc,nt)
  else if (comm.eq.'UV_HANNING') then
    call hanning_uv (duv_next,nu,nv,nchan,duv_previous,ni,nt)
  endif
  !
  ! Set header
  call gdf_copy_header(uvout,huv,error)
  !
  ! Reset proper pointers
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  !
  ! Indicate UV data has changed, and weight must be computed
  call uv_new_data(weight=.true.)
end subroutine uv_resample_mem
!
subroutine hanning_uv (duvout, nu, nv, nchan, duvin, ni, ntrail) 
  use gildas_def
  ! @ private
  integer, intent(in) :: nu           ! Ouput Visibility size
  integer, intent(in) :: nv           ! Number of visibilities
  integer, intent(in) :: nchan        ! Number of ouput channels
  integer, intent(in) :: ntrail       ! Trailing columns
  integer, intent(in) :: ni           ! Input Visibility size
  real, intent(in) :: duvin(ni,nv)    ! Input visibilities
  real, intent(out) :: duvout(nu,nv)  ! Output visibilities
  ! Local
  integer :: nlead
  integer :: i,j,k,kk
  real :: a,b,c,w(3),r
  data w/0.5,1.0,0.5/
  !
  nlead = 7
  !
  duvout = 0
  !
  do j=1,nv
    duvout (1:nlead,j) =  duvin (1:nlead,j)  
    do i=1,nchan
      a = 0
      b = 0
      c = 0
      do k=1,3
        kk = nlead+3*(i+k-1)  ! i=1, k=1, ==> kk=10
        if (duvin(kk,j).ne.0) then
          r = duvin(kk,j)*w(k)
          a = a+duvin(kk-2,j)*r
          b = b+duvin(kk-1,j)*r
          c = c+r
        endif
      enddo
      kk = nlead+3*i-2  ! i=1 ==> kk=8
      if (c.ne.0) then
        duvout(kk,j) = a/c
        duvout(kk+1,j) = b/c
        duvout(kk+2,j) = c         ! time*band
      else
        duvout(kk,j) = 0
        duvout(kk+1,j) = 0
        duvout(kk+2,j) = 0
      endif
    enddo
    if (ntrail.gt.0) then
      duvout(nu-ntrail+1:nu,j) = duvin(ni-ntrail+1:ni,j)
    endif
  enddo
end subroutine hanning_uv

subroutine catalog_comm(line,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! IMAGER
  !
  !   List or define Spectral Line Data Base(s)
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical :: error
  !
  character(len=*), parameter :: rname='CATALOG'
  character(len=1), parameter :: question_mark='?'
  !
  character(len=filename_length) :: line_comm = ' '
  character(len=filename_length) :: chain, file
  logical :: found
  character*16 :: check
  integer :: lt,i,j,narg,nc
  ! This duplicates the list in LINEDB Python code, but
  ! is unavoidable to check proper Data Base existence
  integer, parameter :: monline=4
  character*12 :: onlines(monline)
  data onlines /'voparis', 'cdms', 'jpl', 'splatalogue'/ !! camvamdc, cdmsvamdc
  !
  error = .false.
  !
  ! Normal code
  narg = sic_narg(0)
  if (narg.le.1) then
    chain = '?'
    call sic_ch(line,0,1,chain,nc,.false.,error)
    if (error) return
    if (chain(1:1).eq.question_mark) then
      call exec_program('@ catalog ?')
      return
    endif
  endif
  !
  ! Note the LowerCase for the "in" argument
  line_comm = 'LINEDB\USE in '
  lt = 15
  !
  do i=1,narg
    call sic_ch(line,0,1,chain,nc,.false.,error)
    !
    check = chain
    call sic_lower(check)
    found = .false.
    do j=1,monline
      if (check.eq.onlines(j)) then
        found = .true.
        exit
      endif
    enddo
    !
    if (found) then
      line_comm(lt:) = check
      lt = lt+len_trim(check)
    else
      ! If it is not one of the on-line databases, it can be a local
      ! file. Locate it
      found = sic_findfile(chain,file,' ','.linedb')
      !
      if (found) then
        chain  = '"'//trim(file)//'"'   ! Python LINEDB\USE does not parse anything else
        line_comm(lt:) = chain
        lt = lt+len_trim(chain)
      else
        call message_colour(3)
        call map_message(seve%w,rname,'No such line catalog '//chain)
        call message_colour(-1)
      endif
    endif
  enddo
  !
  ! Execute the LINEDB\USE IN command if needed
  if (lt.gt.15) call exec_program(line_comm(1:lt))
  !
end subroutine catalog_comm    
!
subroutine catalog_init
  use gkernel_interfaces
  !
  character(len=filename_length) :: line_comm = ' '
  character(len=filename_length) :: chain, file
  logical :: found
  ! Initialization patch until  "USE in" command is debugged 
  ! (currently not working in Procedures)
  chain = "~/imager"
  found = sic_findfile(chain,file,' ','.linedb')
  if (.not.found) then
    chain = "imager"
    found = sic_findfile(chain,file,'gag_data:','.linedb')
  endif  
  if (found) then
    line_comm = 'LINEDB\USE in "'//trim(file)//'"'
    call exec_program(line_comm)
  endif
end subroutine catalog_init

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the MAPPING package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mapping_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !
  type(gpack_info_t), intent(out) :: pack
  !
  external :: mapping_pack_init
  external :: mapping_pack_on_exit
  !
  pack%name='mapping'
  pack%ext = '.map'
  pack%depend(1:1) = (/ locwrd(greg_pack_set) /)
  pack%init=locwrd(mapping_pack_init)
  pack%on_exit=locwrd(mapping_pack_on_exit)
  pack%authors="J.Pety, S.Guilloteau, F.Gueth, N.Rodriguez-Fernandez"
  !
end subroutine mapping_pack_set
!
subroutine mapping_pack_init(gpack_id,error)
  use gkernel_interfaces
  use sic_def
  !----------------------------------------------------------------------
  !
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  !
  ! Local language
  call init_clean
  !
  ! One time initialization
  call map_message_set_id(gpack_id)  ! Set library id
  !
  ! Language priorities
  call exec_program('SIC'//backslash//'SIC PRIORITY 1 CLEAN')
  !
  ! Specific initializations
  !
end subroutine mapping_pack_init
!
subroutine mapping_pack_on_exit(error)
  !----------------------------------------------------------------------
  !
  !----------------------------------------------------------------------
  logical :: error
  !
  call save_result(error)
  !
end subroutine mapping_pack_on_exit
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine uvfit_comm(line,error)
  use gkernel_interfaces
  use gbl_message
  use clean_default
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support for command UV_FIT [Func1 ... FuncN] [/WIDGET Nfunc] 
  !     [/SAVE File]
  !---------------------------------------------------------------------
  !
  character(len=*), intent(inout) :: line
  logical, intent(inout) :: error
  !
  integer :: nf, nline, in, nc
  logical :: verbose, do_insert
  integer, parameter :: o_quiet=1
  integer, parameter :: o_save=2
  integer, parameter :: o_widget=3
  character(len=32) :: chain,comm
  character(len=*), parameter :: rname='UV_FIT'
  character(len=filename_length) :: fich
  !
  ! Create the Widget if option is mentionned
  in = index(line,'UV_FIT')+7
  chain = "@ x_uvfit "//line(in:)
  verbose = .not.sic_present(o_quiet,0)
  !
  error =.false.
  if (sic_present(o_save,0)) then
    do_insert = .false. ! To be checked
    call sic_ch(line,o_save,1,fich,nc,.true.,error)
    if (error) return
    !
    call exec_program('@ s_uvfit '//fich(1:nc))
  else if (sic_present(o_widget,0)) then
    do_insert = (sic_lire().eq.0)
    call sic_i4(line,o_widget,1,nf,.true.,error)
    if (error) return
    if (nf.lt.1 .or. nf.gt.4) then
      call map_message(seve%e,rname,'1 to 4 functions possible')
      error = .true.
      return
    endif
    call exec_program(chain)
  else if (sic_narg(0).ne.0) then
    do_insert = (sic_lire().eq.0) 
    call exec_program(chain)
    call sic_get_inte('UVF%NF',nf,error)
    comm = 'UV_FIT'
    nline = len_trim(line)
    call sic_analyse(comm,line,nline,error)
    call uvfit_sub(line,verbose,error)
  else
    do_insert = (sic_lire().eq.0) 
    call uvfit_sub(line,verbose,error)
  endif
  !
  if (error) return
  last_resid = 'UV_FIT'
  if (do_insert) call sic_insert_log(line)
end subroutine uvfit_comm
!
subroutine uvfit_sub(line,verbose,error)
  use gkernel_interfaces
  use gkernel_types
  use image_def
  use gbl_format
  use gbl_message
  use uvfit_data
  !
  use clean_def
  use clean_arrays
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support for command UV_FIT 
  !
  !   The functions have been defined previously by subroutine uvfit_comm
  !---------------------------------------------------------------------
  !---------------------------------------------------------------------
  !     Re-written with Fortran-90 interfaces
  !     on June 30 S.Guilloteau
  !---------------------------------------------------------------------
  !
  character(len=*), intent(in) :: line
  logical, intent(in) :: verbose
  logical, intent(inout) :: error
  !
  ! Local
  integer, allocatable :: iw(:)
  real(8), allocatable :: fvec(:), wa(:), r(:,:)
  real(8), allocatable :: wa1(:), wa2(:), wa3(:), wa4(:)
  integer :: sever
  logical :: warning, report
  !
  !
  real(8) :: xx, yy, xa, xd
  real(8), parameter :: pi = 3.14159265358979323846d0
  real(8), parameter :: clight = 299792458.d-6   ! in meter.mhz
  integer :: j, js, jsmin, lwa, ldr
  integer :: np2, nc
  integer :: n1, l, js1, if1, nvpar, npstart, kstart, ndata,  kc
  integer :: iii, k, i, ki, ic(2), nch, ncol
  integer :: iopt, nprint, info
  integer, parameter :: mstart=1000
  real :: par0(mpar), range(mpar), fact, vit
  real :: uv_range(2), uv_min, uv_max
  real(8) :: parin(mpar,mstart), par2(mpar,mstart), parstep(mpar)
  real(8) :: parout(mpar,mstart), fsumsq, cj(mpar)
  real(8) :: fsumin, epar(mpar), rms, tol, denorm, factor, fluxfactor
  character(len=8) :: fluxunit
  integer, parameter :: mfunc=11
  integer :: mpfunc(mfunc), nstartf(mf,mfunc)
  real :: parf(mf,mfunc), rangef(mf,mfunc)
  character(len=8) :: cf, ccf, cfunc(mfunc), ccpar(mpin,mfunc)
  character(len=20) :: ch
  character(len=20) :: cpar(mpar),errmess
  character(len=80) :: resu, chpar, chain
  character(len=15) :: chpos1
  character(len=15) :: chpos2
  external :: fitfcn
  integer :: ier, nvs
  type(projection_t) :: proj
  !
  data cfunc/'POINT','E_GAUSS','C_GAUSS','C_DISK','RING','EXPO',   &
     &    'POWER-2','POWER-3','E_DISK','U_RING','E_RING'/
  data ccpar/'R.A.','DEC.','FLUX','    ','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','Major','Minor','Pos.Ang.',' ',   &
     &    'R.A.','Dec.','Flux','F.W.H.P.','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','Diam.','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','I.Diam.','O.Diam.','    ',' ',   &
     &    'R.A.','Dec.','Flux','F.W.H.P.','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','F.W.H.P.','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','F.W.H.P.','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','Major','Minor','Pos.Ang.',' ',   &
     &    'R.A.','Dec.','Flux','Radius','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','Outer','Inner','Pos.Ang.','Ratio'/
  data mpfunc /3,6,4,4,5,4,4,4,6,4,7/
  !
  character(len=*), parameter :: Version='Version 2.2 25-Mar-2019 S.Guilloteau'
  character(len=*), parameter :: rname='UV_FIT'
  !
  !-----------------------------------------------------------------------
  !
  call xsetf(0)
  call sic_get_inte('UVF%NF',nf,error)
  do j=1,nf
    write(ch,'(a,i0,a)') 'UVF%PAR',j,'%RESULTS'
    call sic_delvariable(ch,.false.,error)
    write(ch,'(a,i0,a)') 'UVF%PAR',j,'%ERRORS'
    call sic_delvariable(ch,.false.,error)
  enddo
  error = .false.
  warning = .false.
  !     Code:
  !
  ic = 0
  !
  !     2 Additional parameters to use specific uv range.
  uv_range = 0
  uv_min = uv_range(1)
  uv_max = uv_range(2)
  call map_message(seve%i,rname,version)
  if (uv_min.ne.0 .or. uv_max.ne.0) then
    write(chain,*) 'UV data from ',uv_min,   &
     &      ' to ',uv_max,' m.'
    call map_message(seve%i,rname,chain)
  endif
  !
  ! Decode the Initial parameter values from command line
  nf = sic_narg(0)
  if (nf.eq.0) then
    call sic_get_inte('UVF%NF',nf,error)
  else if (nf.ne.1) then
    ! NAME + 7 parameters for each source model
    do i=1,nf/8
      ! Function name
      write(ch,'(a,i0,a)') 'UVF%PAR',i,'%NAME'
      call sic_ch(line,0,i,cf,nch,.false.,error)
      if (.not.error) call sic_let_char(ch,cf,error)
      do j=1,mpin
        write(ch,'(a,i0,a,i0,a)') 'UVF%PAR',i,'%PAR[',j,']'
        call sic_r4(line,0,j+1,parf(j,1),.false.,error)
        if (error) return
        call sic_let_real(ch,parf(j,i),error)
      enddo
    enddo
    nf = nf/8
  endif
  !
  ! The limit 4 could be increased if needed up to 10
  if (nf.lt.1 .or. nf.gt.4) then
    call map_message(seve%e,rname,'1 to 4 functions possible')
    error = .true.
    return
  endif
  !
  k = 0
  !
  ! Scan all function parameters
  do i=1, nf
    write(ch,'(a,i0,a)') 'UVF%PAR',i,'%NAME'
    call sic_get_char(ch,cf,nch,error)
    if (error) then
      chain = 'No such variable '//trim(ch)  
      call map_message(seve%e,rname,chain)
      return
    endif
    !
    call sic_ch(line,0,i,cf,nch,.false.,error)
    if (.not.error) call sic_let_char(ch,cf,error)
    call sic_upper(cf)
    call sic_ambigs('FIT',cf,ccf,ifunc(i),cfunc,mfunc,error)
    if (error) then
      call map_message(seve%e,rname,'Invalid function '//cf)
      return      
    endif
    !
    ! Parameters
    do j=1,mpin
      write(ch,'(a,i0,a,i0,a)') 'UVF%PAR',i,'%PAR[',j,']'
      call sic_get_real(ch,parf(j,i),error)
      if (error) then
        chain = 'Error reading variable '//trim(ch)  
        call map_message(seve%e,rname,chain)
        return
      endif
    enddo
    !
    ! Ranges
    do j=1,mpin
      write(ch,'(a,i0,a,i0,a)') 'UVF%PAR',i,'%RANGE[',j,']'
      call sic_get_real(ch,rangef(j,i),error)
      if (error) then
        chain = 'Error reading variable '//trim(ch)  
        call map_message(seve%e,rname,chain)
        return
      endif
    enddo
    !
    ! Number of starts
    !     start=-1 means fixed parameter.
    do j=1,mpin
      write(ch,'(a,i0,a,i0,a)') 'UVF%PAR',i,'%START[',j,']'
      call sic_get_inte(ch,nstartf(j,i),error)
      if (error) then
        chain = 'Error reading variable '//trim(ch)  
        call map_message(seve%e,rname,chain)
        return
      endif
    enddo
    !
    ! Put them in place
    npfunc(i) = mpfunc(ifunc(i))
    do j=1, npfunc(i)
      k = k + 1
      par0(k) = parf(j,i)
      range(k) = rangef(j,i)
      nstart(k) = nstartf(j,i)
      cpar(k) = ccf//' '//ccpar(j,ifunc(i))
    enddo
    !
    !     Additional option used to subtract model functions.
    ! Should not be needed in this model, since UV_RESIDUAL
    ! can do the job afterwards
    write(ch,'(a,i0,a)') 'UVF%PAR',i,'%SUBTRACT'
    call sic_get_logi(ch,savef(i),error)
    if (error) then
      savef(i) = .false.
      error = .false.
    endif
  enddo
  !
  npar = k
  resu = ' '
  !
  !     Create array of starting values
  npstart = 1
  do i=1, npar
    if (nstart(i).gt.1) then
      n1 = nstart(i)-1
      parstep(i) = range(i)/n1
      parin(i,1) = par0(i)-0.5*parstep(i)*n1
    else
      parin(i,1) = par0(i)
    endif
  enddo
  do i=1, npar
    if (nstart(i).gt.1) then
      kstart = npstart
      do j=1, nstart(i)-1
        do k=kstart+1,kstart+npstart
          do l=1, npar
            parin(l,k)= parin(l,k-npstart)
          enddo
          parin(i,k) = parin(i,k-npstart)+parstep(i)
        enddo
        kstart = kstart+npstart
      enddo
      npstart = kstart
    endif
  enddo
  !
  !     Load input UV Table (HUV -- DUV)
  !
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data')
    error = .true.
    return
  endif
  !
  error = .true.
  !
  ndata = huv%gil%dim(2)
  ier = gdf_range(ic, huv%gil%nchan)
  nc = huv%gil%nchan
  !
  np2 = 2*ndata                ! max. data points
  lwa = npar*(np2+5)+np2
  !
  ! For DNLS1E and DCOV
  ier = 0
  allocate (fvec(np2),wa(lwa),r(np2,npar),iw(npar),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'FVEC allocation error')
    error = .true.
    return
  endif
  !
  ! For DCOV only
  allocate(wa1(npar),wa2(npar),wa3(npar),wa4(np2),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'DCOV allocation error')
    error = .true.
    return
  endif
  !
  !     Create table of fitted results huvfit - duvfit
  call gildas_null (huvfit, type = 'TABLE')
  call gdf_copy_header(huv,huvfit,error)
  huvfit%gil%bval = 0 ! Trial
  huvfit%gil%eval = 0 ! Trial
  !
  huvfit%char%code(2) = 'uv-fit'
  huvfit%char%code(1) = 'freq'
  huvfit%gil%dim(1) = nc
  huvfit%gil%dim(2) = 4 + nf*(3+2*mpin)
  huvfit%gil%val(2) = 0.
  if (allocated(duvfit)) then
    deallocate(duvfit)
    call sic_delvariable('UV_FIT',.false.,error)
    error = .false.
  endif
  !
  allocate (duvfit(huvfit%gil%dim(1),huvfit%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate Fit table')
    error = .true.
    return
  endif
  duvfit = 0.0
  !
  !     Loop on channels
  nvs = huv%gil%dim(1)
  !
  allocate (uvriw(5,ndata),stat=ier)
  !
  report = .not.verbose
  report = report .and. ((ic(2)-ic(1)).gt.15)
  do kc = ic(1),ic(2)
    if (sic_ctrlc()) then
      call map_message(seve%w,rname,'Aborted by ^C')
      error = .true.
      return
    endif
    if (report) then
      if (kc.eq.ic(1)+(ic(2)-ic(1))/4) then
        call map_message(seve%i,rname,'25 % done ')
      else if (kc.eq.ic(1)+(ic(2)-ic(1))/2) then
        call map_message(seve%i,rname,'50 % done ')
      else if (kc.eq.ic(1)+(ic(2)-ic(1))*3/4) then
        call map_message(seve%i,rname,'75 % done ')
      endif
    endif
    !
    ! Load (U,V) in arcsec**-1, compute observing frequency for channel KC
    fact = gdf_uv_frequency(huv,dble(kc)) / clight * pi/180.d0/3600d0
    call load_data(ndata,nvs,kc,fact,duv,npuvfit,uvriw,uv_min,uv_max)
    if (verbose) then
      if (npuvfit.eq.0) then
        write(chain,'(A,I0)') 'No data for channel ', kc
        call map_message(seve%w,rname,chain)
        cycle
      else
        write(chain,'(I0,A,I0)') npuvfit,' data points for channel ', kc
        call map_message(seve%i,rname,chain)
      endif
    endif
    !
    np2 = 2*npuvfit
    vit = huv%gil%voff+(kc-huv%gil%ref(1))*huv%gil%vres
    !
    fsumin = 1d20
    !
    do js=1, npstart
      !     Get only variable parameters:
      nvpar = 0
      do i=1, npar
        if (nstart(i).ge.0) then
          nvpar = nvpar+1
          par2(nvpar,js)=parin(i,js)
        endif
        pars(i) = parin(i,js)
      enddo
      if (verbose) then
        if (nvpar.eq.0) then
          call map_message(seve%i,rname,'No free parameter, using input values')
          jsmin = 1
          exit
        endif
        write(6,'(a,5(1pg12.5))') 'I-UV_FIT, Starting from ',   &
       &        (par2(iii,js),iii=1, nvpar)
      endif
      !
      iopt = 2        ! Supply full Jacobian
      !     iopt = 1  !! or only Function (test mode)
      tol = 1d-8
      nprint = 0
      call dnls1e (fitfcn, iopt, np2, nvpar, par2(1,js),   &
     &        fvec, tol, nprint, info,   &
     &        iw, wa, lwa)
      !
      if (verbose) then
        sever = 0
        if (info.eq.0) then
          write(chain,'(A,I0)') 'Improper input parameters, info= ',   &
       &          info
          sever = seve%e
        elseif (info.eq.6 .or. info.eq.7) then
          write(chain,'(A,I0)') 'TOL too small, info= ',info
          sever = seve%e
        elseif (info.eq.5) then
          write(chain,'(A,I0)') 'Not converging, info= ',info
          sever = seve%e
        elseif (info.eq.4) then
          write(chain,'(A,I0)') 'FVEC orthog. to Jacob. col., info= ',   &
       &          info
          sever = seve%w
        endif
        if (sever.ne.0) then
          call map_message(sever,'DNLS1E',chain)
          warning = .true.
        endif
      else
        if (info.eq.0 .or. (info.ge.4.and.info.le.7)) warning = .true.
      endif
      fsumsq  = denorm(np2, fvec)
      !
      if (fsumsq.lt.fsumin) then
        fsumin = fsumsq
        jsmin = js
      endif
      js1 = js
    enddo
    !
    ! Fit if needed
    if (nvpar.gt.0) then
      if (jsmin.ne.js1) then
        nprint = 0
        call dnls1e (fitfcn, iopt, np2, nvpar, par2(1,jsmin),   &
       &        fvec, tol, nprint, info,   &
       &        iw, wa, lwa)
        if (verbose) then
          sever = 0
          if (info.eq.0) then
            write(chain,'(A,I0)') 'Improper input parameters, info= ',   &
         &          info
            sever = seve%e
          elseif (info.eq.6 .or. info.eq.7) then
            write(chain,'(A,I0)') 'TOL too small, info= ',info
            sever = seve%e
          elseif (info.eq.5) then
            write(chain,'(A,I0)') 'Not converging, info= ',info
            sever = seve%e
          elseif (info.eq.4) then
            write(chain,'(A,I0)') 'FVEC orthog. to Jacob. col., info= ',   &
         &          info
            sever = seve%w
          endif
          if (sever.ne.0) then
            call map_message(sever,'DNLS1E',chain)
            warning = .true.
          endif
        else
          if (info.eq.0 .or. (info.ge.4.and.info.le.7)) warning = .true.
        endif
        fsumsq  = denorm(np2, fvec)
      endif
      ldr = np2
      call dcov (fitfcn, iopt, np2, nvpar, par2(1,jsmin),   &
       &      fvec, r, ldr, info,   &
       &      wa1, wa2, wa3, wa4)
      if (verbose) then
        if (info.eq.0) then
          write(chain,'(A,I0)') 'improper input parameters, info= ',info
          call map_message(seve%e,'DCOV',chain)
        elseif (info.eq.2) then
          write(chain,'(A,I0)') 'Jacobian singular, info= ',info
          call map_message(seve%w,'DCOV',chain)
          warning = .true.
        endif
      else
        if (info.eq.2) warning = .true.
      endif
      !
      !     extract the diagonal of r
      call diagonal(np2,nvpar,r,cj)
      rms = fsumsq*dsqrt(np2*1d0)
      if (verbose) then
        write(chain,'(a,f10.4,a)') ' r.m.s.= ',rms,' Jy.'
        call map_message(seve%i,rname,chain)
      endif
      if1 = info
    endif
    !
    k = 0
    do i=1, npar
      if (nstart(i).ge.0) then
        k = k+1
        parout(i,jsmin) = par2(k,jsmin)
      else
        parout(i,jsmin) = pars(i)
      endif
    enddo
    !
    k = 1
    do j=1, nf
      call outpar(ifunc(j),npfunc(j),parout(k,jsmin))
      k = k + npfunc(j)
    enddo
    k = 0
    ki = 0
    call gwcs_projec(huv%gil%a0,huv%gil%d0,huv%gil%pang,huv%gil%ptyp,proj,error)
    !
    if (verbose) then
      do j=1, nf
        ! Ra/Dec absolute coordinates (1st and 2nd parameters)
        xx = parout(ki+1,jsmin)*pi/180d0/3600d0
        yy = parout(ki+2,jsmin)*pi/180d0/3600d0
        call rel_to_abs(proj,xx,yy,xa,xd,1)
        call rad2sexa(xa,24,chpos1)
        call rad2sexa(xd,360,chpos2)
        ! Flux in best units (3rd parameter)
        if (abs(parout(ki+3,jsmin)).ge.1.d0) then
          fluxfactor = 1.d0
          fluxunit = 'Jy'
        elseif (abs(parout(ki+3,jsmin)).ge.1.d-3) then
          fluxfactor = 1.d3
          fluxunit = 'milliJy'  ! or 'mJy' ?
        else
          fluxfactor = 1.d6
          fluxunit = 'microJy'  ! or 'uJy' ?
        endif
        do i=1, npfunc(j)
          ki = ki+1
          if (i.eq.3) then
            factor = fluxfactor
          else
            factor = 1.d0
          endif
          if (nstart(ki).ge.0) then
            k = k+1
            epar(ki) = sqrt(abs(cj(k)))
            write(errmess,'(f0.5)',iostat=ier)  epar(ki)*factor ! Error can be larger than "999.99999"
            write(chpar,'(2a,f11.5,a,a,a)')  &
              cpar(ki), ' = ',parout(ki,jsmin)*factor,' (',adjustr(errmess(1:9)),')'
          else
            epar(ki) = 0.
            write(chpar,'(2a,f11.5,a)')  &
              cpar(ki), ' = ', parout(ki,jsmin)*factor,' (  fixed  )'
          endif
          nch = len_trim(chpar)
          if (i.eq.1) then
            write(6,*) chpar(1:nch)//'  '//chpos1
          elseif (i.eq.2) then
            write(6,*) chpar(1:nch)//' '//chpos2
          elseif (i.eq.3) then
            write(6,*) chpar(1:nch)//'  '//fluxunit
          else
            write(6,*) chpar(1:nch)
          endif
        enddo
      enddo
    else
      !
      ! Only computes the errors
      do j=1, nf
        do i=1, npfunc(j)
          ki = ki+1
          if (nstart(ki).ge.0) then
            k = k+1
            epar(ki) = sqrt(abs(cj(k)))
          else
            epar(ki) = 0.
          endif
        enddo
      enddo    
      !
    endif
    !
    ncol = huvfit%gil%dim(2)
    call outfit(nc,kc,ncol,duvfit,rms,vit,npar,parout(1,jsmin),epar)
    !
  enddo
  !
  ! Return results in UVF%PARi%RESULT and UVF%PARi%ERRORS if
  ! only one Channel
  if (nc.eq.1) then
    k = 0
    ki = 0
    do j=1,nf
      do i=1, npfunc(j)
        ki = ki+1
        uvf_errors(i,j) = epar(ki)
        uvf_results(i,j) = parout(ki,jsmin)
      enddo
      write(ch,'(a,i0,a)') 'UVF%PAR',j,'%RESULTS'
      call sic_def_real(ch,uvf_results(1,j),1,mpin,.true.,error)
      write(ch,'(a,i0,a)') 'UVF%PAR',j,'%ERRORS'
      call sic_def_real(ch,uvf_errors(1,j),1,mpin,.true.,error)
    enddo
  endif
  !
  if (len_trim(resu).gt.0) then
    call sic_parsef(resu,huvfit%file,' ','.uvfit')
    call map_message(seve%i,rname,'Creating fit table '//   &
       &    trim(huvfit%file) )
    call gdf_write_image(huvfit,duvfit,error)
  endif
  if (warning) then
    call message_colour(1)
    call map_message(seve%w,rname,'Completed with possible errors')
    call message_colour(-1)
  else
    call message_colour(2)
    call map_message(seve%i,rname,'Successful completion')
    call message_colour(-1)
  endif
  !
  call sic_mapgildas('UV_FIT',huvfit,error,duvfit)
end subroutine uvfit_sub
!
subroutine uvfit_residual(line,error)
  use clean_def
  use clean_arrays
  use uvfit_data
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support for command UV_RESIDUAL after a UV_FIT function  !
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='UV_RESIDUAL'
  character(len=80) :: chain
  integer :: nvt, nvs, i, if, nc, ndata, ier, ic(2), narg
  !
  error = .false.
  narg = sic_narg(0)
  if (narg.eq.0) then
    savef(1:nf) = .true.
  else
    savef(1:nf) = .false.
    do i=1,narg
      call sic_i4(line,0,i,if,.true.,error)
      if (if.gt.0 .and. if.le.nf) then
        savef(if) = .true.
      else
        write(chain,'(A,I0,A,I0,A,I0)') 'Argument #',i,' (',if,') out of boud [0,',nf,']'
        call message_colour(1)
        call map_message(seve%e,rname,chain)
        error = .true.
      endif
    enddo
    if (error) then
      call message_colour(-1)
      return
    endif
    if (.not.any(savef)) then
      call message_colour(4)
      call map_message(seve%w,rname,'Nothing to subtract')
      call message_colour(-1)
      return
    endif
  endif
  !
  ! Subtract using DUV as work space... Not standard yet
  ic = [0,0]
  ier = gdf_range(ic, huv%gil%nchan)    ! Where is that range ?
  nvt = huvfit%gil%dim(2)               ! Number of fitted parameters
  ndata = huv%gil%nvisi                 ! Number of visibilities
  nc = huv%gil%nchan                    ! Number of input channels
  nvs = huv%gil%dim(1)                  ! Size of visibilities
  !
  ! Loop on functions for subtracting  model.
  ! This is memory inefficient, but multi-function fits are rare
  do if = 1, nf
    if (savef(if)) then
      write (chain,'(a,i2.2,2i8)') 'Removing UVF%PAR',if,ndata,nc
      call map_message(seve%i,rname,chain)
      call model_data(huv,ndata,nvs,nc,ic(1),ic(2),nvt,duv,duvfit,if)
    endif
  enddo
  call message_colour(2)
  call map_message(seve%i,rname,'Succesful completion')
  call message_colour(-1)
  !
end subroutine uvfit_residual
!
subroutine diagonal(m,n,r,c)
  integer :: m                      !
  integer :: n                      !
  real(kind=8) :: r(m,n)                  !
  real(kind=8) :: c(n)                    !
  ! Local
  integer :: i
  do i=1, n
    c(i) = r(i,i)
  enddo
end subroutine diagonal
!
subroutine outfit(nc,ic,ncol,y,rms,vit,nbpar,par,epar)
  use gildas_def
  use uvfit_data
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support routine for UV_FIT
  !
  ! Store the fitted parameters into the output table Y
  !
  ! Format of table is, for each channel:
  ! 1-4  RMS of fit, number of functions, number of parameters, velocity
  ! then for each function, 3+mpin*2 columns:
  !        Function number, type of function, number of parameters
  !        then 6 times (parameter, error)
  !---------------------------------------------------------------------
  integer, intent(in) :: nc         ! Number of channels
  integer, intent(in) :: ic         ! Current channel
  integer, intent(in) :: ncol       ! Size of Y
  real, intent(out) :: y(nc,ncol)   ! Output table
  real(8), intent(in) :: rms        ! RMS of fit
  real, intent(in) :: vit           ! Velocity
  integer, intent(in) :: nbpar      ! Number of parameters
  real(8), intent(in) :: par(nbpar) ! Parameters
  real(8), intent(in) :: epar(nbpar)! Errors
  ! Local
  integer :: if, ip, k, kcol
  !
  y(ic,1) = rms
  y(ic,2) = nf
  y(ic,3) = nbpar
  y(ic,4) = vit
  kcol = 5
  k = 1
  do if=1, nf
    kcol = 5+(if-1)*(3+2*mpin)
    y(ic,kcol) = if
    y(ic,kcol+1) = ifunc(if)
    y(ic,kcol+2) = npfunc(if)
    kcol = kcol+3
    do ip=1, npfunc(if)
      y(ic,kcol) = par(k)
      y(ic,kcol+1) = epar(k)
      k = k+1
      kcol = kcol+2
    enddo
  enddo
end subroutine outfit
!
subroutine load_data(ndata,nx,ic,fact,visi,np,uvriw,uv_min,uv_max)
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support routine for UV_FIT
  ! Load Data of channel IC from the input UV table into array UVRIW.
  !---------------------------------------------------------------------
  integer, intent(in) :: ndata        ! Number of visibilities
  integer, intent(in) :: nx           ! Size of a visibility
  integer, intent(in) :: ic           ! Channel number
  real, intent(in) :: fact            ! Conversion factor of baselines
  real, intent(in) :: visi(nx,ndata)  ! Visibilities
  integer, intent(out) :: np          ! Number of non zero visibilities
  real, intent(out) :: uvriw(5,ndata) ! Output array
  real, intent(in) :: uv_min          ! Min UV
  real, intent(in) :: uv_max          ! Max UV
  !
  ! Local:
  integer :: i, irc, iic, iwc
  real :: uv1, uv2, uv
  !
  !! pi = 3.14159265358979323
  irc = 5 + 3*ic
  iic = irc + 1
  iwc = iic + 1
  np = 0
  if (uv_min.eq.0.0 .and. uv_max.eq.0.0) then
    do i = 1, ndata
      if (visi(iwc,i).gt.0) then
        np = np + 1
        uvriw(1,np) = visi(1,i) * fact
        uvriw(2,np) = visi(2,i) * fact
        uvriw(3,np) = visi(irc,i)
        uvriw(4,np) = visi(iic,i)
        uvriw(5,np) = visi(iwc,i) * 1e6
      endif
    enddo
  else
    uv1 = uv_min**2
    uv2 = uv_max**2
    do i = 1, ndata
      if (visi(iwc,i).gt.0) then
        uv = visi(1,i)**2+visi(2,i)**2
        if (uv.ge.uv1 .and. uv.lt.uv2) then
          np = np + 1
          uvriw(1,np) = visi(1,i) * fact
          uvriw(2,np) = visi(2,i) * fact
          uvriw(3,np) = visi(irc,i)
          uvriw(4,np) = visi(iic,i)
          uvriw(5,np) = visi(iwc,i) * 1e6
        endif
      endif
    enddo
  endif
  return
end subroutine load_data
!
subroutine model_data(huv,nd,nx,nc,ic1,ic2,ncol,vin,vy,if)
  use image_def
  use uvfit_data
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support routine for UV_FIT
  ! Subtract the model uv data for component function number IF
  ! from the input visibility data.
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: huv  ! Input UV Table header
  integer, intent(in) :: nd         ! Number of visibilities
  integer, intent(in) :: nx         ! Size of a visbility
  integer, intent(in) :: nc         ! Number of channels
  integer, intent(in) :: ic1        ! First channel
  integer, intent(in) :: ic2        ! Last channel
  integer, intent(in) :: ncol       ! Size of VY
  real, intent(inout) :: vin(nx,nd) ! Visibilities
  real, intent(in) :: vy(nc,ncol)   ! Model parameters
  integer, intent(in) :: if         ! Function number
  !
  ! Local
  real :: fact
  integer :: j, i, k, iif, npf, kcol, ic
  real(8) :: y(2), dy(2,7), paris(7), uu, vv
  real(8), parameter :: pi = 3.14159265358979323846d0
  real(8), parameter :: clight = 299792458.d-6   ! in meter.mhz
  !
  ! Code:
  do j=1, nd
    !
    ! Kcol is the first column number in result table VY for function IF
    kcol = 5+(if-1)*(3+2*mpin)
    do ic = ic1, ic2
      fact = huv%gil%val(1) * &
     &        (1.d0+huv%gil%fres/huv%gil%freq*(ic-huv%gil%ref(1)))/clight   &
     &        *pi/180.d0/3600.d0
      uu = vin(1,j)*fact
      vv = vin(2,j)*fact
      !
      ! IIF is the function type and NPF its number of parameters.
      iif = nint(vy(ic,kcol+1))
      npf = nint(vy(ic,kcol+2))
      do i=1, npf
        paris(i) = vy(ic,kcol+3+2*(i-1))
      enddo
      call model(iif,npf,uu,vv,paris,y,dy)
      k = 8 + 3*(ic-1)
      vin(k,j) = vin(k,j) - y(1)
      vin(k+1,j) = vin(k+1,j) - y(2)
    enddo
  enddo
end subroutine model_data
!
subroutine fitfcn(iflag,m,nvpar,x,f,fjac,ljc)
  use gildas_def
  use uvfit_data
  !$ use omp_lib
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support routine for UV_FIT
  ! FITFCN is called by DNLS1E
  !---------------------------------------------------------------------
  integer, intent(in) :: iflag          ! Code for print out
  integer, intent(in) :: m              ! Number of data points
  integer, intent(in) :: nvpar          ! Number of variables
  real(8), intent(in) :: x(nvpar)       ! Variable parameters
  real(8), intent(out) :: f(m)          ! Function value at each point
  integer, intent(in) :: ljc            ! First dimension of FJAC
  real(8), intent(out) :: fjac(ljc,nvpar) ! Partial derivatives
  !
  real(8), external :: denorm
  !
  ! Local
  integer :: k, i, l, j, kpar, iif, kvpar, kf, kl
  integer :: ithread, nthread, ier
  real(8) :: uu, vv, rr, ii, ww, fact, y(2), dy(2,mpar), fa, fb
  real(8), allocatable :: swi(:)
  real(8), allocatable :: fone(:), ftwo(:)
  !
  k = 1
  sw = 0
  !
  ! Put the variable parameters in PARS (already including the fixed ones)
  kvpar = 1
  do j=1, npar
    if (nstart(j).ge.0) then
      pars(j) = x(kvpar)
      kvpar = kvpar+1
    endif
  enddo
  !
  nthread = 1
  !$ nthread = omp_get_max_threads()
  allocate(swi(nthread),fone(nvpar),ftwo(nvpar),stat=ier)
  if (ier.ne.0) then
    write(*,*) 'Memory allocation error in FITCN'
    return
  endif
  swi = 0.0
  !
  !$OMP PARALLEL DEFAULT(none)  &
  !$OMP & SHARED(uvriw) &  ! Input Visibility array
  !$OMP & SHARED(f,fjac) & ! Ouput arrays
  !$OMP & SHARED(npuvfit,nf,nvpar,npfunc,iflag,pars,ifunc,nstart, swi) &
  !$OMP & PRIVATE(i,uu,vv,rr,ii,ww,kf,kl,fact,kpar,kvpar,j,l)  &
  !$OMP & PRIVATE(ithread, iif, y, dy, fone, ftwo, fa, fb)
  !
  ithread = 1
  !$ ithread = omp_get_thread_num()+1
  !$OMP DO
  do i=1, npuvfit
    kf = 2*i-1
    kl = 2*i
    !
    ! Get real and imaginary part of visibility
    call getvisi(npuvfit,uvriw,i,uu,vv,rr,ii,ww)
    !
    ! Initialize F and derivatives.
    ! the weights are 1/sigma**2 (within a factor 2)
    fact = ww
    !
    ! Compute F and FJAC from model
    kpar  = 1
    kvpar = 1
    if (iflag.eq.1) then
      fa = -rr
      fb = -ii
      do j = 1, nf
        iif = ifunc(j)
        call model(iif,npfunc(j),uu,vv,pars(kpar),y,dy)
        fa = fa + y(1)
        fb = fb + y(2)
        kpar = kpar + npfunc(j)
      enddo
      f(kf) = fa*fact
      f(kl) = fb*fact
      !
    else if (iflag.eq.2) then
      fone = 0.d0
      ftwo = 0.d0
      do j = 1, nf
        iif = ifunc(j)
        call model(iif,npfunc(j),uu,vv,pars(kpar),y,dy)
        do l = 1, npfunc(j)
          if (nstart(kpar).ge.0) then
            fone(kvpar) = fone(kvpar) + dy(1,l)
            ftwo(kvpar) = ftwo(kvpar) + dy(2,l)
            kvpar = kvpar+1
          endif
          kpar = kpar + 1
        enddo
      enddo
      do l=1, nvpar
        fjac(kf,l) = fone(l)*fact
        fjac(kl,l) = ftwo(l)*fact
      enddo
      !
    else if (iflag.eq.0) then
      continue
    endif
    !
    ! Weight appropriately:
    swi(ithread) = swi(ithread) + fact
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  sw = 0.0
  do i=1,nthread
    sw = sw+swi(i)
  enddo
  !
  ! In the end: normalize by the sum of weights.
  k = 1
  if (iflag.eq.1) then
    do k = 1, 2*npuvfit
      f(k) = f(k)/sw
    enddo
  else if (iflag.eq.2) then
    do l=1, nvpar
      do k=1,2*npuvfit
        fjac(k,l) = fjac(k,l)/sw
      enddo
    enddo
  endif
  if (iflag.eq.0) then
    print 1000, (x(i), i=1, nvpar), denorm(2*npuvfit,f)
    1000     format (10(1pg19.12))
  endif
  !!  print *,'Done FITFCN'
end subroutine fitfcn
!
subroutine getvisi(n,uvriw,k,u,v,r,i,w)
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support routine for UV_FIT
  !     Obtain U, V, and the visibility from the array UVRIW.
  !
  !     N      Integer     Number of visibilities     Input
  !     UVRIW  real(8)      Input array                Input
  !     K      Integer     Visibility number          Input
  !     U      real(8)      U coord.                   Output
  !     V      real(8)      V coord.                   Output
  !     R      real(8)      Real part                  Output
  !     I      real(8)      Imaginary part.            Output
  !     W      real(8)      Weight                     Output
  !---------------------------------------------------------------------
  integer, intent(in) :: n         ! Number of visibilities
  real, intent(in) :: uvriw(5,n)   ! Visibilities
  integer, intent(in) :: k         ! Desired visibility number
  real(8), intent(out) ::  u       ! U coordinate
  real(8), intent(out) ::  v       ! V coordinate
  real(8), intent(out) ::  r       ! Real part
  real(8), intent(out) ::  i       ! Imaginary part
  real(8), intent(out) ::  w       ! Weight
  !
  u = uvriw(1,k)
  v = uvriw(2,k)
  r = uvriw(3,k)
  i = uvriw(4,k)
  w = uvriw(5,k)
end subroutine getvisi
!
subroutine outpar(k,kfunc,par)
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support routine for UV_FIT
  ! Process fitted parameters to be saved, according to fitted functions
  !---------------------------------------------------------------------
  integer, intent(in) :: k     ! Function code
  integer, intent(in) :: kfunc ! Number of parameters
  real(8), intent(inout) :: par(kfunc)  ! Parameters
  ! Local
  real(8) :: aa
  integer :: ipoint, icgauss, iegauss, icdisk, iedisk, iexpo
  parameter (ipoint=1,iegauss=2,icgauss=3,icdisk=4,iexpo=6,iedisk=9)
  !
  ! Gaussian:  Reorder the axes, and change the P. Angle accordingly
  ! Make sure the axes are positive.
  if (k.eq.iegauss .or. k.eq.iedisk) then
    par(5) = abs(par(5))
    par(4) = abs(par(4))
    if (par(4).lt.par(5)) then
      par(6) = par(6)+90d0
      aa = par(4)
      par(4) = par(5)
      par(5) = aa
    endif
    par(6) = -90d0+mod(par(6)+3690d0,180d0)
  elseif (k.eq.icgauss .or. k.eq.icdisk .or.k.eq.iexpo) then
    par(4) = abs(par(4))
  endif
end subroutine outpar
!
subroutine  model(ifunc,kfunc,uu,vv,x,y,dy)
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support routine for UV_FIT
  ! Compute a model function.
  !---------------------------------------------------------------------
  integer, intent(in) :: ifunc       ! Fuction type
  integer, intent(in) :: kfunc       ! Number of parameters
  real(8), intent(in) :: uu          ! U coordinate in arcsec^-1
  real(8), intent(in) :: vv          ! V coordinate in arcsec^-1
  real(8), intent(in) :: x(kfunc)    ! Parameters
  real(8), intent(inout) :: y(2)        ! Function (real, imag.)
  real(8), intent(inout) :: dy(2,kfunc) ! Partial derivatives.
  !
  ! Global
  real(8), external :: z_exp
  !
  ! Local
  integer :: i
  real(8) :: st, ct, q1, q2, arg, carg, sarg, darg1, darg2
  real(8) :: a, da(7), b, ksi, q, j0, j1, aa, dfac4, dfac5
  real(8) :: dadksi
  real(8) :: dbesj0, dbesj1, dbesk0, dbesk1
  real(8) :: a1, a2, fac, k0, k1, d, daa
  real(8) :: ii, oo, fi, fo, ff, dgo_do, dgi_do, dgi_di, dgo_di, dout2
  real(8), parameter :: pi = 3.14159265358979323846d0
  real(8), parameter :: dpi=2d0*pi
  real(8), parameter :: cst=3.5597073312469d0  ! pi**2/4d0/log(2d0)
  real(8), parameter :: deg=pi/180d0
  real(8) flux,dg_dmaj,dg_dmin,dg_dpa
  real(8) dg_douter,dg_dinner,dg_dratio,dg_drota
  !-----------------------------------------------------------------------
  !
  ! The fitted function is of the form:
  !     F = flux * f(x-x0,y-y0)
  ! corresponding to a visibility model:
  !     G = flux * exp(-2i*pi(u*x0+v*y0)) * g(u,v)
  ! where g is the Fourier transform of f.
  !
  ! The first three parameters 1, 2, 3, are x0, y0, and flux.
  !
  ! First compute A = g(u,v), and DA(k) = dA/dx_k for k=4, ...
  ! depending on model.
  !
  select case (ifunc)
  !
  case (1)  ! Point source
    ! 1- Point source
    ! model = flux * delta(x-x0,y-y0)
    ! g(u,v) = 1
    ! 3 pars (x0, y0, flux)
    a = 1d0
    !
  case (2) ! Gaussian
    ! 2- Gaussian (2-dim)
    !     model = flux*4*ln2/(pi*b1*b2) * exp (-4*ln2*((r1/b1)**2+(r2/b2)**2)
    !     g(u,v) = exp(-pi**2/4/ln2*(b1*u1+b2*u2)**2)
    !       where u1 = u*sin(theta)+v*cos(theta)
    !             u2 = u*cos(theta)-v*sin(theta)
    !     6 pars (x0, y0, flux, theta, b1, b2)
    !
    st = sin(deg*x(6))
    ct = cos(deg*x(6))
    q1 = uu*st+vv*ct
    q2 = uu*ct-vv*st
    a1 = -cst*q1**2
    a2 = -cst*q2**2
    a = z_exp(a1*x(4)**2+a2*x(5)**2)
    da(4) = 2*x(4)*a1*a
    da(5) = 2*x(5)*a2*a
    da(6) = -2d0*cst*q1*q2*(x(4)**2-x(5)**2)*deg*a
    !
  case(3)
    !
    ! 3- Gaussian (1-dim)
    !     model = flux*4*ln2/(pi*b**2) * exp (-4*ln2*(r/b)**2)
    !     g(u,v) = exp(- pi**2/4/ln(2)*(b*q)**2)
    !     where q**2 = u**2+v**2
    !     4 pars (x0, y0, flux, b)
    !
    q2 = uu**2+vv**2
    a1 = -cst*q2
    a = z_exp(a1*x(4)**2)
    da(4) = a1*x(4)*2d0*a
    !
  case (4) ! Disk
    ! 4- Disk
    !     model = flux*4/(pi*b**2)
    !     g(u,v) = J1(pi*b*q)/q
    !     where q**2 = u**2+v**2
    !     4 pars (x0, y0, flux, b)
    !
    q = sqrt(uu**2+vv**2)
    ksi = pi*x(4)*q
    if (ksi.eq.0d0) then
      a = 1
      da(4) = 0
    else
      j1 = dbesj1(ksi)
      j0 = dbesj0(ksi)
      a = j1*2d0/ksi
      da(4) = 2d0*(j0-a)/x(4)
    endif
    !
  case (5) ! Ring
    !
    ! 5- Ring
    q = sqrt(uu**2+vv**2)
    a = 0
    da(4) = 0
    da(5) = 0
    if (x(4).ne.x(5)) then
      d = x(4)**2-x(5)**2
      fac = x(4)**2/d
      dfac4 =-2*x(5)**2*x(4)/d**2
      dfac5 =2*x(4)**2*x(5)/d**2
      ksi = pi*x(4)*q
      if (ksi.eq.0) then
        a = a + fac
        da(4) = da(4) + dfac4
        da(5) = da(5) + dfac5
      else
        j1 = dbesj1(ksi)
        j0 = dbesj0(ksi)
        aa = j1*2d0/ksi
        daa = 2d0*(j0-aa)/x(4)
        a = a + aa*fac
        da(4) = da(4) + daa*fac+aa*dfac4
        da(5) = da(5) + aa*dfac5
      endif
      ksi = pi*x(5)*q
      if (ksi.eq.0) then
        a = a+1d0-fac
        da(4) = da(4)-dfac4
        da(5) = da(5)-dfac5
      else
        j1 = dbesj1(ksi)
        j0 = dbesj0(ksi)
        aa = j1*2d0/ksi
        daa = 2d0*(j0-aa)/x(5)
        a = a + aa*(1d0-fac)
        da(4) = da(4) - aa*dfac4
        da(5) = da(5) + daa*(1d0-fac)-aa*dfac5
      endif
    endif
    !
  case(6) ! Exponential
    ! 6- exponential
    !     model = exp(- 2*ln2*r/b)
    !     g(u,v) = 1 / ( 1 + (q*b*pi/ln2)**2 )**(3/2)
    !
    q2 = uu**2+vv**2
    ksi = q2 * (x(4)*pi/log(2d0))**2
    b = 1d0+ksi
    a = 1d0/b**1.5
    da(4) = -3*a*ksi/b/x(4)
    !
  case(7) ! Power -2
    ! 7- Power -2
    !     model =
    !     g(u,v) =
    !
    q = sqrt(uu**2+vv**2)
    ksi = pi*x(4)*q
    k0 = dbesk0(ksi)
    k1 = dbesk1(ksi)
    a = k0
    da(4) = -ksi/x(4)*k1
    !
  case(8) ! Power -3
    !
    ! 8- Power -3
    !     model =
    !     g(u,v) = exp( -pi*q*b/sqrt(2**(1/3)-1) )
    !
    q = sqrt(uu**2+vv**2)
    ksi = pi*q*x(4)/sqrt(2.**(1./3)-1)
    a = z_exp(-ksi)
    da(4) = -a*ksi/x(4)
    !
  case(9) ! Elliptical disk
    ! 9- Elliptical Disk
    !     model = flux*4/(pi*(b1**2+b2**2)) (inside ellipse, 0 outside)
    !     g(u,v) = 2 J1 (ksi)  / ksi
    !     where u1 = u*sin(theta)+v*cos(theta)
    !           u2 = u*cos(theta)-v*sin(theta)
    !     ksi = pi*sqrt((b1*u1)**2+(b2*u2)**2)
    !     6 pars (x0, y0, flux, b1, b2, theta)
    !
    st = sin(deg*x(6))
    ct = cos(deg*x(6))
    q1 = uu*st+vv*ct
    q2 = uu*ct-vv*st
    ksi = pi*sqrt((x(4)*q1)**2+(x(5)*q2)**2)
    if (ksi.eq.0d0) then
      a = 1
      da(4) = 0
      da(5) = 0
      da(6) = 0
    else
      j1 = dbesj1(ksi)
      a = j1*2d0/ksi
      j0 = dbesj0(ksi)
      dadksi = 2d0*(j0-a)/ksi
      da(4) = dadksi*pi**2*q1**2*x(4)/ksi
      da(5) = dadksi*pi**2*q2**2*x(5)/ksi
      da(6) = dadksi/ksi*pi**2*q1*q2*(x(4)**2-x(5)**2)*deg
    endif
    !
  case (10)  ! Unresolved ring
    !
    ! 10- Unresolved Ring
    !     model = flux/(2*pi*b)*delta(r-b)
    !     g(u,v) = J0(pi*b*q)
    !     where q**2 = u**2+v**2
    !     4 pars (x0, y0, flux, b)
    !
    q = sqrt(uu**2+vv**2)
    ksi = pi*x(4)*q
    if (ksi.eq.0d0) then
      a = 1
      da(4) = 0
    else
      j1 = dbesj1(ksi)
      j0 = dbesj0(ksi)
      a = j0
      da(4) = -j1 * pi*q
    endif
    !
  case(11) ! Elliptical Ring
    ! 11- Elliptical Ring
    !
    !     To be developped more...
    !
    !     7 pars (x0, y0, flux, outer, inner, pa, ratio)
    !
    !     Define a1 = outer
    !     Define a2 = outer*ratio
    !     Define b1 = inner
    !     Define b2 = inner*ratio
    !
    ! Sum of two elliptical disks.
    !     a) a = fa *4/(pi*outer^2*ratio) > 0
    !        ga(u,v) = fa * J1(pi*sqrt((a1*u1)**2+(a2*u2)**2)
    !     b) b = fb *4/(pi*inner^2*ratio) < 0
    !        gb(u,v) = fb * J1(pi*sqrt((b1*u1)**2+(b2*u2)**2)
    !     and
    !        fa + fb = flux
    !        fa / fb = -(outer/inner)^2
    !     where u1 = u*sin(theta)+v*cos(theta)
    !           u2 = u*cos(theta)-v*sin(theta)
    !*     so
    !        fa = flux * outer^2 / (outer^2-inner^2)
    !        fb = - flux * inner^2 / (outer^2-inner^2)
    !
    ! Derivative vs outer
    !
    !     d(fa)/d(out) * J1 + fa * d(J1)/d(out)
    !
    !
    st = sin(deg*x(6))
    ct = cos(deg*x(6))
    q1 = uu*st+vv*ct
    q2 = uu*ct-vv*st
    ii = x(5) ! Inner radius
    oo = x(4) ! Outer radius
    ff = x(7) ! cos (inclination)
    dout2 = (oo**2-ii**2)
    !
    ! First source
    a1 = x(4)
    a2 = x(4)*ff
    !
    ksi = pi*sqrt((a1*q1)**2+(a2*q2)**2)
    if (ksi.eq.0d0) then
      a = 1
      dg_dmaj = 0
      dg_dmin = 0
      dg_dpa = 0
    else
      j1 = dbesj1(ksi)
      j0 = dbesj0(ksi)
      a = j1*2d0/ksi
      dadksi = 2d0*(j0-a)/ksi
      dg_dmaj = dadksi*pi**2*q1**2*a1/ksi    ! d(g)/d(major)
      dg_dmin = dadksi*pi**2*q2**2*a2/ksi    ! d(g)/d(minor)
      dg_dpa = dadksi/ksi*pi**2*q1*q2*(a1**2-a2**2)*deg
    endif
    !
    ! Now it gets a little more complex
    fo = oo**2 / dout2
    !
    dgo_do = 2 * oo * ii**2 / dout2 *  a    ! Strictly speaking
    dgo_do = dgo_do + fo * (dg_dmaj + ff * dg_dmin)
    dgo_di = 2 * oo**2 * ii / dout2 *  a
    !
    flux = a * fo
    dg_dratio = fo * a1 * dg_dmin
    dg_drota = fo * dg_dpa
    !
    ! Second source
    a1 = x(5)
    a2 = x(5)*ff
    !
    ksi = pi*sqrt((a1*q1)**2+(a2*q2)**2)
    if (ksi.eq.0d0) then
      a = 1
      dg_dmaj = 0
      dg_dmin = 0
      dg_dpa = 0
    else
      j1 = dbesj1(ksi)
      j0 = dbesj0(ksi)
      a = j1*2d0/ksi
      dadksi = 2d0*(j0-a)/ksi
      dg_dmaj = dadksi*pi**2*q1**2*a1/ksi    ! d(g)/d(major)
      dg_dmin = dadksi*pi**2*q2**2*a2/ksi    ! d(g)/d(minor)
      dg_dpa = dadksi/ksi*pi**2*q1*q2*(a1**2-a2**2)*deg
    endif
    !
    fi = ii**2 / dout2
    !
    dgi_di = 2 * ii * oo**2 / dout2 *  a    ! Strictly speaking
    dgi_di = dgo_di + fi * (dg_dmaj + ff * dg_dmin)
    dgi_do = 2 * ii**2 * oo / dout2 *  a
    !
    ! Add (or rather subtract...) to previous derivatives
    dg_dinner = dgo_di - dgi_di
    dg_douter  = dgo_do - dgi_do
    dg_dratio = dg_dratio - fi * a1 * dg_dmin
    dg_drota = dg_drota - fi * dg_dpa
    !
    ! and to flux (actually, relative visibility)
    flux = flux - a * fi
    !
    a = flux                     ! Normalized scaling factor now
    da(4) = dg_douter
    da(5) = dg_dinner
    da(6) = dg_drota
    da(7) = dg_dratio
    !
  end select
  !
  ! Compute the phase term exp(-2i*pi(u*x0+v*y0)) and its derivatives
  ! with respect to x_0 and y_0
  !
  ! Sign is correct for X positive towards East.
  darg1 = dpi*uu
  darg2 = dpi*vv
  arg = darg1*x(1)+darg2*x(2)
  carg = cos(arg)
  sarg = sin(arg)
  !
  ! Now compute the real and imaginary part of function.
  y(1) = x(3)*a*carg
  y(2) = x(3)*a*sarg
  !
  ! And its derivatives with respect to x0, y0, flux
  dy(1,1) = -y(2)*darg1
  dy(2,1) =  y(1)*darg1
  dy(1,2) = -y(2)*darg2
  dy(2,2) =  y(1)*darg2
  dy(1,3) = a*carg
  dy(2,3) = a*sarg
  ! And its derivatives with respect to parameters 4, 5, 6, 7
  if (kfunc.ge.4) then
    do i=4, kfunc
      dy(1,i) = x(3)*carg*da(i)
      dy(2,i) = x(3)*sarg*da(i)
    enddo
  endif
end subroutine model
!
function z_exp(x)
  !---------------------------------------------------------------------
  ! protect again underflows in exp(x)
  !---------------------------------------------------------------------
  real(8) :: z_exp                   !
  real(8) :: x                       !
  ! Local
  real(8) :: d1mach, xmin, ymin
  logical :: first
  data first/.true./
  save xmin, ymin, first
  !
  if (first) then
    ymin = 2*d1mach(1)
    xmin = log(ymin)
    first = .false.
  endif
  if (x.lt.xmin) then
    z_exp = ymin
    return
  endif
  z_exp = exp(x)
end function z_exp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_tracked_wsw(mrtset,backcal,backsci,filebuf,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_level_codes
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_calib_tracked_wsw
  !---------------------------------------------------------------------
  ! @ private
  ! Gather all needed steps to read, calibrate, and write a 
  ! tracked wobbler switched scan for a given backend
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(calib_backend_t),   intent(in)    :: backcal
  type(science_backend_t), intent(inout) :: backsci
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=4) :: ion,non
  integer(kind=4) :: iref,nref
  character(len=*), parameter :: rname='CALIB>TRACKED>WSW'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_init_refloop(backsci,nref,error)
  if (error) return
  do iref=1,nref
     call mrtcal_get_nextref(backsci,error)
     if (error) return
     call mrtcal_init_onloop(backsci,non,error)
     if (error) return
     do ion=1,non
        call mrtcal_get_nexton(backsci,error)
        if (error) return
        call mrtcal_sanity_check(backsci,error)
        if (error) return
        call mrtcal_init_cycleloop(&
             mrtset,&
             backsci%list,&
             backsci%on%curr%isub,&
             'track',&
             filebuf%imbf,&
             filebuf%subscanbuf,&
             backsci%switch,&
             error)
        if (failed_calibrate(rname,backsci%on%curr%isub,error))  return
        do while (backsci%switch%book%idump.le.backsci%switch%book%ndump)
           call mrtcal_get_nextcycle(&
                filebuf%imbf,&
                filebuf%subscanbuf%subscan,&
                filebuf%subscanbuf%databuf,&
                backsci,error)
           if (error) return
           if (backsci%switch%book%found) then
              call reassociate_chunkset_2d(backsci%switch%cycle%data(backsci%switch%cycle%ion),backsci%on%curr,error)
              if (error)  return
!!$           call reassociate_chunkset_2d(backsci%switch%cycle%data(backsci%switch%cycle%ioff),backsci%off%curr,error)
!!$           if (error)  return
              backsci%off%curr => backsci%switch%cycle%data(backsci%switch%cycle%ioff)
              call mrtcal_on_minus_off_new(istracked,notfsw,backcal,backsci,error)
              if (error) return
              call mrtcal_tscale_computation(backcal,backsci,error)
              if (error) return
              call mrtcal_tscale_application(backsci%tscale,backsci%diff,error)
              if (error) return
              call mrtcal_accumulate_or_write(level_cycl_code,mrtset,backsci,error)
              if (error) return
           endif
           ! User can interrupt the pipeline
           if (sic_ctrlc_status()) then
              error = .true.
              exit
           endif
        enddo ! switch%book%idump
        call mrtcal_switch_book_list(backsci%switch%book,error)
        if (error) return
        call mrtcal_accumulate_or_write(level_subs_code,mrtset,backsci,error)
        if (error) return
     enddo ! ion
  enddo ! iref
  call mrtcal_accumulate_or_write(level_scan_code,mrtset,backsci,error)
  if (error) return
  !
end subroutine mrtcal_calib_tracked_wsw
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_psw_fill_section_onecycle(list,cycle,error)
  use gbl_message
  use mrtcal_interfaces, except_this=>mrtcal_psw_fill_section_onecycle
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(subscan_list_t), intent(in)    :: list
  type(switch_cycle_t), intent(inout) :: cycle
  logical,              intent(inout) :: error
  ! Local
  integer(kind=4) :: iphase
  character(len=*), parameter :: rname='PSW>FILL>SECTION>ONECYCLE'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  do iphase=1,cycle%n
     call mrtcal_psw_fill_section_onephase(iphase,list,cycle,error)
     if (error) return
  enddo ! iphase
  !
end subroutine mrtcal_psw_fill_section_onecycle
!
subroutine mrtcal_psw_fill_section_onephase(iphase,list,cycle,error)
  use gbl_message
  use mrtcal_interfaces, except_this=>mrtcal_psw_fill_section_onephase
  use gbl_constant
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4),              intent(in)    :: iphase
  type(subscan_list_t),         intent(in)    :: list
  type(switch_cycle_t), target, intent(inout) :: cycle
  logical,                      intent(inout) :: error
  ! Local
!!$  type(class_switch_t), pointer :: sec
  character(len=*), parameter :: rname='PSW>FILL>SECTION>ONEPHASE'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
!!$  !
!!$  ! Shortcut
!!$  sec => cycle%sec(iphase)
!!$  !
!!$  ! Initialize *** JP This should be done in the CLASS type definition.
!!$  sec%ldecal(:) = 0
!!$  sec%bdecal(:) = 0
!!$  sec%decal(:)  = 0
!!$  sec%poids(:)  = 0
!!$  sec%duree(:)  = 0
!!$  ! Fill the interesting part
!!$  sec%swmod = mod_pos
!!$  sec%nphas = cycle%n
!!$  if (iphase.eq.cycle%ion) then
!!$     sec%poids(iphase) = +1
!!$  else if (iphase.eq.cycle%ioff) then
!!$     sec%poids(iphase) = -1
!!$  else
!!$     call mrtcal_message(seve%e,rname,'Unknown phase number')
!!$     error = .true.
!!$     return
!!$  endif
!!$  sec%ldecal(iphase) = list%onoff%val1(iphase)
!!$  sec%bdecal(iphase) = list%onoff%val2(iphase)
!!$  sec%duree(iphase) = 0
  !
end subroutine mrtcal_psw_fill_section_onephase
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine mos_primary (prim,primary,bsize)
  !
  ! Mosaic and Primary beam support
  ! Compute a Gaussian primary beam
  !
  use image_def
  use gkernel_interfaces
  use gkernel_types
  type(gildas), intent(in) :: prim         ! Primary beam header
  real, intent(inout) :: primary(prim%gil%dim(1),prim%gil%dim(2)) ! Values
  real, intent(in) :: bsize                ! Primary beam size in radian
  !
  ! Local
  real :: offx,offy,beamx,beamy
  real, allocatable :: factorx(:),factory(:)
  real(8) :: doffx, doffy
  integer :: j, ier
  type(projection_t) :: proj
  logical :: error
  !
  allocate (factory(prim%gil%dim(2)), factorx(prim%gil%dim(1)), stat=ier)
  !
  error = .false.
  call gwcs_projec(prim%gil%a0,prim%gil%d0,prim%gil%pang,prim%gil%ptyp,proj,error)
  call abs_to_rel(proj,prim%gil%ra,prim%gil%dec,doffx,doffy,1)
  offx = doffx/prim%gil%inc(1)
  offy = doffy/prim%gil%inc(2)
  !
  beamx = prim%gil%inc(1)/bsize*2.0*sqrt(log(2.0))
  beamy = prim%gil%inc(2)/bsize*2.0*sqrt(log(2.0))
  !
  do j=1,prim%gil%dim(2)
     factory(j) = exp(-((j-prim%gil%ref(2)-offy)*beamy)**2)
  enddo
  !
  do j=1,prim%gil%dim(1)
     factorx(j) = exp(-((j-prim%gil%ref(1)-offx)*beamx)**2)
  enddo
  !
  do j=1,prim%gil%dim(2)
     primary(:,j) = factorx * factory(j)
  enddo
  deallocate (factorx, factory)
end subroutine mos_primary
!
subroutine mos_inverse (n,weight,thre)
  integer, intent(in) :: n
  real, intent(inout) :: weight(n)
  real, intent(in) :: thre
  ! Local
  integer :: i
  !
  do i=1,n
    if (weight(i).ge.thre) then
      weight(i) = 1.0/weight(i)
    else
      weight(i) = 10.0
    endif
  enddo
end subroutine mos_inverse
!
subroutine mos_addsq (n,nf,weight,lobe)
  integer, intent(in) :: n                      ! Size of arrays
  integer, intent(in) :: nf                     ! Number of fields
  real, intent(inout) :: weight(n)              ! Total weight
  real, intent(in) :: lobe(nf,n)                ! Primary beam array
  ! Local
  integer :: i,if
  !
  do i=1,n
    do if=1,nf
      weight(i) = weight(i)+lobe(if,i)*lobe(if,i)
    enddo
  enddo
end subroutine mos_addsq
!
subroutine mosaic_loadfield (visi,np,nv,ixoff,iyoff,nf,doff,voff,uvmax,uvmin)
  !----------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! MAP    MOSAIC routines
  !     Load field coordinates into work arrays after sorting.
  !----------------------------------------------------------------------
  integer, intent(in)  :: np                   ! Size of a visibility
  integer, intent(in)  :: nv                   ! Number of visibilities
  real, intent(in) :: visi(np,nv)              ! Input visibilities
  integer, intent(in)  :: ixoff                ! X pointer
  integer, intent(in)  :: iyoff                ! Y pointer
  integer, intent(out) :: nf                   ! Number of fields
  real(kind=4), intent(out), allocatable :: doff(:,:)  ! Fields offsets
  integer, intent(out), allocatable :: voff(:)  ! Fields visibility offsets
  real, intent(inout) :: uvmax    ! Maximum length
  real, intent(inout) :: uvmin    ! Minimum baseline
  !
  integer :: iv, mfi, nfi, ier
  real(4) :: uv
  real(kind=4), allocatable :: dtmp(:,:)
  integer, allocatable :: vtmp(:)
  !
  ! Scan how many fields
  nfi = 1
  mfi = 100
  uvmax = 0
  uvmin = 1e36
  !
  allocate(dtmp(2,mfi),vtmp(mfi),stat=ier)
  dtmp(1,1) = visi(ixoff,1)
  dtmp(2,1) = visi(iyoff,1)
  vtmp(1) = 1
  nfi = 1
  !
  ! Fields are ordered here, so any change is a new one
  do iv=2,nv
    if (visi(ixoff,iv).ne.dtmp(1,nfi) .or. &
      & visi(iyoff,iv).ne.dtmp(2,nfi) ) then
      !
      ! New field
      if (nfi.eq.mfi) then
        allocate(doff(2,nfi),voff(nfi),stat=ier)
        doff(:,:) = dtmp(:,:)
        voff(:) = vtmp(:)
        deallocate(dtmp,vtmp)
        mfi = 2*mfi
        allocate(dtmp(2,mfi),vtmp(mfi),stat=ier)
        dtmp(:,1:nfi) = doff(:,:)
        vtmp(1:nfi) = voff
        deallocate(doff,voff)
      endif
      !
      nfi = nfi+1
      dtmp(1,nfi) = visi(ixoff,iv)
      dtmp(2,nfi) = visi(iyoff,iv)
      vtmp(nfi) = iv
    endif
    !
    uv = visi(1,iv)**2 + visi(2,iv)**2
    if (uv.ne.0) then
      uvmax = max(uv,uvmax)
      uvmin = min(uv,uvmin)
    endif
    !
  enddo
  !
  ! And put everything in place
  nf = nfi
  allocate(doff(2,nf),voff(nf+1),stat=ier)
  doff(:,:) = dtmp(:,1:nfi)
  voff(1:nfi) = vtmp(1:nfi)
  ! And set the last one
  voff(nfi+1) = nv+1
  deallocate(dtmp)
  !
  uvmax = sqrt(uvmax)
  uvmin = sqrt(uvmin)
end subroutine mosaic_loadfield
!
subroutine mosaic_getfields (visi,np,nv,ixoff,iyoff,nf,doff)
  !----------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! MAP    MOSAIC routines
  !     Count number of fields and Get their coordinates
  !----------------------------------------------------------------------
  integer, intent(in)  :: np                   ! Size of a visibility
  integer, intent(in)  :: nv                   ! Number of visibilities
  real, intent(inout)  :: visi(np,nv)              ! Input visibilities
  integer, intent(in)  :: ixoff                ! X pointer
  integer, intent(in)  :: iyoff                ! Y pointer
  integer, intent(out) :: nf                   ! Number of fields
  real, intent(out), allocatable :: doff(:,:)  ! Field offsets
  !
  integer :: iv, mfi, nfi, kfi, ifi, ier
  real(kind=4), allocatable :: dtmp(:,:)
  real(kind=4) :: off_tol
  !
  ! Scan how many fields
  !
  off_tol = 1E-2*acos(-1.0)/180.0/3600.0       ! 0.01 sec is enough
  nfi = 1
  mfi = 100
  !
  allocate(dtmp(2,mfi),stat=ier)
  dtmp(1,1) = visi(ixoff,1)
  dtmp(2,1) = visi(iyoff,1)
  nfi = 1
  !
  ! Fields are not ordered here
  do iv=2,nv
    kfi = 0
    do ifi=1,nfi
      if (abs(visi(ixoff,iv)-dtmp(1,ifi)).le.off_tol .and. &
        & abs(visi(iyoff,iv)-dtmp(2,ifi)).le.off_tol ) then
        visi(ixoff,iv) = dtmp(1,ifi)
        visi(iyoff,iv) = dtmp(2,ifi)
        kfi = ifi
        exit
      endif
    enddo
    !
    ! New field
    if (kfi.eq.0) then
      if (nfi.eq.mfi) then
        allocate(doff(2,mfi),stat=ier)
        doff(:,:) = dtmp(:,:)
        deallocate(dtmp)
        allocate(dtmp(2,2*mfi),stat=ier)
        dtmp(:,1:mfi) = doff
        deallocate(doff)
        mfi = 2*mfi
      endif
      nfi = nfi+1
      dtmp(1,nfi) = visi(ixoff,iv)
      dtmp(2,nfi) = visi(iyoff,iv)
    endif
  enddo
  !
  nf = nfi
  allocate(doff(2,nf),stat=ier)
  doff(:,:) = dtmp(1:2,1:nf)
end subroutine mosaic_getfields

subroutine statistic (line,error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>statistic
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !     Statistics on internal images
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  type (gildas), pointer :: hstat
  real, pointer :: dstat(:,:,:)
  integer ier, plane, na, nx, ny
  character(len=12) argum,stype
  logical do_whole, do_mask
  real valmin, valmax, mean, rms, noise, beam, flux, sec, lambda, jyperk
  integer imin, imax, jmin, jmax, n_sup, n_off, box(4), ntype
  character(len=4) :: rname = 'STAT'
  character(len=8) :: prefix
  character(len=2) :: fixpre
  real :: scale, uscale
  !
  ! Save DO_MASK
  do_mask = user_method%do_mask
  !
  ! Type of image (default = clean)
  !
  argum = 'CLEAN'
  call sic_ke (line,0,1,argum,na,.false.,error)
  call sic_ambigs ('STATISTIC',argum,stype,ntype,vtype,mtype,error)
  if (error) return
  !
  ! Plane
  if (sic_present(0,2)) then
    call sic_i4(line,0,2,plane,.false.,error)
    if (error) return
  else
    call sic_get_inte ('FIRST',plane,error)
  endif
  if (plane.eq.0) plane = 1
  !
  ! Allocate memory
  if (stype.eq.'CLEAN') then
    if (.not.allocated(dclean)) then
      call map_message(seve%e,rname,'No clean image')
      error = .true.
      return
    endif
    hstat => hclean
    dstat => dclean
  elseif (stype.eq.'DIRTY') then
    if (.not.allocated(ddirty)) then
      call map_message(seve%e,rname,'No dirty image')
      error = .true.
      return
    endif
    hstat => hdirty
    dstat => ddirty
  elseif (stype.eq.'RESIDUAL') then
    if (.not.allocated(dresid)) then
      call map_message(seve%e,rname,'No residual image')
      error = .true.
      return
    endif
    hstat => hresid
    dstat => dresid
  else
    call map_message(seve%e,rname,'Unkown image type')
    error = .true.
    return
  endif
  !
  ! Local support
  nx = hstat%gil%dim(1)
  ny = hstat%gil%dim(2)
  !
  !  - set all the support to .true. (ie compute stat on the whole image)
  !    1) /WHOLE option
  !
  !  - otherwise, use the current mask:
  !       - call check_msk to define mask if necessary (e.g. support
  !         just loaded)
  !       - copy mask in the local support memory
  !
  if (sic_present(1,0)) then
    do_whole = .true.
  elseif  (do_mask) then
    if (.not.allocated(d_mask)) then
      allocate(d_mask(nx,ny),d_list(nx*ny),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Error getting support memory')
        error = .true.
        return
      endif
      method%do_mask = .true.
      method%nlist = 0
    endif
    do_whole = .false.
  else
    if (method%nlist.eq.0) do_whole = .true.
  endif
  !
  ! Avoid edges
  box = [nx/16,ny/16,15*nx/16,15*ny/16]
  if (do_whole) then
    call map_message(seve%i,rname,'Using the whole image')
    if (sic_present(1,1)) box = [1,1,nx,ny]
  else
    call check_area(method,hstat,.true.)
    call check_mask(method,hstat)
    box(1) = min(box(1),method%box(1))
    box(2) = min(box(2),method%box(2))
    box(3) = max(box(3),method%box(3))
    box(4) = max(box(4),method%box(4))
    call map_message(seve%i,rname,'Using current support')
  endif
  !
  ! Compute stat
  if (do_whole) then
    call compute_stat(nx,ny,dstat(:,:,plane),box,   &
       &    valmin,imin,jmin,valmax,imax,jmax,mean,rms,noise,n_sup,n_off)
  else
    call compute_stat(nx,ny,dstat(:,:,plane),box,   &
       &    valmin,imin,jmin,valmax,imax,jmax,mean,rms,noise,n_sup,n_off, &
       &    d_mask)
  endif
  !
  write(6,101) 'Found ',n_sup,' pixels on, ',n_off,' off source'
  write(6,102) 'Map maximum: ',valmax,' at ',imax,jmax
  write(6,102) 'Map minimum: ',valmin,' at ',imin,jmin
  !
  !
  ! Find the appropriate unit (Jy, mJy or microJy)
  if (noise.lt.1e-5) then
    scale = 1e6
    prefix = ' microJy'
  else if (noise.lt.0.01) then
    scale = 1e3
    prefix = ' mJy'
  else
    scale = 1.0
    prefix = ' Jy'
  endif
  !
  ! If CLEAN image, compute total flux
  if (stype.eq.'CLEAN') then
    write(6,'(A,1PG11.2,A,A)') ' Mean: ',mean*scale,trim(prefix)//'/beam'
    write(6,'(A,F10.3,A,F10.3,A)') ' rms:  On:', rms*scale, '  Off:', noise*scale,trim(prefix)//'/beam'
    beam = pi*hclean%gil%majo*hclean%gil%mino/4./log(2.0)
    beam = beam/abs(hclean%gil%convert(3,1)*hclean%gil%convert(3,2))
    flux = (mean*n_sup)/beam
    write(6,104) 'Total flux in CLEAN map: ',flux*scale,trim(prefix)
    sec = 180.*3600./pi
    lambda = 2.99792458e8/hclean%gil%freq*1e-6
    jyperk = 2.0*1.38e3*   &
     &      pi*hclean%gil%majo*hclean%gil%mino/4./log(2.0)   &
     &      /lambda**2.
    if (jyperk*scale.gt.1e3) then
      uscale = 1e-3
      fixpre = 'mK'
    else
      uscale = 1
      fixpre = ' K'
    endif
    write(6,105) 'Tb scale for CLEAN map: 1 '//fixpre//' = ',   &
     &      jyperk*uscale*scale,trim(prefix)//'/beam'
    write(6,106) 'Clean Beam is ',   &
     &      hclean%gil%majo*sec,' x ',hclean%gil%mino*sec,   &
     &      ' sec at PA = ',hclean%gil%posa*180/pi,' deg'
    call sic_delvariable ('CLEANFLUX',.false.,error)
    call sic_def_real ('CLEANFLUX',flux,0,0,.false.,error)
  else
    write(6,'(A,F10.2,A,A)') ' Mean: ',mean*scale,trim(prefix)
    write(6,'(A,F10.2,A,F10.2,A)') ' rms:  On:', rms*scale, '  Off:', noise*scale,trim(prefix)
  endif
  !
  !
  101   format (1x,a,i8,a,i8,a)
  102   format (1x,a,f10.3,a,'(',i6,',',i6,')')
  104   format (1x,a,f9.3,a)
  105   format (1x,a,1pg11.3,a)
  106   format (1x,a,f7.3,a,f7.3,a,f5.0,a)
end subroutine statistic
!
subroutine compute_stat(nx,ny,amap,box, &
     &    valmin,imin,jmin,valmax,imax,jmax,mean,rms,noise,np,nn, &
     &    support)
  !--------------------------------------------------------------
  ! @ private-mandatory
  !
  ! MAPPING
  !    Statistics on image
  !--------------------------------------------------------------
  integer, intent(out) :: np, nn
  integer, intent(in) :: nx,ny
  real, intent(in) :: amap(nx,ny)
  integer, intent(out) :: imin, jmin, imax, jmax
  integer, intent(in) ::  box(4)
  real, intent(out) :: valmin, valmax, mean, rms, noise
  logical, intent(in), optional :: support(nx,ny)
  !
  integer i,j
  real val, mean2
  !
  valmin = 1e30                ! ??
  valmax = -1e30
  mean = 0.
  mean2 = 0.
  noise = 0.
  nn = 0
  np = 0
  !
  if (present(support)) then
    do i = box(1),box(3)
      do j = box(2),box(4)
        val = amap(i,j)
        if (support(i,j)) then
          np  = np+1
          mean = mean+val
          mean2 = mean2+val*val
          if (valmax.lt.val) then
            valmax = val
            imax = i
            jmax = j
          endif
          if (valmin.gt.val) then
            valmin= val
            imin = i
            jmin = j
          endif
        else
          nn = nn+1
          noise = noise+val*val
        endif
      enddo
    enddo
  else
    do i = box(1),box(3)
      do j = box(2),box(4)
        val = amap(i,j)
        mean = mean+val
        mean2 = mean2+val*val
        if (valmax.lt.val) then
          valmax = val
          imax = i
          jmax = j
        endif
        if (valmin.gt.val) then
          valmin= val
          imin = i
          jmin = j
        endif
      enddo
    enddo
    np  = (box(4)-box(2)+1)*(box(3)-box(1)+1)
  endif
  !
  mean = mean/np
  mean2 = mean2/np
  rms = sqrt(mean2-mean*mean)
  if (nn.ne.0) then
    noise = sqrt(noise/nn)
  else
    noise = rms
  endif
end subroutine compute_stat

subroutine do_stokes(line,comm,error)
  use gildas_def
  use gkernel_interfaces
  use gbl_message
  !
  ! @ private
  !
  ! STOKES Type FileIn [FileOut] 
  !
  character(len=*), intent(in) :: line
  character(len=*), intent(in) :: comm
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='STOKES'
  character(len=filename_length) :: namei, nameo
  character(len=commandline_length) :: chain
  character(len=4) :: the_stokes, stokes(9)
  character(len=12) :: argu
  integer :: i,n,ni,no,ier
  data stokes/'NONE', 'I', 'Q', 'U', 'V', 'LL', 'RR', 'HH', 'VV'/
  !
  call sic_ke(line,0,1,argu,n,.true.,error)
  call sic_ambigs (rname,argu,the_stokes,i,stokes,9,error)
  if (error) return
  !
  n = sic_narg(0)
  if (n.eq.3) then
    call sic_ch(line,0,2,namei,ni,.true.,error)
    call sic_ch(line,0,3,nameo,no,.true.,error)
    chain = '@ nostokes '//trim(the_stokes)//' '//namei(1:ni)//' '//nameo(1:no)
  else if (n.eq.2) then
    call sic_ch(line,0,2,namei,ni,.true.,error)
    chain = '@ nostokes '//trim(the_stokes)//' '//namei(1:ni)
  else
    call gag_message(seve%e,rname,'Invalid number of arguments')
    error = .true.
    return
  endif
  !
  call exec_program(chain)
end subroutine do_stokes

program casa_to_uvfits
  use, intrinsic :: iso_fortran_env
  character(len=128) :: fileou,filein,line
  integer :: iunit, ounit, punit ! , eunit
  logical :: error
  integer :: ier
  character(len=20) :: v ! Version number
  v = '1.1-02 24-June-2019' ! Remove leading spaces in names
  !
  !iunit = input_unit  ! Sdt IN
  !ounit = output_unit ! Sdt OUT
  !eunit = error_unit  ! Sdt Err
  iunit = 2
  punit = 1
  !
  write(*,*) 'casa_uvfits '//v//' S.Guilloteau, E.Chapillon'
  !
  if (iunit.ne.input_unit) then
    filein = 'listobs.txt'
    open(unit=iunit,file=filein,status='old',iostat=ier)
    if (ier.ne.0) then
      write(*,*) ' ERROR  listobs.txt file does not exists'
      error stop "CASA_UVFITS failed" !       call sysexi(fatale) 
    endif
    read(iunit,'(A)',iostat=ier) line
    if (ier.ne.0) then
      write(*,*) ' ERROR  listobs.txt file is empty'
      error stop " CASA_UVFITS failed" !      call sysexi(fatale) 
    endif
    rewind(iunit)
  endif
  !
  if (punit.ne.output_unit) then
    fileou = 'casa2uvfits.py'
    open(unit=punit,file=fileou)
    rewind(punit)
  endif
  !
  call casa_uvfits(iunit,punit,error)
  if (iunit.ne.input_unit) close(iunit)
  if (punit.ne.output_unit) close(punit)
  if (error) then
    write(*,*) ' ERROR  Could not interpret listobs.txt file'
    error stop " CASA_UVFITS failed" !      call sysexi(fatale) 
  endif
  if (punit.ne.output_unit) then
    write(*,*)  'Script "casa2uvfits.py" created'
    write(*,*) "Use execfile('casa2uvfits.py') to execute"
  endif
  !
contains

subroutine casa_uvfits(iunit,punit,error)
  integer, intent(in) :: iunit, punit
  logical, intent(out) :: error
  !
  ! Scan a "CASA listobs" output file
  ! to write a script for MSTRANSFORM + EXPORTUVFITS
  !
  character(len=1024) :: line, lstring
  character(len=512) :: msname
  integer, parameter :: m_sources=1024 ! More than enough even for ALMA
  integer :: ier,i,j,l,iwin,isour,n_sources,n_fields,n_spw,n_win,n_sou,id
  character(len=20) :: sname, source_name(m_sources), ctmp
  real, allocatable :: win_resol(:), spw_resol(:) 
  character(len=20), allocatable :: field_name(:), win_crest(:), spw_crest(:), spw_center(:)
  character(len=44), allocatable :: spw_name(:), win_name(:)
  character(len=80), allocatable :: win_string(:), names(:) 
  integer, allocatable :: spw_id(:), field_id(:)
  logical, allocatable :: spw_keep(:), spw_ignore(:)
  integer :: iresol, ichan, icenter, k
  !
  error = .true.
  !
  n_sources = 0
  read(iunit,'(A)',iostat=ier) line
  if (ier.ne.0) return
  ! 
  ! Find the MS name : locate the last /
  read(iunit,'(A)') line
  i = 1
  do 
    j = index(line(i:),"/")
    if (j.eq.0) then
      msname = line(i:)
      j = index(msname,' ')
      msname(j:) = ' '
      exit
    else
      i = i+j
    endif
  enddo
  write(ounit,*) "Measurement Set name "//trim(msname)
  !
  k = 2
  !
  ! Loop on input lines
  ! 1) Search for Fields:
  do 
    k = k+1
    read(iunit,'(A)',iostat=ier) line
    if (ier.ne.0) exit
    !
    if (line(1:8).eq."Fields: ") then
      read(line(9:),*) n_fields
      allocate(field_id(n_fields),field_name(n_fields),stat=ier)
      exit
    else if (index(line,'OBSERVE_TARGET').ne.0) then
!123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 
!  Date        Timerange (UTC)          Scan  FldId FieldName             nRows     SpwIds   Average Interval(s)    ScanIntent
!  05-Aug-2016/11:28:49.9 - 11:29:06.0     2      0 J0510+1800               19866  [0]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
!              11:29:26.0 - 11:34:28.4     3      0 J0510+1800              189200  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_BANDPASS#ON_SOURCE,CALIBRATE_FLUX#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
      sname = line(52:70)
      isour = 0
      do i=1,n_sources
        if (sname.eq.source_name(i)) then
          isour = i
          exit
        endif
      enddo
      if (isour.eq.0) then
        n_sources = n_sources+1
        source_name(n_sources) = sname
      endif
    endif
  enddo
  ! read the Field names
!123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 
!Fields: 3
!  ID   Code Name                RA               Decl           Epoch   SrcId      nRows
!  0    none J0510+1800          05:10:02.369000 +18.00.41.58200 ICRS    0         853622
  read(iunit,'(A)',iostat=ier) line
  k = k+1
  if (ier.ne.0) then
    write(ounit,*) 'Read error at line ',k,ier
    return
  endif
  do i=1,n_fields
    read(iunit,'(A)') line
    read(line(1:8),*) field_id(i)
    field_name(i) = line(13:31)
  enddo
  !
  write(ounit,*) "Found ",n_sources," Sources and ",n_fields," fields"
  !
  ! 2) Search for Spectral Windows:
!         1         2         3         4         5         6         7         8         9         10        11
!123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 1234
!Spectral Windows:  (8 unique spectral windows and 1 unique polarization setups)
!  SpwID  Name                                     #Chans   Frame   Ch0(MHz)  ChanWid(kHz)  TotBW(kHz) CtrFreq(MHz) BBC Num  Corrs  
!  0      X54283480#ALMA_RB_06#BB_2#SW-01#FULL_RES    128   TOPO  231028.428     15625.000   2000000.0 232020.6156        2  XX  YY
!
  do 
    read(iunit,'(A)',iostat=ier) line
    k = k+1
    if (ier.ne.0) then
      write(ounit,*) 'Read error at line ',k,ier
      return
    endif
    !
    if (line(1:18).eq."Spectral Windows: ") then
      read(line(21:),*) n_spw
      allocate(spw_name(n_spw),spw_id(n_spw),win_string(n_spw),win_name(n_spw),spw_crest(n_spw),win_crest(n_spw),& 
      & win_resol(n_spw),spw_resol(n_spw),spw_center(n_spw),spw_keep(n_spw),spw_ignore(n_spw))
      exit
    endif
  enddo
  read(iunit,'(A)',iostat=ier) line
  k = k+1
  if (ier.ne.0) then
    write(ounit,*) 'Read error at line ',k,ier
    return
  endif
  write(ounit,*) "Found ",n_spw," Spectral Windows"
  !
  ! Caution: The Name field is of variable length, depending on which version of CASA is used. So use the #Chan and ChanWid has
  ! field position indicators
  ichan  = index(line,'#Chan')-1
  iresol = index(line,'ChanWid(kHz)')
  icenter = index(line,'CtrFreq')
  ! Some MS do not have the above information, use the "Ch0(MHz)" stuff just after the "Frame" keyword
  if (icenter.eq.0) icenter = index(line,'Frame')+5
  !
  do i=1,n_spw
    ! Skip blank lines
    j = 0
    do while(j.eq.0)
      read(iunit,'(A)') line      
      k = k+1
      j = len_trim(line)
    enddo
    !
    !!Print *,'SPW ',i,trim(line)
    if (len_trim(line).eq.0) then
      spw_keep(i) = .false.
      spw_ignore(i) = .true.
    else
      !
      read(line(1:8),*,iostat=ier) spw_id(i)
      if (ier.ne.0) then
        Print *,'Ignoring '//trim(line)
        spw_keep(i) = .false.
        spw_ignore(i) = .true.
      else
        spw_ignore(i) = .false.
        spw_name(i) = line(10:ichan)
        spw_crest(i) = " "
        read(line(iresol:iresol+9),*) spw_resol(i)
        !!Print *,'Resol ',i, line(iresol:iresol+9), spw_resol(i)
        spw_center(i) = line(icenter:icenter+12)
        spw_resol(i) = abs(spw_resol(i))
        !
        ! Retain only the Full Resolution windows
        if (index(line,'FULL_RES').ne.0) then
          spw_keep(i) = .true.
        else
          spw_keep(i) = .false.
        endif
      endif
    endif
    !!Print *,'SPW ',i,spw_keep(i)
  enddo
  !
  ! Special case if no window is selected
  if (.not.(any(spw_keep(1:n_spw)))) then
    Print *,'No FULL_RES windows, falling back on non-ignored windows ',n_spw
    spw_keep(1:n_spw) = .not.spw_ignore(1:n_spw)
    ! They have no name at that stage too... Give them a unique one.
    do i=1,n_spw
      spw_name(i) = char(i-1+ichar('A'))
    enddo
  endif
  if (.not.(any(spw_keep(1:n_spw)))) then
    Print *,'No valid window found '
    error = .true.
    return
  endif
  !
  ! 3) Search for Rest Frequencies
!         1         2         3         4
!123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 
!Sources: 24
!  ID   Name                SpwId RestFreq(MHz)  SysVel(km/s) 
!  0    J0510+1800          0     232006.965027  0     
! or
!  0    The Name            0     -              -       
  do
    read(iunit,'(A)',iostat=ier) line
    k = k+1
    if (ier.ne.0) then
      write(ounit,*) 'Read error at line ',k,ier
      return
    endif
    !
    if (line(1:9).eq."Sources: ") then
      read(line(10:),*) n_sou
      exit
    endif
  enddo
  read(iunit,'(A)',iostat=ier) line
  if (ier.ne.0) return
  do i=1,n_sou
    read(iunit,'(A)') line
    read(line(28:32),*,iostat=ier) id
    if (ier.ne.0) then
      ! Some lines have no ID 
      !!Print *,'Ignoring '//line(1:46)
    else
      do j=1,n_spw
        if (spw_id(j).eq.id) then
          if (line(34:46).eq."-") then
            Print *,'Undefined frequency for ',j,' using ',spw_center(j)
            spw_crest(j) = spw_center(j)
          else if (spw_crest(j).eq." ") then
            Print *,'Void frequency for ',j,' using ',spw_center(j)
            spw_crest(j) = line(34:46)
          else if (spw_crest(j).ne.line(34:46)) then
            write(ounit,*) 'E-SCAN_CASA,  Inconsistent frequency setting for SPW ',spw_id(j) &
              & ,spw_crest(j),' .ne. ',line(34:46)
            spw_keep(i) = .false.
          endif
          exit
        endif
      enddo
    endif
  enddo
  !
  Print *,'SPW_CREST ',spw_crest
  !
  !
  ! Group the SPW by identical names
  n_win = 0
  do i=1,n_spw
    Print *,'#B Window ',i,' keep ',spw_keep(i),'Name: ',spw_name(i)
    if (spw_keep(i)) then
      iwin = 0
      do j=1,n_win
        if (win_name(j).eq.spw_name(i)) then
          l = len_trim(win_string(j))+1
          write(win_string(j)(l:),'(A,I0)') ",",spw_id(i)
          iwin = j
          exit
        endif
      enddo
      if (iwin.eq.0) then
        n_win = n_win+1
        win_name(n_win) = spw_name(i)
        win_crest(n_win) = spw_crest(i)
        win_resol(n_win) = spw_resol(i)
        write(win_string(n_win),'(I0)') spw_id(i)
      endif
    endif
  enddo
  !
  ! Select only the Target Sources
  ! ...
  !
  ! Printout
  write(ounit,*) n_sources,' Target Sources '
  do i=1,n_sources
    write(ounit,*) source_name(i)
  enddo
  write(ounit,*) n_fields,'Fields '
  do i=1,n_fields
    write(ounit,*) field_id(i),field_name(i)
  enddo
  write(ounit,*) n_spw,'SPWs  '
  do i=1,n_spw
    write(ounit,*) spw_id(i),spw_name(i)
  enddo  
  write(ounit,*) n_win,'Windows  '
  do i=1,n_win
    write(ounit,*) win_crest(i),win_resol(i),trim(win_string(i))
  enddo  
  !
  allocate(names(max(n_win,n_sources)),stat=ier)
  !
  rewind(punit)
  write(punit,'(A)') "# Python MS to UVFITS conversion script"
  write(punit,'(A)') "# created by Task CASA_UVFITS"
  write(punit,'(A)') "#      Author S.Guilloteau 15-May-2018"
  write(punit,'(A)') " "
  write(punit,'(A)') "# Original Measurement Set"
  write(punit,'(A)') "my_invis='"//trim(msname)//"'"
  write(punit,'(A)') " "
  write(punit,'(A)') "# Measurement Set Content in Sources & Spectral setups"
  !  
  ! Build the field name Python tuple
  do i=1,n_sources
    names(i) = source_name(i)
    do j=1,len_trim(names(i))
      if (names(i)(j:j).eq.".") then
        names(i)(j:) = "*" ! The source parsing in Python does not handle "." properly
        exit
      endif
    enddo
  enddo
  call tuples("my_fields",n_sources,names,lstring)
  write(punit,'(A)') trim(lstring)
  !
  ! Build the file names from the truncated Field names
  do i=1,n_sources
    do j=1,len_trim(names(i))
      if (names(i)(j:j).eq." ") then
        names(i)(j:j) = "_"
      else if (names(i)(j:j).eq."*") then
        names(i)(j:) = " " ! Truncate the name there
        exit
      endif
    enddo
  enddo
  call tuples("my_names",n_sources,names,lstring)
  write(punit,'(A)') trim(lstring)
  !
  ! Build the window names Python tuple
  call tuples("my_windows",n_win,win_string,lstring)
  write(punit,'(A)') trim(lstring)
  !
  ! Build the frequency Python tuple
  do i=1,n_win
    names(i) = trim(adjustl(win_crest(i)))//"MHz"
  enddo
  call tuples("my_frequency",n_win,names,lstring)
  write(punit,'(A)') trim(lstring)
  !
  ! Build the resolution Python tuple
  do i=1,n_win
    write(ctmp,'(f11.3)')  win_resol(i) 
    names(i) = adjustl(ctmp)
  enddo
  call tupler("my_resol",n_win,names,lstring)
  write(punit,'(A)') trim(lstring)
  !
  do i=1,n_win
    names(i) = adjustl(win_crest(i))
    j = index(names(i),'.')
    if (j.ne.0) names(i)(j:) = ' ' ! We take the risk of duplication ?
  enddo
  call tuples("my_wids",n_win,names,lstring)
  write(punit,'(A)') trim(lstring)
  !
  write(punit,'(A)') ' '
  write(punit,'(A)') '# Remember current visibility '
  write(punit,'(A)') 'if globals().has_key("vis"):'
  write(punit,'(A)') '  old_vis=vis '
  write(punit,'(A)') 'else:'
  write(punit,'(A)') "  old_vis=' '"  !  "sys.exit('ERROR: Argument vis failed to verify')"
  write(punit,'(A)') ' '
  !
  ! Customization part
  write(punit,'(A)') ' '
  write(punit,'(A)') '# Obtain options from  SPACESAVING and DRYRUN globals'
  write(punit,'(A)') 'my_savings=2'
  write(punit,'(A)') 'if globals().has_key("SPACESAVING"):'
  write(punit,'(A)') "  print 'SPACESAVING =', SPACESAVING"
  write(punit,'(A)') '  if (type(SPACESAVING)!=int or SPACESAVING<0):'
  write(punit,'(A)') "      sys.exit('ERROR: SPACESAVING value not permitted, must be int.\n'"
  write(punit,'(A)') "            + 'Valid values: >2 = delete *.ms.tmp on the fly,\n'"
  write(punit,'(A)') "            + '              1 = delete *.ms.tmp at end,\n'"
  write(punit,'(A)') "            + '              0 = do not delete *.ms.tmp')"
  write(punit,'(A)') "  my_savings = SPACESAVING"
  write(punit,'(A)') ' '
  write(punit,'(A)') '# my_dryrun=0 indicates mstransform & exportuvfits should be executed'
  write(punit,'(A)') 'my_dryrun=0'
  write(punit,'(A)') 'if globals().has_key("DRYRUN"):'
  write(punit,'(A)') "  print 'DRYRUN =', DRYRUN"
  write(punit,'(A)') '  my_dryrun = DRYRUN'
  write(punit,'(A)') ' '
  write(punit,'(A)') '# my_savings>1 indicates .ms.tmp should be deleted in the loop'
  write(punit,'(A)') '# my_savings>0 indicates .ms.tmp should be deleted at end'
  write(punit,'(A)') '# my_savings=0 indicates .ms.tmp should be kept'
  !
  ! Now write up the default part of the script
  !
  ! mstransfrom  global parameters
  !
  write(punit,'(A)') '#'
  write(punit,'(A)') '# Main mstransform keywords'
  write(punit,'(A)') 'regridms=True'
  ! We do not know exactly where is the Calibrated data, but in recent versions
  ! it seems to be in 'corrected' column. Unfortunately "mstransform" does not
  ! automatically fall back to 'data'. So we must find out... And CASA is tricky:
  ! case matters in input for some tasks, but in the MS it is in upper case.
  ! Furthermore, the column name is 'corrected' in Input, but sometimes 
  ! 'CORRECTED_DATA' in the MS.
  write(punit,'(A)') "# find out if the data in is 'data' or 'corrected'"
  write(punit,'(A)') "my_datacolumn = 'data'"
  write(punit,'(A)') "tb.open(my_invis, nomodify=True)"
  write(punit,'(A)') "for cname in tb.colnames() :"
  write(punit,'(A)') "  if (cname=='CORRECTED') :"
  write(punit,'(A)') "    my_datacolumn = 'corrected'"
  write(punit,'(A)') "  elif (cname=='CORRECTED_DATA') :"
  write(punit,'(A)') "    my_datacolumn = 'corrected'"
  write(punit,'(A)') "tb.close()"
  ! The main goal in this step of "mstransform" is to re-align the input
  ! spectral window(S) into a single output one in the new Frame, in general LSRK
  ! So we must combine them. The number of combined channels will depend
  ! on the differential Doppler effect between the various days
  write(punit,'(A)') "# This is essential - Note that it is combinespwS (contrary to exportuvfits)"
  write(punit,'(A)') "combinespws=True"
  ! No need to keep totally flagged data...
  write(punit,'(A)') 'keepflags=False'
  write(punit,'(A)') ' '
  ! 
  ! exportuvfits  global parameters
  ! Fortunately, exportuvfits falls back to 'data' when 'corrected' is not found
  write(punit,'(A)') '# Main exportuvfits keywords'
  write(punit,'(A)') 'overwrite=True'
  write(punit,'(A)') '#'
  !
  ! Main body, with two outer loops
  write(punit,'(A)') '# Loop on fields & windows'
  write(punit,'(A)') 'for my_j in range(len(my_fields)):'
  write(punit,'(A)') '  my_field = my_fields[my_j]'
  write(punit,'(A)') '  my_name = my_names[my_j]'
  write(punit,'(A)') '  print "Current source", my_field'
  write(punit,'(A)') '  for my_i in range(len(my_windows)):'
  write(punit,'(A)') '      print "SPW ", my_i, " group :", my_windows[my_i]'
  write(punit,'(A)') '      my_vis=my_name + "-" + my_wids[my_i] +".ms.tmp"'
  write(punit,'(A)') '      print "My Vis ", my_vis'
  write(punit,'(A)') ' '
  write(punit,'(A)') '      vis       = my_invis'
  write(punit,'(A)') '      outputvis = my_vis'
  write(punit,'(A)') '      field     = my_field'
  write(punit,'(A)') '      spw       = my_windows[my_i]'
  write(punit,'(A)') '      restfreq  = my_frequency[my_i]'
  write(punit,'(A)') '      datacolumn = my_datacolumn'
  write(punit,'(A)') '      if (my_resol[my_i]>10000.):'
  write(punit,'(A)') "        outframe  = ''"
  write(punit,'(A)') "      else:"
  write(punit,'(A)') "        outframe  = 'LSRK'"
  write(punit,'(A)') ' '      
  write(punit,'(A)') '      inp(mstransform)'
  write(punit,'(A)') '      if (my_dryrun==0): '
  write(punit,'(A)') "         os.system('rm -rf '+my_vis)"
  write(punit,'(A)') '         mstransform()'
  write(punit,'(A)') '      print "Done      mstransform()"'
  write(punit,'(A)') ' '      
  write(punit,'(A)') '      my_fits  = my_name + "-" + my_wids[my_i] +".uvfits"'
  write(punit,'(A)') '      vis      = my_vis'
  write(punit,'(A)') '      fitsfile = my_fits'
  write(punit,'(A)') "      field    = ''"
  write(punit,'(A)') "      spw      = ''"
  write(punit,'(A)') "      combinespw = True"
  write(punit,'(A)') "      datacolumn = 'data'" 
  write(punit,'(A)') '      inp(exportuvfits)'
  write(punit,'(A)') '      if (my_dryrun==0):'
  write(punit,'(A)') '         exportuvfits()'
  write(punit,'(A)') '         if (my_savings>1): '
  write(punit,'(A)') "           os.system('rm -rf '+my_vis)"
  write(punit,'(A)') ' '
  write(punit,'(A)') '#'
  write(punit,'(A)') '# Final cleanup if needed'
  write(punit,'(A)') 'if (my_dryrun==0): '
  write(punit,'(A)') '   if (my_savings>0): '
  write(punit,'(A)') "      os.system('rm -rf *.ms.tmp')"
  write(punit,'(A)') '   else:'  
  write(punit,'(A)') '      print "To clean scratch MS, use: rm -rf *.ms.tmp"'
  write(punit,'(A)') ' '
  write(punit,'(A)') 'vis=old_vis '
  write(punit,'(A)') 'print "Done      mstransform() + exportuvfits()"'
  close(punit)
  !
  error = .false.
  !  
#if defined(BIDON)
! Sample result from casa 'listobs()' used to determine read formats
! and required operations 
!  
123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 
         1         2         3         4         5         6         7
================================================================================
           MeasurementSet Name:  /Volumes/Travail/TRAVAIL/DG_Tau-B/2015.1.01108.S/science_goal.uid___A001_X2fe_X49d/group.uid___A001_X2fe_X49e/member.uid___A001_X2fe_X49f/calibrated/calibrated.ms      MS Version 2
================================================================================
   Observer: flouvet     Project: uid://A001/X1ed/Xcb2  
Observation: ALMA

  Telescope Observation Date    Observer       Project        
  ALMA      [                   4.97711e+09, 4.97712e+09]flouvet        uid://A001/X1ed/Xcb2
  ALMA      [                   4.97797e+09, 4.97798e+09]flouvet        uid://A001/X1ed/Xcb2
Data records: 4369330       Total elapsed time = 864816 seconds
   Observed from   05-Aug-2016/11:28:49.9   to   15-Aug-2016/11:42:26.2 (UTC)

   ObservationID = 0         ArrayID = 0
  Date        Timerange (UTC)          Scan  FldId FieldName             nRows     SpwIds   Average Interval(s)    ScanIntent
  05-Aug-2016/11:28:49.9 - 11:29:06.0     2      0 J0510+1800               19866  [0]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              11:29:26.0 - 11:34:28.4     3      0 J0510+1800              189200  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_BANDPASS#ON_SOURCE,CALIBRATE_FLUX#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              11:34:54.0 - 11:35:10.1     4      0 J0510+1800               19866  [0]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              11:35:27.8 - 11:35:58.1     5      0 J0510+1800               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              11:36:17.0 - 11:36:47.2     6      1 J0429+2724               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_WVR#ON_SOURCE,OBSERVE_CHECK_SOURCE#ON_SOURCE]
              11:37:04.3 - 11:37:20.4     7      2 DG_Tau_B                 19866  [0]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              11:37:31.8 - 11:44:06.5     8      2 DG_Tau_B                245960  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              11:44:27.1 - 11:44:57.4     9      0 J0510+1800               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              11:45:18.8 - 11:51:53.5    10      2 DG_Tau_B                245960  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              11:52:13.5 - 11:52:29.7    11      0 J0510+1800               19866  [0]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              11:52:59.4 - 11:53:29.6    12      0 J0510+1800               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              11:53:49.6 - 11:54:19.8    13      1 J0429+2724               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_WVR#ON_SOURCE,OBSERVE_CHECK_SOURCE#ON_SOURCE]
              11:54:36.8 - 11:54:52.9    14      2 DG_Tau_B                 19866  [0]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              11:55:03.9 - 12:01:38.6    15      2 DG_Tau_B                245960  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              12:01:59.1 - 12:02:29.3    16      0 J0510+1800               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              12:02:50.8 - 12:09:25.4    17      2 DG_Tau_B                245960  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              12:09:45.0 - 12:10:01.1    18      0 J0510+1800               19866  [0]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              12:10:39.9 - 12:11:10.1    19      0 J0510+1800               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              12:11:30.3 - 12:12:00.5    20      1 J0429+2724               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_WVR#ON_SOURCE,OBSERVE_CHECK_SOURCE#ON_SOURCE]
              12:12:18.2 - 12:12:34.4    21      2 DG_Tau_B                 19866  [0]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              12:12:44.7 - 12:19:19.4    22      2 DG_Tau_B                245960  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              12:19:40.2 - 12:20:10.4    23      0 J0510+1800               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              12:20:34.1 - 12:27:08.8    24      2 DG_Tau_B                245960  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              12:27:28.4 - 12:27:44.5    25      0 J0510+1800               19866  [0]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              12:28:14.2 - 12:28:44.4    26      0 J0510+1800               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              12:29:04.3 - 12:29:34.6    27      1 J0429+2724               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_WVR#ON_SOURCE,OBSERVE_CHECK_SOURCE#ON_SOURCE]
              12:29:51.9 - 12:30:08.0    28      2 DG_Tau_B                 19866  [0]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              12:30:27.1 - 12:37:01.7    29      2 DG_Tau_B                245960  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              12:37:23.4 - 12:37:53.6    30      0 J0510+1800               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              12:38:14.7 - 12:40:45.9    31      2 DG_Tau_B                 94600  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              12:41:07.8 - 12:41:23.9    32      0 J0510+1800               19866  [0]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              12:41:53.9 - 12:42:24.1    33      0 J0510+1800               18920  [0,1,2,3]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]

   ObservationID = 1         ArrayID = 0
  Date        Timerange (UTC)          Scan  FldId FieldName             nRows     SpwIds   Average Interval(s)    ScanIntent
  15-Aug-2016/10:26:08.2 - 10:26:24.3    34      0 J0510+1800               15561  [4]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              10:26:53.9 - 10:31:56.3    35      0 J0510+1800              148200  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_BANDPASS#ON_SOURCE,CALIBRATE_FLUX#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              10:32:20.1 - 10:32:36.2    36      0 J0510+1800               15561  [4]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              10:32:50.8 - 10:33:21.1    37      0 J0510+1800               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              10:33:38.3 - 10:34:08.5    38      1 J0429+2724               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_WVR#ON_SOURCE,OBSERVE_CHECK_SOURCE#ON_SOURCE]
              10:34:26.1 - 10:34:42.2    39      2 DG_Tau_B                 15561  [4]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              10:34:53.1 - 10:41:27.8    40      2 DG_Tau_B                192660  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              10:41:48.1 - 10:42:18.4    41      0 J0510+1800               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              10:42:38.5 - 10:49:13.2    42      2 DG_Tau_B                192660  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              10:49:33.0 - 10:49:49.1    43      0 J0510+1800               15561  [4]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              10:50:17.3 - 10:50:47.5    44      0 J0510+1800               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              10:51:11.6 - 10:51:41.9    45      1 J0429+2724               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_WVR#ON_SOURCE,OBSERVE_CHECK_SOURCE#ON_SOURCE]
              10:51:58.3 - 10:52:18.4    46      2 DG_Tau_B                 15561  [4]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              10:52:29.7 - 10:59:04.3    47      2 DG_Tau_B                192660  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              10:59:28.7 - 10:59:58.9    48      0 J0510+1800               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              11:00:57.6 - 11:07:32.2    49      2 DG_Tau_B                192660  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              11:08:24.3 - 11:08:40.5    50      0 J0510+1800               15561  [4]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              11:09:11.7 - 11:09:41.9    51      0 J0510+1800               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              11:10:00.7 - 11:10:31.0    52      1 J0429+2724               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_WVR#ON_SOURCE,OBSERVE_CHECK_SOURCE#ON_SOURCE]
              11:11:00.3 - 11:11:16.5    53      2 DG_Tau_B                 15561  [4]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              11:11:27.7 - 11:18:02.4    54      2 DG_Tau_B                192660  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              11:18:31.3 - 11:19:01.5    55      0 J0510+1800               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              11:19:29.1 - 11:26:03.8    56      2 DG_Tau_B                192660  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              11:26:29.2 - 11:26:53.0    57      0 J0510+1800               15561  [4]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              11:27:21.1 - 11:27:51.4    58      0 J0510+1800               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              11:28:18.5 - 11:28:48.7    59      1 J0429+2724               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_WVR#ON_SOURCE,OBSERVE_CHECK_SOURCE#ON_SOURCE]
              11:29:14.6 - 11:29:38.4    60      2 DG_Tau_B                 15561  [4]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              11:29:48.7 - 11:36:23.4    61      2 DG_Tau_B                192660  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              11:36:43.1 - 11:37:13.3    62      0 J0510+1800               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
              11:38:10.9 - 11:40:42.1    63      2 DG_Tau_B                 74100  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [OBSERVE_TARGET#ON_SOURCE]
              11:41:03.5 - 11:41:25.1    64      0 J0510+1800               15561  [4]  [0.576] [CALIBRATE_ATMOSPHERE#AMBIENT,CALIBRATE_ATMOSPHERE#HOT,CALIBRATE_ATMOSPHERE#OFF_SOURCE,CALIBRATE_WVR#AMBIENT,CALIBRATE_WVR#HOT,CALIBRATE_WVR#OFF_SOURCE]
              11:41:56.0 - 11:42:26.2    65      0 J0510+1800               14820  [4,5,6,7]  [6.05, 6.05, 6.05, 6.05] [CALIBRATE_PHASE#ON_SOURCE,CALIBRATE_WVR#ON_SOURCE]
           (nRows = Total number of rows per scan) 
Fields: 3
  ID   Code Name                RA               Decl           Epoch   SrcId      nRows
  0    none J0510+1800          05:10:02.369000 +18.00.41.58200 ICRS    0         853622
  1    none J0429+2724          04:29:52.960773 +27.24.37.87624 ICRS    1         134960
  2    none DG_Tau_B            04:27:02.672318 +26.05.30.15109 ICRS    2        3380748
Spectral Windows:  (8 unique spectral windows and 1 unique polarization setups)
  SpwID  Name                                     #Chans   Frame   Ch0(MHz)  ChanWid(kHz)  TotBW(kHz) CtrFreq(MHz) BBC Num  Corrs  
  0      X54283480#ALMA_RB_06#BB_2#SW-01#FULL_RES    128   TOPO  231028.428     15625.000   2000000.0 232020.6156        2  XX  YY
  1      X54283480#ALMA_RB_06#BB_1#SW-01#FULL_RES    960   TOPO  230516.037        61.035     58593.8 230545.3035        1  XX  YY
  2      X54283480#ALMA_RB_06#BB_3#SW-01#FULL_RES    960   TOPO  219595.267       -61.035     58593.8 219566.0009        3  XX  YY
  3      X54283480#ALMA_RB_06#BB_4#SW-01#FULL_RES    960   TOPO  220433.555       -61.035     58593.8 220404.2882        4  XX  YY
  4      X54283480#ALMA_RB_06#BB_2#SW-01#FULL_RES    128   TOPO  231029.786     15625.000   2000000.0 232021.9734        2  XX  YY
  5      X54283480#ALMA_RB_06#BB_1#SW-01#FULL_RES    960   TOPO  230517.430        61.035     58593.8 230546.6967        1  XX  YY
  6      X54283480#ALMA_RB_06#BB_3#SW-01#FULL_RES    960   TOPO  219596.588       -61.035     58593.8 219567.3218        3  XX  YY
  7      X54283480#ALMA_RB_06#BB_4#SW-01#FULL_RES    960   TOPO  220434.876       -61.035     58593.8 220405.6091        4  XX  YY
Sources: 24
  ID   Name                SpwId RestFreq(MHz)  SysVel(km/s) 
  0    J0510+1800          0     232006.965027  0            
  0    J0510+1800          1     230538         0            
  0    J0510+1800          2     219560.358     0            
  0    J0510+1800          3     220398.6842    0            
  1    J0429+2724          1     230538         0            
  1    J0429+2724          0     232006.965027  0            
  1    J0429+2724          2     219560.358     0            
  1    J0429+2724          3     220398.6842    0            
  2    DG_Tau_B            1     230538         9            
  2    DG_Tau_B            0     232006.965027  9            
  2    DG_Tau_B            2     219560.358     9            
  2    DG_Tau_B            3     220398.6842    9            
  0    J0510+1800          4     232006.965027  0            
  0    J0510+1800          5     230538         0            
  0    J0510+1800          6     219560.358     0            
  0    J0510+1800          7     220398.6842    0            
  1    J0429+2724          5     230538         0            
  1    J0429+2724          4     232006.965027  0            
  1    J0429+2724          6     219560.358     0            
  1    J0429+2724          7     220398.6842    0            
  5    DG_Tau_B            5     230538         9            
  5    DG_Tau_B            4     232006.965027  9            
  5    DG_Tau_B            6     219560.358     9            
  5    DG_Tau_B            7     220398.6842    9            
Antennas: 46:
  ID   Name  Station   Diam.    Long.         Lat.                Offset from array center (m)                ITRF Geocentric coordinates (m)        
                                                                     East         North     Elevation               x               y               z
  0    DA41  A004      12.0 m   -067.45.15.9  -22.53.28.0         52.6609     -704.4171       21.7726  2225094.796703 -5440052.421785 -2481687.277348
  1    DA43  A071      12.0 m   -067.45.19.9  -22.53.23.5        -60.7901     -563.2558       23.8843  2225011.316321 -5440147.990974 -2481558.053457
  2    DA44  A134      12.0 m   -067.45.20.4  -22.53.45.6        -76.0034    -1249.4246       24.2039  2224896.299760 -5439906.959912 -2482190.301760
  3    DA46  A034      12.0 m   -067.45.18.4  -22.53.27.8        -18.8313     -698.8163       22.1780  2225029.594430 -5440081.847715 -2481682.275326
  4    DA47  A085      12.0 m   -067.45.10.5  -22.53.20.5        207.6857     -472.2092       16.7974  2225270.736289 -5440073.088670 -2481471.419366
  5    DA48  A074      12.0 m   -067.45.12.1  -22.53.32.0        161.8149     -828.6208       19.2691  2225176.656934 -5439964.246947 -2481800.725557
  6    DA49  A002      12.0 m   -067.45.16.3  -22.53.27.6         40.6333     -690.2503       21.8017  2225085.761085 -5440062.100230 -2481674.237502
  7    DA50  A089      12.0 m   -067.45.19.8  -22.53.39.4        -57.6230    -1056.0764       30.1154  2224943.848412 -5439974.666372 -2482014.484964
  8    DA51  A023      12.0 m   -067.45.17.8  -22.53.26.2         -1.3149     -648.2175       22.0990  2225053.229877 -5440093.366463 -2481635.630404
  9    DA52  A076      12.0 m   -067.45.20.5  -22.53.33.8        -77.9906     -882.7193       24.5705  2224948.593770 -5440040.068799 -2481852.625533
  10   DA53  A081      12.0 m   -067.45.23.9  -22.53.32.5       -174.5616     -842.8373       21.0870  2224863.872445 -5440088.013186 -2481814.529511
  11   DA54  A073      12.0 m   -067.45.22.9  -22.53.28.1       -147.0725     -705.3322       24.2558  2224910.667420 -5440129.817851 -2481689.086344
  12   DA55  A099      12.0 m   -067.45.33.4  -22.53.31.0       -445.2524     -796.0648       17.7405  2224619.055719 -5440204.457010 -2481770.138975
  13   DA56  A100      12.0 m   -067.45.00.9  -22.53.36.1        479.0804     -953.3921       14.3081  2225450.178696 -5439794.977217 -2481913.739571
  14   DA57  A088      12.0 m   -067.45.18.2  -22.53.18.4        -13.0905     -408.0119       24.1745  2225078.424400 -5440186.069988 -2481415.145947
  15   DA58  A110      12.0 m   -067.45.09.2  -22.53.54.8        244.7458    -1530.9470       13.4941  2225147.945277 -5439675.027094 -2482445.475052
  16   DA59  A001      12.0 m   -067.45.16.9  -22.53.27.7         24.1878     -693.3966       21.7931  2225070.073939 -5440067.185715 -2481677.132686
  17   DA60  A101      12.0 m   -067.45.24.0  -22.53.10.5       -177.3504     -163.1875       25.7535  2224962.986782 -5440337.728223 -2481190.209440
  18   DA61  A006      12.0 m   -067.45.15.0  -22.53.28.0         79.0342     -702.0939       21.7770  2225119.549542 -5440043.278017 -2481685.138868
  19   DA62  A103      12.0 m   -067.44.59.5  -22.53.17.7        519.2605     -384.4381        8.7466  2225569.223936 -5439979.852999 -2481387.427705
  20   DA63  A091      12.0 m   -067.45.28.7  -22.53.24.2       -312.9116     -584.7724       23.7284  2224774.741979 -5440235.546349 -2481577.815095
  21   DA64  A079      12.0 m   -067.45.13.6  -22.53.35.0        116.8374     -920.2891       22.6280  2225122.700654 -5439951.132882 -2481886.480533
  22   DA65  A096      12.0 m   -067.45.29.9  -22.53.15.7       -347.1459     -322.7967       23.2980  2224781.474488 -5440342.450209 -2481336.298820
  23   DV01  A065      12.0 m   -067.45.15.8  -22.53.24.6         56.5631     -597.4552       20.5167  2225113.721213 -5440088.382476 -2481588.249961
  24   DV03  A097      12.0 m   -067.45.15.1  -22.53.43.9         75.7014    -1195.0804       24.7063  2225044.882099 -5439869.531470 -2482140.434352
  25   DV04  A015      12.0 m   -067.45.15.3  -22.53.26.0         68.8261     -640.1825       21.0225  2225118.955532 -5440068.788774 -2481627.809377
  26   DV05  A072      12.0 m   -067.45.12.6  -22.53.24.0        147.1735     -580.5874       18.1837  2225199.254332 -5440058.163238 -2481571.802983
  27   DV06  A008      12.0 m   -067.45.15.4  -22.53.26.8         67.5587     -667.6873       20.9558  2225113.708967 -5440059.309351 -2481653.122280
  28   DV07  A084      12.0 m   -067.45.16.9  -22.53.37.5         23.9631     -996.3192       27.1379  2225027.119784 -5439962.760871 -2481958.276503
  29   DV08  A106      12.0 m   -067.45.14.0  -22.53.02.5        105.8162       86.4720       24.7040  2225261.467540 -5440319.499949 -2480959.792518
  30   DV09  A014      12.0 m   -067.45.15.1  -22.53.26.4         74.5074     -654.2095       20.9871  2225122.135828 -5440061.557800 -2481640.718087
  31   DV10  A087      12.0 m   -067.45.08.3  -22.53.33.2        269.0964     -864.0698       16.2364  2225269.668428 -5439908.282917 -2481832.202850
  32   DV11  A086      12.0 m   -067.45.27.0  -22.53.29.3       -262.5023     -744.4841       26.4666  2224798.837957 -5440161.299263 -2481726.014880
  33   DV12  A007      12.0 m   -067.45.15.1  -22.53.27.3         74.0153     -681.2928       21.3235  2225117.809415 -5440052.280278 -2481665.799458
  34   DV14  A104      12.0 m   -067.45.36.4  -22.53.21.2       -530.9015     -492.4911       20.3385  2224585.380723 -5440348.385963 -2481491.481586
  35   DV15  A048      12.0 m   -067.45.15.8  -22.53.30.1         56.5643     -769.5873       20.6083  2225088.406213 -5440026.487837 -2481746.862261
  36   DV16  A102      12.0 m   -067.45.22.9  -22.53.46.9       -145.7588    -1287.0493       22.7273  2224825.684392 -5439918.555820 -2482224.387683
  37   DV17  A092      12.0 m   -067.45.10.1  -22.53.39.1        217.6032    -1047.7089       20.8479  2225196.572435 -5439865.588559 -2482003.171197
  38   DV18  A009      12.0 m   -067.45.16.1  -22.53.26.1         48.2539     -644.4617       21.0136  2225099.282100 -5440075.028456 -2481631.748149
  39   DV19  A135      12.0 m   -067.45.02.2  -22.53.16.5        442.8916     -348.0848       12.4344  2225505.182937 -5440024.999751 -2481355.370832
  40   DV22  A017      12.0 m   -067.45.15.9  -22.53.26.8         51.3631     -665.5904       21.3591  2225099.168855 -5440066.539247 -2481651.347418
  41   DV24  A075      12.0 m   -067.45.17.9  -22.53.21.4         -4.5597     -499.7005       22.5310  2225072.246370 -5440148.431407 -2481498.976123
  42   DV25  A095      12.0 m   -067.45.00.7  -22.53.28.6        485.1070     -722.0920       10.6814  2225488.560223 -5439872.879660 -2481699.246039
  43   DA45  A094      12.0 m   -067.45.27.0  -22.53.37.1       -264.4596     -984.7304       19.8501  2224759.342944 -5440069.895267 -2481944.765337
  44   DV13  A064      12.0 m   -067.45.14.7  -22.53.31.4         85.6565     -808.0275       21.0170  2225109.813380 -5440001.983029 -2481782.434110
  45   DV15  A113      12.0 m   -067.44.48.6  -22.53.38.4        831.0666    -1024.4282        3.2480  2225761.609253 -5439626.691469 -2481974.877491
#endif
!  
end subroutine casa_uvfits
!
subroutine tuples(prefix,n,names,lstring)
  character(len=*), intent(in) :: prefix
  integer, intent(in) :: n
  character(len=*), intent(in) :: names(n)
  character(len=*), intent(out) :: lstring
  !
  integer :: l,i
  lstring = trim(prefix)//"=['"//trim(names(1))//"'"
  l = len_trim(lstring)+1
  do i=2,n
    lstring(l:) = ",'"//trim(names(i))//"'"
    l = len_trim(lstring)+1
  enddo
  lstring(l:l)= "]"
end subroutine tuples

subroutine tupler(prefix,n,names,lstring)
  character(len=*), intent(in) :: prefix
  integer, intent(in) :: n
  character(len=*), intent(in) :: names(n)
  character(len=*), intent(out) :: lstring
  !
  integer :: l,i
  lstring = trim(prefix)//"=["//trim(names(1))
  l = len_trim(lstring)+1
  do i=2,n
    lstring(l:) = ","//trim(names(i))
    l = len_trim(lstring)+1
  enddo
  lstring(l:l)= "]"
end subroutine tupler

end program

subroutine dofft (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv   &
     &    ,ubias,vbias,ubuff,vbuff,ctype)
  use gildas_def
  use gkernel_interfaces
  use clean_default
  !----------------------------------------------------------------------
  ! @ public
  !
  ! GILDAS  UV_MAP
  !   Compute FFT of image by gridding UV data
  !   Operational version using the fastest method.
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  complex, intent(out) :: map(nc+1,nx,ny)     ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  integer, intent(in) :: ctype                ! type of gridding
  !
  integer :: ipara
  logical :: error
  ! Initialize
  map = 0.0
  ipara = omp_grid
  !
  if (ctype.eq.1) then  ! Simple nearest cell
    call dofft_fast (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv)
  else                  ! Gridding with extended support
    if (ipara.eq.0) then
      call dofft_quick (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
    else if (ipara.eq.-1) then
      call dofft_parallel_v_pseudo (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
    else if (ipara.eq.-2) then
      call dofft_parallel_v_true (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
    else if (ipara.eq.-3) then
      call dofft_quick_para (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
    else if (ipara.eq.-4) then
      call dofft_quick_debug (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
    else if (ipara.eq.-11) then
      call dofft_parallel_v_pseudo_out (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
    else if (ipara.eq.-12) then
      call dofft_parallel_v_true_out (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
    else if (ipara.eq.1) then
      call dofft_slow (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
    else if (ipara.eq.2) then
      call dofft_parallel_x (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
    else if (ipara.eq.3) then
      call dofft_parallel_y (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
    endif
  endif
end subroutine dofft
!
subroutine dofft_test (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv   &
     &    ,ubias,vbias,ubuff,vbuff,ctype)
  !----------------------------------------------------------------------
  ! @  private
  !
  ! GILDAS  UV_MAP
  !   Compute FFT of image by gridding UV data
  !   Test version to compare speed of various methods
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  integer, intent(in) :: ctype                ! type of gridding
  !
  !
  ! Initialize
  map = 0.0
  !
  if (ctype.eq.1) then
    print *,'DOFFT_FAST '
    call dofft_fast (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv)
  elseif  (ctype.eq.5) then
    print *,'DOFFT_QUICK '
    call dofft_quick (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
  else
    print *,'DOFFT_SLOW '
    call dofft_slow (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
  endif
end subroutine dofft_test
!
subroutine dofft_quick (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   - Taper before gridding
  !   - Gridding with pre-computed support
  !   - Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io
  integer ixm,ixp,iym,iyp,iu,iv
  real result,resima,staper,etaper,res
  real u,v,du,dv,ufac,vfac
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  integer my,kx,ky
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Use symmetry
  my = ny/2+1
  !
  ! Start with loop on observed visibilities
  do i=1,nv
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    endif
    !
    ! Weight and taper
    result = staper*we(i)
    if (v.gt.0) then
      u = -u
      v = - v
      resima = -result
    else
      resima = result
    endif
    ! Channels
    ! Define map cell
    ixp = int((u-sup(1))/xinc+xref+1.0)
    ixm = int((u+sup(1))/xinc+xref)
    iym = int((v-sup(2))/yinc+yref)
    iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
    !
    if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
      continue
      !            PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
    else
      do iy=iym,iyp
        dv = v-mapy(iy)
        if (abs(dv).le.sup(2)) then
          iv = nint(dv*vfac+vbias)
          do ix=ixm,ixp
            du = u-mapx(ix)
            if (abs(du).le.sup(1)) then
              iu = nint(du*ufac+ubias)
              res = ubuff(iu)*vbuff(iv)
              iou = 1
              iin = io
              do ic=1,nc
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result*res
                iou = iou+1
                iin = iin+1
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*resima*res
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
              map (iou,ix,iy) = map(iou,ix,iy) +   &
     &                res*result
            endif
          enddo
        endif
      enddo
    endif
    !
    ! Borderline case: use symmetry
    u = -u
    v = -v
    resima = -resima
    if (v.le.sup(2)) then
      ixp = int((u-sup(1))/xinc+xref+1.0)
      ixm = int((u+sup(1))/xinc+xref)
      iym = int((v-sup(2))/yinc+yref)
      iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
      if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
        continue
        !               PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
      else
        do iy=iym,iyp
          dv = v-mapy(iy)
          if (abs(dv).le.sup(2)) then
            iv = nint(dv*vfac+vbias)
            do ix=ixm,ixp
              du = u-mapx(ix)
              if (abs(du).le.sup(1)) then
                iu = nint(du*ufac+ubias)
                res = ubuff(iu)*vbuff(iv)
                iou = 1
                iin = io
                do ic=1,nc
                  map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                    visi(iin,i)*result*res
                  iou = iou+1
                  iin = iin+1
                  map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                    visi(iin,i)*resima*res
                  iou = iou+1
                  iin = iin+2
                enddo
                ! Beam
                map (iou,ix,iy) = map(iou,ix,iy) +   &
     &                  res*result
              endif
            enddo
          endif
        enddo
      endif
    endif
  enddo
  !
  ! Apply symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(2*nc-1,1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
end subroutine dofft_quick
!
subroutine dofft_fast (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv)
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   Taper before gridding
  !   Only for "visibility in cell" gridding.
  !   Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io,my,kx,ky
  real result,staper,etaper,resima
  real u,v
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  my = ny/2+1
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Start with loop on observed visibilities
  do i=1,nv
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    endif
    !
    ! Weight and taper
    result = staper*we(i)
    ! Channels
    ! Define map cell
    if (v.gt.0) then
      ix = nint(-u/xinc+xref)
      iy = nint(-v/yinc+yref)
      resima = -result
    else
      ix = nint(u/xinc+xref)
      iy = nint(v/yinc+yref)
      resima = result
    endif
    if (ix.lt.1.or.ix.gt.nx.or.iy.lt.1.or.iy.gt.my) then
      print *,'Visi ',i,' pixels ',ix,iy,my,v
    else
      iou = 1
      iin = io
      do ic=1,nc
        map (iou,ix,iy) = map (iou,ix,iy) +   &
     &          visi(iin,i)*result
        iou = iou+1
        iin = iin+1
        map (iou,ix,iy) = map (iou,ix,iy) +   &
     &          visi(iin,i)*resima
        iou = iou+1
        iin = iin+2
      enddo
      map (iou,ix,iy) = map(iou,ix,iy) + result
    endif
    !
    ix = nint(-u/xinc+xref)
    iy = nint(-v/yinc+yref)
    if (iy.eq.my) then
      iou = 1
      iin = io
      do ic=1,nc
        map (iou,ix,iy) = map (iou,ix,iy) +   &
     &          visi(iin,i)*result
        iou = iou+1
        iin = iin+1
        map (iou,ix,iy) = map (iou,ix,iy) -   &
     &          visi(iin,i)*resima
        iou = iou+1
        iin = iin+2
      enddo
      map (iou,ix,iy) = map(iou,ix,iy) + result
    endif
  enddo
  !
  ! Apply symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(2*nc-1,1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
end subroutine dofft_fast
!
subroutine dofft_slow (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  UVMAP
  !   Compute FFT of image by gridding UV data
  !   Taper after gridding
  !   Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  real :: taperv(nx,ny)
  integer iu,iv
  integer ifirsp,ilastp,ifirsm,ilastm,my
  integer ix,iy,ic,i,iin,iou,io
  integer kx,ky,fy
  real result,staper,vtaper,utaper,etaper
  real u,v,um,up,vm,vp,ufac,vfac
  real cx,cy,sx,sy
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  taperv = 0.0
  !
  ! Initialize
  !     MY = NY       ! Slow version
  my = ny/2+1                  ! Fast version, using symmetry
  ifirsp = 1
  ilastm = nv
  !
  ! Compute the first valid pixel
  fy = int((vv(1)-sup(2))/(mapy(2)-mapy(1))+ny/2+1)
  !
  ! Precompute the taper
  if (taper(3).ne.0.0) then
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
  endif
  !
  if (taper(4).ne.0) then
    etaper = taper(4)/2.0
  else
    etaper = 1.0
  endif
  !
  do iy=fy,my
    v = mapy(iy)
    if (taper(3).ne.0) then
      vtaper = -1.0
    elseif  (taper(2).eq.0) then
      vtaper = 1.0
    else
      vtaper = abs(v/taper(2))**(etaper*2.0)
      if (vtaper.gt.64) then
        vtaper = 0
      else
        vtaper = exp(-vtaper)
      endif
    endif
    if (vtaper.ne.0) then
      do ix=1,nx
        u = mapx(ix)
        if (taper(3).ne.0) then
          ! General rotated case...
          staper = (u*cx + v*sy)**2 +   &
     &            (-u*sx + v*cy)**2
          if (etaper.ne.1) staper = staper**etaper
          if (staper.gt.64.0) then
            staper = 0.0
          else
            staper = exp(-staper)
          endif
        elseif  (taper(1).eq.0) then
          staper = vtaper
        else
          utaper = abs(u/taper(1))**(2.0*etaper)
          if (utaper.gt.64) then
            utaper = 0
          else
            utaper = exp(-utaper)
          endif
          staper = vtaper*utaper
        endif
        if (taper(1).lt.0) then
          staper = 1.0-staper
          if (staper.ne.1.0) print *,u,v,staper
        endif
        !
        taperv(ix,iy) = staper
      enddo
    else
      do ix=1,nx
        taperv(ix,iy) = 0.0
      enddo
    endif
  enddo
  !
  do iy=fy,my
    v = mapy(iy)
    !
    ! Optimized dichotomic search, taking into account the fact that
    !  VV is an ordered array
    !
    ! IFIRSP always increases, ILASTM always decreases
    vm = v-sup(2)
    vp = v+sup(2)
    call findp (nv,vv,vm,ifirsp)
    ilastp = ifirsp
    call findp (nv,vv,vp,ilastp)
    ilastp = ilastp-1
    !
    ilastm = ilastm+1
    vm = -v-sup(2)
    vp = -v+sup(2)
    call findm (nv,vv,vp,ilastm)
    ifirsm = ilastm
    ilastm = ilastm-1
    call findm (nv,vv,vm,ifirsm)
    !
    ! Loop on X cells
    if (ilastp.ge.ifirsp .or. ilastm.ge.ifirsm) then
      do ix=1,nx
        u = mapx(ix)
        staper = taperv(ix,iy)
        !
        ! Do while in X cell for (+U,+V)
        um = u-sup(1)
        up = u+sup(1)
        do i=ifirsp,ilastp
          if (visi(jx,i).ge.um .and. visi(jx,i).le.up) then
            iu = nint((u-visi(jx,i))*ufac+ubias)
            iv = nint((v-visi(jy,i))*vfac+vbias)
            result = ubuff(iu)*vbuff(iv)
            !
            if (result.ne.0.0) then
              if (ix.eq.1) then
                print *,'Unsufficient coverage',iy,ny
              endif
              ! Weight and taper
              result = result*staper*we(i)
              ! Channels
              iou = 1
              iin = io
              do ic=1,nc
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+1
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
              map (iou,ix,iy) = map(iou,ix,iy) + result
            endif
          endif
        enddo
        !
        ! Do while in X cell for (-U,-V)
        um = -u-sup(1)
        up = -u+sup(1)
        do i=ifirsm,ilastm
          if (visi(jx,i).ge.um .and. visi(jx,i).le.up) then
            iu = nint(-(u+visi(jx,i))*ufac+ubias)
            iv = nint(-(v+visi(jy,i))*vfac+vbias)
            result = ubuff(iu)*vbuff(iv)
            if (result.ne.0.0) then
              if (ix.eq.1) then
                print *,'Unsufficient coverage',-iy,ny
              endif
              ! Weight and taper
              result = result*staper*we(i)
              ! Channels
              iou = 1
              iin = io
              do ic=1,nc
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+1
                map (iou,ix,iy) = map (iou,ix,iy) -   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
              map (iou,ix,iy) = map(iou,ix,iy) + result
            endif
          endif
        enddo                  ! Visibility loop
      enddo                    ! IX Loop
    endif
  enddo
  !
  ! Symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
end subroutine dofft_slow
!
subroutine dofft_quick1 (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   For any gridding support
  !   Taper before gridding
  !   Does not use symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io,k
  integer ixm,ixp,iym,iyp,iu,iv
  real result,resima,staper,etaper,res
  real u,v,du,dv,ufac,vfac
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Start with loop on observed visibilities
  do i=1,nv
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    endif
    !
    ! Weight and taper
    result = staper*we(i)
    ! Channels
    ! Define map cell
    do k=1,2
      if (k.eq.1) then
        resima = result
      else
        u = -u
        v = -v
        resima = -result
      endif
      !
      ixp = int((u-sup(1))/xinc+xref+1.0)
      ixm = int((u+sup(1))/xinc+xref)
      iym = int((v-sup(2))/yinc+yref)
      iyp = int((v+sup(2))/yinc+yref+1.0)
      if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
        print *,'Visi ',i,' pixels ',ixm,ixp,iym,iyp
      else
        do iy=iym,iyp
          dv = v-mapy(iy)
          if (abs(dv).le.sup(2)) then
            iv = nint(dv*vfac+vbias)
            do ix=ixm,ixp
              du = u-mapx(ix)
              if (abs(du).le.sup(1)) then
                iu = nint(du*ufac+ubias)
                res = ubuff(iu)*vbuff(iv)
                iou = 1
                iin = io
                do ic=1,nc
                  map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                    visi(iin,i)*result*res
                  iou = iou+1
                  iin = iin+1
                  map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                    visi(iin,i)*resima*res
                  iou = iou+1
                  iin = iin+2
                enddo
                ! Beam
                map (iou,ix,iy) = map(iou,ix,iy) +   &
     &                  res*result
              endif
            enddo
          endif
        enddo
      endif
    enddo
  enddo
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(2*nc-1,1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
end subroutine dofft_quick1
!
subroutine dofft_fast1 (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv)
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   Only for "visibility in cell"
  !   Taper before gridding
  !   Do not use symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  !
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io,k
  real result,resima,staper,etaper
  real u,v
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Start with loop on observed visibilities
  do i=1,nv
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    endif
    !
    ! Weight and taper
    result = staper*we(i)
    ! Channels
    ! Define map cell
    do k=1,2
      if (k.eq.1) then
        ix = nint(u/xinc+xref)
        iy = nint(v/yinc+yref)
        resima = result
      else
        ix = nint(-u/xinc+xref)
        iy = nint(-v/yinc+yref)
        resima = -result
      endif
      if (ix.lt.1.or.ix.gt.nx.or.iy.lt.1.or.iy.gt.ny) then
        print *,'Visi ',i,' pixels ',ix,iy
      else
        iou = 1
        iin = io
        do ic=1,nc
          map (iou,ix,iy) = map (iou,ix,iy) +   &
     &            visi(iin,i)*result
          iou = iou+1
          iin = iin+1
          map (iou,ix,iy) = map (iou,ix,iy) +   &
     &            visi(iin,i)*resima
          iou = iou+1
          iin = iin+2
        enddo
        ! Beam
        map (iou,ix,iy) = map(iou,ix,iy) + result
      endif
    enddo
  enddo                        ! Visibility loop
end subroutine dofft_fast1

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_tracked_psw(mrtset,backcal,backsci,filebuf,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_calib_tracked_psw
  !---------------------------------------------------------------------
  ! @ private
  ! Gather all needed steps to read, calibrate, and write a 
  ! tracked position switched scan for a given backend
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(calib_backend_t),   intent(in)    :: backcal
  type(science_backend_t), intent(inout) :: backsci
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>TRACKED>PSW'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_iterate_cycle_trackedpsw(mrtset,filebuf%imbf,  &
    filebuf%subscanbuf,backcal,backsci,error)
  if (error)  return
  !
end subroutine mrtcal_calib_tracked_psw
!
subroutine mrtcal_calib_tracked_psw_cycle(mrtset,imbf,ifirst,nswitch,  &
  subscanbuf,backcal,backsci,error)
  use gbl_message
  use mrtcal_interfaces, except_this=>mrtcal_calib_tracked_psw_cycle
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  ! Calibrate a TRACKED PSW cycle of subscans
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)            :: mrtset      !
  type(imbfits_t),         intent(in)            :: imbf        !
  integer(kind=4),         intent(in)            :: ifirst      ! First subscan in cycle
  integer(kind=4),         intent(in)            :: nswitch     ! Number of subscans in cycle
  type(subscan_buffer_t),  intent(inout)         :: subscanbuf  !
  type(calib_backend_t),   intent(in)            :: backcal     !
  type(science_backend_t), intent(inout), target :: backsci     !
  logical,                 intent(inout)         :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CALIB>TRACKED>PSW>CYCLE'
  integer(kind=4) :: isub
  logical, parameter :: iscal=.false.
  type(chunkset_2d_t) :: curr  ! Buffer for reading a ON or OFF subscan
  type(chunkset_2d_t), pointer :: cumul  ! Pointer to current ON or OFF cumulation
  logical :: initon,initoff
  character(len=23) :: iso
  character(len=message_length) :: mess
  !
  initon = .true.
  initoff = .true.
  do isub=ifirst,ifirst+nswitch-1
    call mrtcal_average_times(mrtset,iscal,isub,'track',imbf,subscanbuf,curr,error)
    if (error)  goto 10
    !
    if (backsci%list%onoff%bak(isub).eq.backsci%list%on) then
      if (initon) then
        ! Use first ON subscan to initialize the ON structure (in particular
        ! regarding offsets)
        call mrtcal_chunkset_2d_accumulate_init(curr,backsci%on%curr,error)
        if (error)  goto 10
        initon = .false.
      endif
      cumul => backsci%on%curr
    else
      if (initoff) then
        ! Use first OFF subscan to initialize the OFF structure (in particular
        ! regarding offsets)
        if (.not.associated(backsci%off%curr)) then
          ! Because this one is a pointer => allocate a scalar object
          allocate(backsci%off%curr)
        endif
        call mrtcal_chunkset_2d_accumulate_init(curr,backsci%off%curr,error)
        if (error)  goto 10
        initoff = .false.
      endif
      cumul => backsci%off%curr
    endif
    !
    call mrtcal_chunkset_2d_accumulate_setweight(curr,backsci%tscale,  &
      mrtset%out%weight,error)
    if (error)  goto 10
    call mrtcal_chunkset_2d_accumulate_do(curr,cumul,error)
    if (error)  goto 10
  enddo
  !
  backsci%switch%cycle%ion = 0   ! Deactivated in this context
  backsci%switch%cycle%ioff = 0  ! Deactivated in this context
  call mrtcal_on_minus_off(istracked,notfsw,backsci,error)
  if (error)  goto 10
  call mrtcal_tscale_computation(backcal,backsci,error)
  if (error)  goto 10
  call mrtcal_tscale_application(backsci%tscale,backsci%diff,error)
  if (error)  goto 10
  !
  call gag_mjd2isodate(backsci%off%curr%chunkset(1,1)%chunks(1)%mjd,iso,error)
  write(mess,'(6a)') 'Average OFF    date: ',iso
  call mrtcal_message(seve%i,rname,mess)
  call gag_mjd2isodate(backsci%on%curr%chunkset(1,1)%chunks(1)%mjd,iso,error)
  write(mess,'(6a)') 'Average ON     date: ',iso
  call mrtcal_message(seve%i,rname,mess)
  call gag_mjd2isodate(backsci%diff%chunkset(1,1,1)%chunks(1)%mjd,iso,error)
  write(mess,'(6a)') 'Average ON-OFF date: ',iso
  call mrtcal_message(seve%i,rname,mess)
  !
  if (mrtset%out%accmode.eq.accmode_cycl) then
    call mrtcal_write_toclass(backsci%diff,mrtset%out,backsci%nspec,error)
    if (error)  goto 10
  endif
  !
10 continue
  call free_chunkset_2d(curr,error)
  if (error)  return
  !
end subroutine mrtcal_calib_tracked_psw_cycle
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! Following code is generic to OTF and TRACKED PSW
!
subroutine mrtcal_psw_read_surrounding_offs(mrtset,imbf,subscanbuf,backsci,error)
  use gbl_message
  use gkernel_types
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_psw_read_surrounding_offs
  !---------------------------------------------------------------------
  ! @ private
  ! Get in the current list of subscans the number of the previous and 
  ! the next OFF subscans, read them, average them in time, and store 
  ! them into backsci%off
  !
  ! That's a stack. The code must start the previous OFF subscan, because 
  ! it probably is the current next OFF subscan, as the subscans are 
  ! ordered by increasing time. This saves data reading. Setting the 
  ! subscan number to zero means that we did not find either the previous 
  ! or the next off
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),            intent(in)    :: mrtset
  type(imbfits_t),                 intent(in)    :: imbf
  type(subscan_buffer_t),          intent(inout) :: subscanbuf
  type(science_backend_t), target, intent(inout) :: backsci
  logical,                         intent(inout) :: error
  ! Local
  logical, parameter :: iscal = .false.
  logical :: found
  integer(kind=4) :: ioff,iprev,inext
  type(chunkset_2d_t), pointer :: altoff
  character(len=*), parameter :: rname='PSW>READ>SURROUNDING>OFFS'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Stack previous off
  ioff = backsci%on%curr%isub
  call eclass_2dble_getprev(backsci%list%onoff,backsci%list%off,ioff,found,error)
  if (error) return
  if (found) then
     iprev = backsci%list%isub(ioff)
     if (backsci%off%prev%isub.eq.iprev) then
        ! Nothing to be done...
     else if (backsci%off%next%isub.eq.iprev) then
        altoff => backsci%off%prev
        backsci%off%prev => backsci%off%next
        backsci%off%next => altoff
     else
        call mrtcal_average_times(mrtset,iscal,backsci%list%isub(ioff),'track',imbf,subscanbuf,backsci%off%prev,error)
        if (failed_calibrate(rname,backsci%list%isub(ioff),error))  return
     endif
  else
     backsci%off%prev%isub = 0 ! Nevertheless, leave the type allocated
  endif
  ! Stack next off
  ioff = backsci%on%curr%isub
  call eclass_2dble_getnext(backsci%list%onoff,backsci%list%off,ioff,found,error)
  if (error) return
  if (found) then
     inext = backsci%list%isub(ioff)
     if (backsci%off%prev%isub.eq.inext) then
        altoff => backsci%off%next
        backsci%off%next => backsci%off%prev
        backsci%off%prev => altoff
     else if (backsci%off%next%isub.eq.inext) then
        ! Nothing to be done...
     else
        call mrtcal_average_times(mrtset,iscal,backsci%list%isub(ioff),'track',imbf,subscanbuf,backsci%off%next,error)
        if (error)  return
     endif
  else
     backsci%off%next%isub = 0 ! Nevertheless, leave the type allocated
  endif
  !
end subroutine mrtcal_psw_read_surrounding_offs
!
subroutine mrtcal_psw_interpolate_off_init(off,error)
  use gbl_message
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_psw_interpolate_off_init
  !---------------------------------------------------------------------
  ! @ private
  ! *** JP In output, interp%isub = prev%isub or interp%isub = next%isub
  ! *** JP It would be better to have the averaged value stored as a real
  ! *** JP If this subscan number is used at read time, some additional
  ! *** JP protection would be needed.
  !---------------------------------------------------------------------
  type(off_stack_t), target, intent(inout) :: off
  logical,                   intent(inout) :: error
  ! Local
  type(chunkset_2d_t), pointer :: prev,next,offset,slope,interp
  character(len=*), parameter :: rname='PSW>INTERPOLATE>OFF>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  prev => off%prev
  next => off%next
  slope  => off%slope
  offset => off%offset
  interp => off%interp
  !
  if ((prev%isub.gt.0).and.(next%isub.gt.0)) then
     ! Both are there => Interpolation possible
     call mrtcal_chunkset_2d_interpolate_init(prev,next,slope,offset,interp,error)
     if (error) return
  else if ((prev%isub.le.0).and.(next%isub.le.0)) then
     ! Both are missing => Something wrong
     call mrtcal_message(seve%e,rname,'No subscans associated to previous and next OFF')
     error = .true.
     return
  else
     ! Only one is missing => Use the other one
     if (error) return
     if (prev%isub.le.0) then
        ! Previous is missing, just use the next one
        call mrtcal_chunkset_2d_interpolate_init_as_ref(next,slope,offset,interp,error)
        if (error) return
        call mrtcal_chunkset_2d_copy_data(next,offset,error)
        if (error) return
     endif
     if (next%isub.le.0) then
        ! Next is missing, just use the previous one
        call mrtcal_chunkset_2d_interpolate_init_as_ref(prev,slope,offset,interp,error)
        if (error) return
        call mrtcal_chunkset_2d_copy_data(prev,offset,error)
        if (error) return
     endif
     ! Set slope to zero (This ones must come after the header copy)
     call mrtcal_chunkset_2d_init_data(slope,0.,0.,0.,error)
  endif
  ! 
  off%curr => off%interp
  !
end subroutine mrtcal_psw_interpolate_off_init
!
subroutine mrtcal_psw_prepare_nextoff(mrtset,filebuf,backsci,error)
  use gbl_message
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_psw_prepare_nextoff
  !---------------------------------------------------------------------
  ! @ private
  ! Read the OFF subscans surrounding the current ON subscan and prepare
  ! the linear interpolation in time, i.e., compute the segment slope and
  ! constant
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  type(science_backend_t), intent(inout) :: backsci
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='PSW>PREPARE>NEXTOFF'
  !
  call mrtcal_psw_read_surrounding_offs(mrtset,&
       filebuf%imbf,&
       filebuf%subscanbuf,&
       backsci,error)
  if (error) return
  call mrtcal_psw_interpolate_off_init(backsci%off,error)
  if (error) return
  !
end subroutine mrtcal_psw_prepare_nextoff
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program p_line2cont
  use gkernel_interfaces
  use gildas_def
  use uvmap_def_task
  !
  ! Compute Dirty images from .TUV tables
  !
  character(len=256) line,cont 
  logical error
  type (par_uvmap) :: map
  !
  error = .false.
  map%channels(3) = 1
  call i_line2cont (line,cont,map,error)
  if (error) call sysexi(fatale)
  map%uvcode = code_tuv   ! Must be 2
  call t_line2cont (line,cont,map,error)
  if (error) call sysexi (fatale)
  !
  contains
!
subroutine t_line2cont(line,cont,map,error) 
  use image_def
  use gkernel_interfaces
  use uvmap_def_task
  use phys_const
  !
  character(len=*), intent(inout) :: line     ! Line file name
  character(len=*), intent(inout) :: cont     ! Continuum file name
  type (par_uvmap), intent(inout) :: map   ! Imaging parameters
  logical, intent(inout) :: error
  !
  type (gildas) :: hluv
  type (gildas) :: hcuv
  integer ier,nc,mc
  ! 
  ! Read Headers  
  call gildas_null(hluv, type = 'UVT')
  call sic_parsef (line,hluv%file,' ','.tuv')
  call gdf_read_header (hluv,error)
  if (error) return
  !
  ! Define channels and Center frequency
  call t_channel (hluv,map)
  !! nc = map%channels(2)-map%channels(1)+1 
  !
  ! Allocate & Read appropriate data set
  !
  allocate(hluv%r2d(hluv%gil%dim(1),hluv%gil%dim(2)),stat=ier)
  call gdf_read_data(hluv,hluv%r2d,error)
  !
  call gildas_null (hcuv, type = 'UVT')
  call gdf_copy_header(hluv,hcuv,error) 
  !
  nc = (map%channels(2)-map%channels(1)+1)
  mc = nc/map%channels(3)
  if (mc*map%channels(3).ne.nc) mc = mc+1
  hcuv%gil%dim(1) = hluv%gil%dim(1)*mc
  hcuv%gil%dim(2) = 10
  hcuv%gil%nchan = 1
  allocate(hcuv%r2d(hcuv%gil%dim(1),hcuv%gil%dim(2)),stat=ier)
  call t_continuum1(hluv,hcuv,map,error)
  call sic_parsef (cont,hcuv%file,' ','.tuv')
  call gdf_write_image(hcuv,hcuv%r2d,error)
end subroutine t_line2cont
!
subroutine i_line2cont (line,cont,map,error) 
  use gkernel_interfaces
  !
  ! UV_LINE2CONT 
  !    Define parameters
  !
  use uvmap_def_task
  character(len=*), intent(out) :: line  
  character(len=*), intent(out) :: cont
  type (par_uvmap), intent(out) :: map
  logical, intent(out) :: error
  !
  call gildas_open
  call gildas_char('UV_LINE$',line)
  call gildas_char('UV_CONT$',cont)
  call gildas_inte('CHANNELS$',map%channels,3)
  call gildas_close
end subroutine i_line2cont
!
subroutine t_continuum1(hluv,hcuv,map,error)
  !----------------------------------------------------------
  ! UV_INVERT / UV_MAP
  !    Create a continuum UV table from a Line one
  !----------------------------------------------------------
  use gildas_def
  use image_def
  use uvmap_def_task
  !
  type (gildas), intent(in) :: hluv          ! Line UV header
  type (gildas), intent(inout) :: hcuv          ! Line UV header
  type (par_uvmap), intent(inout) :: map  ! Imaging parameters
  logical, intent(out) :: error
  !
  real(8) :: freq,scale_uv
  real, allocatable :: re(:), im(:), we(:), dw(:)
  integer :: ifi,ila,nc,nv,ic,jc,ier
  !
  error = .false.
  !
  ! Define number of Visibilities and Channels...
  if (map%uvcode.eq.code_uvt) then  ! UVT order
     nv = hluv%gil%dim(2)
  else ! TUV order
     nv = hluv%gil%dim(1)
     allocate (re(nv),im(nv),we(nv),dw(nv),stat=ier)
     if (ier.ne.0) then
        error = .true.
        return
     endif
     !
     ! Fill in, channel after channel
     ifi = 1
     ila = nv
     do ic=map%channels(1),map%channels(2),map%channels(3)
        Print *,'ic ',ic,ifi,ila
        freq = hluv%gil%val(2) + hluv%gil%fres * & 
             & (ic+map%channels(3)/2 - hluv%gil%ref(2))
        scale_uv = hluv%gil%val(2)/freq
        !
        hcuv%r2d(ifi:ila,1:3) = hluv%r2d(1:nv,1:3)*scale_uv
        hcuv%r2d(ifi:ila,4:7) = hluv%r2d(1:nv,4:7)
        !
        ! Compact the channels first
        if (map%channels(3).gt.1) then
           re = 0
           im = 0
           we = 0
           do jc = ic,min(ic+map%channels(3)-1,map%channels(2))
              dw(:) = max(0.,hluv%r2d(1:nv,7+3*ic))
              re(:) = re + hluv%r2d(1:nv,5+3*jc)*dw
              im(:) = im + hluv%r2d(1:nv,6+3*jc)*dw
              we(:) = we+dw
           enddo
           where (we.ne.0)
             re = re/we
             im = im/we
           end where
           hcuv%r2d(ifi:ila,8) = re
           hcuv%r2d(ifi:ila,9) = im
           hcuv%r2d(ifi:ila,10) = we
        else
           hcuv%r2d(ifi:ila,8:10) = hluv%r2d(1:nv,5+3*ic:7+3*ic)
        endif
        ifi = ila+1
        ila = ila+nv
     enddo
     map%channels = 1
     map%freq = hcuv%gil%val(2)
     hcuv%gil%ref(2) = 1
     hcuv%gil%val(2) = map%freq
     hcuv%gil%inc(2) = hluv%gil%inc(2)*nc
     deallocate (re,im,we,dw,stat=ier)
  endif
end subroutine t_continuum1
!
include 'lib/util_uvmap.f90'
!
end program p_line2cont

        

!
subroutine t_setextrema(h,rmi,jmi,rma,jma)
  use gkernel_interfaces
  use gildas_def
  use image_def
  !------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   Put extrema into the specified header
  !------------------------------------------------
  type (gildas), intent(inout), target :: h
  real(kind=4), intent(in) :: rmi     ! Value of minimum
  integer(kind=size_length), intent(in) :: jmi  ! Position of minimum
  real(kind=4), intent(in) :: rma     ! Value of maximum
  integer(kind=size_length), intent(in) :: jma  ! Position of maximum
  !
  integer(kind=8) :: ilong 
  !
  h%gil%rmax = rma
  h%gil%rmin = rmi
  ilong = jmi
  call gdf_index_to_where (ilong,h%gil%ndim,h%gil%dim,h%gil%minloc)  
  ilong = jma
  call gdf_index_to_where (ilong,h%gil%ndim,h%gil%dim,h%gil%maxloc)  
  h%gil%extr_words = def_extr_words                ! extrema computed
end subroutine t_setextrema
!
subroutine map_minmax(hmap)
  use image_def
  !
  type(gildas), intent(inout) :: hmap
  real :: rmi,rma
  !
  hmap%gil%extr_words = def_extr_words  ! extrema computed
  hmap%gil%minloc = 1
  hmap%gil%maxloc = 1
  hmap%gil%minloc(1:3) = minloc(hmap%r3d)
  hmap%gil%maxloc(1:3) = maxloc(hmap%r3d)
  rma = hmap%r3d(hmap%gil%maxloc(1),hmap%gil%maxloc(2),hmap%gil%maxloc(3))
  rmi = hmap%r3d(hmap%gil%minloc(1),hmap%gil%minloc(2),hmap%gil%minloc(3))
  hmap%gil%rmax = rma
  hmap%gil%rmin = rmi
end subroutine map_minmax

subroutine mask_comm(line,error)
  use gildas_def
  use gbl_message
  use gkernel_types
  use clean_arrays
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !   IMAGER
  ! Support routine for command
  !   ADVANCED\MASK
  !
  ! Several modes
  !   MASK  ADD Figure Description
  !                 Add the corresponding figure to mask
  !   MASK  APPLY Variable  
  !                 Apply the current mask to 3-D Variable
  !   MASK  INIT [2D|3D]
  !                 Initialize a mask
  !   MASK  OVERLAY
  !                 Overlay the mask on the current Image
  !   MASK  READ File
  !                 Read a Mask from disk (is that a .msk or a .pol ?) 
  !                 (redundant with READ MASK )
  !   MASK  REMOVE  Fig_Description
  !                 Removed the figure from mask
  !   MASK  USE   
  !                 Activate the current mask as a Support
  !                 (redundant with SUPPORT /MASK)
  !   MASK  SHOW    
  !                 as SHOW MASK
  !   MASK  THRESHOLD Raw Smooth [Length]
  !                 automatic Mask builder by Thresholding
  !   MASK  WRITE File
  !                 Write a mask to disk 
  !                 (almost redundant with WRITE MASK ? )
  !
  !   MASK          Launch interactive mask definition
  !          (would be better on currently displayed image, rather
  !           than only the CLEAN data cube. Rank could depend
  !           on how many channels are displayed)
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Input command line
  logical,          intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MASK'
  !
  !! Not needed, actually
  !! integer, parameter :: v_mask=8  ! MASK is number 8 in list
  !
  type(gildas) :: head
  integer, parameter :: mvoc=12
  character(len=12) :: vocab(mvoc), key, lkey
  data vocab /'ADD','APPLY','CHECK','INITIALIZE','INTERACTIVE','OVERLAY','READ','REMOVE', &
    & 'SHOW','THRESHOLD','USE','WRITE'/
  integer, parameter :: mfig=4
  character(len=12) :: figure(mfig), kfig
  data figure /'CIRCLE','ELLIPSE','POLYGON','RECTANGLE'/
  character(len=24) :: argum, chain
  character(len=filename_length) :: name
  character(len=commandline_length) :: aline
  integer :: ikey,is,nc,na,narg
  logical :: do_insert, all
  real :: r4
  !
  integer :: nchans(2)
  !
  error = .false.
  !
  do_insert = sic_lire().eq.0
  !
  ! If no argument, activate the default interactive mode
  argum = 'INTERACTIVE'
  !
  call sic_ke(line,0,1,argum,nc,.false.,error)
  if (error) return  !
  call sic_ambigs (rname,argum,key,ikey,vocab,mvoc,error)
  if (error) return
  !
  if (key.eq.'CHECK') then
    call mask_check(.true.,error)
    return
  endif
  ! These create the MASK
  select case(key)
  case ('INITIALIZE')
    if (sic_narg(0).eq.1) then
      argum = '3D'
    else
      call sic_ke(line,0,2,argum,nc,.false.,error)
    endif
    call mask_init(argum,error)
    if (error) return
    call exec_program('@ p_mask init NO')  ! Support is void at this stage
  case ('READ') 
    call sic_ch(line,0,2,name,nc,.true.,error)
    if (error) return
    !
    call gildas_null(head)
    call sic_parse_file(name,' ','.msk',head%file)
    call gdf_read_header (head,error)
    if (error) return
    !
    nchans = 0
    call map_read (head,'MASK',nchans,.false.,error)  
    call gdf_close_image (head,error)
    call exec_program('@ p_mask init YES')  ! Support is filled 
  case ('THRESHOLD')
    call mask_threshold(line,error)
    call exec_program('@ p_mask init YES')  ! Support is filled 
  !
  ! These need the MASK and the Clean image
  case ('INTERACTIVE') 
    call mask_check(.true.,error)
    if (error) return
    !
    argum = '1'
    call sic_ke(line,0,2,argum,nc,.false.,error)
    call exec_program('@ p_mask interactive '//argum)
  case ('ADD','REMOVE')
    call mask_check(.true.,error)
    if (error) return
    call sic_ke(line,0,2,argum,nc,.false.,error)
    if (error) return  !
    call sic_ambigs (rname,argum,kfig,ikey,figure,mfig,error)
    if (error) return
    call sic_lower(kfig)
    lkey = key
    call sic_lower(lkey)
    narg = sic_narg(0)
    if (narg.gt.2) then
      ! Get the numerical values of all arguments
      aline = '@ p_mask '//trim(lkey)//' '//kfig
      na = len_trim(aline)+2
      do is=3,narg
        call sic_r4(line,0,is,r4,.true.,error)
        if (error) return
        write(chain,*) r4
        aline(na:) = chain
        na = na + len_trim(chain)
      enddo
      call exec_program(aline)
    else
      call exec_program('@ p_mask '//trim(lkey)//' '//kfig)
    endif
  case ('APPLY') 
    call mask_check(.true.,error)
    if (error) return
    call mask_apply(line,error)
    do_insert = .false.
  case ('OVERLAY') 
    call mask_check(.true.,error)
    if (error) return
    call exec_program('@ p_mask over')
  !
  ! Only MASK is needed below
  case ('USE')
    call mask_check(.false.,error)
    if (error) return
    call exec_program('SUPPORT /MASK')
  case ('SHOW')
    call mask_check(.false.,error)
    if (error) return
    call exec_program('SHOW MASK')
  case ('WRITE')
    call mask_check(.false.,error)
    if (error) return
    !
    is = sic_start(0,2) 
    call exec_program('WRITE MASK '//line(is:))
  case default
    call map_message(seve%e,rname,trim(key)//' not yet supported')
    error = .true.
    return
  end select  
  if (do_insert) call sic_insert_log(line)
end subroutine mask_comm
!
subroutine mask_apply(line,error)
  use gildas_def
  use gbl_message
  use gkernel_types
  use clean_arrays
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !   IMAGER
  ! Support routine for command
  !   ADVANCED\MASK APPLY Variable
  !---------------------------------------------------------------------  
  character(len=*), intent(in)  :: line   ! Input command line
  logical,          intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MASK'
  !
  type(gildas) :: hin
  type(sic_descriptor_t) :: desc
  real(kind=4) :: blank
  real(kind=8) :: i_freq
  integer(kind=4) :: nc,ier,ikey
  character(len=6) :: argum,key
  integer :: iplane, ipm
  logical :: equal
  integer(kind=address_length) :: ipnt
  integer, save :: memory(8)
  !
  if (hmask%loca%size.eq.0) then
    call map_message(seve%e,rname,'No mask defined')
    error = .true.
    return
  endif
  error = .false.
  !
  call sic_ke(line,0,2,argum,nc,.false.,error)
  if (error) return
  !
  if (argum.eq.'MASK') then
    call map_message(seve%e,rname,'Cannot MASK the Mask...')
    error = .true.
    return
  endif
  !
  ! Any SIC 2-D+ variable with matching coordinate is acceptable
  call gildas_null(hin)
  call get_gildas(rname,argum,desc,hin,error)
  if (error) return
  !
  blank = hin%gil%bval
  hin%gil%eval = max(hin%gil%eval,0.0)
  !
  ! Check that HIN and HMASK match in 2-D and that Frequency axis
  ! can be interpolated properly
  call gdf_compare_2d(hin,hmask,equal)
  if (.not.equal) then
    call map_message(seve%e,rname,'MASK and '//trim(argum)//' do not match')
    error = .true.
    return
  endif
  !
  ipnt = gag_pointer(desc%addr,memory)
  hmask%r3d => dmask
  call sub_mask_apply(hin,hmask,memory(ipnt),error)
  !
end subroutine mask_apply
  !
subroutine sub_mask_apply(hin,hmask,din,error)
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface
  !   Apply a mask
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hin
  type(gildas), intent(in) :: hmask
  real, intent(inout) :: din(hin%gil%dim(1),hin%gil%dim(2),hin%gil%dim(3))
  logical :: error
  !
  character(len=*), parameter :: rname='MASK'
  integer :: iplane, ipm
  real(8) :: i_freq
  real :: blank
  !
  blank = hin%gil%bval
  !
  !!Print *,'Mask rank ',hmask%gil%ndim,hmask%gil%dim(1:3)
  if (hmask%gil%dim(3).le.1) then
    !
    ! Apply Mask to all planes
    do iplane=1,hin%gil%dim(3)
      !!PRINT *,'DOING ',iplane,hin%gil%dim(3),' Blank ',blank
      where (hmask%r3d(:,:,1).eq.0) din(:,:,iplane) = blank
    enddo
  else
    if (hin%gil%faxi.ne.3) then
      call map_message(seve%e,rname,'3rd axis is not Frequency | Velocity')
      error = .true.
      return
    endif
    !
    ! Find matching planes
    do iplane=1,hin%gil%dim(3)
      ! This may be the better way of doing it:
      i_freq = (iplane-hin%gil%ref(3))*hin%gil%fres + hin%gil%freq
      ! i_freq = (ibeam-hbeam%gil%ref(4))*hbeam%gil%fres + hbeam%gil%freq
      ipm = nint((i_freq-hmask%gil%freq)/hmask%gil%fres + hmask%gil%ref(3))
      ipm = min(max(1,ipm),hmask%gil%dim(3)) ! Just  in case
      where (hmask%r3d(:,:,ipm).eq.0) din(:,:,iplane) = blank
    enddo
  endif
end subroutine sub_mask_apply
!
subroutine gdf_compare_2d(hone,htwo,equal)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !   Check 2D consistency of data cubes
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hone
  type(gildas), intent(in) :: htwo
  logical, intent(out) :: equal
  !
  real(8) :: tolerance=0.001    ! Pixels...
  real(8) :: x0, y0
  integer :: i
  !
  ! Compare first 2 axes
  equal = .true.
  do i=1,2
    if (hone%gil%dim(i).ne.htwo%gil%dim(i)) then
      equal = .false.
      return
    else
      x0 = (0-hone%gil%ref(i))*hone%gil%inc(i) + hone%gil%val(i)
      y0 = (0-htwo%gil%ref(i))*htwo%gil%inc(i) + htwo%gil%val(i)
      if ( abs(x0-y0).gt.tolerance*abs(hone%gil%inc(i)) ) then
        equal = .false.
        return
      endif
    endif
  enddo
end subroutine gdf_compare_2d  
!
subroutine mask_threshold(line,error)
  use gkernel_interfaces
  use imager_interfaces, only : map_message, sub_mask_threshold
  use clean_arrays
  use clean_default
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   IMAGER
  ! Support for command
  !   ADVANCED\MASK THRESHOLD Raw Smooth [Length]
  !
  !  Raw      Thresholding (in Sigma) of the Clean image
  !  Smooth   Thresholding (in Sigma) after smoothing
  !  Length   Smoothing length: default is Clean beam major axis
  !
  ! Select CLEAN or SKY depending on last available
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  if (last_shown.eq.'CLEAN') then
    call sub_mask_threshold(hclean,last_shown,line,error)
  else if (last_shown.eq.'SKY') then
    call sub_mask_threshold(hsky,last_shown,line,error)
  else
    call map_message(seve%e,'MASK','No CLEAN or SKY available')
    error = .true.
  endif
end subroutine mask_threshold
!
subroutine sub_mask_threshold(head,name,line,error)
  use gkernel_interfaces
  use imager_interfaces, only : map_message, mask_clean
  use clean_arrays  
  use clean_support
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support for command
  ! MASK THRESHOLD Raw Smooth [Length]
  !
  !  Raw      Thresholding (in Sigma) of the Clean image
  !  Smooth   Thresholding (in Sigma) after smoothing
  !  Length   Smoothing length: default is Clean beam major axis
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: head
  character(len=*), intent(in) :: name
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  integer, parameter :: o_thre=0 ! In command line, not in option
  integer, parameter :: a_offs=1 ! But shifted by 1 argument
  character(len=*), parameter :: rname='MASK'
  !
  real :: raw,smo,length,noise,margin
  integer :: ier
  !
  if (head%loca%size.eq.0) then
    call map_message(seve%e,rname,'No '//trim(name)//' image')
    error = .true.
    return
  endif
  raw = 5.0
  smo = 2.0
  length = head%gil%majo
  !
  call sic_r4(line,o_thre,a_offs+1,raw,.false.,error)
  if (error) return
  call sic_r4(line,o_thre,a_offs+2,smo,.false.,error)
  if (error) return
  call sic_r4(line,o_thre,a_offs+3,length,.false.,error)
  if (error) return
  if (length.eq.0)  length = head%gil%majo
  margin = 0.18
  call sic_r4(line,o_thre,a_offs+4,margin,.false.,error)
  if (margin.lt.0 .or. margin.gt.0.5) then
    call map_message(seve%e,rname,'Margin must be >0 and <0.5')
    error = .true.
    return
  endif
  !
  noise = max(hdirty%gil%noise,head%gil%noise,head%gil%rms)
  if (noise.le.0) then
    call map_message(seve%e,rname,'No noise estimate, use STATISTIC before')
    error = .true.
    return
  endif
  !
  call sic_delvariable('MASK',.false.,error)
  if (allocated(dmask)) deallocate(dmask)    
  call gdf_copy_header(head,hmask,error)
  allocate(dmask(hmask%gil%dim(1),hmask%gil%dim(2),hmask%gil%dim(3)),   &
   &        stat=ier)
  !
  call mask_clean(hmask,dmask,head%r3d,raw*noise,smo*noise,length,margin,error)
  if (error) return
  !
  ! sic_mapgildas produces a Read-Only variable, so preset the
  ! content as 0/1 and the Min Max as appropriate.
  where(dmask.ne.0) dmask = 1.0 
  hmask%gil%rmin = 0.0
  hmask%gil%rmax = 1.0
  !
  call sic_mapgildas('MASK',hmask,error,dmask)
  user_method%do_mask = .true.
  support_type = 1 ! First plane will be used by default 
  !
end subroutine sub_mask_threshold
!
subroutine mask_clean (head,mask,data,raw,smo,length,margin,error) 
  use clean_def
  use image_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : mulgau, map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !   Support routine for SUPPORT /THRESHOLD and
  !   MASK THRESHOLD 
  !
  !   Builds a Mask from a Threshold and Smoothing 
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: head
  real, intent(out), target :: mask(head%gil%dim(1),head%gil%dim(2),head%gil%dim(3))
  real, intent(in) :: data (head%gil%dim(1),head%gil%dim(2),head%gil%dim(3))
  real, intent(in) :: raw
  real, intent(in) :: smo
  real, intent(in) :: length
  real, intent(in) :: margin
  logical, intent(out) :: error
  !
  real(8), parameter :: pi=3.141592653589793d0
  character(len=*), parameter :: rname='MASK'
  !
  integer nx,ny,nc,ix,iy,ic,jx,jy,ndim,dim(2),ier
  real xinc, yinc,fact
  real, allocatable :: wfft(:)
  real, pointer :: tmp(:,:)
  complex, allocatable :: ft(:,:)
  character(len=80) :: chain
  !
  nx = head%gil%dim(1)
  ny = head%gil%dim(2)
  nc = head%gil%dim(3)
  allocate (wfft(2*max(nx,ny)),ft(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error in MASK_CLEAN')
    error = .true.
    return
  endif
  xinc = head%gil%convert(3,1)
  yinc = head%gil%convert(3,2)
  !
  dim(1) = nx
  dim(2) = ny
  ndim = 2
  jy = margin*ny
  jx = margin*nx
  !
  write(chain,'(A,1PG10.2,1PG10.2,A,0PF8.2,A,F6.2)') 'Threshold',raw,smo, &
    & ',  Smoothing ',length*180.*3600./pi,'", guard band ',margin
  call map_message(seve%i,rname,chain)
  !
  do ic=1,nc
    tmp => mask(:,:,ic)
    !
    ! Guard band of margin-th of the image size on each edge to
    ! avoid aliased sidelobes and "raw" thresholding
    tmp = 0.0
    if (head%gil%eval.ge.0.0) then
      do iy=jy+1,ny-jy
        do ix=jx+1,nx-jx
          if (abs(data(ix,iy,ic)-head%gil%bval).gt.head%gil%eval) then
            if (data(ix,iy,ic).ge.raw) tmp(ix,iy) = data(ix,iy,ic)
          endif
        enddo
      enddo    
    else
      do iy=jy+1,ny-jy
        do ix=jx+1,nx-jx
          if (data(ix,iy,ic).ge.raw) tmp(ix,iy) = data(ix,iy,ic)
        enddo
      enddo
    endif
    !
    ! Smoothing of "raw" mask
    ft(:,:) = cmplx(tmp,0.0)
    !
    call fourt(ft,dim,ndim,-1,0,wfft)
    !
    ! Correct for Beam Area for flux density normalisation
    fact = length**2*pi/(4.0*log(2.0))/abs(xinc*yinc)/(nx*ny)
    call mulgau(ft,nx,ny,   &
         &    length, length, 0.0,   &
         &    fact,xinc,yinc, -1)
    call fourt(ft,dim,ndim,1,1,wfft)
    !
    ! Extract Real part
    tmp(:,:) = real(ft)
    where (tmp.lt.smo) tmp = 0.0
  enddo
  !
  ! To be coded: Pruning small isolated regions
  ! a) Label fields
  ! b) Sort them by size
  ! c) Suppress those with size smaller than fraction of beam
  !
  deallocate (wfft,ft)
end subroutine mask_clean
!
subroutine mask_init(key,error)
  use clean_arrays
  use clean_types
  use clean_default
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   IMAGER
  !     Support for command
  !   MASK INIT [2D|3D]
  !--------------------------------------------------------------------- 
  character(len=*), intent(in) :: key
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='MASK'
  integer :: ier
  !
  error = .false.
  !
  ! Free the current MASK if any
  save_data(code_save_mask) = .false.
  call sic_delvariable ('MASK',.false.,error)
  if (allocated(dmask)) deallocate(dmask,stat=ier)
  hmask%loca%size = 0
  if (key.eq.' ') return
  !
  if (key.ne.'2D'.and.key.ne.'3D') then
    call map_message(seve%e,rname,' INITIALIZE invalid argument '//trim(key))
    error = .true.
    return
  endif
  !
  !!Print *,'Last_Shown ',last_shown
  if (last_shown.eq.'CLEAN') then
    if (hclean%loca%size.eq.0) then
      call map_message(seve%e,rname,' INITIALIZE : no Clean image')
      error = .true.
      return
    endif
    call gdf_copy_header(hclean,hmask,error)  
  else if (last_shown.eq.'SKY') then
    if (hsky%loca%size.eq.0) then
      call map_message(seve%e,rname,' INITIALIZE : no Sky image')
      error = .true.
      return
    endif
    call gdf_copy_header(hsky,hmask,error)  
  else
    call map_message(seve%e,rname,' INITIALIZE : no Clean or Sky image')
    error = .true.
    return
  endif
  !
  if (key.eq.'2D') hmask%gil%dim(3) = 1
  allocate(dmask(hmask%gil%dim(1),hmask%gil%dim(2),hmask%gil%dim(3)),   &
   &        stat=ier)
  dmask = 0.0 ! By default, nothing is selected
  hmask%loca%size = hmask%gil%dim(1)*hmask%gil%dim(2)*hmask%gil%dim(3)
  !
  call sic_mapgildas ('MASK',hmask,error,dmask)
end subroutine mask_init
!
subroutine mask_check(all,error)
  use clean_arrays
  use imager_interfaces, only : map_message
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   IMAGER
  ! Support for command MASK
  !---------------------------------------------------------------------
  logical, intent(in) :: all
  logical, intent(inout) :: error
  character(len=*), parameter :: rname='MASK'
  !
  error = .true.
  !
  if (hmask%loca%size.eq.0) then
    call map_message(seve%e,rname,'No Mask defined')
    return
  endif  
  if (hclean%loca%size.eq.0) then
    call map_message(seve%w,rname,'No Clean image')
    error = all
    return
  endif
  !
  if (any(hmask%gil%dim(1:2).ne.hclean%gil%dim(1:2))) then
    call map_message(seve%e,rname,'Mask and Clean sizes do not match')
    return
  else if (hmask%gil%dim(3).ne.1) then
    ! Check matching velocity range would be better
    if (hmask%gil%dim(3).ne.hclean%gil%dim(3)) then
      call map_message(seve%w,rname,'Mask and Clean planes mismatch, proceed at own risk')
    endif
  endif 
  error = .false.
end subroutine mask_check

subroutine define_var (error)
  use gildas_def
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use clean_support
  !
  logical :: error  ! Logical error flag
  logical :: warning
  ! Local
  real :: wdata
  integer :: ier
  integer(kind=index_length) :: dim(4) = 0
  !
  ! CLEAN program variables
  user_method%m_iter = 0
  call sic_def_inte ('NITER',user_method%m_iter,0,dim,.false.,error)
  dim(1) = 2
  user_method%patch = 0
  call sic_def_inte ('BEAM_PATCH',user_method%patch,1,dim,.false.,error)
  dim(1) = 2
  user_method%blc = 0
  call sic_def_inte ('BLC',user_method%blc,1,dim,.false.,error)
  user_method%trc = 0
  call sic_def_inte ('TRC',user_method%trc,1,dim,.false.,error)
  user_method%p_iter = 0
  call sic_def_inte ('POSITIVE',user_method%p_iter,0,dim,.false.,error)
  user_method%n_major = 50
  call sic_def_inte ('NMAJOR',user_method%n_major,0,dim,.false.,error)
  user_method%gain = 0.2
  call sic_def_real ('GAIN',user_method%gain,0,dim,.false.,error)
  user_method%fres = 0.01
  call sic_def_real ('FRES',user_method%fres,0,dim,.false.,error)
  user_method%ares = 0.0
  call sic_def_real ('ARES',user_method%ares,0,dim,.false.,error)
  major_sec = 0.0
  call sic_def_real ('MAJOR',major_sec,0,dim,.false.,error)
  minor_sec = 0.0
  call sic_def_real ('MINOR',minor_sec,0,dim,.false.,error)
  ! Delete the ANGLE variable defined by define.greg and recreate it
  ! such as it maps 'user_method%angle'
  call sic_delvariable('ANGLE',.true.,warning)
  user_method%angle = 0.0
  call sic_def_real ('ANGLE',user_method%angle,0,dim,.false.,error)
  user_method%keep = .true.
  call sic_def_logi ('KEEP',user_method%keep,.false.,error)
  user_method%spexp = 1.0
  call sic_def_real ('SPEED',user_method%spexp,0,dim,.false.,error)
  user_method%ngoal = 10000
  call sic_def_inte ('NGOAL',user_method%ngoal,0,dim,.false.,error)
  ! MultiScale
  user_method%nker = (/1,7,11/)
  dim(1) = 3
  call sic_def_inte ('KERNEL',user_method%nker,1,dim,.false.,error)
  user_method%ninflate = 20   ! A decent value, sometimes too short
  call sic_def_inte ('INFLATE',user_method%ninflate,0,0,.false.,error)
  user_method%smooth = sqrt(3.0)
  call sic_def_real ('SMOOTH',user_method%smooth,0,dim,.false.,error)
  !
  ! MRC
  user_method%ratio = 0
  call sic_def_real ('RATIO',user_method%ratio,0,dim,.false.,error)
  !
  ! Mosaic mode
  user_method%search = 0.2
  call sic_def_real ('SEARCH_W',user_method%search,0,dim,.false.,error)
  user_method%restor = 0.2
  call sic_def_real ('RESTORE_W',user_method%restor,0,dim,.false.,error)
  ! Delete the MOSAIC variable defined by define.greg and recreate it
  ! such as it maps 'user_method%mosaic'
  call sic_delvariable('MOSAIC',.true.,warning)
  user_method%mosaic = .false.
  call sic_def_logi ('MOSAIC',user_method%mosaic,.false.,error)
  user_method%verbose = .false.
  call sic_def_logi ('VERBOSE',user_method%verbose,.false.,error)
  ! Compact Array parameters
  cuse_method%gain = 0.4
  call sic_def_real ('C_GAIN',cuse_method%gain,0,dim,.false.,error)
  !
  ! UV_MAP variables
  default_map%precis = 0.1       ! Requested precision
  call sic_def_real ('MAP_PRECIS',default_map%precis,0,dim,.false.,error)
  default_map%beam = -1          ! Number of channels per beam
  call sic_def_inte ('MAP_BEAM_STEP',default_map%beam,0,dim,.false.,error)
  dim = [2,0,0,0]
  default_map%field = 0          ! Map field in arcsecond
  call sic_def_real ('MAP_FIELD',default_map%field,1,dim,.false.,error)
  default_map%size = 0           ! Map size in Pixels
  call sic_def_inte ('MAP_SIZE',default_map%size,1,dim,.false.,error)
  default_map%xycell = 0         ! Map cell size in arcsecond
  call sic_def_real ('MAP_CELL',default_map%xycell,1,dim,.false.,error)
  dim = [3,0,0,0]
  default_map%taper = 0          ! UV Taper in m and Degree
  call sic_def_real ('MAP_UVTAPER',default_map%taper,1,dim,.false.,error)
  default_map%taper(4) = 2       ! Taper exponent
  call sic_def_real ('MAP_TAPEREXPO',default_map%taper(4),0,dim,.false.,error)
  !
  default_map%uniform(1) = 0.0      ! UV cell size
  call sic_def_real ('MAP_UVCELL',default_map%uniform(1),0,dim,.false.,error)
  default_map%uniform(2) = 1.0      ! Robustness coefficient
  call sic_def_real ('MAP_ROBUST',default_map%uniform(2),0,dim,.false.,error)
  default_map%mode = 'NATURAL'   ! Weighting mode
  call sic_def_char ('MAP_WEIGHT',default_map%mode,.false.,error)
  !
  default_map%truncate = 20.0     ! Truncation level (Mosaic or Primary)
  call sic_def_real ('MAP_TRUNCATE',default_map%truncate,0,dim,.false.,error)
  !
  default_map%ctype = 5    ! Convolution code
  call sic_def_inte ('MAP_CONVOLUTION',default_map%ctype,0,dim,.false.,error)
  !
  default_map%shift = .false.
  call sic_def_logi ('MAP_SHIFT',default_map%shift,.false.,error)
  default_map%ra_c = ' '   ! Weighting mode
  call sic_def_char ('MAP_RA',default_map%ra_c,.false.,error)
  default_map%dec_c = ' '   ! Weighting mode
  call sic_def_char ('MAP_DEC',default_map%dec_c,.false.,error)
  default_map%angle = 0.0      ! Robustness coefficient
  call sic_def_real ('MAP_ANGLE',default_map%angle,0,dim,.false.,error)
  !
  ! Old names for compatibility
  !   define logical uv_shift /global
  !   define integer convolution /global
  !   define double uv_cell[2] uv_taper[3] taper_expo /global
  old_map = default_map
  call sic_def_inte ('CONVOLUTION',old_map%ctype,0,dim,.false.,error)
  call sic_def_logi ('UV_SHIFT',old_map%shift,.false.,error)
  call sic_def_char ('WEIGHT_MODE',old_map%mode,.false.,error)
  dim = [2,0,0,0]
  call sic_def_real ('UV_CELL',old_map%uniform(1),1,dim,.false.,error)
  dim = [3,0,0,0]
  call sic_def_real ('UV_TAPER',old_map%taper,1,dim,.false.,error)
  call sic_def_real ('TAPER_EXPO',old_map%taper(4),0,dim,.false.,error)
  ! Initialize status
  save_map = old_map
  !
  ! Dummy definition of the variable
  call sic_def_real('W',wdata,0,dim,.true.,error)
  !
  ! W Header
  call sic_def_header('W',w_plot,.false.,error)
  !
  ! Dirty Min/Max
  call sic_def_real('D_MAX',d_max,0,dim,.false.,error)
  call sic_def_real('D_MIN',d_min,0,dim,.false.,error)
  !
  ! CLEAN\SUPPORT polygon, mapped on SUPPORT%  (reserved structure name)
  call sic_defstructure(supportvar,.true.,error)
  !
  ! UV Size
  dim(1) = 2
#if defined(INDEX4) || !defined(BITS64)
  call sic_def_inte('UV_DIM',huv%gil%dim,1,dim,.false.,error)
  call sic_def_inte('UVS_DIM',huvt%gil%dim,1,dim,.false.,error)
#else
  call sic_def_long('UV_DIM',huv%gil%dim,1,dim,.false.,error)
  call sic_def_long('UVS_DIM',huvt%gil%dim,1,dim,.false.,error)
#endif
  call sic_def_inte('UV_NCHAN',huv%gil%nchan,0,dim,.false.,error)
  !
  dim(1) = mtype
  call sic_def_charn('FILE_TYPE',vtype,1,dim,.true.,error)
  call sic_def_charn('FILE_EXT',etype,1,dim,.false.,error)
  !
  ! Delete the TYPE variable defined by define.greg and recreate it
  ! such as it maps 'ctype'
  call sic_delvariable('TYPE',.true.,warning)
  dim(1) = 0
  ctype = ' '  ! Make sure it is initialized
  call sic_def_char('TYPE',ctype,.false.,error)
  !
  call gildas_null(hbeam)
  call gildas_null(hclean)
  call gildas_null(hresid)
  call gildas_null(hdirty)
  !
  call gildas_null(hprim)
  call gildas_null(huv, type = 'UVT')
  call gildas_null(huvi, type = 'UVT')
  call gildas_null(huvt, type = 'UVT')
  call gildas_null(huvm, type = 'UVT')
  call gildas_null(hcct)
  call gildas_null(hmask)
  call gildas_null(hsky)
  !
  ! Read/Write Optimization
  rw_optimize = 0
  ier = sic_getlog('MAPPING_OPTIMIZE',rw_optimize)
  call sic_def_inte('MAPPING_OPTIMIZE',rw_optimize,0,dim,.false.,error)
  !
  ! Debug
  call sic_def_logi('DO_WEIG',do_weig,.false.,error)
  !
end subroutine define_var

subroutine uv_time_comm(line,error)
  use clean_arrays
  use clean_types
  use gkernel_interfaces
  use mapping_interfaces, except_this => uv_time_comm
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !
  ! Time-Average the UV Table (usefull for ALMA data, although
  ! it is more efficient to do that on the original UV table
  ! before reading it).
  !
  ! UV_TIME Time /Weight Wcol
  !
  ! Works on the "current" UV data set: Uses UVS or UVR as needed.
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='UV_TIME_AVERAGE'
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  real(4) :: mytime
  integer(4) :: wcol
  character(len=80) :: mess
  real(8), allocatable :: times(:), ttime(:)
  integer, allocatable :: ip(:), ftime(:), ltime(:)
  integer :: ntime, mtime, first_time, last_time
  real(8) :: old_time, t0
  integer :: iv, jv, kv, lv, it, ier, mvisi, maxant
  integer :: nu, nv, mv, myseve
  real :: rmax, diam
  type (gildas) :: hcuv
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  real, allocatable :: din(:,:)
  character(len=64) :: mychain
  integer :: nc, first, fstart, fend
  integer :: ifield, np, nvout, ixoff, iyoff
  real(4), allocatable :: doff(:,:)
  integer, allocatable :: voff(:)
  logical :: shift, sorted
  real :: uvmax, uvmin
  real(8) :: new(3)
  !
  shift = .false.
  new = 0.d0
  !
  !
  if (.not.sic_present(0,1)) then
    call uvgmax(huv,duv,uvmax,uvmin)
    !
    call sic_get_real('UV_CELL[1]',diam,error)
    if (diam.eq.0) then
      call map_message(seve%e,rname,'UV_CELL[1] is not specified')
      error = .true.
      return
    endif
    mytime = nint(diam/(4*pi*uvmax)*86400)
    write(mychain,*) 'Smoothing to ',mytime
    call map_message(seve%i,rname,mychain)
  else
    call sic_r4(line,0,1,mytime,.true.,error)
    if (error) return
  endif
  !
  wcol = 0
  call sic_i4(line,1,1,wcol,.false.,error)
  if (error) return
  !
  ! The UV table is available in HUV%
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data loaded')
    error = .true.
    return
  endif
  nu = huv%gil%dim(1)
  nv = huv%gil%dim(2)
  !
  if (themap%nfields.eq.0) then
    !
    ! Read the Time Baseline information, and verify it is sorted
    allocate (times(nv), ip(nv), stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    t0 = duv(4,1) ! First date
    maxant = 0
    do iv = 1, nv
      times(iv) = (duv(4,iv)-t0)*86400.d0+duv(5,iv)-duv(5,1)
      rmax = max(duv(6,iv),duv(7,iv))
      maxant = max(maxant,nint(rmax))
    enddo
    !
    ! So here is the maximum number of visibilities per time range
    mvisi = (maxant*(maxant-1))/2
    !
    ! Sort the time array
    call gr8_trie(times,ip,nv,error)
    !
    ! Figure out how many output times
    old_time = -1d10
    ntime = 0
    do iv = 1, nv
      if ((times(iv)-old_time).ge.mytime) then
        old_time = times(iv)
        ntime = ntime+1
      endif
    enddo
    mtime = ntime
    !
    allocate (ttime(mtime), ftime(mtime), ltime(mtime), stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    ! Find out the time boundaries
    jv = 0
    ntime = 0
    old_time = -1d10
    do iv = 1, nv
      if ((times(iv)-old_time).ge.mytime) then
        if (ntime.gt.0) ltime(ntime) = iv-1
        old_time = times(iv)
        ntime = ntime+1
        ftime(ntime) = iv
        ttime(ntime) = times(iv)
      endif
    enddo
    ltime(ntime) = nv   ! The last is a time change
    !
    ! Prepare header and allocate buffers
    call gildas_null(hcuv,type='UVT')
    call gdf_copy_header(huv,hcuv,error)
    mvisi = ntime*mvisi     
    hcuv%gil%dim(2) = mvisi
    hcuv%gil%nvisi = mvisi     ! For the time being...
    nullify (duv_previous, duv_next)
    call uv_find_buffers (rname,nu,mvisi,duv_previous,duv_next,error)
    if (error) return
    !
    ! Setup the Weight column
    if (wcol.eq.0) wcol = max(3,huv%gil%nchan)/3
    !
    ! Now do the job
    old_time = ttime(1)
    jv = 1  ! Initialize here
    do it=1,ntime
      !
      first_time = ftime(it)
      last_time = ltime(it)
      ! Some useless debugging...
      !write(mess,*) 'Time ',old_time,' range ',first_time,last_time, ' / ',nv
      !call map_message(seve%i,rname,mess)
      mv = last_time-first_time+1
      allocate (din(nu,mv),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error')
        error = .true.
        return
      endif
      kv = 0
      do lv = first_time,last_time
        kv = kv+1
        din(:,kv) = duv(:,ip(lv))
      enddo
      if (mv.ne.kv) Print *,'Missing antennas on time ',it,kv,mv
      kv = jv
      call time_compress(din,nu,1,mv, &
          wcol, hcuv, duv_next, jv, mvisi, error)
      if (error) then
        write(mess,*) 'Programming error or strange UV table ',jv,' > ',mvisi
        call map_message(seve%e,rname,mess)
        return
      endif
      if (jv.lt.kv) then
        write(mess,*) 'No valid averaged visibility for ',old_time
        call map_message(seve%w,rname,mess)
      endif
      jv = jv+1     ! Point to next one, then...
      old_time = ttime(it)
      deallocate (din)
    enddo
    !
    ! Finalize the UV Table with the right numbers
    hcuv%gil%dim(2)= jv-1 ! Is this allowed ?...
    hcuv%gil%nvisi = jv-1
  else
    !
    ! Make sure the UV table has been sorted by fields first
    call map_message(seve%w,rname,'Sorting mosaic UV table')
    ixoff = huv%gil%column_pointer(code_uvt_xoff)
    iyoff = huv%gil%column_pointer(code_uvt_yoff)
    if (ixoff.eq.0) then
      ixoff = huvi%gil%column_pointer(code_uvt_loff)
      iyoff = huvi%gil%column_pointer(code_uvt_moff)
    endif
    call mosaic_sort (error,sorted,shift,new,uvmax,uvmin, &
      & ixoff,iyoff,np,doff,voff)
    if (error) return
    !
    ! Prepare header and allocate buffers
    call gildas_null(hcuv,type='UVT')
    call gdf_copy_header(huv,hcuv,error)
    nullify (duv_previous, duv_next)
    call uv_find_buffers (rname,nu,nv,duv_previous,duv_next,error)
    if (error) return
    !
    if (wcol.eq.0) wcol = max(3,huv%gil%nchan)/3
    !
    ! Loop over fields to sort each data
    first = 1
    ! This loop cannot be parallelized ...
    do ifield = 1,np
      !
      fstart = voff(ifield)       ! Starting Visibility of field
      fend   = voff(ifield+1)-1   ! Ending Visibility of field
      !
      call time_integrate(rname,huv,mytime,wcol,nu,fend-fstart+1, &
        & duv(:,fstart:fend),duv_next(:,first:),nvout,error)
        if (error) return
      Print *,'Field ',ifield,nvout, ' Visibilities from range ',fstart,fend
      first = first+nvout
    enddo
    !
    hcuv%gil%dim(2)= first-1 ! Is this allowed ?...
    hcuv%gil%nvisi = first-1
  endif
  !
  write(mess,'(i12,a,i12,a)') hcuv%gil%nvisi,' Visibilities created (', &
    & huv%gil%nvisi,' before)'
  call map_message(seve%i,rname,mess)
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  !
  ! Copy back to UV data set
  call gdf_copy_header(hcuv,huv,error)
  !
  ! Indicate Weights have changed, optimization and save status
  do_weig = .true.
  optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
  save_data(code_save_uv) = .true.
  ! Redefine SIC variables (mandatory)
  call sic_delvariable ('UV',.false.,error)
  call sic_mapgildas ('UV',huv,error,duv)
  !
end subroutine uv_time_comm
!
subroutine time_compress(invisi,nd,first,last,wcol, out, ovisi, jv, &
  & mvisi, error)
  use gildas_def
  use image_def
  use mapping_interfaces, except_this => time_compress
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !   Time compress a UV table
  !   Compute visibilities for a single output time
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: out
  integer, intent(in) :: nd                     ! Visibility size
  real, intent(in) :: invisi(:,:)               ! Input visibilities
  integer, intent(in) :: wcol                   ! Weight column
  real, intent(inout) :: ovisi(:,:)             ! Output visibilities
  integer, intent(in) :: first, last            ! First and last input visibilities
  integer, intent(inout) :: jv                  ! Current output visibility number
  integer, intent(in) :: mvisi
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='TIME_COMPRESS'
  real, allocatable, target :: avisi(:,:), bvisi(:,:)
  real, pointer :: my_visi(:,:)
  integer, allocatable :: tb(:), indx(:)
  integer :: vmax, iant, jant
  integer :: iv, kv, nvisi, ier, icol, ic
  logical :: sorted
  real :: sw
  !
  error = .false.
  !
  ! Extract the relevant - A copy is needed in all cases...
  nvisi = last-first+1
  allocate (avisi(nd,nvisi),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  avisi(1:nd,1:nvisi) = invisi(:,first:last)
  !
  ! Sort it by BASELINE.
  ! We do not care about time here, since we are time averaging
  !
  ! Check the order
  allocate (tb(nvisi),stat=ier)
  do iv=1,nvisi
    ! Use the baseline number code as major driver
    if (avisi(7,iv).lt.avisi(6,iv)) then
      tb(iv) = (256*avisi(6,iv)+avisi(7,iv))
    else if (avisi(7,iv).gt.avisi(6,iv)) then
      tb(iv) = (256*avisi(7,iv)+avisi(6,iv))
    else
      ! No Baseline code for Short spacings which have Iant = Jant
      tb(iv) = 0
    endif
  enddo
  sorted = .true.
  vmax = tb(1)
  do iv = 1,nvisi
    if (tb(iv).lt.vmax) then
      sorted = .false.
      exit
    endif
    vmax = tb(iv)
  enddo
  !
  ! Sort it if needed
  if (.not.sorted) then
    allocate(indx(nvisi),bvisi(nd,nvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    do iv = 1,nvisi
      indx(iv) = iv
    enddo
    call gi4_trie(tb,indx,nvisi,error)
    if (error) then
      call map_message(seve%e,rname,'Sorting error')
      return
    endif
    do iv=1,nvisi
      kv = indx(iv)
      bvisi(:,iv) = avisi(:,kv)
    enddo
    my_visi => bvisi
  else
    my_visi => avisi
  endif
  !
  ! Now do the real work for each baseline
  icol = out%gil%nlead+out%gil%natom*wcol
  !
  kv = jv ! Output visibility pointer
  ovisi(:,jv) = 0      ! Current visibility
  sw = 0.0             ! Current running weight
  iant = my_visi(6,1)  ! First antenna
  jant = my_visi(7,1)  ! Last antenna
  do iv=1,nvisi
    if (iant.eq.my_visi(6,iv) .and. jant.eq.my_visi(7,iv)) then
      ! Same antennas... Continue adding 
      ! ... unless it is a Short spacing stuff...
      if (iant.eq.-1 .and. sw.ne.0.0) then
        call mean_visiw(out,ovisi(:,kv),sw)
        kv = kv+1
        if (kv.gt.mvisi) then  ! Test for overflow (normally none...)
          Print *,'MVISI ',mvisi,' First ',first, ' Overflow ...'
          Print *,'KV ',kv, ' -- Visi ',iv+first-1,' changing from ',iant,jant, &
      & ' to ',my_visi(6,iv),my_visi(7,iv)
          error = .true.
          return
        endif
      endif
    else if (iant.eq.my_visi(7,iv) .and. jant.eq.my_visi(6,iv)) then
      ! Same antennas, but reversed order...
      !
      ! We take care of reversed visibilities, which could happen
      ! when V is close to zero, and the UV table has been already
      ! sorted. This can be done by changing the Imaginary part of
      ! my_visi as well as u,v (and w in principle...)
      ! Print *,iv,' Reversed ',my_visi(1:7,iv)
      my_visi(1,iv) = -my_visi(1,iv)
      my_visi(2,iv) = -my_visi(2,iv)
      my_visi(6,iv) = iant
      my_visi(7,iv) = jant
      do ic=out%gil%fcol+1,out%gil%lcol,3
        my_visi(ic,iv) = -my_visi(ic,iv)
      enddo
    else
 !!     Print *,'KV ',kv, ' -- Visi ',iv,' changing from ',iant,jant, &
 !!     & ' to ',my_visi(6,iv),my_visi(7,iv)
      if (sw.ne.0.0) then
        call mean_visiw(out,ovisi(:,kv),sw)
        kv = kv+1
        if (kv.gt.mvisi) then
          Print *,'MVISI ',mvisi,' First ',first
          Print *,'KV ',kv, ' -- Visi ',iv+first-1,' changing from ',iant,jant, &
      & ' to ',my_visi(6,iv),my_visi(7,iv)
          error = .true.
          return
        endif
        ovisi(:,kv) = 0.0
      endif
      iant = my_visi(6,iv)
      jant = my_visi(7,iv)
      sw = 0.0
    endif
    !
    ! Once done, Add to Current visibility - 
    ! For the first one, it simply copies it to the output place
    call add_visiw(out,ovisi(:,kv),my_visi(icol,iv),my_visi(:,iv),sw)
  enddo
  !
  if (sw.ne.0.0) then
    jv = kv
    call mean_visiw(out,ovisi(:,kv),sw)
  else
    jv = kv-1
  endif
  !
end subroutine time_compress
!
subroutine add_visiw(out,ovisi,aw,avisi,sw)
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  !   Add a visibility to current output one
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: out   ! Input image header
  real, intent(inout) :: ovisi(:)   ! Output visibilities
  real, intent(in) :: aw            ! Input weight
  real, intent(inout) :: avisi(:)   ! Input visibilities
  real, intent(inout) :: sw         ! Output weight
  !
  integer i
  real :: uv2
  real :: uv2max=12.0**2
  !
  if (aw.le.0) return
  !
  ! This is a patch for old files which have been incorrectly
  ! sorted, without the antennas being swapped...
  if (sw.gt.0) then
    uv2 = (ovisi(1)/sw-avisi(1))**2 + (ovisi(2)/sw-avisi(2))**2
    if (uv2.gt.uv2max) then
      if (ovisi(1)*avisi(1).lt.0) then
        Print *,'Continuity problem',sqrt(uv2), &
        & '(Bad Antenna order ?), Patching data'
        Print *,ovisi(1:2)/sw,avisi(1:2)
        avisi(1) = -avisi(1)
        avisi(2) = -avisi(2)
        do i = out%gil%nlead+2,out%gil%natom*out%gil%nchan+out%gil%nlead,out%gil%natom
          avisi(i) = -avisi(i)
        enddo
      endif
    endif
  endif
  !
  ovisi(1:3) = ovisi(1:3)+aw*avisi(1:3)
  ovisi(4:out%gil%nlead) = avisi(4:out%gil%nlead)
  do i = out%gil%nlead+1,out%gil%natom*out%gil%nchan+out%gil%nlead,out%gil%natom
    ovisi(i) = ovisi(i) + aw*avisi(i)
    ovisi(i+1) = ovisi(i+1) + aw*avisi(i+1)
    ovisi(i+2) = ovisi(i+2) + avisi(i+2)   ! Sum the weights
  enddo
  do i=out%gil%lcol+1,out%gil%dim(1)
    ovisi(i) = avisi(i)
  enddo
  sw = sw+aw
end subroutine add_visiw
!
subroutine mean_visiw(out,ovisi,sw)
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  !   Normalize the final visibility
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: out   ! Input image header
  real, intent(inout) :: ovisi(:)   ! Output visibilities
  real, intent(inout) :: sw         ! Output weight
  !
  integer i
  !
  if (sw.le.0) return
  !
  ovisi(1:3) = ovisi(1:3)/sw
  do i = out%gil%nlead+1,out%gil%natom*out%gil%nchan+out%gil%nlead,out%gil%natom
    ovisi(i) = ovisi(i)/sw
    ovisi(i+1) = ovisi(i+1)/sw
  enddo
end subroutine mean_visiw

subroutine time_integrate(rname,huv,mytime,wcol,nu,nv,vin,vout,nvout,error)
  use image_def
  use gbl_message
  use mapping_interfaces, only : map_message, time_compress
  !---------------------------------------------------------------------
  ! @ public
  ! Time-Average a UV data set
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname  ! Calling routine
  type(gildas), intent(in) :: huv        ! UV Header
  real(4), intent(in) :: mytime          ! Integration time
  integer, intent(in) :: wcol            ! Weight column
  integer, intent(in) :: nu              ! Size of a visibility
  integer, intent(in) :: nv              ! Number of input visibilities
  real, intent(in) :: vin(:,:)           ! input visibilities
  real, intent(inout) :: vout(:,:)       ! output visibilities
  integer, intent(out) :: nvout          ! Number of output visibilities
  logical, intent(out) :: error          ! Error flag
  !
  character(len=80) :: mess
  real(8), allocatable :: times(:), ttime(:)
  integer, allocatable :: ip(:), ftime(:), ltime(:)
  real, allocatable :: din(:,:)
  integer :: ier, ntime, mtime
  real(8) :: t0, old_time
  integer :: first_time, last_time
  integer :: it,iv,jv,kv,lv,mv
  real(8) :: new
  logical :: shift
  integer :: mvisi
  !
  ! Read the Time Baseline information, and verify it is sorted
  allocate (times(nv), ip(nv), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  mvisi = ubound(vout,2)
  !
  t0 = vin(4,1) ! First date
  do iv = 1, nv
    times(iv) = (vin(4,iv)-t0)*86400.d0+vin(5,iv)-vin(5,1)
  enddo
  !
  ! Sort the time array
  call gr8_trie(times,ip,nv,error)
  !
  ! Figure out how many output times
  old_time = -1d10
  ntime = 0
  do iv = 1, nv
    if ((times(iv)-old_time).ge.mytime) then
      old_time = times(iv)
      ntime = ntime+1
    endif
  enddo
  mtime = ntime
  !
  allocate (ttime(mtime), ftime(mtime), ltime(mtime), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Find out the time boundaries
  jv = 0
  ntime = 0
  old_time = -1d10
  do iv = 1, nv
    if ((times(iv)-old_time).ge.mytime) then
      if (ntime.gt.0) ltime(ntime) = iv-1
      old_time = times(iv)
      ntime = ntime+1
      ftime(ntime) = iv
      ttime(ntime) = times(iv)
    endif
  enddo
  ltime(ntime) = nv   ! The last is a time change
  !
  ! Now do the job
  old_time = ttime(1)
  jv = 1  ! Initialize here
  do it=1,ntime
    !
    first_time = ftime(it)
    last_time = ltime(it)
    ! Some useless debugging...
    !!Print *,'Time ',old_time,' range ',first_time,last_time, ' / ',nv
    mv = last_time-first_time+1
    allocate (din(nu,mv),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    kv = 0
    do lv = first_time,last_time
      kv = kv+1
      din(:,kv) = vin(:,ip(lv))
    enddo
    if (mv.ne.kv) Print *,'Missing antennas on time ',it,kv,mv
    kv = jv
    call time_compress(din,nu,1,mv, wcol, huv, vout, jv, mvisi, error)
    if (error) then
      write(mess,*) 'Programming error or strange UV table ',jv,' > ',mvisi
      call map_message(seve%e,rname,mess)
      return
    endif
    if (jv.lt.kv) then
      write(mess,*) 'No valid averaged visibility for ',old_time
      call map_message(seve%w,rname,mess)
    endif
    jv = jv+1     ! Point to next one, then...
    old_time = ttime(it)
    deallocate (din)
  enddo
  !
  nvout = jv-1
end subroutine time_integrate

subroutine mulgau(data,nx,ny,bmaj,bmin,pa,scale,xinc,yinc,isign)
  !----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  ! 	Multiply of Divide (according to isign) the TF of an image by the 
  ! TF of a convolving gaussian function. BMAJ and BMIN are the
  !	widths of the original gaussian. PA is the position angle of major
  !	axis (from north towards east), in Degrees
  !----------------------------------------------------------------------
  integer, intent(in) :: nx,ny    ! X,Y size
  real, intent(in) :: bmaj        ! Major axis in Radian
  real, intent(in) :: bmin        ! Minor axis in Radian 
  real, intent(in) :: pa          ! Position Angle in Degree
  real, intent(in) :: scale       ! Flux scale factor
  real, intent(in) :: xinc        ! X pixel size
  real, intent(in) :: yinc        ! Y pixel size
  complex, intent(inout) :: data(nx,ny)  ! TF of Data to be smoothed
  integer, intent(in) :: isign
  !
  real(8), parameter :: pi=3.141592653589793d0
  real(4), parameter :: eps=1.e-7
  integer i,j,nx1,nx2
  real amaj,amin,fact,cx,cy,sx,sy
  real seuil, gain
  logical norot,rot90
  real(8) rpa, dpa
  logical :: debug=.false.
  !
  dpa = pa         ! in degrees
  norot = ( abs(mod(dpa,180.d0)).le.eps)
  rot90 = ( abs(mod(dpa,180.d0)-90.d0).le.eps)
  amaj = bmaj*pi/(2.*sqrt(log(2.)))
  amin = bmin*pi/(2.*sqrt(log(2.)))
  rpa = pa*pi/180.d0   ! in radians here...  
  !
  gain = scale
  !!Print *,'major & minor ',bmaj*3600*180/pi,bmin*3600*180/pi
  !!Print *,'position angle ',pa*180/pi
  !!Print *,'isign ',isign
  !
  if (isign.gt.0) then
    seuil = 10.0
  else
    seuil = 80.0
  endif
  !
  cx = cos(rpa)/nx*amin
  cy = cos(rpa)/ny*amaj
  sx = sin(rpa)/nx*amaj
  sy = sin(rpa)/ny*amin
  !!Print *,'CX CY SX SY user ',cx,cy,sx,sy
  !
  ! convert map units to pixels
  cx = cx / xinc
  cy = cy / yinc
  sx = sx / xinc
  sy = sy / yinc
  !!Print *,'CX CY SX SY pixels ',cx,cy,sx,sy
  nx2 = nx/2
  nx1 = nx2+1
  !
  ! optimised code for position angle 0 degrees
  if (norot) then
    do j=1,ny/2
      do i=1,nx2
        fact = (float(j-1)*cy)**2 + (float(i-1)*cx)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(j-1)*cy)**2 + (float(i-nx-1)*cx)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(j-ny-1)*cy)**2 + (float(i-1)*cx)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(j-ny-1)*cy)**2 + (float(i-nx-1)*cx)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    !
    ! optimised code for position angle 90 degrees
  elseif (rot90) then
    do j=1,ny/2
      do i=1,nx2
        fact = (float(i-1)*sx)**2 +(float(j-1)*sy)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx)**2 + (float(j-1)*sy)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(i-1)*sx)**2 + (float(j-ny-1)*sy)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx)**2 + (float(j-ny-1)*sy)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    !
    ! general case of a rotated elliptical gaussian
  else
    do j=1,ny/2
      do i=1,nx2
        fact = (float(i-1)*sx + float(j-1)*cy)**2 + &
            (-float(i-1)*cx + float(j-1)*sy)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx + float(j-1)*cy)**2 + &
            ( -float(i-nx-1)*cx + float(j-1)*sy)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(i-1)*sx + float(j-ny-1)*cy)**2 + &
            ( -float(i-1)*cx + float(j-ny-1)*sy)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx & 
          + float(j-ny-1)*cy)**2 + &
          ( -float(i-nx-1)*cx + float(j-ny-1)*sy)**2
        if (fact.lt.seuil) then
          fact = exp (isign*fact)
          data(i,j) = data(i,j)*fact*gain
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
  endif
end subroutine mulgau
!

subroutine uv_check_comm(line,error)
  use gkernel_interfaces
  use gbl_message
  use mapping_interfaces, only : howmany_beams
  use clean_types
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING support routine for command
  !     UV_CHECK [Beams|Null]
  !----------------------------------------------------------------------
  logical, intent(out) :: error ! Logical error flag
  character(len=*), intent(in) :: line
  !
  integer :: nu,nv,nc,na,ncase, ier, i, iv, ic, kv
  integer, allocatable :: cases(:), bad(:)
  character(len=*), parameter :: rname='UV_CHECK'
  character(len=12) :: argum,cmode
  integer, parameter :: mmode=2
  character(len=8) :: smode(2)
  data smode /'BEAMS','NULLS'/
  !
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data loaded')
    error = .true.
    return
  endif
  nu = huv%gil%dim(1)
  nv = huv%gil%dim(2)
  nc = huv%gil%nchan
  !
  argum = 'BEAMS'
  call sic_ke(line,0,1,argum,na,.false.,error)
  call sic_ambigs (rname,argum,cmode,na,smode,mmode,error)
  if (error) return
  !
  select case (cmode)
  case('BEAMS')
    allocate (cases(nc),stat=ier)
    !
    call howmany_beams(huv,nv,duv,cases,ncase,error)
    !
    ! Write the result
    if (ncase.eq.1) then
      call map_message(seve%i,rname,'Only one beam needed')
    else
      if (ncase.eq.nc) then
        call map_message(seve%w,rname,'Need one beam per channel')
      else
        call map_message(seve%w,rname,'Beams needed for the following channel ranges:')
        cases(ncase+1) = nc
        do i=1, ncase
          write(6,'(a,i6,a,i6,a)') '[',cases(i),'-',cases(i+1),']'
        enddo
      endif
    endif
  case ('NULLS')
    call map_message(seve%i,rname,'Checking for null visibilities')
    allocate (bad(0:nv),stat=ier)
    bad(0) = 0
    kv = 0
    do iv=1,nv
      do ic=1,nc
        if (duv(7+3*ic,iv).gt.0) then
          if (duv(5+3*ic,iv).eq.0 .and. duv(6+3*ic,iv).eq.0) then
            if (bad(kv).ne.iv) then
              kv = kv+1
              bad(kv) = iv
            endif
            duv(7+3*ic,iv) = 0
          endif
        endif
      enddo
    enddo
    if (kv.ne.0) then
      write(6,*) 'Flagged ',kv,' null visibilities'
      write(6,*) (bad(iv),iv=1,kv)
    else
      call map_message(seve%i,rname,'No null visibilities left unflagged')
    endif
    deallocate (bad,stat=ier)
  end select
end subroutine uv_check_comm
!
subroutine howmany_beams(uvin, nvisi, din, cases, ncase, error)
  use image_def
  !----------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING support routine for command
  !     UV_CHECK
  !----------------------------------------------------------------------
  type(gildas), intent(in) :: uvin                  ! UV table header
  integer, intent(in) :: nvisi                      ! Number of visibilities
  real, intent(in), target :: din(uvin%gil%dim(1),nvisi)    ! UV data
  integer, intent(inout) :: cases(uvin%gil%nchan)   ! Possible cases for beams
  integer, intent(inout) :: ncase                   ! Number of cases
  logical, intent(out) :: error                     ! flag
  !
  real, pointer :: wlast(:), wcur(:)
  logical, allocatable :: mask(:)
  !
  integer :: k,ic,ier
  !
  allocate (mask(nvisi),stat=ier)
  error = ier.ne.0
  if (error) return
  !
  wlast => din(uvin%gil%fcol+2,:)
  ncase = 1
  cases(1) = 1
  !
  k = uvin%gil%fcol+2
  do ic = 2,uvin%gil%nchan
    k = k+3
    wcur => din(k,:)
    mask(:) = wcur.ne.wlast
    if (any(mask)) then
      ncase = ncase+1
      cases(ncase) = ic ! Which channel
      wlast => din(k,:)
    endif
  enddo
  deallocate (mask)
end subroutine howmany_beams

module ast_horizon
! Old horizon.inc
      integer(kind=4), parameter :: m_horiz=9
      integer(kind=4), parameter :: m_source=1000
!
      real(kind=8) :: horiz(m_horiz), rise(m_source, m_horiz)
      real(kind=8) :: set (m_source, m_horiz), transit(m_source)
      real(kind=8) :: declin(m_source), righta(m_source),dsun(m_source)
      real(kind=8) :: sunriz(4),sunset(4),moonphse, moonmag
      integer(kind=4) :: n_horiz, next_source(2), n_rise
      logical :: airmass, night_mark
!
      character(len=36) :: c_rise(m_source)
      integer(kind=4) :: min_elev(m_source)
!
      type :: astro_source_mem
        integer(kind=4)   :: soukind
        character(len=32) :: name
        character(len=2)  :: coord
        real(kind=4)   :: equinox
        real(kind=8)      :: lambda  ! radians
        real(kind=8)      :: beta  ! radians
        character(len=2)  :: vtype
        real(kind=8) :: velocity
        real(kind=8) :: redshift
      end type astro_source_mem
!
! Old projec.inc
      character(len=4) :: c_proj(m_source)
      character(len=8) :: c_freq(m_source)
      character(len=4) :: c_weig(m_source)
end module ast_horizon
!
module ast_line
! PDBI/ALMA receiver/correlator setup
      integer(kind=4) :: pdbi_year
      integer(kind=4) :: alma_cycle
! NOEMA mode (ONLINE or OFFLINE)
      character(len=8) :: noema_mode
!
! spurious lines
      real(kind=8) :: flo1ref
      logical :: do_spurious
!
! correlator setup
      logical :: narrow_def
      integer(kind=4) :: narrow_input(2)
      integer(kind=4), parameter :: nunit=8
      logical :: unit_def(nunit)
      integer(kind=4) :: unit_band(nunit)
      real(kind=4) :: unit_cent(nunit)
      integer(kind=4) :: unit_wind(nunit)
      integer(kind=4) :: unit_bmode(nunit)
!
! ALMA correlator setup
      logical :: bb_def(4)
      real(kind=4) :: bb_cfreq(4)
      integer(kind=4) :: bb_sideband(4)
      integer(kind=4) :: bb_nspw(4)
      real(kind=4) :: tolerance_freq
!
      integer(kind=4) :: maxsp
      parameter(maxsp=40)
      real spw_width(4,maxsp)
      real spw_cfreq(4,maxsp)
      integer spw_polar(4,maxsp)
      real spw_use(4,maxsp)
      integer spw_sideband(4,maxsp)
!---------------------------------------------
!
! Molecules
      integer nmol
    integer, parameter :: mmol=1000
      character(len=20) molname(mmol)
      real(8) molfreq(mmol)
      real(4) width
!------------------------------------
!
! plot
      real(8) flo1
      integer plot_mode
      real(4) iflim(2), userlim(2)
      integer sky
      character(len=132) label
!
! for plot /atmosphere
      logical do_atmplot
      real plotwater
!
! for print command
      character(len=80) linecomm
      integer recband
end module

module ast_constant
    real(kind=8),  parameter :: pi=3.141592653589793d0
    real(kind=8),  parameter ::  halfpi=pi/2d0
    real(kind=8),  parameter :: twopi = pi*2d0
    real(kind=8),  parameter :: j2000 = 2451545.0d0
    real(kind=8),  parameter :: light = 299792.458d0   ! km/s
    real(kind=8),  parameter :: radius=6367.435d0      ! earth radius in kilometers
    real(kind=8), parameter :: astro_nullr8=-1.2345d36
    real(kind=4), parameter :: astro_nullr4=-1.2345e36
    real(kind=8), parameter :: astro_nulli8=-12345678
    real(kind=4), parameter :: astro_nulli4=-12345678
    character(len=4), parameter :: astro_nulla='NULL'
end module

module ast_astro
      logical :: library_mode  ! Astro loaded in Library or Interactive mode?
      !
! astro.inc
      real(kind=8) :: jnow_utc              ! date julienne utc
      real(kind=8) :: jnow_ut1              ! date julienne ut1
      real(kind=8) :: jnow_tdt              ! date julienne tdt
      real(kind=8) :: d_ut1                 ! ut1 - utc (seconds)
      real(kind=8) :: d_tdt                 ! tdt - utc (seconds)
      real(kind=8) :: lst                   ! local "true" sidereal time
      real(kind=8) :: lonlat(2)             ! e-longitude, latitude in degrees
      real(kind=8) :: altitude              ! altitude in kilometers
      real(kind=8) :: xsun_0(3)             ! earth_sun vector, in r0 , in km
      real(kind=8) :: xsun_2(3)             ! sun az-el at current time
      real(kind=8) :: xg_0(3)               ! earth_g vector, in r0 , in km
      real(kind=8) :: vg_0(3)               ! earth_g vector derivative, in r0 , in km/s
      real(kind=8) :: trfm_30(9)            ! matrix r0 to r3
      real(kind=8) :: trfm_20(9)            ! matrix r0 to r2
      real(kind=8) :: trfm_23(9)            ! matrix r3 to r2
      real(kind=8) :: trfm_43(9)            ! matrix r3 to r4
      real(kind=8) :: trfm_05(9)            ! matrix r5 (day ecliptic) to r0 (j2000 ecliptic)
      real(kind=8) :: s_1(2)                ! source reference coords.
      real(kind=8) :: azimuth, elevation    ! horizontal coords
      real(kind=8) :: ra, dec               ! present_day equatorial coords
      real(kind=8) :: parallactic_angle     ! parallactic angle
      real(kind=8) :: azimuth_old, elevation_old  ! horizontal coords
      real(kind=8) :: ra_old, dec_old       ! present_day equatorial coords
      real(kind=8) :: slimit                ! sun avoidance radius
      real(kind=8) :: fshift                ! frequency ratio due to doppler effect
      real(kind=8) :: freq                  ! frequency (rest) in ghz
      real(kind=8) :: primbeam              ! telescope primary beam width in radian (value used in computations)
      real(kind=8) :: velocity              ! source velocity
      real(kind=8) :: redshift              ! source redshift
      real(kind=4) :: z_axis
      logical :: projection
      integer(kind=4) :: name_out
      character(len=36) :: source_name
      ! Possible values for sourcetype
      integer(kind=4), parameter :: msoukind=4
      integer(kind=4), parameter :: soukind_none=1      ! no source defined
      integer(kind=4), parameter :: soukind_full=2      ! source defined, full computations
      integer(kind=4), parameter :: soukind_vlsr=3      ! use only LSR
      integer(kind=4), parameter :: soukind_red=4      ! use only Redshift
      character(len=12), parameter ::soukinds(msoukind)= (/ 'NO SOURCE   ','ASTRO SOURCE', &
                                                            'LSR         ','REDSHIFT    ' /)
      integer(kind=4) :: soukind=soukind_none
!
! Support for ASTRO%SOURCE% variable
      character(len=60) :: source_alpha, source_delta
      real(kind=8):: source_az, source_el
      real(kind=8):: source_ra, source_dec
      character(len=36) :: astro_source_name
      real(kind=8) :: source_vlsr, source_dop, source_vshift, source_lsr
      real(kind=8) :: source_redshift
! Support for ASTRO%SOURCE%IN variable
      character(len=2)  :: source_incoord
      character(len=2)  :: source_invtype
      character(len=14) :: source_inbetasexa,source_inlambdasexa
      real(kind=4)      :: source_ineq
      real(kind=8)      :: source_invelocity,source_inredshift
!       Planet stuff
      real(kind=4) :: planet_tmb            ! planet main beam brightness
      real(kind=4) :: planet_flux           ! planet flux
      real(kind=4) :: planet_size(3)        ! planet size
!
      character(len=2) :: z_axis_type
      character(len=12) :: frame           ! 'horizontal','equatorial' display
      character(len=128) :: catalog_name(2) ! for sources
      character(len=1) :: azref
      character(len=2) :: vtype           ! velocity system ('ls', 'ea', 'he','re')
      character(len=16) :: obsname         ! observatory name
!
! For plots
      integer(kind=4) :: msplot, nsplot
      parameter (msplot=2000)
      real(kind=8) :: xsplot(msplot), ysplot(msplot), zsplot(msplot)
      character(len=36) :: splot(msplot)
      character(len=80) :: ccplot(msplot)

end module ast_astro
!
module atm_params
  !---------------------------------------------------------------------
  ! ATM input and output parameters.
  ! For portability, SAVE Fortran variables which are target of SIC
  ! variables.
  !---------------------------------------------------------------------
  real(kind=4), save :: t0,p0,p1,h0,water,airmass
  real(kind=4), save :: freqs,freqi,feff,trec,gim,tsys,tant
  real(kind=4), save :: tauox,tauw,taut,temis,temii,paths,pathi,tatms,tatmi
  logical, save :: atm_initdone=.false.
  !
  ! Noise information
  real(kind=4) :: bandwidth
  real(kind=4) :: jy_per_k
  real(kind=4) :: inttime
  real(kind=4) :: uvweight
end module atm_params

subroutine astro_uv(line,error)
  use gildas_def
  use image_def
  use gkernel_interfaces, no_interface=>gr4_marker
  use gkernel_types
  use gbl_message
  use ast_astro
  use ast_constant
  use atm_params
  use astro_interfaces, except_this=>astro_uv
  !---------------------------------------------------------------------
  ! @ private
  ! ASTRO Support for command
  ! UV_TRACKS Station1_ .. StationN
  !       [/FRAME Max_U] #1
  !       [/HOUR Hmin Hmax] #2
  !   [/TABLE Name] #3
  !       [/HORIZON Elv] #4
  !       [/INTEGRATION T] #5
  !       [/STATIONS ALL|list] #6
  !       [/SIZE size1 nsize1 size2 nsize2 ...] #7
  !   [/OFFSET offset] #8
  !       [/WEIGHT mode [Jy_per_K Bandwidth]] #9
  !------------------------------------------------------------------------
  ! Notes:
  ! - RL 09-nov-1998 /SIZE must be given to antenna size.
  ! - OFFSET is the position of the fixed delay line which corresponds to the
  ! the first station. It is then necessary to insure that in the following
  ! the tables X(MSTAT) reflect the order in which the stations were entered
  ! in the command line.
  !
  ! Note about XX YY ZZ TT, the positions written in the station's file:
  ! TT is (or should be) the total length (in m) from the center of
  ! the aperture to a reference plane common to all beams (preferably the
  ! entrance plane of delay lines). For XX, YY and ZZ, these are the 3
  ! components of the vector going from the earth centre to the location of
  ! the station on the surface of the earth (local equatorial coordinates),
  ! with XX along this direction, YY in the W-E direction
  ! (positive towards EAST) and ZZ in the N direction. Given local horizontal
  ! (on earth surface) coordinates x,y,z of the station,
  ! x towards Local east, y toward N and z toward Zenith,
  ! the transformation matrix is :
  !
  ! XX      / 0,-sin(lat),  cos(lat) \   x
  ! YY =    | 1,        0,         0 | * y
  ! ZZ      \ 0, cos(lat),  sin(lat) /   z
  !
  ! Where lat is the latitude of the interferometer center
  ! Note about u,v,w:
  ! the transformation from the equatorial coordinates Bx,By,Bz
  ! of a Baseline B to u,v,w is given by the matrix:
  ! u       / sin(H)       , cos(H)       ,      0 \   Bx
  ! v  =    |-sin(D)*cos(H), sin(D)*sin(H), cos(D) | * By
  ! w       \ cos(D)*cos(H),-cos(D)*sin(H), sin(D) /   Bz
  ! where H is the hour angle and D the declination of the source
  !
  ! which give ellipses of centre (0, (B/lambda)*sin(d)*cos(D)), with semi-major
  ! axis (B/lambda)*cos(d) and semi-minor axis (B/lambda)*cos(d)*sin(D)
  !
  ! Taking into account a maximum throw for delay lines may be useful for
  ! RadioInterferometers too (some may have cable length limitations) but
  ! is not desirable by default for them. However, the geometrical delay between
  ! apertures ('aerials'? 'telescopes'?) is used deep in the program. To avoid
  ! problems, I suggest to define the throw of fake 'delay lines' for radio
  ! interferometers to 2 a.u = 3.0E11 m ,with OFFSET to 1 a.u.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='UV_TRACK'
  integer(kind=4), parameter :: mstat=100,muv=3000,mlist=20,msize=20
  integer(kind=4) :: nstat, ier, nc, ii, i1, i2
  integer(kind=4) :: istation(mstat), nlu, nn
  type(sic_listi4_t) :: list
  character(len=12) :: name, station(mstat), statn
  character(len=132) :: clu, oldlis, stalis
  real(kind=4) :: t(mstat), tt, offset
  integer(kind=4) :: flag,iequal
  real(kind=4) :: x(mstat), xx, yy, zz, sd, cd, sp, cp, h, sh, ch, y(mstat)
  real(kind=4) :: z(mstat), zch(muv), zsh(muv), hmin, hmax, array
  real(kind=4) :: uk, vk, wk, wkj, wki, horizon, uvmin,psize,throw, latitud
  real(kind=8) :: decs, az, el,avec(3), bvec(3), amat(9)
  integer(kind=4) :: i, j, k, l, ns, nh, lun, nvis
  character(len=256) :: chain
  character(len=message_length) :: mess
  character(len=132) :: fstation
  logical :: take, found(mstat), do_frame, present, table, do_size
  logical :: all, complete(mstat)
  real(kind=4) :: integ_time, frac
  real(kind=4) :: size(msize)
  integer(kind=4) :: nsize, isize(msize), iused, nused, ntake
  real(kind=4) :: asize(mstat)
  real(kind=4) :: test
  real(kind=4), parameter :: au=149597870700d0
  character(len=8) :: weight(3)
  integer(kind=4) :: wkey
  integer(kind=4), parameter :: mw=3
  real(kind=4), allocatable :: myvisi(:,:)
  integer(kind=4), parameter :: visi_size=10
  integer(kind=4) :: ivisi
  ! Saved variables
  type(gildas), save :: xtab  ! Probably needs to be SAVE'd
  integer(kind=4), save :: count=0
  logical, save :: first_call = .true.
  real(kind=4), save :: extr=300.0  ! Array size in meters
  real(kind=4) :: px !page_x from sic
  integer :: date(7)
  character(len=16) :: d_chain
  integer :: idate
  character(len=filename_length), save :: file = ' '
  ! Data
  data weight /'UNIFORM','AIRMASS','FULL'/
  !
  call sic_get_dble('DEC',decs,error)
  if (error) return
  table = sic_present(3,0)
  do_frame = sic_present(1,0)
  !
  if (first_call) then
    do_frame = .true.
    first_call = .false.
  endif
  !
  ! The logic is VERY restrictive.
  !          /TABLE Name     should only be used with /FRAME
  !          /TABLE          without /FRAME can only be used
  !                          if a previous /FRAME /TABLE Name
  !                          has been given in the session.
  ! This means it is impossible to add some UV coverage to an
  ! existing UV Table...  It should be changed at some time.
  if (table) then
    if (do_frame) then
      call sic_ch (line,3,1,chain,nc,.true.,error)
      if (error) return
      call sic_parsef(chain,file,' ','.uvt')
    elseif (sic_present(3,1)) then
      if (len_trim(file).eq.0) then
        call astro_message(seve%e,rname,'No previous Table')
        error = .true.
        return
      endif
      call astro_message(seve%w,rname,'Table name ignored, using '//file)
    endif
  endif
  !
  ! /STATIONS
  all = .false.
  if (sic_present(6,1)) then
    call sic_ke(line,6,1,stalis,nc,.true.,error)
    if (stalis.eq.'ALL') then
      all = .true.
      nstat = -1
    else
      i1 = sic_start(6,1)
      i2 = sic_end(6,sic_narg(6))
      stalis = line(i1:i2)
      call sic_parse_listi4('UV_TRACKS',stalis,list,mlist,error)
      if (error) return
      nstat = 0
      do i=1,list%nlist
        do ii=list%i1(i),list%i2(i),list%i3(i)
          if (nstat.ge.mstat) then
            call astro_message(seve%e,rname,'Too many stations, list truncated')
          else
            nstat = nstat+1
            istation(nstat) = ii
            station(nstat) = ' '
          endif
        enddo
      enddo
    endif
  else
    !
    ! Stations. Check validity of names passed as 'character variables'.
    stalis = ' '
    nc = 0
    ns = 0
    nstat = min(sic_narg(0),mstat)
    if (nstat.eq.0) then
      call astro_message(seve%e,rname,'No stations')
      error = .true.
      return
    endif
    if (nstat.eq.1) then
      call sic_ke (line,0,1,statn,l,.true.,error)
      if (statn(1:3).eq.'ALL') then
        call astro_message(seve%i,rname,'Using all stations from input file')
        all =.true.
        nstat = -1
      else
        call astro_message(seve%e,rname,'Only one station - no uv coverage')
        error = .true.
        return
      endif
    else
      do i=1, nstat
        call sic_ke (line,0,i,statn,l,.true.,error)
        if (error) return
        if(lenc(statn).gt.0)then
          ns=ns+1
          call sic_blanc(statn,l)
          station(ns)=statn(1:l)
          istation(ns) = -1
        endif
      enddo
      nstat = ns
      if (nstat.eq.0) then
        call astro_message(seve%e,rname,'No stations')
        error = .true.
        return
      endif
    endif
  endif
  !
  ! /SIZES size1 nsize1 size2 nsize2 ...
  ! Compute minimum valid UV spacing from dish sizes. For inhomogeneous arrays
  ! (i.e. for the VLT) this should be done for each baseline.
  nsize = 1
  isize(1) = mstat
  size(1) = 0.
  throw = 2.0*au               ! essentially, ignore delay (radio interferometers)
  offset= au                   ! so the dl max is +- 1 au
  ! Note that OFFSET and THROW are updated
  !
  ! Defaults for some observatories we know of. Note that there is no external
  ! definition of THROW, nor different THROWS for pairs of telescopes.
  if (obsname(1:4).eq.'BURE'.or.obsname(1:4).eq.'NOEM'.or.obsname(1:4).eq.'PDBI') then
    size(1) = 15.0
  elseif (obsname(1:4).eq.'ALMA') then
    size(1) = 12.0
  elseif (obsname(1:4).eq.'ACA ') then
    size(1) = 7.0
  elseif (obsname(1:4).eq.'VLA ') then
    size(1) = 25.0
  elseif (obsname(1:4).eq.'PARA'.or.obsname(1:4).eq.'VLT ') then
    ! Assume Main UT telescopes for the time being...
    nsize = 2
    isize(1) = 4
    size(1) = 8.0
    isize(2) = 2
    size(2) = 1.5
    throw   = 127
    offset = 0.0
  elseif  (obsname(1:4).eq.'PTI ') then
    size(1) = 0.40
    throw = 76.0               ! 2 delay lines
    offset = 0.0
  elseif  (obsname(1:4).eq.'GI2T') then
    size(1) = 1.50
    throw = 6.0                ! 2 delay lines
    offset = 0.0
  elseif  (obsname(1:4).eq.'IOTA') then
    size(1) = 0.45
    throw = 3.9                ! new iota small delay ?
    offset = 0.0
  endif
  ! Here one can update the default OFFSET:
  ! option /OFFSET
  ! Load the value of the fixed delay line
  if (sic_present(8,0)) then
    call sic_r4 (line,8,1,offset,.true.,error)
    if (error) then
      call astro_message(seve%e,rname,'No valid offset given')
      return
    endif
  endif
  !
  do_size = sic_present(7,0)
  if (sic_present(7,1)) then
    iused = 0
    nsize = 0
    i = 1
    do while(nsize.lt.msize .and. i.lt.sic_narg(7))
      nsize = nsize+1
      call sic_r4(line,7,i,size(nsize),.true.,error)
      if (error) return
      i = i+1
      isize(nsize) = mstat-iused
      call sic_i4(line,7,i,isize(nsize),.false.,error)
      if (error) return
      i = i+1
      iused = iused+isize(nsize)
    enddo
  endif
  if (size(1).eq.0) then
    call astro_message(seve%w,rname,'Antenna size unknown. No shadowing '//  &
    'warnings will be given.')
  endif
  !
  ! Hour angle coverage
  horizon = 0.0
  call sic_r4  (line,4,1,horizon,.false.,error)
  if (error) return
  horizon = max(3.0,min(horizon,90.0))
  latitud = lonlat(2)
  hmin = a_lever(sngl(decs),latitud,horizon)
  if (hmin.ge.0) then
    call astro_message(seve%e,rname,'Source is not visible')
    error = .true.
    return
  endif
  hmax = -hmin
  if (sic_present(2,0)) then
    call sic_r4 (line,2,1,h,.true.,error)
    if (error) return
    if (h.lt.hmin) then
      write(mess,'(A,1PG10.3)') 'Source rises only at ',hmin
      call astro_message(seve%w,rname,mess)
      h = hmin
    endif
    hmin = h
    h = -hmin
    present = hmin.ge.0.
    call sic_r4 (line,2,2,h,present,error)
    if (error) return
    if (h.gt.hmax) then
      write(mess,'(A,1PG10.3)') 'Source sets at ',hmax
      call astro_message(seve%w,rname,mess)
      h = hmax
    endif
    hmax = h
  endif
  !
  ! Compute Hour angle range (one data point every 15mn; just OK for Bure but
  ! a shorter interval is needed for long VLA configurations or the VLT).
  !
  ! to allow any integration time
  integ_time = 15.0
  call sic_r4 (line,5,1,integ_time,.false.,error)
  if (error) return
  if (integ_time.le.0) integ_time = 15.0
  write(mess,'(A,1PG10.3,A)') 'Integration time ',integ_time,' min'
  call astro_message(seve%i,rname,mess)
  frac = integ_time/60
  inttime = integ_time*60.
  !
  nh = 0
  h = pi*hmin/12.0
  do while (h.le.pi*hmax/12.0)
    ch = cos(h)
    sh = sin(h)
    nh = nh + 1
    zch(nh) = ch
    zsh(nh) = sh
    h = h+pi*frac/12.0
  enddo
  !
  ! /WEIGHT option
  !
  wkey = 1
  if (sic_present(9,0)) then
     call sic_ke (line,9,1,chain,nc,.true.,error)
     call sic_ambigs('UV_TRACK',chain,name,wkey,weight,mw+1,error)
     if (error) return
     call astro_message(seve%i,rname,'Weighting mode is '//name)
     if (name.eq.'FULL') then
       call sic_r4 (line,9,3,bandwidth,.true.,error)
       if (error) return
       call sic_r4 (line,9,2,jy_per_k,.true.,error)
       if (error) return
       !
       ! Make sure the Frequencies are set properly by default
       if (freq.ne.freqs) then
          freqs = freq
          freqi = freq
          gim   = 0.0
       endif
     endif
  else
    bandwidth = 1.0
  endif
  !
  if (.not.sic_query_file('astro_stations','data#dir:','.dat',fstation)) then
    call astro_message(seve%f,rname,'astro_stations not found')
    error = .true.
    return
  endif
  !
  ! Open Station Main List; Get best coverage from First Line
  ier = sic_getlun (lun)
  ier = sic_open(lun,fstation,'OLD',.true.)
  if (ier.ne.0) goto 998
  if (obsname.eq.'BURE'.or.obsname.eq.'NOEMA') then
    read (lun,*,iostat=ier) array
    if (ier.ne.0)  goto 998
  else
    !
    ! Patch for ALMA configuration files
    ! Skip first 7 lines:
    do i=1,7
      read(lun,*,iostat=ier)
      if (ier.ne.0)  goto 998
    enddo
    read(lun,'(a)',iostat=ier) clu
    if (ier.ne.0)  goto 998
    iequal = index(clu,'=')
    read(clu(iequal+1:),*,iostat=ier)  array
    if (ier.ne.0)  goto 998
    array = array*1.2
  endif
  !
  ! Frame : Reset coverage and station list
  if (do_frame) then
    extr = array
    ! Optional coverage by user
    call sic_r4 (line,1,1,extr,.false.,error)
    if (error) goto 999
    if (extr.le.0) extr=array
    call gr_exec ('CLEAR DIRECTORY')
    write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-extr,extr,-extr,extr
    call gr_exec1(chain)
    if (gr_error()) goto 999
    call gr_exec1('SET BOX 4 19 3 18')
    if (gr_error()) goto 999
    call gr_exec1('TICKS 0 0 0 0 ')
    if (error .or. freq.eq.0.0) then
      error = .false.
      freq = 0.0
      call gr_exec1('BOX')
    else
      call uvbox (extr,freq)
    endif
    count = 0
    oldlis = ' '
  else
    oldlis = stalis
  endif
  !
  ! Get and plot stations
  call sic_get_real('page_x',px,error)
  if (px.gt.21) then
     call gr_exec('SET BOX 20 30 9 19')
  else
     call gr_exec('SET BOX 3 12 18 28')
  endif
  if (gr_error()) goto 999
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-array,array,-array,array
  !
  ! Patch for ALMA configuration files
  !
  if (obsname.eq.'ALMA') then
     write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-array,array,-array-660,array-660
  else if (obsname.eq.'ACA ') then
     write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-array-52,array-52,-array-571,array-571
  endif
  !
  call gr_exec1(chain)
  if (gr_error()) goto 999
  do i=1,mstat
    found(i) =.false.
  enddo
  sd = sin(decs)
  cd = cos(decs)
  sp = sin(pi*(lonlat(2))/180.0d0)
  cp = cos(pi*(lonlat(2))/180.0d0)
  !
  call gr_segm('ARRAY',error)
  nn = 0
  iused = 1
  nused = 0
  do while (.true.)
    read(lun,'(a)',iostat=ier) clu
    if (ier.lt.0)  exit      ! EOF
    if (ier.ne.0)  goto 998  ! Error reading line
    if (clu(1:1).eq.'!')  cycle  ! ignore comments
    nlu = lenc(clu)
    if (nlu.eq.0)  cycle     ! ignore empty lines
    !
    if (obsname.eq.'BURE'.or.obsname.eq.'NOEMA') then
      ! BURE format: 4 columns
      read(clu(1:nlu),*,iostat=ier)  name,xx,yy,zz
      tt = 0.0
    else
      ! ALMA format: at least 5 columns (antenna size in column 5)
      read(clu(1:nlu),*,iostat=ier)  name,xx,yy,zz,tt
    endif
    if (ier.ne.0) then
      call astro_message(seve%w,rname,'Could not decode line: '//clu)
      cycle
    endif
    !
    take = .false.
    nn = nn+1
    if (all) then
      ntake = nn
      take = .true.
    else
      do i=1, nstat
        if (name.eq.station(i) .or. nn.eq.istation(i)) then
          ntake = i
          take = .true.
        endif
      enddo
    endif
    if (take) then
      station(ntake) = name
      x(ntake) = xx
      y(ntake) = yy
      z(ntake) = zz
      t(ntake) = tt
      found(ntake) = .true.
      if (nused.ge.isize(iused)) then
        iused = iused+1
        nused = 0
      endif
      nused = nused+1
      asize(ntake) = size(iused)
      ! Compute marker size to try represent the respective size of the dish
      ! vs the size of the array:
      call gr_set_marker (4,3,.3)
      if (do_size) then
        psize = asize(ntake)*10/(2*array)  ! box is 10 cm...
        if (psize.gt.0.1) then
          call gr_set_marker (20,3,psize)
        endif
      endif
      zz = zz*cp-xx*sp
      call gr4_marker(1,yy,zz,0.,-1.0)
    elseif (do_frame) then     !only a square to mark the position
      call gr_set_marker(4,0,.1)
      call gr4_marker(1,yy,zz*cp-xx*sp,0.,-1.0)
    endif
  enddo
  !
  close(unit=lun)
  call sic_frelun (lun)
  call gr_segm_close(error)
  !
  if (all) nstat=nn
  if (nc.eq.0) then            !means: names typed in the command line.
    k = 0
    do i=1, nstat
      if (found(i)) then
        stalis(k+1:) = station(i)//'-'
        call sic_black(stalis,k)
      else
        call astro_message(seve%f,rname,'Station not found: '//station(i))
        goto 999               ! for GTVIEW and other problems...
      endif
    enddo
    nc = k-1
    if (offset.gt.0.0.and.offset.lt.au) then
      write (stalis(nc+1:),102) offset
      call sic_noir(stalis,nc)
    endif
  endif
  if (all) stalis='ALL STATIONS'
  !
  !draw legend:  stations used, source declination and frequency
  call astro_uv_legend(rname,freq,decs,stalis,oldlis,nused, count,nc,error)
  !
  ! Plot coverage
  ! Consider setting marker size to equivalent dish size?
  ! size is a ratio
  call gr_exec('SET BOX 4 19 3 18')
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-extr,extr,-extr,extr
  call gr_exec1(chain)
  if (gr_error()) goto 999
  call gr_segm('UVTRACK',error)
  !
  ! Size of Output Table. Must be computed exactly, since we
  ! do not want null entries at the end. we must take into account here
  ! rejected samples due to shadowing and/or delay line THROW.
  !
  t(1)=t(1)+offset
  nvis = 0
  if (table) then
    do k = 1,nh
      !
      ! Check for stations
      do i=1,nstat-1
        complete(i) = found(i)
        do j=i+1,nstat
          complete(j) = found(j)
        enddo
      enddo
      !
      ! Check for shadowing
      do i=1,nstat-1
        if (complete(i)) then
          do j=i+1,nstat
            if (complete(j)) then
              psize = sqrt(asize(i)*asize(j))*15/(2*extr) ! size of the symbol to plot
              uvmin = asize(i)/2.+asize(j)/2.
              xx = x(j)-x(i)
              yy = y(j)-y(i)
              zz = z(j)-z(i)
              uk = zsh(k)*xx + zch(k)*yy
              vk = sd*(-zch(k)*xx+zsh(k)*yy)+cd*zz
              if ((uk**2+vk**2).le.uvmin**2) then
                test = (xx*zch(k) - yy*zsh(k))*cd + zz*sd
                if (test.gt.0.0) then
                  complete(i) = .false.
                else
                  complete(j) = .false.
                endif
              endif
            endif
          enddo
        endif
      enddo
      !
      ! Now, Take in account max delay of Delay lines
      do i=1,nstat-1
        if (complete(i)) then
          do j=i+1,nstat
            if (complete(j)) then
              xx = x(j)-x(1)
              yy = y(j)-y(1)
              zz = z(j)-z(1)
              wkj = cd*(-zsh(k)*yy+zch(k)*xx)+sd*zz+t(1)-t(j)
              if (i.gt.1) then
                xx = x(i)-x(1)
                yy = y(i)-y(1)
                zz = z(i)-z(1)
                wki = cd*(-zsh(k)*yy+zch(k)*xx)+ sd*zz+t(1)-t(i)
              else
                wki=0
              endif
              if ((wkj.ge.0).and.(wkj.le.throw).and. (wki.ge.0).and.  &
                  (wki.le.throw))  nvis=nvis+1
            endif
          enddo
        endif
      enddo
    enddo
    if (do_frame) then
      write(mess,'(A,A,A,I0,A)')  &
        'Initialising ',trim(file),' with ',nvis,' (u,v) points'
      call astro_message(seve%i,rname,mess)
      call astro_init_table(xtab,file,nvis,decs,freq,bandwidth,error)
    else
      !
      write(mess,'(A,I0,A,A)')  &
        'Adding ',nvis,' (u,v) points to table ',trim(file)
      call astro_message(seve%i,rname,mess)
      call astro_extend_table(xtab,file,nvis,decs,freq,error)
    endif
    if (error) then
      call astro_message(seve%w,rname,'Cannot open output Table')
      call astro_close_table(xtab)
      table = .false.
      error = .false.
    else
      allocate(myvisi(visi_size,nvis),stat=ier)
      if (ier.ne.0) then
         call astro_message(seve%w,rname,'Memory allocation failure for Table')
         call astro_close_table(xtab)
         table = .false.
         error = .false.
      endif
    endif
  endif
  !
  call jjdate(jnow_utc, date)
  call ndatec(date, d_chain, error)
  call gag_fromdate(d_chain,idate,error)
  idate = idate+count
  !
  ! OK, redo for good now!
  ivisi = 0
  do k = 1,nh
    !
    ! Check for stations
    do i=1,nstat-1
      complete(i) = found(i)
      do j=i+1,nstat
        complete(j) = found(j)
      enddo
    enddo
    !
    ! Source elevation
    !
    call amset(lonlat(2),amat)
    avec(1) = zch(k)*cd
    avec(2) = zsh(k)*cd
    avec(3) = sd
    call matmul(amat,avec,bvec,1)
    call dangle(az,el,bvec)
    !
    if (wkey.eq.3) then
      call astro_setuv_weight(el)
    endif
    !
    ! Check for shadowing
    do i=1,nstat-1
      if (complete(i)) then
        do j=i+1,nstat
          if (complete(j)) then
            psize = sqrt(asize(i)*asize(j))*15/(2*extr)
            uvmin = asize(i)/2.+asize(j)/2.
            xx = x(j)-x(i)
            yy = y(j)-y(i)
            zz = z(j)-z(i)
            uk = zsh(k)*xx + zch(k)*yy
            vk = sd*(-zch(k)*xx+zsh(k)*yy)+cd*zz
            if ((uk**2+vk**2).le.uvmin**2) then
              test = (xx*zch(k) - yy*zsh(k))*cd + zz*sd ! w coordinates
              if (test.gt.0.0) then
                write(mess,'(A,I0,A,I0)') 'Antenna ',i,' is shadowed by ',j
                complete(i) = .false.
              else
                write(mess,'(A,I0,A,I0)') 'Antenna ',j,' is shadowed by ',i
                complete(j) = .false.
              endif
              call astro_message(seve%w,rname,mess)
            endif
          endif
        enddo
      endif
    enddo
    !
    ! Fill the table now and Plot, Take in account max delay of Delay lines
    do i=1,nstat-1
      if (complete(i)) then
        do j=i+1,nstat
          if (complete(j)) then
            xx = x(j)-x(1)
            yy = y(j)-y(1)
            zz = z(j)-z(1)
            wkj = cd*(-zsh(k)*yy+zch(k)*xx)+sd*zz+t(1)-t(j)
            if (i.gt.1) then
              xx = x(i)-x(1)
              yy = y(i)-y(1)
              zz = z(i)-z(1)
              wki = cd*(-zsh(k)*yy+zch(k)*xx)+sd*zz+t(1)-t(i)
            else
              wki=0
            endif
            xx = x(j)-x(i)
            yy = y(j)-y(i)
            zz = z(j)-z(i)
            uk = zsh(k)*xx + zch(k)*yy
            vk = sd*(-zch(k)*xx+zsh(k)*yy)+cd*zz
            wk = cd*(-zsh(k)*yy+zch(k)*xx)+sd*zz
            psize = sqrt(asize(i)*asize(j))*15/(2*extr)
            ! Plot 'bad' points (throw unable to follow delay) only if DO_SIZE
            if ((wkj.lt.0).or.(wkj.gt.throw).or.(wki.lt.0) .or.  &
                (wki.gt.throw)) then
              if (do_size) then
                call gr_set_marker (4,1,0.05)
                flag=0
              else
                flag=1         ! do not plot
              endif
            else
              flag=0
              if (psize.lt.0.0001 .or. .not.do_size) then
                call gr_set_marker (4,0,0.05)
              else
                call gr_set_marker (20,0,psize)
              endif
            endif
            uvmin = asize(i)/2.+asize(j)/2.
            if ((uk**2+vk**2).le.uvmin**2) then
              call astro_message(seve%d,rname,'---- Y A UN PROBLEME ----')
            else
              if (table.and.(wkj.ge.0).and.(wkj.le.throw).and.(wki.ge.0).and.  &
                  (wki.le.throw)) then
                ivisi = ivisi+1
                call fill_table (uk,vk,wk,float(idate),(integ_time*60*k),i,j,  &
                myvisi(1,ivisi),el,wkey)
              endif
              if (flag.eq.0) then
                call gr4_marker(1,uk,vk,0.0,-1.0)
                uk = -uk
                vk = -vk
                wk = -wk
                call gr4_marker(1,uk,vk,0.0,-1.0)
              endif
              flag=0
            endif
          endif
        enddo
      endif
    enddo
    !
  enddo
  call gr_segm_close(error)
  !
  if (table) then
    call gdf_write_data(xtab,myvisi,error)
    call astro_close_table (xtab)
    deallocate (myvisi, stat=ier)
  endif
  return
  !
  998   continue
  call astro_message(seve%e,rname,'Trouble with ASTRO_STATIONS file:')
  call astro_message(seve%e,rname,fstation)
  call putios('E-UV_TRACK, ',ier)
  close(unit=lun)
  call sic_frelun (lun)
  999   error = .true.
  return
  102   format (', DL set @ ',f12.5,' m')
end subroutine astro_uv
!
subroutine astro_uv_legend(rname,freq,decs,stalis,oldlis,nused, count, nc,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_uv_legend
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !
  ! draw the legend (stations used, declination, frequency)
  ! at the right place according to the plot_page orientation
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  real(kind=8), intent(in) :: freq         ! Frequency
  real(kind=8), intent(in) :: decs         ! Declination [radian]
  character(len=*), intent(in) :: stalis   !list of used stations
  character(len=*), intent(in) :: oldlis   !previous list of used stations
  integer(kind=4), intent(in) :: nused     ! number of used stations
  integer(kind=4), intent(inout) :: count  !
  integer(kind=4), intent(in) :: nc        !
  logical, intent(inout) :: error 
  ! Local
  real(kind=4) :: px
  logical :: err
  character(len=200) :: chain,stafile
  integer(kind=4) :: nc2,ier
  !
  call sic_get_real('page_x',px,err)
  if (px.ge.30) then !landscape
     call gr_exec('SET BOX 20 30 3 9')
  else ! portrait
     call gr_exec('SET BOX 12 20 20 26')
  endif
  call gr_exec('limits 0 10 0 10')
  if (freq.gt.1e3) then
     write(chain,102) clight/freq/1d3
  else
     write(chain,100) freq
  endif
  call gr_exec('set char 0.5')
  call gr_exec1(chain)
  write(chain,101) sngl(decs*180d0/pi) !write in degrees
  call gr_exec1(chain)
  call gr_exec('set char /def')
100   format ('DRAW TEXT 1 1 "Frequency ',f5.1,' GHz" 6 /user')
102   format ('DRAW TEXT 1 1 "Wavelength ',f6.3,' microns" /user')
101   format ('DRAW TEXT 1 0 "Declination ',f5.1,' ^" 6 /user ')
  !
  ! Plot on two lines when more than 6 stations (and less than 13)
  call gr_exec('set char 0.5')
  if (oldlis.ne.stalis) then
     if (nused.gt.12.or.stalis.eq."ALL STATIONS") then !ALMA or other observatory?
        count = count+2
        chain = 'DRAW TEXT 1 1234 "'//stalis//'"   6 /user'
        write(chain(13:16),'(I4)') count
        call gr_exec1 (chain)
        count = count+1
        ier = sic_getlog('ASTRO_STATIONS',stafile)
        if (ier.ne.0) then
          call astro_message(seve%e,rname,  &
               'Failure in translation of ASTRO_STATIONS logical')
          error = .true.
          return
        endif
        chain = 'DRAW TEXT 1 1234 "'//trim(stafile)//'"   6 /user'
        write(chain(13:16),'(I4)') count
        call gr_exec1 (chain)
     else if (nused.le.6) then !PDB = 1 line
        count = count+4
        chain = 'DRAW TEXT 1 1234 "'//stalis(1:nc) //'" 6 /user'
        write(chain(13:16),'(I4)') count
        call gr_exec1 (chain)
     else if (nused.le.12) then !NOEMA = 2 lines
        nc2 = int(nused/2)*4
        count = count+2
        chain = 'DRAW TEXT 1 1234 -"'//stalis(nc2+1:nc) //'" 6 /user'
        write(chain(13:16),'(I4)') count
        call gr_exec1 (chain)
        count = count+1
        chain = 'DRAW TEXT 1 1234 "'//stalis(1:nc2) //'" 6 /user'
        write(chain(13:16),'(I4)') count
        call gr_exec1 (chain)
     endif
  endif
  call gr_exec('set char /def')
  !
end subroutine astro_uv_legend
!
subroutine uvbox(base,freq)
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: base  ! Baseline length
  real(kind=8), intent(in) :: freq  ! Frequency
  ! Global
  logical, external :: gr_error
  ! Local
  real(kind=4) :: x
  real(kind=8), parameter :: clight=2.99792458d8   !SPEED OF LIGHT
  character(len=80) :: chain
  !
  call gr_exec1('SET BOX 4 19 3 18')
  if (gr_error()) return
  x = base*freq*1d6/clight
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-x,x,-x,x
  call gr_exec1(chain)
  chain = 'DRAW TEXT 0 2.5 "U (k'//char(92)//'gl)" 5 /CHARACTER 8'
  call gr_exec1(chain)
  call gr_exec1('SET ORIENT 90.0')
  chain = 'DRAW TEXT 2.0 0 "V (k'//char(92)//'gl)" 5 /CHARACTER 6'
  call gr_exec1(chain)
  call gr_exec1('SET ORIENT 0')
  call gr_exec1('AXIS XU /LABEL P')
  call gr_exec1('AXIS YR /LABEL O')
  x = base
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-x,x,-x,x
  call gr_exec1(chain)
  call gr_exec1('AXIS XL')
  call gr_exec1('AXIS YL')
  call gr_exec1('LABEL "U (meters)" /X')
  call gr_exec1('SET ORIENT 90.0')
  call gr_exec1('DRAW TEXT -2.0 0 "V (meters)" 5 /CHARACTER 4')
  call gr_exec1('SET ORIENT 0')
end subroutine uvbox
!
subroutine astro_close_table(x)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! To be re-written using
  !    gdf_write_image(header,array,error)
  ! AND may be also
  !    gdf_close_image(header,error)
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: x  !
  ! Local
  logical :: error
  !
  error = .false.
  call gdf_close_image(x,error)
end subroutine astro_close_table
!
subroutine astro_extend_table(x,name,nvis,dec,freq,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Re-written for new Imgage I/O interface
  !---------------------------------------------------------------------
  type(gildas),     intent(inout) :: x      ! Image structure
  character(len=*), intent(in)    :: name   ! File name
  integer(kind=4),  intent(in)    :: nvis   ! Number of visibilities to add
  real(kind=8),     intent(in)    :: dec    ! Declination
  real(kind=8),     intent(in)    :: freq   ! Frequency
  logical,          intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ASTRO_UV'
  character(len=80) :: chain
  integer(kind=index_length) :: mvis
  !
  call gildas_null(x, type='UVT')
  x%file = name
  x%loca%read = .false.
  !
  call gdf_read_gildas(x,name,'.uvt',error, data=.false.)
  if (error) return
  !! call gio_lsis(error)
  !! read(5,*) i
  call gdf_close_image(x,error)
  !
  ! Couple of checks
  if (abs(x%gil%dec-dec).gt.1d-6) then
    call astro_message(seve%e,rname,'Different declinations')
    error = .true.
  endif
  if (freq.ne.0.0 .and. (abs(freq-x%gil%freq*1d-3).gt.1d-6)) then
    call astro_message(seve%e,rname,'Different frequencies')
    error = .true.
  endif
  if (error) goto 100
  !
  ! Compute new size, and remember there may be more preallocated data
  ! than used in the table to be appended
  write(chain,1001) x%gil%dim(2),nvis
1001 format('Old table size ',i8,' Adding ',i8)
  call astro_message(seve%i,rname,chain)
  !
  mvis = x%gil%dim(2)+nvis
  !
  call gdf_extend_image (x,mvis,error)
  if (error) goto 100
  !
  x%gil%nvisi = mvis  ! Update number of visibilities
  call gdf_update_header(x,error)
  !
  ! Map only new region
  x%blc(1) = 1
  x%blc(2) = x%gil%dim(2)+1-nvis
  x%trc(1) = x%gil%dim(1)
  x%trc(2) = x%gil%dim(2)
  return
  !
  100   call astro_message(seve%e,rname,'Table extension failed')
end subroutine astro_extend_table
!
subroutine astro_init_table(x,name,nvis,dec,freq,band,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gildas),     intent(inout) :: x      ! Image structure
  character(len=*), intent(in)    :: name   ! File name
  integer(kind=4),  intent(in)    :: nvis   ! Number of visibilities to write
  real(kind=8),     intent(in)    :: dec    ! Declination
  real(kind=8),     intent(in)    :: freq   ! Frequency
  real(kind=4),     intent(in)    :: band   ! Frequency resolution
  logical,          intent(out)   :: error  ! Logical error flag
  !
  error = .false.
  !
  ! Create new file
  call gildas_null(x, type = 'UVT')
  x%file = name
  x%gil%convert(1,1) = 1.0
  x%gil%convert(3,1) = 1.0
  x%gil%blan_words = 2
  x%gil%extr_words = 0
  x%gil%bval = -1.0
  x%gil%eval = 0.
  x%gil%dim(2) = nvis
  x%gil%dim(1) = 10  ! 7 daps + (real, imag, weight)*nchannels
  !
  x%gil%ndim = 2
  x%char%unit = 'Jy'
  x%char%syst = 'EQUATORIAL'
  x%char%name = ' '
  x%gil%ra = 0.0
  x%gil%dec = dec
  x%gil%epoc = 2000.0
  x%char%line = ' '
  x%gil%fres = band
  if (freq.ne.0d0) then
    x%gil%fima = 0.0
    x%gil%freq = freq*1d3
  else
    x%gil%fima = 102d3
    x%gil%freq = 90d3
  endif
  x%gil%convert(2,1) = x%gil%freq
  x%gil%vres = -299792.458*x%gil%fres/x%gil%freq
  x%gil%voff = 0.0
  x%gil%faxi = 1
  x%loca%size = x%gil%dim(1) * x%gil%dim(2)
  x%gil%nvisi = x%gil%dim(2)
  x%gil%nchan = 1
  !
  call gdf_create_image(x,error)
  x%blc = 0
  x%trc = 0
end subroutine astro_init_table
!
subroutine fill_table (u,v,w,d,t,ideb,ifin,visi,el,wkey)
  use atm_params
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: u         ! U coordinate
  real(kind=4),    intent(in)  :: v         ! V
  real(kind=4),    intent(in)  :: w         ! W
  real(kind=4),    intent(in)  :: d         ! Date
  real(kind=4),    intent(in)  :: t         ! Time
  integer(kind=4), intent(in)  :: ideb      ! Start Antenna
  integer(kind=4), intent(in)  :: ifin      ! End Antenna
  real(kind=4),    intent(out) :: visi(10)  ! Visibility
  real(kind=8),    intent(in)  :: el        ! Elevation
  integer(kind=4), intent(in)  :: wkey      ! Code for Weights
  !
  ! 7 parameters:
  !  U, V, W, Date, Time, Ant1, Ant2
  ! 3 values:
  !  Real, Imag, Weight
  !  1.0, 0.0, 1.0
  !
  visi(1) = u
  visi(2) = v
  visi(3) = w
  visi(4) = d
  visi(5) = t
  visi(6) = ideb
  visi(7) = ifin
  visi(8) = 1.0
  visi(9) = 0.0
  if (wkey.eq.1) then
     visi(10) = 1.0
  elseif (wkey.eq.2) then
     visi(10) = sin(el)**2
  elseif (wkey.eq.3) then
     visi(10) = uvweight
  endif
end subroutine fill_table
!
subroutine matmul(mat,a,b,n)
  !---------------------------------------------------------------------
  ! @ private
  ! version 1.0  mpifr cyber edition  22 may 1977.  G.Haslam
  ! version 2.0  iram
  !
  ! this routine provides the transformation of vector a to vector b
  ! using the n dimensional direction cosine array, mat.
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: mat(3,3)  !
  real(kind=8),    intent(in)  :: a(3)      !
  real(kind=8),    intent(out) :: b(3)      !
  integer(kind=4), intent(in)  :: n         !
  ! Local
  integer(kind=4) :: i,j
  !
  if (n.gt.0) then
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(i,j)*a(j)
      enddo
    enddo
  else
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(j,i)*a(j)
      enddo
    enddo
  endif
end subroutine matmul
!
subroutine amset(obslat,amat)
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  !   subroutine to provide transformation matrix from hour angle - dec
  !       into azimuth - elevation.
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: obslat   ! in degrees
  real(kind=8), intent(out) :: amat(9)  !
  ! Local
  real(kind=8) :: x1,y1,z1
  !
  x1=pi/180d0*obslat
  y1=dsin(x1)
  z1=dcos(x1)
  amat(1)=-y1
  amat(2)=0.d0
  amat(3)=z1
  amat(4)=0.d0
  amat(5)=-1.d0
  amat(6)=0.d0
  amat(7)=z1
  amat(8)=0.d0
  amat(9)=y1
end subroutine amset
!
subroutine dangle(along,alat,a)
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  ! version 1.0  mpifr cyber edition  22 may 1977.
  ! see nod 2 manual page m 9.1
  ! c.g haslam       mar  1972.
  ! this routine recovers the longitude and latitude angles, along
  ! (0 - 360) and alat ( +.- 180) in deg_to_radrees, which correspond to the
  ! vector a.
  !---------------------------------------------------------------------
  real(kind=8), intent(out) :: along  !
  real(kind=8), intent(out) :: alat   !
  real(kind=8), intent(in)  :: a(3)   !
  ! Local
  real(kind=8) :: aa
  !
  aa     = a(1)*a(1)+a(2)*a(2)
  aa     = dsqrt(aa)
  alat   = pi/2d0
  if (aa.ge.0.000001d0) then
    aa = a(3)/aa
    alat = datan(aa)           ! latitude in Radian
  endif
  !
  if (a(2).ne.0.d0 .or. a(1).ne.0.d0) then
    along = datan2(a(2),a(1))    ! longitude in Radian
  else
    along = 0.d0
  endif
end subroutine dangle
!
subroutine astro_setuv_weight(el)
  use gildas_def
  use gkernel_interfaces
  use atm_params
  use atm_interfaces_public
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! ATM
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: el
  !
  real(4) :: w
  real(4) :: frequ
  integer :: ier
  !
  airmass = 1./sin(el)
  h0 = altitude
  !
  p1 = p0*2.0**(-h0/5.5)     ! Pressure at altitude H0
  call atm_atmosp(t0,p1,h0)
  !
  if (gim.ne.0) then
    frequ = freqi
    call atm_transm(water,airmass,frequ,temii,tatmi,tauox,tauw,taut,ier)
    frequ = freqs
    call atm_transm(water,airmass,frequ,temis,tatms,tauox,tauw,taut,ier)
    !
    tant = (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
           (feff*temis+(1.0-feff)*t0 + trec) ) / (1.0+gim)
    tsys = exp(taut*airmass) * (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
           (feff*temis+(1.0-feff)*t0 + trec) ) / feff
  else
    frequ = freqs
    call atm_transm(water,airmass,frequ,temis,tatms,tauox,tauw,taut,ier)
    !
    tant = feff*temis+(1.0-feff)*t0 + trec
    tsys = exp(taut*airmass) * (feff*temis+(1.0-feff)*t0 + trec) / feff
  endif
  !
  ! Need  Integration time
  ! Need  Bandwidth
  ! Need  Antenna Jy/K conversion factor
  w = jy_per_k*tsys/sqrt(bandwidth * inttime)
  uvweight = 1./w**2
end subroutine astro_setuv_weight
!

subroutine check_area(method,head,quiet)
  use clean_def
  use image_def
  use gbl_message
  use mapping_interfaces, only : map_message, check_box
  !-----------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Check search area for Cleaning
  !-----------------------------------------------
  type (gildas), intent(in) :: head
  type (clean_par), intent(inout) :: method
  logical, intent(in) :: quiet
  !
  real ares,hmax
  integer max_iter0, nx, ny
  character(len=message_length) :: chain
  character(len=5) :: rname = 'CLEAN'
  !
  ! BLC & TRC
  nx = head%gil%dim(1)
  ny = head%gil%dim(2)
  call check_box(nx,ny,method%blc,method%trc)
  !
  ! Support for Clean
  method%box = (/method%blc(1),method%blc(2),   &
       &    method%trc(1),method%trc(2)/)
  !
  hmax = max(abs(head%gil%rmax),abs(head%gil%rmin))
  ares = method%ares
  if (ares.eq.0) then
    ares = method%fres*hmax
  endif
  if (ares.eq.0) then
    ares = head%gil%noise
  endif
  !
  if (.not.quiet) then
    write(chain,'(A,1pg11.3)') 'Cleaning down to ',ares
    call map_message(seve%i,rname,chain)
  endif
  !
  if (hmax.lt.ares) then
    max_iter0 = 0
    if (.not.quiet) then
      write(chain,'(A,1pg11.3,A)') 'Peak flux ',hmax,' is smaller, no Cleaning needed'
      call map_message(seve%w,rname,chain)
    endif
  else
    max_iter0 = log(ares/hmax)/log(1.0-method%gain)*  &
         &(method%trc(1)-method%blc(1)+1)*(method%trc(2)-method%blc(2)+1)/50.0
    if (max_iter0.lt.0) then
      Print *,'Unable to guess Iteration number - set to 100 '
      Print *,'Ares ',ares,'  Hmax',hmax,'  Gain ',method%gain
      max_iter0 = 100
    endif
    !
    if (.not.quiet) then
      if (ares.lt.head%gil%noise) then
        write(chain,'(A,1pg11.3)') 'Expected noise is larger... ',head%gil%noise
        call map_message(seve%w,rname,chain)
      endif
      write(chain,'(A,i12,a)') 'May need ',max_iter0,' iterations'
      call map_message(seve%i,rname,chain)
    endif
  endif
  !
  if (method%m_iter.eq.0) then
     method%m_iter = max_iter0
     method%ares = ares
  endif
end subroutine check_area
!
subroutine beam_plane(method,hbeam,hdirty)
  use clean_def
  use image_def
  use gbl_message
  use mapping_interfaces, only : map_message, beam_for_channel
  !----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Define beam plane and check if fit is required
  !----------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: hbeam
  type (gildas), intent(in) :: hdirty ! Used to figure out which plane
  !
  integer :: nstep, ibeam
  real(8) :: i_freq
  !
  ! Check if beam parameters must be recomputed
  if (hbeam%gil%dim(4).le.1) then
    method%ibeam = 1
  else
    ! Cannot set method%ibeam  directly ?
    ibeam = beam_for_channel(method%iplane,hdirty,hbeam)
    !!call map_message(seve%w,'CLEAN','Recomputing the beam parameters')
    method%ibeam = ibeam
    !! Print *,'IBEAM ',method%ibeam,'... '
  endif
end subroutine beam_plane
!
function beam_for_channel(iplane,hdirty,hbeam)
  use image_def
  !
  ! @ public
  !
  integer :: beam_for_channel !! intent(out)
  type(gildas), intent(in) :: hdirty
  type(gildas), intent(in) :: hbeam
  integer, intent(in) :: iplane
  !
  real(8) :: i_freq
  integer ibeam, nstep
  !
  if (hbeam%gil%dim(4).le.1) then
    beam_for_channel = 1
  else
    nstep = hdirty%gil%dim(3) / hbeam%gil%dim(4)
    if (hbeam%gil%dim(4)*nstep.ne.hdirty%gil%dim(3)) nstep = nstep+1
    ibeam = (iplane+nstep-1)/nstep
    !!Print *,'Approximate Beam channel ',ibeam,' for ',iplane
    ! This may be the better way of doing it:
    i_freq = (iplane-hdirty%gil%ref(3))*hdirty%gil%fres + hdirty%gil%freq
    ! i_freq = (ibeam-hbeam%gil%ref(4))*hbeam%gil%fres + hbeam%gil%freq
    ibeam = nint((i_freq-hbeam%gil%freq)/hbeam%gil%fres + hbeam%gil%ref(4))
    !!Print *,'Nearest Beam channel ',ibeam,' for ',iplane
    ibeam = min(max(1,ibeam),hbeam%gil%dim(4)) ! Just  in case
    !
    beam_for_channel = ibeam
  endif
end function beam_for_channel
!
subroutine clean_make90(method,hclean,clean,tcc)
  use clean_def
  use image_def
  use gkernel_interfaces
  use mapping_interfaces, only : mulgau
  !----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Build clean image from Component List
  !----------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  type (gildas), intent(inout) :: hclean
  real, intent(inout) :: clean(hclean%gil%dim(1),hclean%gil%dim(2))
  type (cct_par), intent(in) :: tcc(method%n_iter)
  !
  real(8), parameter :: pi=3.141592653589793d0
  !
  integer nx,ny,nc,ix,iy,ic,imax,ndim,dim(2),ier
  real xinc, yinc,rmax,flux,r,fact
  real, allocatable :: wfft(:)
  complex, allocatable :: ft(:,:)
  !
  nx = hclean%gil%dim(1)
  ny = hclean%gil%dim(2)
  allocate (wfft(2*max(nx,ny)),ft(nx,ny),stat=ier)
  if (ier.ne.0) then
    Print *,'F-MAPPING,  Memory allocation error in CLEAN_MAKE90'
    STOP
  endif
  xinc = hclean%gil%convert(3,1)
  yinc = hclean%gil%convert(3,2)
  !
  if (method%method.eq.'SDI'.or.method%method.eq.'MULTI') then
    ft(:,:) = cmplx(clean,0.0)
  else
    !
    ! Check minimum flux
    ft = 0.0
    rmax = abs(tcc(1)%value)
    imax = 1
    nc = method%n_iter
    do ic=1,nc
      r = abs(tcc(ic)%value)
      if (r.lt.rmax) then
        imax = ic
        rmax = r
      endif
    enddo
    if (imax.lt.nc-10) then
    !            WRITE(CHAIN,*)
    !     $      'I-CLEAN,  Truncating CLEAN component to '
    !     $      ,IMAX,' / ',NC
    !            CALL GAGOUT(CHAIN)
    !            NC = IMAX
    endif
    !
    ! Convolve source list into residual map ---
    if (method%bshift(3).eq.0) then
      do ic=1,nc
        ix = tcc(ic)%ix
        iy = tcc(ic)%iy
        ft(ix,iy) = ft(ix,iy) + tcc(ic)%value
      enddo
    else
      do ic=1,nc
        flux = 0.5*tcc(ic)%value
        ix = tcc(ic)%ix
        iy = tcc(ic)%iy
        ft(ix,iy) = ft(ix,iy) + flux
        ix = ix+method%bshift(1)
        iy = iy+method%bshift(2)
        ft(ix,iy) = ft(ix,iy) + flux
      enddo
    endif
  endif
  !
  ndim = 2
  dim(1) = nx
  dim(2) = ny
  call fourt(ft,dim,ndim,-1,0,wfft)
  !
  ! Beam Area = PI * BMAJ * BMIN / (4 * LOG(2) ) for flux density
  ! normalisation
  fact = method%major*method%minor*pi/(4.0*log(2.0))   &
       &    /abs(xinc*yinc)/(nx*ny)
  call mulgau(ft,nx,ny,   &
       &    method%major,method%minor,method%angle,   &
       &    fact,xinc,yinc)
  call fourt(ft,dim,ndim,1,1,wfft)
  !
  ! Extract Real part
  clean = real(ft)
  deallocate (wfft,ft)
end subroutine clean_make90

subroutine histos (r,nx,ny, list, nl, hx,nh,hmin,hstep)
  !----------------------------------------------------------------------
  ! @ public
  !
  ! GDF	Internal routine
  !
  !	Computes the histogram of part of an image
  !----------------------------------------------------------------------
  integer, intent(in) :: nx        ! X size
  integer, intent(in) :: ny        ! Y size
  real, intent(in)  :: r(nx*ny)    ! Input array 
  integer, intent(in) :: nl        ! List size
  integer, intent(in) :: list(nl)  ! List of values
  integer, intent(in) :: nh        ! Histogram size
  integer, intent(out) :: hx(nh)   ! Histogram
  real, intent(in) :: hmin         ! Min bin
  real, intent(in) :: hstep        ! Bin size
  !
  real steph
  integer i,k,ntot,nin,nout,n
  !
  nin = 0
  nout = 0
  hx = 0
  steph = 1.0/hstep
  !
  do i=1,nl
    k = list(i)
    n = nint((abs(r(k))-hmin)*steph + 1.0)
    if (n.ge.1 .and. n.le.nh) then
      hx(n) = hx(n)+1
      nin = nin+1
    else
      nout= nout+1
    endif
  enddo
  !
  ! Convert to cumulative form
  do n=nh-1,1,-1
    hx(n) = hx(n)+hx(n+1)
  enddo
end subroutine histos
!
subroutine choice (r,nx,ny,list,nl,limite,   &
     &    mcl,wcl,ncl,rmax,ngoal)
  use clean_def
  !----------------------------------------------------------------------
  ! @ public
  !
  !  GILDAS:	CLEAN 	Internal routine
  !	Select possible clean components in residual map.
  !	Components are returned ordered in increasing I and J.
  ! 
  ! Search list is built if ngoal>0, re-used otherwise.
  !----------------------------------------------------------------------
  integer, intent(in) :: nx          ! X size
  integer, intent(in) :: ny          ! Y size
  integer, intent(in) :: nl          ! List size
  integer, intent(in) :: mcl         ! Maximum number of components
  integer, intent(out) :: ncl        ! Number of components found
  real, intent(in) :: r(nx*ny)       ! Input array
  type(cct_par), intent(out) :: wcl(mcl)      ! Components
  integer, intent(in) :: list(nl)    ! List of pixels 
  real, intent(inout) ::  limite     ! selection threshold
  real, intent(in) :: rmax           ! Maximum value
  integer, intent(in) :: ngoal       ! Intended number   
  !
  ! Local variables
  integer i,k
  integer, parameter :: nh=128
  integer hx(nh)
  real hmin, hstep
  !
  if (ngoal.gt.0) then
    hmin = 0.0
    hstep = rmax/(nh-2)
    call histos(r,nx,ny,   &
     &      list,nl,hx,nh,hmin,hstep)
    !
    ! Locate a "reasonable" number of components
    hmin = 0
    do i=1,nh
      if (hmin.eq.0) then
        if (hx(i).lt.ngoal) then
          hmin = (i-1)*hstep
          ncl = hx(i)
        endif
      endif
    enddo
    limite = max(limite,hmin)
  endif
  !
  ! Select possible components in Clean Box
  ncl = 0
  do i=1,nl
    k = list(i)
    if (abs(r(k)).ge.limite) then
      ncl=ncl+1
      wcl(ncl)%influx =r(k)
      wcl(ncl)%iy = (k-1)/nx+1
      wcl(ncl)%ix = k-(wcl(ncl)%iy-1)*nx
    endif
  enddo
end subroutine choice
!
subroutine find_sidelobe (beam,nx,ny,i0,j0,nxp,nyp,bgain)
  !----------------------------------------------------------------------
  ! @ public
  !
  ! GILDAS:	CLEAN	Internal routine
  !	Find the maximum sidelobe outside the beam patch defined
  !	by the beam center (I0,J0) and patch size (NXP,NYP)
  !----------------------------------------------------------------------
  integer, intent(in) :: nx       ! X size
  integer, intent(in) :: ny       ! Y size
  real, intent(in) :: beam(nx,ny) ! Input beam
  integer, intent(in) :: i0       ! X beam center
  integer, intent(in) :: j0       ! Y beam center
  integer, intent(in) :: nxp      ! X beam patch
  integer, intent(in) :: nyp      ! Y beam patch
  real, intent(out) :: bgain      ! Maximum sidelobe
  !
  integer i,j
  real bmax,bmin
  !
  ! Compute maximum sidelobe
  bmax = beam(1,1)
  bmin = beam(1,1)
  do j = 1,j0-nyp
    do i = 1,nx
      if (beam(i,j).gt.bmax) then
        bmax = beam(i,j)
      elseif (beam(i,j).lt.bmin) then
        bmin = beam(i,j)
      endif
    enddo
  enddo
  do j = max(1,j0-nyp+1),min(ny,j0+nyp-1)
    do i = 1,i0-nxp
      if (beam(i,j).gt.bmax) then
        bmax = beam(i,j)
      elseif (beam(i,j).lt.bmin) then
        bmin = beam(i,j)
      endif
    enddo
    do i = i0+nxp,nx
      if (beam(i,j).gt.bmax) then
        bmax = beam(i,j)
      elseif (beam(i,j).lt.bmin) then
        bmin = beam(i,j)
      endif
    enddo
  enddo
  do j = j0+nyp,ny
    do i = 1,nx
      if (beam(i,j).gt.bmax) then
        bmax = beam(i,j)
      elseif (beam(i,j).lt.bmin) then
        bmin = beam(i,j)
      endif
    enddo
  enddo
  bgain = max(abs(bmax),abs(bmin))
  bgain = bgain/abs(beam(i0,j0))
end subroutine find_sidelobe
!
subroutine mos_sidelobe (beam,nx,ny,i0,j0,nxp,nyp,bgain,nf)
  !----------------------------------------------------------------------
  ! @ public
  !
  ! GILDAS:	CLEAN	Internal routine
  !	Find the maximum sidelobe outside the beam patch defined
  !	by the beam center (I0,J0) and patch size (NXP,NYP)
  ! Adapted for Mosaic
  !----------------------------------------------------------------------
  integer nx,ny,i0,j0,nxp,nyp,nf
  real beam(nx,ny,nf),bgain
  !
  integer i,j,k
  real bmax,bmin
  !
  ! Compute maximum sidelobe
  bmax = 0
  bmin = 0
  do k = 1,nf
    do j = 1,j0-nyp
      do i = 1,nx
        if (beam(i,j,k).gt.bmax) then
          bmax = beam(i,j,k)
        elseif (beam(i,j,k).lt.bmin) then
          bmin = beam(i,j,k)
        endif
      enddo
    enddo
    do j = max(1,j0-nyp+1),min(ny,j0+nyp-1)
      do i = 1,i0-nxp
        if (beam(i,j,k).gt.bmax) then
          bmax = beam(i,j,k)
        elseif (beam(i,j,k).lt.bmin) then
          bmin = beam(i,j,k)
        endif
      enddo
      do i = i0+nxp,nx
        if (beam(i,j,k).gt.bmax) then
          bmax = beam(i,j,k)
        elseif (beam(i,j,k).lt.bmin) then
          bmin = beam(i,j,k)
        endif
      enddo
    enddo
    do j = j0+nyp,ny
      do i = 1,nx
        if (beam(i,j,k).gt.bmax) then
          bmax = beam(i,j,k)
        elseif (beam(i,j,k).lt.bmin) then
          bmin = beam(i,j,k)
        endif
      enddo
    enddo
  enddo
  bgain = max(abs(bmax),abs(bmin))
  bgain = bgain/abs(beam(i0,j0,1))
end subroutine mos_sidelobe

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_otf_psw(mrtset,backcal,backsci,filebuf,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_calib_otf_psw
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(calib_backend_t),   intent(in)    :: backcal
  type(science_backend_t), intent(inout) :: backsci
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=4) :: ion,non
  character(len=*), parameter :: rname='CALIB>OTF>PSW'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_init_onloop(backsci,non,error)
  if (error) return
  do ion=1,non
     call mrtcal_get_nexton(backsci,error)
     if (error) return
     call mrtcal_psw_prepare_nextoff(mrtset,filebuf,backsci,error)
     if (error) return
     call mrtcal_sanity_check(backsci,error)
     if (error) return
     call mrtcal_init_cycleloop(&
          mrtset,&
          backsci%list,&
          backsci%on%curr%isub,&
          'onTheFly',&
          filebuf%imbf,&
          filebuf%subscanbuf,&
          backsci%switch,&
          error)
     if (error) return
     do while (backsci%switch%book%idump.lt.backsci%switch%book%ndump)
        call mrtcal_get_nextcycle(&
             filebuf%imbf,&
             filebuf%subscanbuf%subscan,&
             filebuf%subscanbuf%databuf,&
             backsci,error)
        if (error) return
        if (backsci%switch%book%found) then
           call reassociate_chunkset_2d(backsci%switch%cycle%data(1),backsci%on%curr,error)
           if (error) return
           call mrtcal_psw_select_off(mrtset,backsci,error)
           if (error) return
           call mrtcal_on_minus_off(isotfmap,notfsw,backsci,error)
           if (error) return
           call mrtcal_tscale_computation(backcal,backsci,error)
           if (error) return
           call mrtcal_tscale_application(backsci%tscale,backsci%diff,error)
           if (error) return
           call mrtcal_write_toclass(backsci%diff,mrtset%out,backsci%nspec,error)
           if (error) return
        endif
     enddo ! switch%book%idump
     call mrtcal_switch_book_list(backsci%switch%book,error)
     if (error) return
     ! User can interrupt the pipeline
     if (sic_ctrlc_status()) then
        error = .true.
        exit
     endif
  enddo !ion
  !
end subroutine mrtcal_calib_otf_psw
!
subroutine mrtcal_psw_select_off(mrtset,backsci,error)
  use mrtcal_interfaces, except_this=>mrtcal_psw_select_off
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  ! Select the OFF subscan to be used. It can be either a linear
  ! interpolation of the previous and next OFF or the nearest neighbour
  ! in time. That's MRTSET%CAL%INTERPOFF that switches the behavior.
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),            intent(in)    :: mrtset
  type(science_backend_t), target, intent(inout) :: backsci
  logical,                         intent(inout) :: error
  ! Local
  real(kind=8) :: dist_onprev,dist_onnext
  real(kind=8), parameter :: mjd_tol = 2d0/(24d0*3600d0) ! 2 sec in mjd
  character(len=*), parameter :: rname='PSW>SELECT>OFF'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! *** JP 1. This can be checked for each dump. It would be more efficiency
  ! *** JP    to have the address of the right subroutine decided earlier
  ! *** JP    and passed here. Is it needed?
  ! *** JP 2. OFF interpolation should be forbidden for tracked position
  ! *** JP    switched
  select case(mrtset%cal%interpoff)
  case (interp_linear)
     ! Interpolate
     call mrtcal_chunkset_2d_interpolate_do(&
          backsci%on%curr%mjd%med,&
          backsci%off%slope,&
          backsci%off%offset,&
          backsci%off%interp,&
          error)
     !
  case (interp_nearest)
     ! Use off nearest in time
     if ((backsci%off%prev%isub.gt.0).and.(backsci%off%next%isub.gt.0)) then
        dist_onprev = backsci%on%curr%mjd%beg-backsci%off%prev%mjd%end
        dist_onnext = backsci%off%next%mjd%beg-backsci%on%curr%mjd%end
        ! *** JP The MJD tolerance should probably depend on the observing mode
        ! *** JP 0 sec for OTF, 2 sec for tracked???
        if (dist_onprev-dist_onnext.le.mjd_tol) then
           call mrtcal_message(mseve%calib%book,rname,'Using previous OFF')
           backsci%off%curr => backsci%off%prev
        else
           call mrtcal_message(mseve%calib%book,rname,'Using next OFF')
           backsci%off%curr => backsci%off%next
        endif
     else if (backsci%off%prev%isub.gt.0) then
        ! *** JP Transfered Warning into Information to avoid too many messages.
        ! *** JP Is there anything else to be done for TRACKED observations?
        call mrtcal_message(mseve%calib%book,rname,'Only previous OFF available')
        backsci%off%curr => backsci%off%prev
     else if (backsci%off%next%isub.gt.0) then
        ! *** JP Transfered Warning into Information to avoid too many messages.
        ! *** JP Is there anything else to be done for TRACKED observations?
        call mrtcal_message(mseve%calib%book,rname,'Only next OFF available')
        backsci%off%curr => backsci%off%next
     else
        call mrtcal_message(seve%e,rname,'No subscans associated to previous nor to next OFF')
        error = .true.
        return
     endif
     !
  case default
     call mrtcal_message(seve%e,rname,'Interpolation mode not implemented')
     error = .true.
     return
     !
  end select
  !
end subroutine mrtcal_psw_select_off
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
subroutine write_image (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>write_image
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_format
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for command
  !   WRITE Type File [/RANGE Start End Kind] [/TRIM]
  !       [/APPEND] [/REPLACE]
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(out) :: error
  ! Global
  integer, parameter :: o_append=1
  integer, parameter :: o_range=2
  integer, parameter :: o_replace=3
  integer, parameter :: o_trim=4  
  character(len=*), parameter :: rname='WRITE'
  ! Local
  integer ntype, nc(2), mc(2), larg
  character(len=12) argu,atype,crange
  character(len=filename_length) :: name
  real(8) :: drange(2)
  logical :: err
  !
  call sic_ke (line,0,1,argu,larg,.true.,error)
  if (error) return
  if (argu.eq.'?') then
    call sic_ambigs (rname,argu,atype,ntype,vtype,mtype,error)
    return
  elseif (argu.eq.'UV') then
    argu = 'UV_DATA'
  endif
  !
  call sic_ch (line,0,2,name,larg,.true.,error)
  if (error) return
  drange = 0.0
  crange  = 'NONE'
  nc = 0
  !
  if (sic_present(o_range,0)) then
    call sic_r8 (line,o_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,o_range,3,crange,larg,.true.,error)
    if (error) return
  endif
  !
  if (sic_present(o_replace,0)) then
    call sic_ambigs (rname,argu,atype,ntype,vtype,mtype,error)
    if (error) return
    !
    if (atype.eq.'UV_DATA') then
      call map_message(seve%e,rname,'Replacing channels in UV data is not allowed')
      error = .true.
      return
    else
      call map_message(seve%e,rname,'Replacing channels in '//atype) 
      call sub_replace_image(name,ntype,nc,error)
    endif
  else if (sic_present(o_append,0)) then
    call sic_ambigs (rname,argu,atype,ntype,vtype,mtype,error)
    if (error) return
    !
    call sub_append_image(name,ntype,nc,error)
    return
  else
    !
    if (argu.eq.'*') then
      if (crange.ne.'NONE') then
        call map_message(seve%e,rname,'/RANGE option not supported for ' &
            & //' WRITE *')
        error = .true.
        return
      endif
      do ntype=1,mtype
        if (save_data(ntype)) then
          call map_message(seve%i,rname,'saving '//vtype(ntype))
          if (vtype(ntype).eq.'UV_DATA') then
            mc =[1,huv%gil%nchan]
          else
            mc = 0
          endif
          call sub_write_image(name,vtype(ntype),ntype,mc,err)
          error = error.or.err
        endif
      enddo
    else
      !
      call sic_ambigs (' ',argu,atype,ntype,vtype,mtype,error)
      if (error) then
        call map_message(seve%w,rname,'Attempting to write a SIC image')
        error = .false.
        atype = argu
      else
        atype = vtype(ntype)
      endif
      !
      if (atype.eq.'MOMENTS') then
        if (crange.ne.'NONE') then
          call map_message(seve%e,rname,'/RANGE option not supported for ' &
              & //' WRITE MOMENTS')
          error = .true.
          return
        endif
        !
        call sub_write_moments(name,error)
        return
      else if (atype.eq.'FLUX') then
        if (crange.ne.'NONE') then
          call map_message(seve%e,rname,'/RANGE option not supported for ' &
              & //' WRITE FLUX')
          error = .true.
          return
        endif
        !
        call sub_write_flux(name,error)
        return
      else if (atype.eq.'UV_DATA') then
        ! Find the range
        call out_range(rname,crange,drange,nc,huv,error)
      else if (crange.ne.'NONE') then
       !      if (atype.ne.'CLEAN') then
        call map_message(seve%e,rname,'/RANGE option not supported for ' &
            & //atype)
        error = .true.
        return
        !  endif
      endif
      !
      call sub_write_image(name,atype,ntype,nc,error)
    endif
  endif
  !
end subroutine write_image
!
subroutine sub_write_image (name,atype,ntype,nc,error)
  use gkernel_interfaces, no_interface=>gdf_write_image
  use imager_interfaces, except_this=>sub_write_image
  use clean_def
  use clean_arrays
  use clean_support
  use clean_types
  use uvfit_data
  use gkernel_types
  use gbl_format
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for command
  !   WRITE Type File [/RANGE Start End Kind] [/TRIM]
  !
  ! Dispatch the writing operation to specific subroutines depending
  ! on the Type of data to be written
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: name
  character(len=*), intent(in) :: atype
  integer, intent(in) :: nc(2), ntype
  logical, intent(out) :: error
  !
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='WRITE'
  type (gildas) :: htv, hin
  integer, allocatable :: ivis(:)
  logical subset, trim_uv, trim_uvany
  character(len=filename_length) :: file
  integer np, nch, nv, mv, im, iv, ic, ier
  integer, parameter :: o_trim=4
  type(sic_descriptor_t) :: desc
  integer(kind=address_length) :: ipnt
  !
  subset = .false.
  !
  ! WRITE SUPPORT
  if (atype.eq.'SUPPORT') then
    call greg_poly_write(rname,supportpol,name,error)
    return
  endif
  !
  if (ntype.ne.0) then
    call sic_parse_file (name,' ',etype(ntype),file)
  else
    call sic_parse_file (name,' ','.gdf',file)
  endif
  !
  select case(atype)
  case ('UV_DATA')
    if (huv%loca%size.eq.0) then
      call map_message(seve%e,rname,'UV data undefined ')
      error = .true.
      return
    endif
    !
    if (themap%nfields.ne.0 .and. huv%gil%pang.ne.0.0) then
      call map_message(seve%e,rname,'Cannot write rotated Mosaic UV data: no convention defined by IRAM')
      error = .true.
      return    
    endif
    !
    ! Trim if needed
    trim_uv = sic_present(o_trim,0)
    trim_uvany = sic_present(o_trim,1)
    if (trim_uv) then
      call gildas_null(htv, type = 'UVT')
      np = huv%gil%dim(1)
      nv = huv%gil%nvisi  !! not %dim(2)
      nch = huv%gil%nchan * huv%gil%nstokes
      allocate(ivis(nv),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation failure')
        error = .true.
        return
      endif
      !
      ! First passs to identify all valid visibilities
      ! Caution: assume default model here.
      ! This is guaranteed inside Mapping, since we use gdf_read_uvdataset
      mv = 0
      do iv = 1,nv
        if (trim_uvany) then
          ! If a single channel is Bad, flag data
          im = 1
          do ic=1,nch
            if (duv(7+3*ic,iv).le.0) then
              im = 0
              exit
            endif
          enddo
        else
          ! If a single channel is Good, use data
          im = 0
          do ic=1,nch
            if (duv(7+3*ic,iv).gt.0) then
              im = 1
              exit
            endif
          enddo
        endif
        if (im.ne.0) then
          mv = mv+1
          ivis(mv) = iv
        endif
      enddo
      !
      ! Create output image
      call sub_write_uvdata(file,nc,huv,duv,error, mv, ivis)
    else
      ! Create output image
      call sub_write_uvdata(file,nc,huv,duv,error)
      call sub_setmodif(file,optimize(code_save_uv),nc)
    endif
    save_data(code_save_uv) = .false.
    return ! This is a special case
  case ('MODEL')
    if (huvm%loca%size.eq.0) then
      call map_message(seve%e,rname,'Model UV data undefined ')
      error = .true.
      return
    endif
    call sub_write_uvdata(file,nc,huvm,duvm,error)
  case ('CGAINS')
    if (hbgain%loca%size.eq.0) then
      call map_message(seve%e,rname,'Baseline Gains CGAINS undefined ')
      error = .true.
      return
    endif
    call sub_write_uvdata(file,nc,hbgain,duvbg,error)
  case ('SELFCAL')
    if (hagain%loca%size.eq.0) then
      call map_message(seve%e,rname,'Antenna Gains AGAINS undefined ')
      error = .true.
      return
    endif
    hagain%file = file
    call gdf_write_image(hagain,dagain,error)
  case ('BEAM')
    if (hbeam%loca%size.eq.0) then
      call map_message(seve%e,rname,'BEAM image undefined ')
      error = .true.
      return
    endif
    hbeam%file = file
    do while (hbeam%gil%dim(hbeam%gil%ndim).eq.1)
      hbeam%gil%ndim = hbeam%gil%ndim-1
      if (hbeam%gil%ndim.eq.0) exit
    enddo
    call gdf_write_image(hbeam,dbeam,error)
  case ('DIRTY')
    if (hdirty%loca%size.eq.0) then
      call map_message(seve%e,rname,'DIRTY image undefined ')
      error = .true.
      return
    endif
    hdirty%file = file
    call gdf_write_image(hdirty,ddirty,error)
  case ('CLEAN')
    if (hclean%loca%size.eq.0) then
      call map_message(seve%e,rname,'CLEAN image undefined ')
      error = .true.
      return
    endif
    hclean%file = file
    if (subset) then
      hclean%blc(3) = nc(1)
      hclean%trc(3) = nc(2)
      call gdf_update_image(hclean,dclean(1,1,nc(1)),error)
      hclean%blc(3) = 0
      hclean%trc(3) = 0
    else
      call gdf_write_image(hclean,dclean,error)
    endif
  case ('RESIDUAL')
    if (hresid%loca%size.eq.0) then
      call map_message(seve%e,rname,'RESIDUAL image undefined ')
      error = .true.
      return
    endif
    hresid%file = file
    call gdf_write_image(hresid,dresid,error)
  case ('MASK')
    if (hmask%loca%size.eq.0) then
      call map_message(seve%e,rname,'MASK image undefined ')
      error = .true.
      return
    endif
    hmask%file = file
    call gdf_write_image(hmask,dmask,error)
  case ('CCT')
    if (hcct%loca%size.eq.0) then
      call map_message(seve%e,rname,'CC Table undefined ')
      error = .true.
      return
    endif
    call write_cct(file,error)
  case ('PRIMARY')
    if (hprim%loca%size.eq.0) then
      call map_message(seve%e,rname,'Primary BEAM image undefined ')
      error = .true.
      return
    endif
    hprim%file = file
    call gdf_write_image(hprim,dprim,error)
  case ('SKY')
    if (hsky%loca%size.eq.0) then
      call map_message(seve%e,rname,'SKY brightness image undefined ')
      error = .true.
      return
    endif
    hsky%file = file
    if (subset) then
      hsky%blc(3) = nc(1)
      hsky%trc(3) = nc(2)
      call gdf_update_image(hsky,dsky(1,1,nc(1)),error)
      hsky%blc(3) = 0
      hsky%trc(3) = 0
    else
      call gdf_write_image(hsky,dsky,error)
    endif
  case ('FIELDS')
    call create_fields(error)
    if (hfields%loca%size.eq.0) then
      call map_message(seve%e,rname,'Primary FIELDS image undefined ')
      error = .true.
      return
    endif
    hfields%file = file
    call gdf_write_image(hfields,dfields,error)
  case ('UV_FIT') 
    if (huvfit%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV_FIT table')
      error = .true.
      return
    endif
    huvfit%file = file
    call gdf_write_image(huvfit,duvfit,error)
    return 
  case default
    ! Write any SIC Image variable
    call gildas_null(hin)
    call get_gildas(rname,atype,desc,hin,error)
    if (error) return
    call gdf_copy_header(desc%head,hin,error)
    if (error) return
    ipnt = gag_pointer(desc%addr,memory)
    hin%file = file
    call gdf_write_image(hin,memory(ipnt),error)
    return
  end select
  !
  ! Set the Read/Write optimization and Save status
  call sub_setmodif(file,optimize(ntype),nc)
  save_data(ntype) = .false.
  !
end subroutine sub_write_image
!
subroutine sub_setmodif (file,opti,nc)
  use gkernel_types
  use clean_types
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Update the Read / Write optimization status
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: file  ! Filename
  type(readop_t), intent(inout) :: opti ! Status of corresponding buffer
  integer, intent(in) :: nc(2)          ! Range to be read
  !
  logical :: error
  !
  if (any(nc.ne.0)) then
    !
    ! Subset write: the internal buffer is not the written file
    return
  else
    ! Whole write: the buffer and the written file match exactly
    ! so one can reset the corresponding "optimize" structure
    ! with this new file.  However, this does not guarantee a full
    ! read optimization here, as the input file and output file may
    ! have different names (but be identical).
    !
    call gag_filmodif(file,opti%modif,error)
  endif
end subroutine sub_setmodif
!
subroutine write_cct(file,error)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for command
  !   WRITE CCT File [/RANGE Start End Kind]
  !----------------------------------------------------------------------
  !
  character(len=*), intent(in) :: file
  logical, intent(out) :: error
  !
  type (gildas) :: htcc
  integer :: mclean,i
  !
  ! Define the image header
  call gildas_null (htcc, type = 'IMAGE')
  call gdf_copy_header (hdirty,htcc, error)
  htcc%file = file
  htcc%gil%ndim = 3
  htcc%char%unit = 'Jy'
  !
  htcc%gil%dim(1) = 3
  ! Keep the same axis description
  htcc%gil%xaxi = 1
  !
  htcc%gil%convert(:,2) = hdirty%gil%convert(:,3)
  htcc%gil%convert(:,3) = hdirty%gil%convert(:,2)
  htcc%gil%dim(2) = hdirty%gil%dim(3)
  htcc%char%code(2) = hdirty%char%code(3)
  htcc%gil%faxi = 2
  !
  htcc%gil%dim(3) = ubound(dcct,3)
  htcc%char%code(3) = 'COMPONENT'
  htcc%gil%yaxi = 3
  !
  mclean = htcc%gil%dim(3)
  do i=1,htcc%gil%dim(3)
    if (all(dcct(:,:,i).eq.0)) then
      mclean = i-1
      exit
    endif
  enddo
  !
  ! Initialize BLCs...
  htcc%blc = 0
  htcc%trc = 0
  htcc%gil%dim(3) = mclean
  call gdf_write_image(htcc,dcct(:,:,1:mclean),error)
  !
end subroutine write_cct
!
subroutine sub_write_uvdata(file,nc,uvin,duv,error, mv, ivis)
  use image_def
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !   Write a subset of the loaded UV data
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: file
  integer, intent(in) :: nc(2)
  type(gildas), intent(in) :: uvin
  real, intent(in) :: duv(:,:)
  logical, intent(out) :: error
  !
  integer, intent(in), optional :: mv
  integer, intent(in), optional :: ivis(:)
  !
  type (gildas) :: uvou
  integer :: blc, trc, ib, iv, nblock, ier, i
  integer(kind=index_length) :: nvisi
  logical :: all
  character(len=80) :: mess
  !
  call gildas_null(uvou, type= 'UVT')
  call gdf_print_header(uvin) ! Test
  call gdf_copy_header(uvin, uvou, error)
  if (error) return
  call sic_parse_file(file,' ','.uvt',uvou%file)
  !
  !
  uvou%gil%nchan = nc(2)-nc(1)+1
  uvou%gil%ref(1) = uvin%gil%ref(1)-nc(1)+1
  uvou%gil%dim(1) = uvou%gil%nlead + uvou%gil%nstokes*uvou%gil%natom*uvou%gil%nchan + uvou%gil%ntrail
  uvou%gil%lcol = uvou%gil%nlead + uvou%gil%nstokes*uvou%gil%natom*uvou%gil%nchan 
  !
  all = uvou%gil%nchan.eq.uvin%gil%nchan
  if (all .and. .not.present(mv)) then
    !
    call gdf_write_image(uvou,duv,error)
  else
    ! Only write a subset, either by trimming or by channels, or both at once...
    !
    ! Define blocking factor
    if (present(mv)) then
      uvou%gil%nvisi = mv
      uvou%gil%dim(2) = mv
    endif
    call gdf_nitems('SPACE_GILDAS',nblock,uvou%gil%dim(1)) ! Visibilities at once
    nblock = min(nblock,uvou%gil%dim(2))
    ! Allocate space
    allocate (uvou%r2d(uvou%gil%dim(1),nblock), stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Memory allocation error ',uvou%gil%dim(1), nblock
      call map_message(seve%e,'WRITE',mess)
      error = .true.
      return
    endif
    !
    ! Shift trailing columns if any
    if (uvou%gil%ntrail.ne.0) then
      do i=1,code_uvt_last
        if (uvou%gil%column_pointer(i).gt.uvou%gil%lcol) then
          uvou%gil%column_pointer(i) = uvou%gil%column_pointer(i)-uvin%gil%lcol+uvou%gil%lcol
        endif
      enddo
    endif    
    !
    call gdf_create_image(uvou,error)
    if (error) then
      deallocate(uvou%r2d,stat=ier)
      call gdf_close_image(uvou,error)
      error = .true.
      return
    endif
    ! Loop over UV table
    uvou%blc = 0
    uvou%trc = 0
    do ib = 1,uvou%gil%dim(2),nblock
      write(mess,*) ib,' to ',ib+nblock-1,' / ',uvou%gil%dim(2)
      call map_message(seve%i,'WRITE',mess)
      blc = ib
      trc = min(uvou%gil%dim(2),ib-1+nblock)
      uvou%blc(2) = blc
      uvou%trc(2) = trc
      nvisi = trc-blc+1
      !
      ! Here do the job
      if (present(mv)) then
        do iv=blc,trc
          if (all) then
            uvou%r2d(:,iv-blc+1) = duv(:,ivis(iv))
          else
            call sub_extract_block(uvou, uvou%r2d(:,iv-blc+1), uvin, &
              &   duv(:,ivis(iv)), nvisi, nc)
          endif
        enddo
      else
        call sub_extract_block(uvou, uvou%r2d, uvin, duv(:,blc:trc), &
          & nvisi, nc)
      endif
      !
      ! Write
      call gdf_write_data(uvou, uvou%r2d, error)
    enddo
    call gdf_close_image(uvou,error)
    deallocate(uvou%r2d,stat=ier)
  endif
  !
end subroutine sub_write_uvdata
!
subroutine sub_extract_block(out, dout, in, din, nvisi, nc)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Extract a subset block of UV data
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: out
  type(gildas), intent(in) :: in
  integer(kind=index_length) :: nvisi
  real, intent(in) :: din(in%gil%dim(1),nvisi)
  real, intent(out) :: dout(out%gil%dim(1),nvisi)
  integer, intent(in) :: nc(2)
  !
  integer :: iv, icf, icl, jcf, jcl
  !
  icf = in%gil%nlead+(nc(1)-1)*in%gil%natom+1
  icl = in%gil%nlead+nc(2)*in%gil%natom
  jcf = out%gil%nlead+1
  jcl = out%gil%nlead+out%gil%nchan*out%gil%natom
  !
  do iv=1,nvisi
    dout(1:in%gil%nlead,iv) = din(1:in%gil%nlead,iv)
    dout(jcf:jcl,iv) = din(icf:icl,iv)
    if (out%gil%ntrail.gt.0) then
      dout(out%gil%dim(1)-out%gil%ntrail+1:out%gil%dim(1),iv) =   &
      &     din(in%gil%dim(1)-in%gil%ntrail+1:in%gil%dim(1),iv)
    endif
  enddo
end subroutine sub_extract_block
!
subroutine sub_replace_image (name,ntype,nc,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_replace_image
  use clean_def
  use clean_arrays
  use clean_support
  use clean_types
  use gbl_format
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for command
  !   WRITE Type File /REPLACE 
  !
  ! Dispatch the writing operation to specific subroutines depending
  ! on the Type of data to be written
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: name
  integer, intent(in) :: nc(2)
  integer, intent(in) :: ntype
  logical, intent(out) :: error
  ! Local
  character(len=*), parameter :: rname='WRITE /REPLACE'
  character(len=12) atype
  character(len=filename_length) :: file
  !
  atype = vtype(ntype)
  call sic_parse_file (name,' ',etype(ntype),file)
  !
  select case(atype)
  case ('BEAM')
    if (hbeam%gil%dim(3).ne.1) then
      if (hbeam%gil%dim(4).ne.1) then
        call map_message(seve%e,rname,'Multi-frequency beams not yet supported for mosaics')
        error = .true.
      else
        call sub_replace(atype,file,dbeam(:,:,:,1),hbeam,error)
      endif
    else
      call map_message(seve%w,rname,'Single beam plane only')
    endif  
  case ('DIRTY')
    call sub_replace(atype,file,ddirty,hdirty,error)
  case ('CLEAN')
    call sub_replace(atype,file,dclean,hclean,error)
  case ('RESIDUAL')
    call sub_replace(atype,file,dresid,hresid,error)
  case ('MASK')
    call sub_replace(atype,file,dmask,hmask,error)
  case ('CCT')      !! The structure is quite different here
    call map_message(seve%e,'WRITE','Type '//atype//' not yet supported for /APPEND')
    error = .true.
    return
!!    call sub_replace(atype,file,dcct,hcct,error)
  case ('SKY')
    call sub_replace(atype,file,dsky,hsky,error)
  case default
    call map_message(seve%e,'WRITE','Unsupported type '//atype//' for /REPLACE')
    error = .true.
    return
  end select
  !
  ! Set the Read/Write optimization and Save status
  call sub_setmodif(file,optimize(ntype),nc)
  save_data(ntype) = .false.
  !
end subroutine sub_replace_image
!
subroutine sub_replace(name,file,data,head,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  !-------------------------------------------------------
  ! @ private
  !   Support routine for WRITE /REPLACE
  !-------------------------------------------------------
  character(len=*), intent(in) :: name
  character(len=*), intent(in) :: file
  type(gildas), intent(inout) :: head
  real(kind=4), intent(in) :: data(:,:,:)
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='WRITE /REPLACE'
  type(gildas) :: hall
  integer :: imin, imax, itmp
  real(8) :: rval, velo
  real(8), parameter :: epsilon=1d-5
  character(len=64) :: chain
  !
  if (head%loca%size.eq.0) then
    call map_message(seve%e,rname,name//' image undefined ')
    error = .true.
    return
  endif
  !
  call gildas_null(hall)
  hall%file = file
  call gdf_read_header(hall,error)
  if (error) return
  !
  ! Basic checks of coordinates
  if ( any(head%gil%dim(1:2).ne.hall%gil%dim(1:2)) ) then
    call map_message(seve%e,rname,'Dimensions do not match')
    error = .true.
  endif
  if ( any(head%gil%convert(:,1:2).ne.hall%gil%convert(:,1:2)) ) then
    call map_message(seve%e,rname,'Positions do not match')
    Print *,'Head ',head%gil%convert(:,1:2)
    Print *,'Hout ',hall%gil%convert(:,1:2)
    Print *,'Difference ',head%gil%convert(:,1:2)-hall%gil%convert(:,1:2)
    error = .true.
  endif
  !
  if ( abs(head%gil%inc(3)).ne.abs(hall%gil%inc(3)) ) then
    call map_message(seve%e,rname,'Frequency resolution do not match')
    error = .true.
  endif
  if (error) return
  !
  ! Check which range in the file is needed - Match the velocities
  velo = (1.d0-head%gil%ref(3))*head%gil%inc(3) + head%gil%val(3)
  rval = (velo-hall%gil%val(3))/hall%gil%inc(3) + hall%gil%ref(3)
  imin = nint(rval)
  !
  if (abs(dble(imin)-rval).gt.epsilon*abs(head%gil%inc(3))) then
    call map_message(seve%e,rname,'Frequency axis does not match')
    error = .true.
  endif
  if (error) return
  !
  velo = (head%gil%dim(3)-head%gil%ref(3))*head%gil%inc(3) + head%gil%val(3)
  rval = (velo-hall%gil%val(3))/hall%gil%inc(3) + hall%gil%ref(3)
  imax = nint(rval)
  !
  if (imin.gt.imax) then
    itmp = imin
    imin = imax
    imax = itmp
  endif
  !
  if (imin.lt.1 .or. imax.gt.hall%gil%dim(3)) then
    write(chain,'(A,A,I0,A,I0)') name,' falls in range ',imin,',',imax
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  endif
  !
  hall%blc(3) = imin
  hall%trc(3) = imax
  !
  call gdf_update_image(hall,data,error)
end subroutine sub_replace
!
subroutine sub_append_image (name,ntype,nc,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_append_image
  use clean_def
  use clean_arrays
  use clean_support
  use clean_types
  use gbl_format
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for command
  !   WRITE Type File /APPEND  
  !
  ! Dispatch the writing operation to specific subroutines depending
  ! on the Type of data to be written
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: name
  integer, intent(in) :: nc(2)
  integer, intent(in) :: ntype
  logical, intent(out) :: error
  ! Local
  character(len=*), parameter :: rname='WRITE /REPLACE'
  character(len=12) atype
  character(len=filename_length) :: file
  !
  atype = vtype(ntype)
  call sic_parse_file (name,' ',etype(ntype),file)
  !
  select case(atype)
  case ('BEAM')
    if (hbeam%gil%dim(3).ne.1) then
      if (hbeam%gil%dim(4).ne.1) then
        call map_message(seve%e,rname,'Multi-frequency beams not yet supported for mosaics')
        error = .true.
      else
        call sub_append(atype,file,dbeam(:,:,:,1),hbeam,error)
      endif
    else
      call map_message(seve%w,rname,'Single beam plane only')
    endif  
  case ('DIRTY')
    call sub_append(atype,file,ddirty,hdirty,error)
  case ('CLEAN')
    call sub_append(atype,file,dclean,hclean,error)
  case ('RESIDUAL')
    call sub_append(atype,file,dresid,hresid,error)
  case ('MASK')
    call sub_append(atype,file,dmask,hmask,error)
  case ('CCT')   !! The structure is quite different here
    call map_message(seve%e,'WRITE','Type '//atype//' not yet supported for /APPEND')
    error = .true.
    return
!!   call sub_append(atype,file,dcct,hcct,error)
  case ('SKY')
    call sub_append(atype,file,dsky,hsky,error)
  case default
    call map_message(seve%e,'WRITE','Unsupported type '//atype//' for /APPEND')
    error = .true.
    return
  end select
  !
  ! Set the Read/Write optimization and Save status
  call sub_setmodif(file,optimize(ntype),nc)
  save_data(ntype) = .false.
  !
end subroutine sub_append_image
!
subroutine sub_append(name,file,data,head,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  !-------------------------------------------------------
  ! @ private
  !   Support routine for WRITE /APPEND
  !-------------------------------------------------------
  character(len=*), intent(in) :: name
  character(len=*), intent(in) :: file
  type(gildas), intent(inout) :: head
  real(kind=4), intent(in) :: data(:,:,:)
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='WRITE /APPEND'
  type(gildas) :: hall
  integer :: imin, imax, itmp
  real(8) :: rval, velo
  real(8), parameter :: epsilon=1d-5
  character(len=64) :: chain
  integer(kind=index_length) :: newdim  ! New value of last dimension
  !
  if (head%loca%size.eq.0) then
    call map_message(seve%e,rname,name//' image undefined ')
    error = .true.
    return
  endif
  !
  call gildas_null(hall)
  hall%file = file
  call gdf_read_header(hall,error)
  if (error) return
  !
  ! Basic checks of coordinates
  if ( any(head%gil%dim(1:2).ne.hall%gil%dim(1:2)) ) then
    call map_message(seve%e,rname,'Dimensions do not match')
    error = .true.
  endif
  if ( any(head%gil%convert(:,1:2).ne.hall%gil%convert(:,1:2)) ) then
    call map_message(seve%e,rname,'Positions do not match')
    Print *,'Head ',head%gil%convert(:,1:2)
    Print *,'Hout ',hall%gil%convert(:,1:2)
    Print *,'Difference ',head%gil%convert(:,1:2)-hall%gil%convert(:,1:2)
    error = .true.
  endif
  !
  if ( abs(head%gil%inc(3)).ne.abs(hall%gil%inc(3)) ) then
    call map_message(seve%e,rname,'Frequency resolution do not match')
    error = .true.
  endif
  if (error) return
  !
  ! Check which range in the file is needed - Match the velocities
  velo = (1.d0-head%gil%ref(3))*head%gil%inc(3) + head%gil%val(3)
  rval = (velo-hall%gil%val(3))/hall%gil%inc(3) + hall%gil%ref(3)
  imin = nint(rval)
  !
  if (abs(dble(imin)-rval).gt.epsilon*abs(head%gil%inc(3))) then
    call map_message(seve%e,rname,'Frequency axis does not match')
    error = .true.
  endif
  if (error) return
  !
  velo = (head%gil%dim(3)-head%gil%ref(3))*head%gil%inc(3) + head%gil%val(3)
  rval = (velo-hall%gil%val(3))/hall%gil%inc(3) + hall%gil%ref(3)
  imax = nint(rval)
  !
  if (imin.gt.imax) then
    itmp = imin
    imin = imax
    imax = itmp
  endif
  !
  ! Tolerate a 1 channel error overlap, but no gap
  if (imin.ne.hall%gil%dim(3)+1 .and. imin.ne.hall%gil%dim(3)) then
    write(chain,'(A,A,I0,A,I0)') name,' is not contiguous, starts at ',imin
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  endif
  !
  ! Extend image - image is left open
  newdim = imax ! in all cases, even for a 1 channel overlap 
  write(chain,'(A,A,I0,A)') name,' extended to ',imax, ' channels' 
  call map_message(seve%i,rname,chain)
  call gdf_extend_image (hall,newdim,error)
  if (error) then
    call map_message(seve%e,rname,'Extension failed')
    return
  endif
  !
  ! Write in place (will replace possible overlap here)
  hall%blc(3) = imin
  hall%trc(3) = imax
  call gdf_write_data(hall,data,error)
  if (error) then
    call map_message(seve%e,rname,'Data writing failed after extension')
  endif
  ! Close image
  call gdf_close_image (hall,error)
end subroutine sub_append
!
subroutine sub_write_moments(name,error)
  use gkernel_interfaces
  use moment_arrays
  use gbl_message
  !-------------------------------------------------------
  ! @ private
  !   IMAGER
  !   Support routine for WRITE MOMENTS 
  !-------------------------------------------------------
  character(len=*), intent(in) :: name
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='WRITE MOMENTS'
  !
  error = .false.
  if (hmean%loca%size.eq.0) then
    call map_message(seve%e,rname,'No M_AREA buffer')
    error = .true.
  endif
  if (hpeak%loca%size.eq.0) then
    call map_message(seve%e,rname,'No M_PEAK buffer')
    error = .true.
  endif
  if (hvelo%loca%size.eq.0) then
    call map_message(seve%e,rname,'No M_VELO buffer')
    error = .true.
  endif
  if (hwidth%loca%size.eq.0) then
    call map_message(seve%e,rname,'No M_WIDTH buffer')
    error = .true.
  endif
  if (error) return
  !
  call sic_parse_file (name,' ','.area',hmean%file)
  call gdf_write_image(hmean,dmean,error)
  call sic_parse_file (name,' ','.peak',hpeak%file)
  call gdf_write_image(hpeak,dpeak,error)
  call sic_parse_file (name,' ','.velo',hvelo%file)
  call gdf_write_image(hvelo,dvelo,error)
  call sic_parse_file (name,' ','.width',hwidth%file)
  call gdf_write_image(hwidth,dwidth,error)
end subroutine sub_write_moments
! 
!
subroutine sub_write_flux(name,error)
  use gkernel_interfaces
  use moment_arrays
  use gbl_message
  !-------------------------------------------------------
  ! @ private
  !   IMAGER
  !   Support routine for WRITE FLUX  
  !-------------------------------------------------------
  character(len=*), intent(in) :: name
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='WRITE FLUX'
  type(gildas) :: htab
  integer :: ier
  !
  if (flux_nf.eq.0) then
    call map_message(seve%e,rname,'No FLUX data, use command FLUX to create one')
    error = .true.
    return
  endif
  !
  call gildas_null(htab)
  call sic_parse_file (name,' ','.tab',htab%file)
  htab%gil%ndim = 2
  htab%gil%dim(1) = flux_nc
  htab%gil%dim(2) = flux_nf+2
  allocate (htab%r2d(htab%gil%dim(1),htab%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif  
  !
  htab%r2d(:,1) = flux_velo
  htab%r2d(:,2) = flux_freq  ! Loss of precision, but tolerable in most cases.
  htab%r2d(:,3:) = flux_values
  !
  call gdf_write_image(htab,htab%r2d,error)
  deallocate(htab%r2d)
end subroutine sub_write_flux
  
 

! Sblock is the Blocking factor
! Experience shows that the efficiency does not
! increase with large blocking factors. Values of order
! 16 are often sufficient and even optimal.
!   Huge values (e.g. 1024) yield a penalty.
! This drives from the fact that gridding is essentially
! memory access limited, so page fault dominate.
! In the presence of Multi-Threading, a good policy is
! be to have the number of blocks being a multiple of
! the number of threads.
!
!
subroutine one_beam_para (rname,map,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,uvdata,   &
     &    w_mapu, w_mapv, w_grid, w_weight, w_v, do_weig,    &
     &    wcol,mcol,wfft,sblock,cpu0,error,uvmax)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>one_beam_para
  use clean_def
  use image_def
  use gbl_message
  !$ use omp_lib
  !------------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Compute a map from a CLIC UV Sorted Table
  !   by Gridding and Fast Fourier Transform, with
  !   one single beam for all channels.
  !
  ! Input :
  ! a precessed UV table, sorted in V, ordered in
  ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  ! Output :
  ! a beam image
  ! a VLM cube
  ! Work space :
  ! a  VLM complex Fourier cube (first V value is for beam)
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: rname   ! Calling Task name
  type (uvmap_par), intent(inout) :: map  ! Mapping parameters
  type (gildas), intent(inout) :: huv     ! UV data set
  type (gildas), intent(inout) :: hbeam   ! Dirty beam data set
  type (gildas), intent(inout) :: hdirty  ! Dirty image data set
  integer, intent(in) :: nx   ! X size
  integer, intent(in) :: ny   ! Y size
  integer, intent(in) :: nu   ! Size of a visibilities
  integer, intent(in) :: nv   ! Number of visibilities
  real, intent(inout) :: uvdata(nu,nv)
  real, intent(inout) :: w_mapu(nx)      ! U grid coordinates
  real, intent(inout) :: w_mapv(ny)      ! V grid coordinates
  real, intent(inout) :: w_grid(nx,ny)   ! Gridding space
  real, intent(inout) :: w_weight(nv)    ! Weight of visibilities
  real, intent(inout) :: w_v(nv)         ! V values
  logical, intent(inout) :: do_weig
  !
  real, intent(inout) :: wfft(*)     ! Work space
  real, intent(inout) :: cpu0        ! CPU
  real, intent(inout) :: uvmax       ! Maximum baseline
  integer, intent(inout) :: sblock   ! Blocking factor
  integer, intent(inout) :: wcol     ! Weight channel
  integer, intent(inout) :: mcol(2)  ! First and last channel
  logical, intent(inout) :: error
  ! Global variables:
  !
  real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
  !
  real ubias,vbias,ubuff(4096),vbuff(4096)
  common /conv/ ubias,vbias,ubuff,vbuff ! To be saved
  !
  integer :: nc   ! Number of channels
  integer :: nd   ! Size of data
  integer ier
  real(kind=8) freq
  integer ctypx,ctypy
  integer icol,lcol,fcol,imi,ima,iv
  real rmi,rma,wall,cpu1
  real xparm(10),yparm(10)
  real vref,voff,vinc
  real(kind=4) :: loff,boff
  integer ndim, nn(2), i, lx, ly
  integer istart,iblock,nblock,kz,iz,kkz
  integer blc(4),trc(4)
  character(len=message_length) :: chain
  !
  real rms, null_taper(4)
  complex, allocatable :: ftbeam(:,:)
  complex, allocatable :: tfgrid(:,:,:)
  real, allocatable :: w_xgrid(:),w_ygrid(:), w_w(:)
  integer(kind=8) :: ilong
  !
  integer :: ithread, nthread
  !$ integer(kind = OMP_lock_kind) :: lck
  real(8) :: elapsed_s, elapsed_e, elapsed
  real :: local_wfft(2*max(nx,ny))
  !
  data blc/4*0/, trc/4*0/
  !------------------------------------------------------------------------
  !
  ! Code:
  nd = nx*ny
  nc = huv%gil%nchan
  !
  ! Reset the parameters
  xparm = 0.0
  yparm = 0.0
  !
  vref = huv%gil%ref(1)
  voff = huv%gil%voff
  vinc = huv%gil%vres
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nc))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nc
  else
    mcol(2) = max(1,min(mcol(2),nc))
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  if (wcol.eq.0) then
    wcol = (fcol+lcol)/3
  endif
  wcol = max(1,wcol)
  wcol = min(wcol,nc)
  nc = lcol-fcol+1
  !
  ! Compute observing sky frequency for U,V cell size
  freq = gdf_uv_frequency(huv, 0.5d0*dble(lcol+fcol) )
  !
  ! Compute gridding function
  ctypx = map%ctype
  ctypy = map%ctype
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, ubuff, ubias)
  call convfn (ctypy, yparm, vbuff, vbias)
  map%uvcell = clight/freq/(map%xycell*map%size)
  map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
  map%support(2) = yparm(1)*map%uvcell(2)
  !
  ! Load V values and original Weights
  icol = 3*wcol + 7
  allocate(w_w(nv),stat=ier)
  call dovisi (nu,nv,uvdata,w_v,w_w,icol)
  !
  ! Compute weights
  !
  if (do_weig) then
    call doweig (nu,nv,   &
       &    uvdata,   &          ! Visibilities
       &    1,2,   &             ! U, V pointers
       &    wcol,   &            ! Weight channel
       &    map%uniform(1),   &  ! Uniform UV cell size
       &    w_weight,   &        ! Weight array
       &    map%uniform(2),   &  ! Fraction of weight
       &    w_v,              &  ! V values
       &    error)
    if (error)  return
    !
    ! Should also plug the TAPER here, rather than in DOFFT later  !
    call dotape (nu,nv,   &
       &    uvdata,   &          ! Visibilities
       &    1,2,   &             ! U, V pointers
       &    map%taper,  &        ! Taper
       &    w_weight)            ! Weight array
    do_weig = .false.
  else
    call map_message(seve%i,rname,'Reusing weights')
  endif
  null_taper = 0
  ! For test
  !  else
  !    null_taper = map%taper
  !  endif
  !
  call gag_cpu(cpu1)
  write(chain,102) 'Finished weighting CPU ',cpu1-cpu0
  call map_message(seve%i,rname,chain)
  !
  wall = 0
  do iv=1,nv
    if (w_w(iv).gt.0) then
       wall = wall + w_w(iv)
    endif
  enddo
  if (wall.eq.0.0) then
    write(chain,101) 'Plane ',wcol,' has Zero weight'
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  else
    !
    ! Noise definition
    wall = 1e-3/sqrt(wall)
    call prnoise(rname,'Natural',wall,rms)
    !
    ! Re-normalize the weights and re-count the noise
    call scawei (nv,w_weight,w_w,wall)
    wall = 1e-3/sqrt(wall)
    call prnoise(rname,'Expected',wall,rms)
  endif
  deallocate(w_w)
  !
  lx = (uvmax+map%support(1))/map%uvcell(1) + 2
  ly = (uvmax+map%support(2))/map%uvcell(2) + 2
  lx = 2*lx
  ly = 2*ly
  if (ly.gt.ny) then
    write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
        &      ' Undersampling ratio ',float(ly)/float(ny)
    call map_message(seve%e,rname,chain)
    ly = min(ly,ny)
    lx = min(lx,nx)
  endif
  call docoor (lx,-map%uvcell(1),w_mapu)
  call docoor (ly,map%uvcell(2),w_mapv)
  !
  ! Optimize SBLOCK now, allowing some additional memory if NBLOCK small
  if (sblock.gt.0) then
    nblock = (nc+sblock-1)/sblock
    kz = mod(nc,sblock)
    if (kz.ne.0 .and. kz.lt.(sblock/(nblock+1))) then
      if (nblock.ne.1) nblock = nblock-1
    endif
    sblock = (nc+nblock-1)/nblock
    kz = min(sblock,nc)
  else
    kz = nc
    nblock = 1
  endif
  !
  ! Get FFT's work space
  write(chain,101) 'Using a blocking factor of ',sblock,' planes'
  call map_message(seve%i,rname,chain)
  allocate (tfgrid(kz+1,lx,ly),ftbeam(nx,ny),stat=ier)
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt_plan(ftbeam,nn,ndim,-1,1)
  !
  ! Prepare grid correction,
  !
  allocate(w_xgrid(nx),w_ygrid(ny),stat=ier)
  call grdtab (ny, vbuff, vbias, w_ygrid)
  call grdtab (nx, ubuff, ubias, w_xgrid)
  !
  ! Make beam, not normalized
  call gdf_copy_header(huv,hbeam,error)
  hbeam%gil%dopp = 0    ! Nullify the Doppler factor
  !
  hbeam%gil%ndim = 2
  hbeam%gil%dim(1) = nx
  hbeam%gil%dim(2) = ny
  hbeam%gil%dim(3) = 1
  hbeam%gil%dim(4) = 1
  hbeam%gil%convert(1,1) = nx/2+1
  hbeam%gil%convert(1,2) = ny/2+1
  hbeam%gil%convert(2,1) = 0
  hbeam%gil%convert(2,2) = 0
  hbeam%gil%convert(3,1) = -map%xycell(1)  ! Assume EQUATORIAL system
  hbeam%gil%convert(3,2) = map%xycell(2)
  hbeam%gil%proj_words = 0
  hbeam%gil%extr_words = 0
  hbeam%gil%reso_words = 0
  hbeam%gil%uvda_words = 0
  hbeam%gil%type_gdf = code_gdf_image
  !
  hbeam%char%code(1) = 'ANGLE'
  hbeam%char%code(2) = 'ANGLE'
  hbeam%gil%majo = 0.0
  hbeam%loca%size = nx*ny
  hbeam%char%type = 'GILDAS_IMAGE'
  !
  ! Prepare the dirty map header
  call gdf_copy_header(hbeam,hdirty,error)
  hdirty%gil%ndim = 3
  hdirty%gil%dim(1) = nx
  hdirty%gil%dim(2) = ny
  hdirty%gil%dim(3) = nc
  hdirty%gil%dim(4) = 1
  hdirty%gil%convert(1,3) = vref-fcol+1
  hdirty%gil%convert(2,3) = voff
  hdirty%gil%convert(3,3) = vinc
  hdirty%gil%proj_words = def_proj_words
  hdirty%gil%uvda_words = 0
  hdirty%gil%type_gdf = code_gdf_image
  hdirty%char%code(1) = 'RA'
  hdirty%char%code(2) = 'DEC'
  hdirty%char%code(3) = 'VELOCITY'
  call equ_to_gal(hdirty%gil%ra,hdirty%gil%dec,0.0,0.0,   &
                  hdirty%gil%epoc,hdirty%gil%lii,hdirty%gil%bii,loff,boff,error)
  if (huv%gil%ptyp.eq.p_none) then
    hdirty%gil%ptyp = p_azimuthal  ! Azimuthal (Sin)
    hdirty%gil%pang = 0.d0     ! Defined in table.
    hdirty%gil%a0 = hdirty%gil%ra
    hdirty%gil%d0 = hdirty%gil%dec
  else
    hdirty%gil%ptyp = p_azimuthal
    hdirty%gil%pang = huv%gil%pang ! Defined in table.
    hdirty%gil%a0 = huv%gil%a0
    hdirty%gil%d0 = huv%gil%d0
  endif
  hdirty%char%syst = 'EQUATORIAL'
  hdirty%gil%xaxi = 1
  hdirty%gil%yaxi = 2
  hdirty%gil%faxi = 3
  hdirty%gil%extr_words = 0          ! extrema not computed
  hdirty%gil%reso_words = 0          ! no beam defined
  hdirty%gil%nois_words = 2
  hdirty%gil%majo = 0
  hdirty%gil%noise = wall
  hdirty%char%unit = 'Jy/beam'
  hdirty%char%type = 'GILDAS_IMAGE'
  hdirty%loca%size = nx*ny*nc
  !
  ! Loop over blocks
  !$ call omp_init_lock(lck)
  !
  kkz = kz
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP PRIVATE(iblock,istart,kz,blc,trc)  &
  !$OMP PRIVATE(tfgrid,ftbeam) &  ! Big arrays
  !$OMP SHARED(nblock, sblock, kkz, nu,nv,nx,ny,nc,nd,fcol,lx,ly, lck,nthread) &
  !$OMP SHARED(w_mapu,w_mapv,map,null_taper) &
  !$OMP SHARED(ubias,vbias,ubuff,vbuff) &
  !$OMP SHARED(nn,ndim,hbeam,hdirty,rname) &
  !$OMP SHARED(w_grid,w_xgrid,w_ygrid,w_v,w_weight,uvdata, wfft) &
  !$OMP PRIVATE(rmi,rma,imi,ima,ilong,chain) &
  !$OMP SHARED(cpu0,cpu1) PRIVATE(elapsed_s, elapsed_e, elapsed, ithread)
  !
  !$OMP MASTER
  nthread = 1
  !$  nthread = omp_get_num_threads()
  if (nblock.lt.nthread) then
    nblock = min(nthread,nc)
    sblock = (nc+nblock-1)/nblock
    write(chain,'(A,I6,A,I8,A)') 'Reset ',nblock,' blocks of ',&
      & sblock,' channels for Threading'
    call map_message(seve%w,rname,chain)
    kkz = sblock
  endif
  !$OMP END MASTER
  !$OMP BARRIER
  !
  !$OMP DO
  do iblock = 1,nblock
    !$ elapsed_s = omp_get_wtime()
    !$ ithread = omp_get_thread_num()
    !$ if (iblock.eq.1) call omp_set_lock(lck)
    !
    istart = fcol+(iblock-1)*sblock
    blc(3) = (iblock-1)*kkz+1
    kz = min (sblock,nc-sblock*(iblock-1))
    trc(3) = blc(3)-1+kz
    !
    ! This is the power-hungry routine...
    call dofft (nu,nv,   &   ! Size of visibility array
         &        uvdata,   &      ! Visibilities
         &        1,2,   &         ! U, V pointers
         &        istart,   &      ! First channel to map
         &        kz,lx,ly,   &    ! Cube size
         &        tfgrid,   &      ! FFT cube
         &        w_mapu,w_mapv,   &   ! U and V grid coordinates
         &        map%support,map%uvcell,null_taper,   &    ! Gridding parameters
         &        w_weight,w_v,   &    ! Weight array
         &        ubias,vbias,ubuff,vbuff,map%ctype)
    !
    ! Should one beam per block be created, this test can be
    ! easily modified
    if (iblock.eq.1) then
      call map_message(seve%i,rname,'Creating beam ')
      !
      call extracs(kz+1,nx,ny,kz+1,tfgrid,ftbeam,lx,ly)
      call fourt  (ftbeam,nn,ndim,-1,1,wfft)
      call cmtore (ftbeam,hbeam%r3d(:,:,1),nx,ny)
      !
      ! Compute Grid correction and Free the Grid lock
      ! Normalization factor is applied to grid correction,
      ! for further use on beam and channel maps.
      call dogrid (w_grid,w_xgrid,w_ygrid,nx,ny,hbeam%r3d(:,:,1))
      !$ call omp_unset_lock(lck)
      !
      ! Normalize and Free beam
      call docorr (hbeam%r3d(:,:,1),w_grid,nd)
      rma = -1e38
      rmi = 1e38
      call domima (hbeam%r3d(:,:,1),rmi,rma,imi,ima,nd)
      hbeam%gil%extr_words = def_extr_words          ! extrema computed
      hbeam%gil%rmax = rma
      hbeam%gil%rmin = rmi
      ilong = imi
      call gdf_index_to_where (ilong,hbeam%gil%ndim,hbeam%gil%dim,hbeam%gil%minloc)
      ilong = ima
      call gdf_index_to_where (ilong,hbeam%gil%ndim,hbeam%gil%dim,hbeam%gil%maxloc)
      !
      !$ elapsed_e = omp_get_wtime()
      elapsed = elapsed_e - elapsed_s
      write(chain,102) 'Finished Beam, Elapsed ',elapsed
      call map_message(seve%i,rname,chain)
      call map_message(seve%i,rname,'Creating map file ')
    endif
    !
    ! Wait for gridding correction to be computed
    !$  call omp_set_lock(lck)
    ! but free lock immediately, as no further waiting is needed.
    !$  call omp_unset_lock(lck)
    ! In general, the time spent here is negligible,
    ! so Parallel Nesting is not needed,
    ! but this is not always the case...
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP & PRIVATE(i,iz,ftbeam,local_wfft) &
    !$OMP & SHARED(lck,nx,ny,nd,nn,ndim,lx,ly,iblock,kz,kkz) &
    !$OMP & SHARED(hdirty,w_grid,tfgrid)
    !$OMP DO
    do i=1,kz
      iz = i+(iblock-1)*kkz
      call extracs(kz+1,nx,ny,i,tfgrid,ftbeam,lx,ly)
      call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
      call cmtore (ftbeam,hdirty%r3d(:,:,iz),nx,ny)
      call docorr (hdirty%r3d(:,:,iz),w_grid,nd)
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !$  elapsed_e = omp_get_wtime()
    elapsed = elapsed_e - elapsed_s
    write(chain,103) 'End planes ',blc(3),trc(3),' Time ',elapsed &
      & ,' Block ',iblock,' Thread ',ithread
    call map_message(seve%i,rname,chain)
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !$  call omp_destroy_lock(lck)
  !
  call gag_cpu(cpu1)
  write(chain,102) 'Finished maps ',cpu1-cpu0
  call map_message(seve%i,rname,chain)
  !
  hdirty%gil%extr_words = def_extr_words  ! extrema computed
  hdirty%gil%minloc = 1
  hdirty%gil%maxloc = 1
  hdirty%gil%minloc(1:3) = minloc(hdirty%r3d)
  hdirty%gil%maxloc(1:3) = maxloc(hdirty%r3d)
  rma = hdirty%r3d(hdirty%gil%maxloc(1),hdirty%gil%maxloc(2),hdirty%gil%maxloc(3))
  rmi = hdirty%r3d(hdirty%gil%minloc(1),hdirty%gil%minloc(2),hdirty%gil%minloc(3))
  hdirty%gil%rmax = rma
  hdirty%gil%rmin = rmi
  !  !
  ! Delete scratch space
  error = .false.
  if (allocated(tfgrid)) deallocate(tfgrid)
  if (allocated(ftbeam)) deallocate(ftbeam)
  if (allocated(w_xgrid)) deallocate(w_xgrid)
  if (allocated(w_ygrid)) deallocate(w_ygrid)
  return
  !
101 format(a,i6,a)
102 format(a,f9.2)
103 format(a,i5,' to ',i5,a,f9.2,a,i2,a,i2)
end subroutine one_beam_para
!
subroutine one_beam_serial (rname,map,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,uvdata,   &
     &    w_mapu, w_mapv, w_grid, w_weight, w_v, do_weig,    &
     &    wcol,mcol,wfft,sblock,cpu0,error,uvmax)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>one_beam_serial
  use clean_def
  use image_def
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Compute a map from a CLIC UV Sorted Table
  !   by Gridding and Fast Fourier Transform, with
  !   one single beam for all channels.
  !
  ! Input :
  ! a precessed UV table, sorted in V, ordered in
  ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  ! Output :
  ! a beam image
  ! a VLM cube
  ! Work space :
  ! a  VLM complex Fourier cube (first V value is for beam)
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: rname   ! Calling Task name
  type (uvmap_par), intent(inout) :: map  ! Mapping parameters
  type (gildas), intent(inout) :: huv     ! UV data set
  type (gildas), intent(inout) :: hbeam   ! Dirty beam data set
  type (gildas), intent(inout) :: hdirty  ! Dirty image data set
  integer, intent(in) :: nx   ! X size
  integer, intent(in) :: ny   ! Y size
  integer, intent(in) :: nu   ! Size of a visibilities
  integer, intent(in) :: nv   ! Number of visibilities
  real, intent(inout) :: uvdata(nu,nv)
  real, intent(inout) :: w_mapu(nx)      ! U grid coordinates
  real, intent(inout) :: w_mapv(ny)      ! V grid coordinates
  real, intent(inout) :: w_grid(nx,ny)   ! Gridding space
  real, intent(inout) :: w_weight(nv)    ! Weight of visibilities
  real, intent(inout) :: w_v(nv)         ! V values
  logical, intent(inout) :: do_weig
  !
  real, intent(inout) :: wfft(*)     ! Work space
  real, intent(inout) :: cpu0        ! CPU
  real, intent(inout) :: uvmax       ! Maximum baseline
  integer, intent(inout) :: sblock   ! Blocking factor
  integer, intent(inout) :: wcol     ! Weight channel
  integer, intent(inout) :: mcol(2)  ! First and last channel
  logical, intent(inout) :: error
  ! Global variables:
  !
  real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
  !
  real ubias,vbias,ubuff(4096),vbuff(4096)
  common /conv/ ubias,vbias,ubuff,vbuff ! To be saved
  !
  integer :: nc   ! Number of channels
  integer :: nd   ! Size of data
  integer ier
  real(kind=8) freq
  integer ctypx,ctypy
  integer icol,lcol,fcol,imi,ima,iv
  real rmi,rma,wall,cpu1
  real xparm(10),yparm(10)
  real vref,voff,vinc
  real(kind=4) :: loff,boff
  integer ndim, nn(2), i, lx, ly
  integer istart,iblock,nblock,kz,iz,kkz
  integer blc(4),trc(4)
  character(len=message_length) :: chain
  !
  real rms, null_taper(4)
  complex, allocatable :: ftbeam(:,:)
  complex, allocatable :: tfgrid(:,:,:)
  real, allocatable :: w_xgrid(:),w_ygrid(:), w_w(:)
  integer(kind=8) :: ilong
  !
  integer ithread
  real :: local_wfft(2*max(nx,ny))
  !
  data blc/4*0/, trc/4*0/
  !------------------------------------------------------------------------
  !
  ! Code:
  nd = nx*ny
  nc = huv%gil%nchan
  !
  ! Reset the parameters
  xparm = 0.0
  yparm = 0.0
  !
  vref = huv%gil%ref(1)
  voff = huv%gil%voff
  vinc = huv%gil%vres
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nc))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nc
  else
    mcol(2) = max(1,min(mcol(2),nc))
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  if (wcol.eq.0) then
    wcol = (fcol+lcol)/3
  endif
  wcol = max(1,wcol)
  wcol = min(wcol,nc)
  nc = lcol-fcol+1
  !
  ! Compute observing sky frequency for U,V cell size
  freq = gdf_uv_frequency(huv, 0.5d0*dble(lcol+fcol) )
  !
  ! Compute gridding function
  ctypx = map%ctype
  ctypy = map%ctype
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, ubuff, ubias)
  call convfn (ctypy, yparm, vbuff, vbias)
  map%uvcell = clight/freq/(map%xycell*map%size)
  map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
  map%support(2) = yparm(1)*map%uvcell(2)
  !
  ! Load V values and original Weights
  icol = 3*wcol + 7
  allocate(w_w(nv),stat=ier)
  call dovisi (nu,nv,uvdata,w_v,w_w,icol)
  !
  ! Compute weights
  !
  if (do_weig) then
    call doweig (nu,nv,   &
       &    uvdata,   &          ! Visibilities
       &    1,2,   &             ! U, V pointers
       &    wcol,   &            ! Weight channel
       &    map%uniform(1),   &  ! Uniform UV cell size
       &    w_weight,   &        ! Weight array
       &    map%uniform(2),   &  ! Fraction of weight
       &    w_v,              &  ! V values
       &    error)
    if (error)  return
    !
    ! Should also plug the TAPER here, rather than in DOFFT later  !
    call dotape (nu,nv,   &
       &    uvdata,   &          ! Visibilities
       &    1,2,   &             ! U, V pointers
       &    map%taper,  &        ! Taper
       &    w_weight)            ! Weight array
    do_weig = .false.
  else
    call map_message(seve%i,rname,'Reusing weights')
  endif
  null_taper = 0
  ! For test
  !  else
  !    null_taper = map%taper
  !  endif
  !
  call gag_cpu(cpu1)
  write(chain,102) 'Finished weighting CPU ',cpu1-cpu0
  call map_message(seve%i,rname,chain)
  !
  wall = 0
  do iv=1,nv
    if (w_w(iv).gt.0) then
       wall = wall + w_w(iv)
    endif
  enddo
  if (wall.eq.0.0) then
    write(chain,101) 'Plane ',wcol,' has Zero weight'
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  else
    !
    ! Noise definition
    wall = 1e-3/sqrt(wall)
    call prnoise(rname,'Natural',wall,rms)
    !
    ! Re-normalize the weights and re-count the noise
    call scawei (nv,w_weight,w_w,wall)
    wall = 1e-3/sqrt(wall)
    call prnoise(rname,'Expected',wall,rms)
  endif
  deallocate(w_w)
  !
  lx = (uvmax+map%support(1))/map%uvcell(1) + 2
  ly = (uvmax+map%support(2))/map%uvcell(2) + 2
  lx = 2*lx
  ly = 2*ly
  if (ly.gt.ny) then
    write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
        &      ' Undersampling ratio ',float(ly)/float(ny)
    call map_message(seve%e,rname,chain)
    ly = min(ly,ny)
    lx = min(lx,nx)
  endif
  call docoor (lx,-map%uvcell(1),w_mapu)
  call docoor (ly,map%uvcell(2),w_mapv)
  !
  ! Optimize SBLOCK now, allowing some additional memory if NBLOCK small
  if (sblock.gt.0) then
    nblock = (nc+sblock-1)/sblock
    kz = mod(nc,sblock)
    if (kz.ne.0 .and. kz.lt.(sblock/(nblock+1))) then
      if (nblock.ne.1) nblock = nblock-1
    endif
    sblock = (nc+nblock-1)/nblock
    kz = min(sblock,nc)
  else
    kz = nc
    nblock = 1
  endif
  !
  ! Get FFT's work space
  write(chain,101) 'Using a blocking factor of ',sblock,' planes'
  call map_message(seve%i,rname,chain)
  allocate (tfgrid(kz+1,lx,ly),ftbeam(nx,ny),stat=ier)
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt_plan(ftbeam,nn,ndim,-1,1)
  !
  ! Compute FFT's
  call dofft (nu,nv,   &       ! Size of visibility array
       &    uvdata,   &          ! Visibilities
       &    1,2,   &             ! U, V pointers
       &    fcol,   &            ! First channel to map
       &    kz,lx,ly,   &        ! Cube size
       &    tfgrid,   &          ! FFT cube
       &    w_mapu,w_mapv,   &   ! U and V grid coordinates
       &    map%support,map%uvcell,null_taper,   &    ! Gridding parameters
       &    w_weight,w_v,   &    ! Weight array + V Visibilities
       &    ubias,vbias,ubuff,vbuff,map%ctype)
  call gag_cpu(cpu1)
  write(chain,102) 'Finished gridding CPU ',cpu1-cpu0
  call map_message(seve%i,rname,chain)
  !
  ! Make beam, not normalized
  call gdf_copy_header(huv,hbeam,error)
  hbeam%gil%dopp = 0    ! Nullify the Doppler factor
  !
  hbeam%gil%ndim = 2
  hbeam%gil%dim(1) = nx
  hbeam%gil%dim(2) = ny
  hbeam%gil%dim(3) = 1
  hbeam%gil%dim(4) = 1
  hbeam%gil%convert(1,1) = nx/2+1
  hbeam%gil%convert(1,2) = ny/2+1
  hbeam%gil%convert(2,1) = 0
  hbeam%gil%convert(2,2) = 0
  hbeam%gil%convert(3,1) = -map%xycell(1)  ! Assume EQUATORIAL system
  hbeam%gil%convert(3,2) = map%xycell(2)
  hbeam%gil%proj_words = 0
  hbeam%gil%extr_words = 0
  hbeam%gil%reso_words = 0
  hbeam%gil%uvda_words = 0
  hbeam%gil%type_gdf = code_gdf_image
  !
  hbeam%char%code(1) = 'ANGLE'
  hbeam%char%code(2) = 'ANGLE'
  hbeam%gil%majo = 0.0
  hbeam%loca%size = nx*ny
  hbeam%char%type = 'GILDAS_IMAGE'
  call map_message(seve%i,rname,'Creating beam ')
  !
  call extracs(kz+1,nx,ny,kz+1,tfgrid,ftbeam,lx,ly)
  !
  ! For debugging
  !      call sic_descriptor('ffta',desc,found)
  !      if (found) then
  !         jpd = pointer(desc%addr,memory)
  !         call r4tor4 (memory(ipf),memory(jpd),2*nx*ny)
  !      endif
  !
  call fourt  (ftbeam,nn,ndim,-1,1,wfft)
  call cmtore (ftbeam,hbeam%r3d(:,:,1),nx,ny)
  !
  ! Compute grid correction,
  ! Normalization factor is applied to grid correction, for further
  ! use on channel maps.
  !
  allocate(w_xgrid(nx),w_ygrid(ny),stat=ier)
  call grdtab (ny, vbuff, vbias, w_ygrid)
  call grdtab (nx, ubuff, ubias, w_xgrid)
  call dogrid (w_grid,w_xgrid,w_ygrid,nx,ny,   &
       &    hbeam%r3d(:,:,1))
  !
  ! Normalize and Free beam
  call docorr (hbeam%r3d(:,:,1),w_grid,nd)
  rma = -1e38
  rmi = 1e38
  call domima (hbeam%r3d(:,:,1),rmi,rma,imi,ima,nd)
  hbeam%gil%extr_words = def_extr_words          ! extrema computed
  hbeam%gil%rmax = rma
  hbeam%gil%rmin = rmi
  ilong = imi
  call gdf_index_to_where (ilong,hbeam%gil%ndim,hbeam%gil%dim,hbeam%gil%minloc)
  ilong = ima
  call gdf_index_to_where (ilong,hbeam%gil%ndim,hbeam%gil%dim,hbeam%gil%maxloc)
  !
  ! For debugging
  !      call sic_descriptor('fftb',desc,found)
  !      if (found) then
  !         jpd = pointer(desc%addr,memory)
  !         call r4toc4 (memory(ipy),memory(jpd),nx*ny)
  !         call fourt (memory(jpd),nn,ndim,1,0,wfft)
  !      endif
  !
  call gag_cpu(cpu1)
  write(chain,102) 'Finished beam CPU ',cpu1-cpu0
  call map_message(seve%i,rname,chain)
  !
  ! Create image (in order l m v )
  call map_message(seve%i,rname,'Creating map file ')
  call gdf_copy_header(hbeam,hdirty,error)
  hdirty%gil%ndim = 3
  hdirty%gil%dim(1) = nx
  hdirty%gil%dim(2) = ny
  hdirty%gil%dim(3) = nc
  hdirty%gil%dim(4) = 1
  hdirty%gil%convert(1,3) = vref-fcol+1
  hdirty%gil%convert(2,3) = voff
  hdirty%gil%convert(3,3) = vinc
  hdirty%gil%proj_words = def_proj_words
  hdirty%gil%uvda_words = 0
  hdirty%gil%type_gdf = code_gdf_image
  hdirty%char%code(1) = 'RA'
  hdirty%char%code(2) = 'DEC'
  hdirty%char%code(3) = 'VELOCITY'
  call equ_to_gal(hdirty%gil%ra,hdirty%gil%dec,0.0,0.0,   &
                  hdirty%gil%epoc,hdirty%gil%lii,hdirty%gil%bii,loff,boff,error)
  if (huv%gil%ptyp.eq.p_none) then
    hdirty%gil%ptyp = p_azimuthal  ! Azimuthal (Sin)
    hdirty%gil%pang = 0.d0     ! Defined in table.
    hdirty%gil%a0 = hdirty%gil%ra
    hdirty%gil%d0 = hdirty%gil%dec
  else
    hdirty%gil%ptyp = p_azimuthal
    hdirty%gil%pang = huv%gil%pang ! Defined in table.
    hdirty%gil%a0 = huv%gil%a0
    hdirty%gil%d0 = huv%gil%d0
  endif
  hdirty%char%syst = 'EQUATORIAL'
  hdirty%gil%xaxi = 1
  hdirty%gil%yaxi = 2
  hdirty%gil%faxi = 3
  hdirty%gil%extr_words = 0          ! extrema not computed
  hdirty%gil%reso_words = 0          ! no beam defined
  hdirty%gil%nois_words = 2
  hdirty%gil%majo = 0
  hdirty%gil%noise = wall
  hdirty%char%unit = 'Jy/beam'
  hdirty%char%type = 'GILDAS_IMAGE'
  hdirty%loca%size = nx*ny*nc
  !
  !
  ! Make maps with grid correction
  rmi = 1e38
  rma = -1e38
  blc(3) = 1
  trc(3) = kz
  iz = 0
  !
  do i=1,kz
     iz = i
     call extracs(kz+1,nx,ny,i,tfgrid,ftbeam,lx,ly)
     call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
     call cmtore (ftbeam,hdirty%r3d(:,:,iz),nx,ny)
     call docorr (hdirty%r3d(:,:,iz),w_grid,nd)
  enddo
  call gag_cpu(cpu1)
  write(chain,103) 'Finished planes ',blc(3),trc(3),' CPU ',cpu1-cpu0
  call map_message(seve%i,rname,chain)
  !
  ! Proceed with further planes
  if (kz.lt.nc) then
     kkz = kz
     do iblock = 2,nblock
        istart = fcol+(iblock-1)*sblock
        blc(3) = blc(3)+kz
        kz = min (sblock,nc-sblock*(iblock-1))
        trc(3) = blc(3)-1+kz
        call dofft (nu,nv,   &   ! Size of visibility array
             &        uvdata,   &      ! Visibilities
             &        1,2,   &         ! U, V pointers
             &        istart,   &      ! First channel to map
             &        kz,lx,ly,   &    ! Cube size
             &        tfgrid,   &      ! FFT cube
             &        w_mapu,w_mapv,   &   ! U and V grid coordinates
             &        map%support,map%uvcell,null_taper,   &    ! Gridding parameters
             &        w_weight,w_v,   &    ! Weight array
             &        ubias,vbias,ubuff,vbuff,map%ctype)
        do i=1,kz
           iz = i+(iblock-1)*kkz
           call extracs(kz+1,nx,ny,i,tfgrid,ftbeam,lx,ly)
           call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
           call cmtore (ftbeam,hdirty%r3d(:,:,iz),nx,ny)
           call docorr (hdirty%r3d(:,:,iz),w_grid,nd)
        enddo
        call gag_cpu(cpu1)
        write(chain,103) 'Finished planes ',blc(3),trc(3),   &
             &        ' CPU ',cpu1-cpu0
        call map_message(seve%i,rname,chain)
     enddo
  endif
  call gag_cpu(cpu1)
  write(chain,102) 'Finished maps ',cpu1-cpu0
  call map_message(seve%i,rname,chain)
  !
  hdirty%gil%extr_words = def_extr_words  ! extrema computed
  hdirty%gil%minloc = 1
  hdirty%gil%maxloc = 1
  hdirty%gil%minloc(1:3) = minloc(hdirty%r3d)
  hdirty%gil%maxloc(1:3) = maxloc(hdirty%r3d)
  rma = hdirty%r3d(hdirty%gil%maxloc(1),hdirty%gil%maxloc(2),hdirty%gil%maxloc(3))
  rmi = hdirty%r3d(hdirty%gil%minloc(1),hdirty%gil%minloc(2),hdirty%gil%minloc(3))
  hdirty%gil%rmax = rma
  hdirty%gil%rmin = rmi
  !  !
  ! Delete scratch space
  error = .false.
  if (allocated(tfgrid)) deallocate(tfgrid)
  if (allocated(ftbeam)) deallocate(ftbeam)
  if (allocated(w_xgrid)) deallocate(w_xgrid)
  if (allocated(w_ygrid)) deallocate(w_ygrid)
  return
  !
101 format(a,i6,a)
102 format(a,f9.2)
103 format(a,i5,' to ',i5,a,f9.2)
end subroutine one_beam_serial
!

subroutine flux_comm(line,error)
  use image_def
  use gkernel_types
  use gkernel_interfaces
  use clean_arrays
  use moment_arrays
  use clean_support
  use gbl_message
  use imager_interfaces, except_this => flux_comm
  !---------------------------------------------------------------------
  ! @ private
  ! IMAGER
  !   Support for command
  !       FLUX CURSOR|MASK|SUPPORT [/CCT] 
  ! Compute the Flux in the specified region(s)
  !
  ! The output should be a SIC Structure named FLUX
  !   FLUX%NF   The number of fields
  !   FLUX%NC   The number of channels
  !   FLUX%VELOCITIES     The channel velocities
  !   FLUX%FREQUENCIES     The channel frequencies
  !   FLUX%VALUES[Flux%Nc,Flux%Nf]   The spectra for every field
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  real(8), parameter :: pi=3.141592653589793d0
  integer, parameter :: o_cct=1 ! /CCT option
  real, parameter :: large=3
  character(len=*), parameter :: varflux='FLUX'
  character(len=*), parameter :: rname='FLUX'
  !
  character(len=12) :: key, argum
  integer, parameter :: mvoc=3
  character(len=12) :: vocab(mvoc)
  integer :: ikey
  data vocab/'CURSOR','MASK','SUPPORT'/
  !
  real :: flux, beam_area
  character(len=80) :: chain
  real :: bval, eval
  ! For polygon support
  character(len=12) :: file
  integer :: n
  logical :: fromfile=.false.
  type (polygon_t), save, target :: polflux
  real(kind=4) :: sum,aire,mean,sigma,prev_sigma,minmax(2)
  real(kind=4) :: nsig_clip
  real(kind=4) :: range,center
  logical :: clip,quiet
  ! For Mask support
  real :: threshold, scale
  real, allocatable :: fmask(:,:), gmask(:,:)
  integer :: ier
  integer :: nfields, if, kf
  integer(kind=index_length) :: nx,ny
  integer, allocatable :: npix(:)
  real, allocatable :: sums(:)
  real :: pixel_area
  ! Test type of Display
  integer, parameter :: mcase=4
  integer :: icase,jcase
  character(len=24) :: dircase(mcase)  
  character(len=12) :: showcas(mcase)
  data dircase /'<GREG<AREA','<GREG<P1-1','<GREG<XY','<GREG<M_AREA'/
  data showcas /'VIEW','SHOW','INSPECT','MOMENTS'/
  logical :: active
  integer :: win_num
  !
  integer :: ic
  integer(kind=index_length) :: dim(2)
  real, pointer :: aplane(:,:)
  !
  logical :: do_insert
  !
  if (sic_present(o_cct,0)) then
    call map_message(seve%e,rname,'/CCT option not yet implemented')
    error = .true.
    return
  endif
  !
  do_insert = sic_lire().eq.0
  !
  file = ' '
  argum = ' ' ! 'SUPPORT' or 'CURSOR' as a default ?
  call sic_ke(line,0,1,argum,n,.true.,error)
  call sic_ambigs (rname,argum,key,ikey,vocab,mvoc,error)
  if (error) return
  !
  ! Erase any previous FLUX structure
  if (flux_nf.ne.0 .and. flux_nc.ne.0) then
    call sic_delvariable('FLUX',.false.,error)  ! not User
    if (allocated(flux_velo)) deallocate(flux_velo,flux_freq)
    if (allocated(flux_values)) deallocate(flux_values)
    flux_nf = 0
    flux_nc = 0
  endif
  !
  flux_nc = max(1,hclean%gil%dim(3))   ! Number of channels
  flux_nf = 1                          ! 1 field by default
  allocate(flux_velo(flux_nc),flux_freq(flux_nc),stat=ier)
  do ic = 1,flux_nc
    flux_velo(ic) = (ic-hclean%gil%ref(3))*hclean%gil%vres + hclean%gil%voff
    flux_freq(ic) = (ic-hclean%gil%ref(3))*hclean%gil%fres + hclean%gil%freq
  enddo
  !
  ! Beam area
  beam_area = pi*hclean%gil%majo*hclean%gil%mino/(4.*log(2.))
  ! Pixel area
  pixel_area = abs(hclean%gil%inc(1)*hclean%gil%inc(2))
  ! Blanking values
  bval = hclean%gil%bval
  eval = hclean%gil%eval
  !
  if (key.eq.'CURSOR') then
    ! Call cursor to define - This only makes sense if a single
    ! image plane is defined, or if we are in a "Map" display
    ! That can be tested by the names of the sub-directories
    ! <GREG<AREA  (for VIEW command)
    ! <GREG<P1-1  (for SHOW command)
    ! <GREG<XY    (for INSPECT command)
    ! <GREG<M_AREA for SHOW MOMENTS  (or SHOW COMPOSITE)
    !
    jcase = 0
    do icase=1,mcase
      if (gtexist(dircase(icase))) then
        call gr_execl('CHANGE DIREC '//dircase(icase))
        call relocate(0.d0,0.d0)  ! call_exec1('DRAW RELO 0 0 /USER')
        jcase = icase
        exit
      endif
    enddo
    if (jcase.eq.0) then
      call map_message(seve%e,rname,'No image plane panel available for cursor')
      error = .true.
      return
    else
      call map_message(seve%i,rname,'Defining support from a '//trim(showcas(jcase))//' display')
    endif
    !
    ! and calling the proper routine:
    call greg_poly_define(rname,file,fromfile,polflux,varflux,error)
    if (error)  return
    !
    ! Return back to <GREG
    call gr_execl('CHANGE DIREC <GREG')
    !
    ! Compute moments over polygon for each channel
    allocate(sums(flux_nf),npix(flux_nf),flux_values(flux_nc,flux_nf),stat=ier) 
    do ic=1,flux_nc
      aplane => dclean(:,:,ic)
      center = 0
      range =  0
      call my_moments(aplane,hclean,polflux,.false.,center,range,& 
        & sums(1),aire,npix(1),mean,sigma,minmax)
      !
      ! Convert to Flux
      !
      ! The formula for the Flux depends on the relative size of the beams 
      ! and covered area (aire).
      !
      ! This below assumes that the Area is sufficiently larger than the Beam
      !     flux = sum / beam_area         !
      ! But the minimum significant area is one beam. Since "sum = mean * aire",
      ! we should use "mean" instead of "sum / beam_area" if aire < beam_area.
      ! So the appropriate formula is 
      !     flux = mean * max(aire/beam_area,1.0)
      !
      ! The formula above is not strictly correct, as we should take the 
      ! value towards the centroid when the area is smaller than about
      ! a beam. However the values will not change much across the support
      ! in this case, as the pixels are correlated across one beam, so 
      ! it is a (very) reasonable approximation  in most cases.
      !
      ! It would fail if the support was made of disconnected pixels 
      ! separated by more than one beamwidth.
      !
      ! Put in place
      flux_values(ic,1) = mean * max(aire/beam_area,1.0)
    enddo
  else if (key.eq.'SUPPORT') then
    if (supportpol%ngon.lt.3) then
      call map_message(seve%e,rname,'SUPPORT is not yet defined')
      error = .true.
      return
    endif
    ! Compute moments over polygon for each channel
    allocate(sums(flux_nf),npix(flux_nf),flux_values(flux_nc,flux_nf),stat=ier) 
    ! Compute moments over polygon
    do ic=1,flux_nc
      aplane => dclean(:,:,ic)
      call my_moments(aplane,hclean,supportpol,.false.,center,range, &
        & sums(1),aire,npix(1),mean,sigma,minmax)
      ! Convert to flux, see above for description
      flux_values(ic,1) = mean * max(aire/beam_area,1.0)
    enddo
  else if (key.eq.'MASK') then
    if (hmask%loca%size.eq.0) then
      call map_message(seve%e,rname,'MASK is not yet defined')
      error = .true.
      return
    endif
    nx = hmask%gil%dim(1)
    ny = hmask%gil%dim(2)
    threshold = 0.1
    allocate(fmask(nx,ny),gmask(nx,ny),stat=ier)
    if (hmask%gil%dim(3).gt.1) then
      call map_message(seve%i,rname,'Collapsing Mask planes')
      do ic=1,hmask%gil%dim(3)
        gmask(:,:) = gmask(:,:)+dmask(:,:,ic)
      enddo
    else
      gmask(:,:) = dmask(:,:,1)
    endif
    where (gmask.ne.0) gmask=1.0
    !
    ! The mask is now a 0/1 valued image
    ! We convert it to a 0 - N valued image,
    ! where the N is the number of isolated regions
    call label_field(gmask,nx,ny,fmask,nfields,threshold,  &
      & 0.0,-1.0,error)
    dmask(:,:,1) = fmask     ! Copy back for tests
    hmask%gil%rmax = nfields
    flux_nf = max(1,nfields)
    !
    allocate(sums(flux_nf),npix(flux_nf),flux_values(flux_nc,flux_nf),stat=ier) 
    flux_values = 0
    !
    do ic=1,flux_nc
      aplane => dclean(:,:,ic)
      call label_stat(nx,ny,fmask,aplane,nfields,npix,sums,bval,eval)
      !
      ! Put in place
      do if=1,nfields
        if (npix(if).ne.0) then
          ! Convert to Flux - pixel area was not yet included there
          scale = max(pixel_area/beam_area,1.0/npix(if))
          flux_values(ic,if) = sums(if)*scale
        endif
      enddo
    enddo
    !
  else
    Print *,'Not yet coded for '//key
    error = .true.
  endif
  if (error) return
  !
  ! Define resulting structure
  call sic_defstructure('FLUX',.true.,error)
  dim(1) = flux_nc
  dim(2) = flux_nf
  call sic_def_real('FLUX%VALUES',flux_values,2,dim,.false.,error) 
  call sic_def_real('FLUX%VELOCITIES',flux_velo,1,dim,.false.,error) 
  call sic_def_dble('FLUX%FREQUENCIES',flux_freq,1,dim,.false.,error) 
  call sic_def_inte('FLUX%NF',flux_nf,0,dim,.false.,error) 
  call sic_def_inte('FLUX%NC',flux_nc,0,dim,.false.,error) 
  !
  if (do_insert) call sic_insert_log(line)
  if (flux_nc.ne.1) return
  !
  kf = 1
  do if=1,flux_nf
    if (nfields.gt.1) then
      write(chain,'(A,I0)') 'Zone number ',if      
      kf = 21
    endif
    flux = sums(if)
    ! Printout
    if (flux.lt.0.03) then
      if (flux.gt.0.001) then
        write(chain(kf:),'(A,F6.1,A)') "Total Flux ", flux*1000., " mJy"
      else
        write(chain(kf:),'(A,I4,A)')  "Total Flux ", nint(flux*1e6), "   microJy"
      endif
    else if (flux.lt.0.2) then
      write(chain(kf:),'(A,I4,A)')  "Total Flux ", nint(flux*1e3), "   mJy"
    else
      write(chain(kf:),'(A,F6.1,A)')  "Total Flux ", flux, "Jy"
    endif
    call map_message(seve%i,rname,chain)
  enddo
end subroutine flux_comm
!
subroutine label_field(imagein,ncolumns,nlines,labelout,nfields,threshold,  &
  blank,eblank,error)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !
  ! Modifie S.Guilloteau LAB 20 Janv 2013
  !    Order the field numbers by number of pixels
  ! Modifie S.Guilloteau
  !   Groupe d Astrophysique de Grenoble 22 Octobre 1985
  ! Valeurs non definies et declaration LabelOut en reel
  !
  ! Origine : A.Bijaoui 25 octobre 1984 Observatoire de Nice
  ! Saidi1 Permet l'etiquettage des domaines a partir d'une
  ! segmentation avec seuil de flux
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)    :: ncolumns                   ! Number of "Columns"
  integer(kind=index_length), intent(in)    :: nlines                     ! Number of "lines"
  real(kind=4),               intent(in)    :: imagein(ncolumns,nlines)   ! Input image
  real(kind=4),               intent(out)   :: labelout(ncolumns,nlines)  ! Labels of fields
  integer(kind=4),            intent(out)   :: nfields                    ! Number of fields
  real(kind=4),               intent(in)    :: threshold                  ! Threshold
  real(kind=4),               intent(in)    :: blank                      ! Blanking
  real(kind=4),               intent(in)    :: eblank                     ! and tolerance
  logical,                    intent(inout) :: error                      ! Logical error flag
  ! Local
  integer(kind=index_length) :: iline,icolumn
  integer(kind=4) :: l1,l2,la1,la2,la,ier
  integer(kind=4), allocatable :: buf1(:),buf2(:)
  integer(kind=4) :: mfields,nfieldsi,ifield,jfield
  !
  ! Allocate working buffers
  mfields = nlines*ncolumns  ! Maximum number of fields in image
  allocate(buf1(mfields),buf2(mfields),stat=ier)
  if (failed_allocate('FIELD_FIND','buffers',ier,error))  return
  !
  nfieldsi=0
  do iline=1,nlines
    do icolumn=1,ncolumns
      if (imagein(icolumn,iline).lt.threshold) then
        labelout(icolumn,iline)=0.0
      elseif (abs(imagein(icolumn,iline)-blank).le.eblank) then    !SG
        labelout(icolumn,iline)=0.0    !SG
      else
        labelout (icolumn,iline) = 0.0
        if (icolumn.ne.1) then
          l1=labelout(icolumn-1,iline)
          if (l1.ne.0) labelout(icolumn,iline)=l1
        endif
        if (iline.ne.1) then
          l2=labelout(icolumn,iline-1)
          if (l1.eq.0) then
            if (l2.eq.0) then
              nfieldsi=nfieldsi+1
              buf1(nfieldsi)=nfieldsi
              labelout(icolumn,iline)=nfieldsi
            else
              labelout(icolumn,iline)=l2
            endif
          else
            if (l2.ne.0) then
              if (l2.ne.l1) then
                call descen(buf1,l1,la1)
                call descen(buf1,l2,la2)
                la=min0(la1,la2)
                buf1(la1)=la
                buf1(la2)=la
                labelout(icolumn,iline)=la
              endif
            endif
          endif
        endif
      endif
    enddo
  enddo
  !
  nfields=0
  do ifield=1,nfieldsi
    call descen(buf1,ifield,jfield)
    if (ifield.eq.jfield) then
      nfields=nfields+1
      buf2(ifield)=nfields
    endif
  enddo
  do iline=1,nlines
    do icolumn=1,ncolumns
      l1 = labelout(icolumn,iline)
      if (l1.ne.0) then
        call descen(buf1,l1,la1)
        labelout(icolumn,iline)=buf2(la1)
      endif
    enddo
  enddo
  !
  ! Sort the final labels by descending number of pixels...
  buf1(:) = 0  ! buf1 is now used as the number of pixels per field
  do iline=1,nlines
    do icolumn=1,ncolumns
      if (labelout(icolumn,iline).ne.0) then
        ifield = labelout(icolumn,iline)
        buf1(ifield) = buf1(ifield)-1
      endif
    enddo
  enddo
  !
  ! Compute the sorting array
  do iline=1,nfields
    buf2(iline) = iline  ! buf2 is now used as the sorting array
  enddo
  call gi4_trie(buf1,buf2,nfields,error)
  ! Compute back sorting array
  do iline=1,nfields
    buf1(buf2(iline)) = iline  ! buf1 is now used as the back sorting srray
  enddo
  !
  do iline=1,nlines
    do icolumn=1,ncolumns
      if (labelout(icolumn,iline).ne.0) then
        ifield = labelout(icolumn,iline)
        labelout(icolumn,iline) = buf1(ifield)
      endif
    enddo
  enddo
  !
  deallocate(buf1,buf2)
  !
contains
  !
  subroutine descen(label,labin,labout)
    integer(kind=4), intent(inout) :: label(*)
    integer(kind=4), intent(in)    :: labin
    integer(kind=4), intent(out)   :: labout
    ! Local
    integer(kind=4) :: lab
    !
    labout = labin
    do
      lab = label(labout)
      if (lab.eq.labout) return
      labout = lab
    enddo
  end subroutine descen
  !
end subroutine label_field
!
subroutine label_stat(nx,ny,label,data,nf,npix,sums,bval,eval)
  use gildas_def
  !---------------------------------------------------------------------
  !   @ private
  ! IMAGER
  !     Compute statistics from an image and an associated
  !   label fields.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nx  ! Number of pixels in X
  integer(kind=index_length), intent(in) :: ny  ! Number of pixels in Y
  real, intent(in) :: label(nx,ny)              ! Label array
  real, intent(in) :: data(nx,ny)               ! Data array
  integer, intent(in) :: nf                     ! Number of fields
  integer, intent(out) :: npix(nf)              ! Number of pixels per field
  real, intent(out) :: sums(nf)                 ! Sum per field
  real, intent(in) :: bval, eval                ! Blanking values
  !
  integer :: i,j
  integer :: ilab
  real :: value
  !
  npix = 0
  sums = 0.
  !
  do j = 1,ny
    do i = 1,nx
      ilab = label(i,j)
      if (ilab.ne.0) then
        value = data(i,j) 
        if (abs(value-bval).gt.eval) then
          npix(ilab) = npix(ilab)+1
          sums(ilab) = sums(ilab)+value
        endif
      endif
    enddo
  enddo
end subroutine label_stat
!
subroutine my_moments(z,head,poly,clip,center,range, &
  sum,aire,npix,mean,sigma,minmax)
  use phys_const
  use image_def
  use greg_types
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! IMAGER
  !   Compute statistics about a 2-D array within a N-gon
  ! Derived from gr8_moments, but using image header instead
  ! of regular grid description
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: z(:,:)     ! Data array
  type(gildas),    intent(in)  :: head       ! Data Header
  type(polygon_t), intent(in)  :: poly       ! Current polygon
  logical,         intent(in)  :: clip       ! Clip out of range values
  real(kind=4),    intent(in)  :: center     ! Center of accepted interval
  real(kind=4),    intent(in)  :: range      ! Half width of accepted interval
  real(kind=4),    intent(out) :: sum        ! Integrated map value
  real(kind=4),    intent(out) :: aire       ! Area of polygon
  integer(kind=4), intent(out) :: npix       ! Number of interior pixels
  real(kind=4),    intent(out) :: mean       ! Mean map value
  real(kind=4),    intent(out) :: sigma      ! RMS value
  real(kind=4),    intent(out) :: minmax(2)  ! Min and max values
  ! Local
  real(kind=8)    :: x,y,s1,s2,value
  integer(kind=4) :: i,j,s0,imin,imax,jmin,jmax
  real(kind=4)    :: b          ! Blanking value
  real(kind=4)    :: eb         ! Tolerance on blanking
  !
  b = head%gil%bval
  eb = head%gil%eval
  !
  s0 = 0
  s1 = 0.
  s2 = 0.
  sigma = 0.
  mean = 0.
  !
  ! Avoid exploring all the Map by finding IMIN,IMAX,JMIN,JMAX
  if (head%gil%inc(1).gt.0.) then
    imin = max (1,    int((poly%xgon1-head%gil%val(1))/head%gil%inc(1)+head%gil%ref(1)) )
    imax = min (head%gil%dim(1),int((poly%xgon2-head%gil%val(1))/head%gil%inc(1)+head%gil%ref(1))+1 )
  else
    imin = max (1,    int((poly%xgon2-head%gil%val(1))/head%gil%inc(1)+head%gil%ref(1)) )
    imax = min (head%gil%dim(1),int((poly%xgon1-head%gil%val(1))/head%gil%inc(1)+head%gil%ref(1))+1 )
  endif
  if (head%gil%inc(2).gt.0.) then
    jmin = max (1,    int((poly%ygon1-head%gil%val(2))/head%gil%inc(2)+head%gil%ref(2)) )
    jmax = min (head%gil%dim(2),int((poly%ygon2-head%gil%val(2))/head%gil%inc(2)+head%gil%ref(2))+1 )
  else
    jmin = max (1,    int((poly%ygon2-head%gil%val(2))/head%gil%inc(2)+head%gil%ref(2)) )
    jmax = min (head%gil%dim(2),int((poly%ygon1-head%gil%val(2))/head%gil%inc(2)+head%gil%ref(2))+1 )
  endif
  !
  ! Now explore a reasonable part of the map
  if (eb.lt.0.0) then
    ! Blanking is disabled
    minmax(:) = z(imin,jmin)  ! First value is valid
    do j=jmin,jmax
      do i=imin,imax
        value = z(i,j) 
        if (.not.clip.or.abs(value-center).le.range) then
          x = (i-head%gil%ref(1))*head%gil%inc(1)+head%gil%val(1)
          y = (j-head%gil%ref(2))*head%gil%inc(2)+head%gil%val(2)
          if (greg_poly_inside(x,y,poly)) then
            s0 = s0 + 1
            s1 = s1 + value
            s2 = s2 + value**2
            if (minmax(1).gt.value)  minmax(1) = value  ! Min
            if (minmax(2).lt.value)  minmax(2) = value  ! Max
          endif
        endif
      enddo
    enddo
  else
    ! Blanking is enabled
    minmax(:) = b  ! First valid value is not known
    do j=jmin,jmax
      do i=imin,imax
        value = z(imin,jmin) 
        if (.not.clip.or.abs(value-center).le.range) then
          if (abs(value-b).gt.eb) then
            x = (i-head%gil%ref(1))*head%gil%inc(1)+head%gil%val(1)
            y = (j-head%gil%ref(2))*head%gil%inc(2)+head%gil%val(2)
            if (greg_poly_inside(x,y,poly)) then
              s0 = s0 + 1
              s1 = s1 + value
              s2 = s2 + value**2
              if (minmax(1).eq.b) then
                minmax(1) = value
              elseif (minmax(1).gt.value) then
                minmax(1) = value  ! Min
              endif
              if (minmax(2).eq.b) then
                minmax(2) = value
              elseif (minmax(2).lt.value) then
                minmax(2) = value  ! Max
              endif
            endif
          endif
        endif
      enddo
    enddo
  endif
  !
  x = abs(head%gil%inc(1)*head%gil%inc(2))
  sum = s1*x
  aire = s0*x
  npix = s0
  if (s0.ne.0) then
    s1 = s1 / s0
    mean = s1  ! Downcast to single precision, do not reuse below
    s2 = s2 / s0
    sigma = sqrt(s2-s1**2)
  endif
end subroutine my_moments
!

subroutine display_check_uv(comm,error)
  use clean_def
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   SHOW UV
  !     TIME-BASE sort the UV table before displaying it
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: comm 
  logical, intent(out) :: error ! Logical error flag
  !
  ! Check data presence in buffer
  if (.not.associated(duv)) then
     call map_message(seve%e,comm,'No UV data')
     error = .true.
     return
  endif
  ! Sort buffer (TIME-BASE) when needed and create the associated SIC buffer
  if (.not.allocated(duvt)) call uv_tri(2,error)
end subroutine display_check_uv
!
subroutine display_uv(chain,error)
  use clean_def
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   SHOW UV
  !     TIME-BASE sort the UV table before displaying it
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: chain
  logical, intent(out) :: error ! Logical error flag
  !
  character(len=32) :: comm
  !
  ! Check data presence in buffer
  call display_check_uv('SHOW',error)
  if (error) return
  !
  ! Plot SIC buffer
  comm = 'let type "%"'
  call exec_command(comm,error)
  call exec_program('@ p_uvshow_sub '//chain)
end subroutine display_uv
!
subroutine uv_sort_comm(line,error)
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Support routine for command
  !   UVSORT [TIME|BASE|UV]
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  ! Command line
  logical,          intent(out) :: error ! Logical error flag
  !
  ! Local variables
  integer code,na
  character(len=4) argu,voc1(2),vvoc
  data voc1/'BASE','TIME'/ ! ,'UV'/ not needed here
  !
  ! Parse input line. Default argument is TIME
  argu = 'TIME'
  call sic_ke(line,0,1,argu,na,.false.,error)
  if (error) return
  call sic_ambigs('UV_SORT',argu,vvoc,code,voc1,2,error)
  if (error) return
  ! Sort uv buffer
  call uv_tri(code,error)
  if (error) return
  !
end subroutine uv_sort_comm
!
subroutine uv_tri(code,error)
  use gkernel_interfaces
  use imager_interfaces, only : uv_findtb
  use clean_def
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Support routine for command
  !   UVSORT [TIME|BASE|UV]
  !     BASE is code 1
  !     TIME is code 2
  !     UV is code 3
  !----------------------------------------------------------------------
  integer, intent(in)  :: code  ! Sorting code
  logical, intent(out) :: error ! Logical error flag
  !
  ! Local variables
  integer code_bt,code_tb
  parameter(code_bt=1)
  parameter(code_tb=2)
  integer ier,nd,nv,id,iv
  integer, allocatable :: it(:),ot(:)
  real(kind=8), allocatable :: order(:)
  character(len=7) :: rname = 'UV_SORT'
  logical sorted, warning, alloc
  !
  if (.not.associated(duv)) then
    call map_message(seve%e,rname,'No UV data')
    error = .true.
    return
  endif
  error = .false.
  !
  ! Create Sorted UV data
  call sic_delvariable('UVS',.false.,warning)
  !
  ! Check first if UVT is already matching UV
  alloc = .false.
  if (allocated(duvt)) then
    if ( (huv%gil%dim(2).ne.huvt%gil%dim(1)) .or. &
      & (huv%gil%dim(1)+3.ne.huvt%gil%dim(2)) ) then
      deallocate (duvt)
    else
      alloc = .true.
    endif
  endif
  !
  call gildas_null (huvt, type = 'TUV')
  call gdf_transpose_header(huv,huvt,'21  ',error)
  if (error)  return
  nd = huvt%gil%dim(2)
  nv = huvt%gil%dim(1)
  huvt%gil%dim(2) = nd+3
  !
  if (.not.alloc) then
    allocate(duvt(huvt%gil%dim(1),huvt%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Error getting UV memory ')
      error = .true.
      return
    endif
  endif
  call sic_def_real('UVS',duvt,huvt%gil%ndim,huvt%gil%dim,.false.,error)
  if (error) return
  !
  allocate(order(nv),it(nv),ot(nv),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Error getting memory ')
    error = .true.
    return
  endif
  !
  call uv_findtb(code,duv,nv,nd,order,it,ot,sorted)
  if (sorted) then
    !!Print *,'****  SHOW UV -- already sorted for code ',code
    do id=1,nd
      do iv=1,nv
        duvt(iv,id) = duv(id,iv)
      enddo
    enddo
  else
    do id=1,nd
      do iv=1,nv
        duvt(iv,id) = duv(id,it(iv))
      enddo
    enddo
  endif
  do iv=1,nv
    duvt(iv,nd+1) = 1.0
  enddo
  deallocate(order,it,ot)
end subroutine uv_tri
!
subroutine uv_findtb(code,uv,nv,nd,order,it,ot,sorted)
  use imager_interfaces, only : triuv8
  !---------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for SHOW UV
  !---------------------------------------------------------------
  integer, intent(in)       :: code      ! Code for sort operation
  integer, intent(in)       :: nd,nv     ! Size of visibility table
  real, intent(in)          :: uv(nd,nv) ! Input UV data
  real(kind=8), intent(out) :: order(nv) ! Sorting array
  integer, intent(out)      :: it(nv)    ! Sort index
  integer, intent(out)      :: ot(nv)    ! Reverse order
  logical, intent(out)      :: sorted    ! Is already sorted
  !
  ! Local variables
  integer code_bt,code_tb
  parameter(code_bt=1)
  parameter(code_tb=2)
  real(kind=4) rdate
  real(kind=8) olast
  integer iv
  logical error
  !
  if (code.eq.code_bt) then
    ! Order BASE(primary) then TIME(secondary)
    rdate = uv(4,1)
    do iv=1,nv
      order(iv) = 1000.d0*86400.0d0*(100.0*uv(6,iv)+uv(7,iv))   &
           &        +(uv(4,iv)-rdate)*86400.d0 + uv(5,iv)
      it(iv) = iv
    enddo
  elseif (code.eq.code_tb) then
    ! Order TIME(primary) then BASE(secondary)
    rdate = uv(4,1)
    do iv=1,nv
      order(iv) =(uv(4,iv)-rdate)*86400.d0 + uv(5,iv) +   &
           &       (100.0d0*uv(6,iv)+uv(7,iv))*1.0d-4
      it(iv) = iv
    enddo
  endif
  !
  ! Check order... This is for dummy UV Tables produced by e.g. UV_CIRCLE
  ! which have no unique ordering...
  olast = order(1)
  sorted = .true.
  do iv=1,nv
    if (order(iv).lt.olast) then
      sorted = .false.
      exit
    endif
    olast = order(iv)
  enddo
  if (sorted) return
  !
  call triuv8(order,it,nv,error)
  if (error) return
  do iv=1,nv
    ot(it(iv)) = iv
  enddo
end subroutine uv_findtb
!
subroutine triuv8(x,it,n,error)
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !
  !   Sorting program that uses a quicksort algorithm.
  ! Applies for an input array of real*8 values, which are left
  ! unchanged. Returns an array of indexes sorted for increasing
  ! order of X. Use GR8_SORT to reorder X.
  !------------------------------------------------------------------------
  integer,      intent(in)    :: n     ! Array length
  real(kind=8), intent(inout) :: x(n)  ! Unsorted array
  integer,      intent(out)   :: it(n) ! Sort index
  logical,      intent(out)   :: error ! Logical return flag
  !
  ! Local variables
  integer mstack, nstop
  parameter(mstack=1000,nstop=15)
  integer i, j, k, itemp, l, r, m, lstack(mstack), rstack(mstack), sp
  real(kind=8) temp, key
  logical mgtl, lgtr, rgtm
  character(len=message_length) :: mess
  !
  ! Initial pointers are already loaded
  !
  if (n.le.nstop) goto 50
  sp = 0
  sp = sp + 1
  lstack(sp) = 1
  rstack(sp) = n
  !
  ! Sort a subrecord off the stack
  ! Set KEY = median of X(L), X(M), X(R)
  ! No! This is not reasonable, as systematic very inequal partitioning will
  ! occur in some cases(especially for nearly already sorted files)
  ! To fix this problem, I found(but I cannot prove it) that it is best to
  ! select the estimation of the median value from intermediate records. P.V.
1 l = lstack(sp)
  r = rstack(sp)
  sp = sp - 1
  m =(l + r) / 2
  !
  mgtl = x(m) .gt. x(l)
  rgtm = x(r) .gt. x(m)
  !
  ! Algorithm to select the median key. The original one from MONGO
  ! was completely wrong. P. Valiron, 24-Jan-84 .
  !
  !       MGTL  RGTM  LGTR  MGTL.EQV.LGTR MEDIAN_KEY
  !
  ! KL < KM < KR  T T * *   KM
  ! KL > KM > KR  F F * *   KM
  !
  ! KL < KM > KR  T F F F   KR
  ! KL < KM > KR  T F T T   KL
  !
  ! KL > KM < KR  F T F T   KL
  ! KL > KM < KR  F T T F   KR
  !
  if (mgtl .eqv. rgtm) then
     key = x(m)
  else
     lgtr = x(l) .gt. x(r)
     if (mgtl .eqv. lgtr) then
        key = x(l)
     else
        key = x(r)
     endif
  endif
  i = l
  j = r
  !
  ! Find a big record on the left
10 continue
  if (x(i).ge.key) goto 11
  i = i + 1
  goto 10
11 continue
  ! Find a small record on the right
20 if (x(j).le.key) goto 21
  j = j - 1
  goto 20
21 continue
  if (i.ge.j) goto 2
  !
  ! Exchange records
  temp = x(i)
  x(i) = x(j)
  x(j) = temp
  itemp = it(i)
  it(i) = it(j)
  it(j) = itemp
  i = i + 1
  j = j - 1
  goto 10
  !
  ! Subfile is partitioned into two halves, left .le. right
  ! Push the two halves on the stack
2 continue
  if (j-l+1 .gt. nstop) then
     sp = sp + 1
     if (sp.gt.mstack) then
        write(mess,*) 'Stack overflow ',sp
        call map_message(seve%e,'SORT',mess)
        error = .true.
        return
     endif
     lstack(sp) = l
     rstack(sp) = j
  endif
  if (r-j .gt. nstop) then
     sp = sp + 1
     if (sp.gt.mstack) then
        write(mess,*) 'Stack overflow ',sp
        call map_message(seve%e,'SORT',mess)
        error = .true.
        return
     endif
     lstack(sp) = j+1
     rstack(sp) = r
  endif
  !
  ! Anything left to process?
  if (sp.gt.0) goto 1
  !
50 continue
  !
  do j = n-1,1,-1
     k = j
     do i = j+1,n
        if (x(j).le.x(i)) goto 121
        k = i
     enddo
121  continue
     if (k.eq.j) goto 110
     temp = x(j)
     do i = j+1,k
        x(i-1) = x(i)
     enddo
     x(k) = temp
     itemp = it(j)
     do i = j+1,k
        it(i-1) = it(i)
     enddo
     it(k) = itemp
110  continue
  enddo
  error = .false.
end subroutine triuv8
!
subroutine uv_flag_comm(line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_flag_comm
  use clean_def
  use clean_arrays
  use clean_support
  use clean_types
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Support routine for command
  !     UV_FLAG [/ANTENNA] [/RESET]
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  ! Command line
  logical,          intent(out) :: error ! Logical error flag
  !
  type(polygon_t), save :: flagspol      ! User defined polygon
  !
  integer :: iant, idate, nc, ic
  integer(kind=index_length) :: iv
  character(len=16) :: argum
  character(len=16) :: chain
  integer, parameter :: O_RESET=3
  integer, parameter :: O_DATE=2
  integer, parameter :: O_ANT=1
  !
  ! Parse input line
  call sic_delvariable('UVFLAG%SUPPORT',.false.,error)
  if (sic_present(O_RESET,0)) then  ! /RESET
    ! Reset flag array
    if (.not.allocated(duvt)) then
      ! No Displayed UV data, work directly
      do iv=1,huv%gil%nvisi
        do ic=1,huv%gil%nchan*huv%gil%nstokes
          duv(7+3*ic,iv) = abs( duv(7+3*ic,iv))
        enddo
      enddo
      return
    endif
    call reset_uvflag(duvt,huvt%gil%dim(1),huvt%gil%dim(2))
    flagspol%ngon = 0
  else if (sic_present(O_ANT,0) ) then  ! /ANTENNA
    flagspol%ngon = 0
    call sic_i4(line,O_ANT,1,iant,.true.,error)
    if (error) return
    ! Verify if data ready
    call display_check_uv('UV_FLAG',error)
    if (error) return
    call get_uvflag_ant(duvt,huvt%gil%dim(1),huvt%gil%dim(2),iant)
  else if (sic_present(O_DATE,0) ) then  ! /DATE
    flagspol%ngon = 0
    call sic_ke(line,O_DATE,1,argum,nc,.true.,error)
    call gag_fromdate(argum(1:nc),idate,error)
    if (error) return
    ! Verify if data ready
    call display_check_uv('UV_FLAG',error)
    if (error) return
    call get_uvflag_date(duvt,huvt%gil%dim(1),huvt%gil%dim(2),idate)
  else
    ! Plot data
    call sic_let_logi('uvshow%flag',.true.,error)
!    call display_buffer_sub('UV_FLAG',2,'UV',line,error)
    chain = 'UV'   !! !dtype//' '//trim(argu1)//' '//trim(argu2) First Last
    call display_uv (chain,error)
    if (error) return
    ! Ideally, plot the previous Polygon if any
    ! ...
    if (flagspol%ngon.ge.2) call greg_poly_plot(flagspol,error)
    ! Make user to define a polygon from cursor
    call sic_defstructure('UVFLAG%SUPPORT',.true.,error)
    call greg_poly_define('UV_FLAG',' ',.false.,flagspol,'UVFLAG%SUPPORT',error)
    if (error)  return
    ! Get flag array
    call get_uvflag(flagspol,duvt,huvt%gil%dim(1),huvt%gil%dim(2))
    call sic_let_logi('uvshow%flag',.false.,error)
  endif
  ! Apply flag array to buffer
  call apply_uvflag(duvt,huvt%gil%dim(1),huvt%gil%dim(2)-3,duv)
  do_weig = .true.
  optimize(code_save_uv)%lastnc = -1 !  means UV data.
end subroutine uv_flag_comm
!
subroutine get_uvflag_ant(uvs,nv,nd,iant)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Set uvflag array from antenna number
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd        ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)
  integer, intent(in) :: iant
  !
  ! Local variables
  integer ne,nf,i
  !
  ne = nd-1
  nf = nd-2
  do i=1,nv
    if (uvs(i,6).eq.iant .or. uvs(i,7).eq.iant) then
      uvs(i,nf) = 0.0
    endif
  enddo
  !
end subroutine get_uvflag_ant
!
subroutine get_uvflag_date(uvs,nv,nd,idate)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Set uvflag array from (gildas) Date number
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd        ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)
  integer, intent(in) :: idate
  !
  ! Local variables
  integer ne,nf,i
  !
  ne = nd-1
  nf = nd-2
  do i=1,nv
    if (uvs(i,4).eq.idate) then
      uvs(i,nf) = 0.0
    endif
  enddo
  !
end subroutine get_uvflag_date
!
subroutine get_uvflag(spol,uvs,nv,nd)
  use gildas_def
  use clean_support
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Get uvflag array from polygon (0 => Flag, 1 => Keep)
  !----------------------------------------------------------------------
  type(polygon_t), intent(in) :: spol                ! User defined region polygon
  integer(kind=index_length), intent(in) :: nv,nd    ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)
  !
  ! Local variables
  integer ne,nf
  !
  ne = nd-1
  nf = nd-2
  !
  ! Oh gosh, all that logic assumes the plotted stuff is in
  ! ne, nd, nf ...
  call gr4_inout(spol,uvs(1,ne),uvs(1,nd),uvs(1,nf),nv,.true.)
  !
end subroutine get_uvflag
!
!
subroutine reset_uvflag(uvs,nv,nd)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Reset uvflag array to 1
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd        ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)   ! UV data set
  !
  ! Local variables
  integer :: nf,i
  !
  nf = nd-2
  do i=1,nv
    uvs(i,nf) = 1.0
  enddo
end subroutine reset_uvflag
!
subroutine apply_uvflag(uvs,nv,nd,uv)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Apply uvflag array by making negative the weight of the flagged data
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd    ! Size of UV data
  real, intent(inout) :: uvs(nv,nd+3)   ! UV data set with Flags
  real, intent(inout) :: uv(nd,nv)      ! Transposed version
  !
  ! Local variables
  real :: factor
  integer :: i,j
  !
  ! Loop on visibilities
  do i=1,nv
    ! Apply uvflag array
    factor = 2*uvs(i,nd+1)-1    ! 1 or -1 depending on selected option
    do j=10,nd,3
      uvs(i,j) = abs(uvs(i,j))*factor
    enddo
    ! Transpose uvs completely because uv and uvs may be ordered differently...
    do j=1,nd
      uv(j,i) = uvs(i,j)
    enddo
  enddo
end subroutine apply_uvflag

subroutine read_sdm(line,error)
  use gkernel_interfaces
  !------------------------------------------------------------------------
  ! Support READ FILE
  ! read  a SDM data set in ALMA SDM format
  !------------------------------------------------------------------------
  use gildas_def
  use gkernel_types
  use sdm_Main
  use sdm_State
  use sdm_TotalPower
  use sdm_configDescription
  ! Dummy variables:
  character*(*) line
  logical error
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_number.inc'
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Local variables:
  integer :: ier, mainSize, tpmSize, hSize, nch, num, i, j, cdSize
  character (len=filename_length) :: fich
  logical :: first, check, present
  integer :: lfich
  type (ConfigDescriptionKey) :: cdKey
  type (ConfigDescriptionRow) :: cdRow
  type (cputime_t) :: time
  !------------------------------------------------------------------------
  ! Code:
  !
  ! Verify if any output file
  call check_output_file(error)
  if (error) return
  write_mode = 'NEW'
  check = .true.
  r_presec(rfset_sec)= .true.
  r_presec(contset_sec)= .true.
  r_presec(lineset_sec)= .true.
  r_presec(atparm_sec)= .true.
  r_presec(atmon_sec)= .true.
  r_presec(scanning_sec)= .true.
  r_presec(atparm_sec)= .true.
  r_presec(alma_sec)= .true.
  r_presec(abpcal_sec)= .true.
  r_presec(aical_sec)= .true.
  r_presec(bpcal_sec)= .true.
  r_presec(ical_sec)= .true.
  r_icdeg = 3
  r_aicdeg = 3
  !
  ! Get file name
  fich = 'clicFile' 
  call sic_ch(line,0,1,fich,nch,.false.,error)
  if (error) return
  call sic_parse_file(fich,'','',fich)
  !
  lfich = lenc(fich)
  file_name = fich(1:lfich)//char(0) 
  call reset_times(time)
  call sdm_init(fich(1:lfich)//char(0), error)
  if (error) goto 99
  call message_times(time,'Sdm_init')
  !
  next_Uid = 0
  ! reset all local identifiers
  call init_sdm
  !
  !     Scan the main table
  !
  !     should als check ths scan table to discard the calDMs which have
  !     no scan table
  call getMainTableSize(mainSize, error)
  ! print *,'mainSize ', mainSize
  call getTotalPowerTableSize(tpmSize, error)
  ! print *, 'tpmSize ', tpmSize
  !
  if (mainSize.gt.0) then
    call read_sdm_Tables(error)
  elseif (tpmSize.gt.0) then
    call getHolographyTableSize(hSize, error)
    if (hSize.gt.0) then
      call message(2,1,'Read_sdm'   &
        ,'This is a Single-dish Holography Data Set')
      call read_sdm_HoloTables(error)
    else
      call message(8,4,'Read_sdm'   &
        ,'Unidentified non-correlator mode !')
      error = .true.
    endif
  endif
99 return
end subroutine read_sdm
!--------------------------------------------------------------------
subroutine message_times(time,where)
  use gkernel_interfaces
  use gkernel_types
  type(cputime_t), intent(inout) :: time
  character ::  chain*160, where*(*)
  integer :: l
  !
  call gag_cputime_get(time)
  !
  write (chain,1000) time%diff%user + time%diff%system,  &
                     time%curr%user + time%curr%system,  &
                     time%diff%elapsed,                  &
                     time%curr%elapsed
1000 format ('CPU ',f8.2,'/',f8.2,' s. Elapsed ',f8.2, '/',f8.2   &
    ,' s: ')
  l = lenc(chain)
  chain = chain(1:l)//' '//where
  l = lenc(chain)
  call message(2,1,'Timing',chain(1:l))
  return
end subroutine message_times
!--------------------------------------------------------------------
subroutine reset_times(time)
  use gkernel_interfaces
  use gkernel_types
  type(cputime_t), intent(inout) :: time
  !
  call gag_cputime_init(time)
  !
end subroutine reset_times

subroutine gtz_open(output,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtz_open
  use gtv_types
  use gtv_protocol
  use gtv_graphic
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GTVIRT, Z Routine
  !   Open a graphic device
  !---------------------------------------------------------------------
  type(gt_display)       :: output  ! Output instance
  logical, intent(inout) :: error   !
  ! Local
  integer :: ier
  !
  if (output%dev%protocol.eq.p_x          .or.  &
      output%dev%protocol.eq.p_postscript .or.  &
      output%dev%protocol.eq.p_png        .or.  &
      output%dev%protocol.eq.p_svg) then
    ! Do nothing for devices which will open the unit themselves.
    output%opened = .false.
    return
  endif
  !
  ! Open the file for non FORTRAN I/O
  ier = sic_open(output%iunit,output%file,'UNKNOWN',.false.)
  if (ier.ne.0) then
    call gtv_message(seve%f,'GTOPEN','Cannot open graphics device '//  &
    output%file)
    call putios ('E-GTOPEN,  ',ier)
    call gtx_err
    ! Switch to the null_device
    error = .true.
    return
  endif
  !
  output%opened = .true.
  !
end subroutine gtz_open
!
subroutine gtz_close(output)
  use gtv_dependencies_interfaces
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! GTVIRT Z routine
  ! Close a graphic device
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! Output instance
  ! Local
  integer(kind=4) :: ier
  !
  if (output%iunit.eq.6) return
  if (output%opened) then
    ier = sic_close(output%iunit)
    output%opened = .false.
  endif
end subroutine gtz_close

module gsys_interfaces_private
  interface
    subroutine set_ctrlc
      use gsys_variables
      !---------------------------------------------------------------------
      ! @ private
      ! Set CONTROLC flag to .TRUE.
      ! Re-initiate the ^C trapping by calling TRAP_CTRLC
      !---------------------------------------------------------------------
    end subroutine set_ctrlc
  end interface
  !
  interface
    function gag_julda(nyr)
      !---------------------------------------------------------------------
      ! @ private
      !  Returns Julian date of 1 day of Year
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_julda  ! Date returned
      integer(kind=4), intent(in) :: nyr  !
    end function gag_julda
  end interface
  !
  interface
    subroutine gag_gregorian2mjd(iy,im,id,djm,ier)
      !---------------------------------------------------------------------
      ! @ private
      ! Gregorian Calendar to Modified Julian Date
      ! MJD is not computed when ier.ne.0
      !
      ! The year must be -4699 (i.e. 4700BC) or later.
      !
      ! The algorithm is derived from that of Hatcher 1984
      ! (QJRAS 25, 53-55).
      !
      ! Derived from P.T.Wallace   Starlink   11 March 1998
      ! Copyright (C) 1998 Rutherford Appleton Laboratory
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: iy  ! year in Gregorian calendar
      integer(kind=4), intent(in)  :: im  ! month in Gregorian calendar
      integer(kind=4), intent(in)  :: id  ! day in Gregorian calendar
      real(kind=8),    intent(out) :: djm ! Modified Julian Date (JD-2400000.5) for 0 hrs
      integer(kind=4), intent(out) :: ier ! Status  (0 = OK, 1 = bad year, 2 = bad month, 3 = bad day)
    end subroutine gag_gregorian2mjd
  end interface
  !
  interface
    subroutine gag_mjd2gregorian(mjd,iy,im,id,error)
      use phys_const
      !---------------------------------------------------------------------
      ! @ private
      ! Modified Julian Date to Gregorian Calendar
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)    :: mjd    ! Modified Julian Date (JD-2400000.5) for 0 hrs
      integer(kind=4), intent(out)   :: iy     ! Year in Gregorian calendar
      integer(kind=4), intent(out)   :: im     ! Month in Gregorian calendar
      integer(kind=4), intent(out)   :: id     ! Day in Gregorian calendar
      logical(kind=4), intent(inout) :: error  ! Logical error flag
    end subroutine gag_mjd2gregorian
  end interface
  !
  interface
    subroutine gmessage_open(mesname,error)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! Opens message file in GAG_LOG: directory. Must be called only once.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: mesname  ! Message base filename
      logical,          intent(inout) :: error    ! Error flag
    end subroutine gmessage_open
  end interface
  !
  interface
    subroutine gmessage_flush(error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @private
      ! Closes message file and reset its logical unit for a clean handling
      ! of very last messages.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error    ! Error flag
    end subroutine gmessage_flush
  end interface
  !
  interface
    function gmessage_isoff(id,mkind)
      !---------------------------------------------------------------------
      ! @ private
      ! Checks if the message sent to gmessage_write is intended to be
      ! printed to at least one of the outputs (screen or message file).
      ! Should be used if you want to skip string formatting (for example)
      ! in order to save CPU time.
      !---------------------------------------------------------------------
      logical :: gmessage_isoff
      integer(kind=4), intent(in) :: id     ! Package id
      integer(kind=4), intent(in) :: mkind  ! Message kind
    end function gmessage_isoff
  end interface
  !
  interface
    subroutine gmessage_gbl_filters_on(rule)
      !---------------------------------------------------------------------
      ! @ private
      ! Set Global filters and activate its use.
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: rule  ! Optional rule to alter filters
    end subroutine gmessage_gbl_filters_on
  end interface
  !
  interface
    subroutine gmessage_gbl_filters_off
      !---------------------------------------------------------------------
      ! @ private
      ! Deactivate use of Global filters
      !---------------------------------------------------------------------
      !
    end subroutine gmessage_gbl_filters_off
  end interface
  !
  interface
    subroutine gpack_get_name(id,packname,error)
      use gpack_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Get package name from the given package id
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: id
      character(len=*), intent(out)   :: packname
      logical,          intent(inout) :: error
    end subroutine gpack_get_name
  end interface
  !
  interface
    function gpack_register(pack,error)
      use gpack_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ private
      ! Private function to register a package and return a new package id
      !----------------------------------------------------------------------
      integer(kind=4) :: gpack_register
      type(gpack_prop_t), intent(in)    :: pack
      logical,            intent(inout) :: error
    end function gpack_register
  end interface
  !
  interface
    recursive subroutine gpack_recurse(pack_fct,pack_id,error)
      !---------------------------------------------------------------------
      ! @ private
      ! Call pack_fct on all package from the dependency hierarchy, starting
      ! from low level packages and ending with the root package given by
      ! pack_id
      !---------------------------------------------------------------------
      external                       :: pack_fct
      integer(kind=4), intent(in)    :: pack_id
      logical,         intent(inout) :: error
    end subroutine gpack_recurse
  end interface
  !
  interface
    subroutine gpack_recurse_high_first(pack_fct,pack_id,error)
      !---------------------------------------------------------------------
      ! @ private
      ! Call pack_fct on all package from the dependency hierarchy, starting
      ! from the root package given by pack_id and ending with low level
      ! packages
      !---------------------------------------------------------------------
      external                       :: pack_fct
      integer(kind=4), intent(in)    :: pack_id
      logical,         intent(inout) :: error
    end subroutine gpack_recurse_high_first
  end interface
  !
  interface
    recursive subroutine gpack_recurse_depend(pack_fct,pack,parent_pack,low_first,  &
      recurse_level,pack_reach_flags,error)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ private
      ! Generic routine to recurse through all dependent packages of package
      ! pack
      !---------------------------------------------------------------------
      external                          :: pack_fct       ! Function to call on each package
      type(gpack_prop_t), intent(in)    :: pack           ! Package to start from
      type(gpack_prop_t), intent(in)    :: parent_pack    ! Initial recursion package
      logical,            intent(in)    :: low_first      ! Call pack_fct from low level package to high level
      integer(kind=4),    intent(in)    :: recurse_level  !
      logical,            intent(inout) :: pack_reach_flags(gpack_max_count)
      logical,            intent(inout) :: error          ! Error flag
    end subroutine gpack_recurse_depend
  end interface
  !
  interface
    recursive subroutine gpack_set_dependencies(pack,error)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ private
      ! Intermediate routine to call gpack_set recursively and build package
      ! depend_id member
      !---------------------------------------------------------------------
      type(gpack_prop_t), intent(inout) :: pack
      logical,            intent(inout) :: error
    end subroutine gpack_set_dependencies
  end interface
  !
  interface
    subroutine gpack_init(pack,parent_pack,error)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      ! Call package init method from gpack_recurse
      !---------------------------------------------------------------------
      type(gpack_prop_t), intent(inout) :: pack
      type(gpack_prop_t), intent(in)    :: parent_pack
      logical,            intent(inout) :: error
    end subroutine gpack_init
  end interface
  !
  interface
    subroutine gpack_exec_on_child(pack,parent_pack,error)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      ! Call package exec_on_child method from gpack_recurse_again
      !---------------------------------------------------------------------
      type(gpack_prop_t), intent(in)    :: pack
      type(gpack_prop_t), intent(in)    :: parent_pack
      logical,            intent(inout) :: error
    end subroutine gpack_exec_on_child
  end interface
  !
  interface
    subroutine gpack_clean(pack,parent_pack,error)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ private
      ! Call package start method from gpack_recurse_high_first
      !---------------------------------------------------------------------
      type(gpack_prop_t), intent(in)    :: pack
      type(gpack_prop_t), intent(in)    :: parent_pack
      logical,            intent(inout) :: error
    end subroutine gpack_clean
  end interface
  !
  interface
    subroutine gsys_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gsys_message
  end interface
  !
  interface
    subroutine sic_handlelog(name,trans,codeop,coderr)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !
      !     Get or Set a log name according to Code Op
      !
      ! Simulates recursive translation of a VMS logical name by looking into
      ! a dictionary in the user's path. The calling list should probably be
      ! modified to include the string length.
      ! Three dictionaries are used: a global dictionary contains site independent
      ! definitions, a local one is defined at installation level and a user
      ! specific one can be used by any individual user to customize his
      ! definitions. Local definitions override more global definitions, so the
      ! user has the final say.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: name     !
      character(len=*), intent(in)    :: trans    !
      integer(kind=4),  intent(in)    :: codeop   !
      integer(kind=4),  intent(out)   :: coderr   !
    end subroutine sic_handlelog
  end interface
  !
  interface
    function sic_get_npath(paths,sep)
      !---------------------------------------------------------------------
      ! @ private
      ! Return number of paths in a list of paths PATHS separated by SEP.
      ! Return 0 if input string is empty. Take care that PATHS may or may not
      ! end with a SEP.
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_get_npath  !
      character(len=*), intent(in) :: paths  ! Paths list
      character(len=*), intent(in) :: sep    ! Separator (assume len=1)
    end function sic_get_npath
  end interface
  !
  interface
    subroutine sic_get_path(paths,sep,n,istart,iend)
      !---------------------------------------------------------------------
      ! @ private
      ! Return Nth path indices in a list of paths PATHS separated by SEP.
      ! Return indexes for an empty string if such a path does not exist.
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: paths   ! Paths list
      character(len=*), intent(in)  :: sep     ! Separator (assume len=1)
      integer(kind=4),  intent(in)  :: n       ! Position
      integer(kind=4),  intent(out) :: istart  ! Beginning of string
      integer(kind=4),  intent(out) :: iend    ! End of string
    end subroutine sic_get_path
  end interface
  !
  interface
    subroutine load_dict(maxlog,pflog,pnlog,diclog,translog,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  Fills the internal dictionary, reading from the three possible
      ! configuration files.
      !---------------------------------------------------------------------
      integer(kind=4),    intent(in)    :: maxlog            !
      integer(kind=4),    intent(out)   :: pflog(0:27)       ! Alphabetic pointers PF(27)=number of
      integer(kind=4),    intent(out)   :: pnlog(maxlog)     ! Chained pointers
      character(len=512), intent(inout) :: diclog(maxlog)    ! Identifiers
      character(len=512), intent(inout) :: translog(maxlog)  ! Translation for identifiers
      logical,            intent(inout) :: error             !
    end subroutine load_dict
  end interface
  !
  interface
    subroutine gtlblanc(c,n)
      !---------------------------------------------------------------------
      ! @ private
      !  Reduce the character string C to the standard SIC internal syntax.
      !  Suppress all unecessary separators.
      !  Ignores and destroys comments.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: c  ! Character string to be formatted
      integer(kind=4),  intent(inout) :: n  ! Length of C
    end subroutine gtlblanc
  end interface
  !
  interface
    function sic_expenv(name)
      !---------------------------------------------------------------------
      ! @ private
      !
      ! This Unix specific routine expands environment variables in file names.
      ! Environment variables begin with a $ sign. They are terminated by a /
      ! sign.
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_expenv  !
      character(len=*), intent(inout) :: name  !
    end function sic_expenv
  end interface
  !
  interface
    subroutine sic_ctrans (name,nn,trans,np)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      !     Returns the translation (TRANS(1:NP)) of a Logical name (NAME(1:NN))
      !     NAME and TRANS are assumed to be C Strings, i.e. Byte arrays.
      !---------------------------------------------------------------------
      integer(kind=1), intent(in)    :: name(*)   !
      integer(kind=4), intent(in)    :: nn        !
      integer(kind=1), intent(out)   :: trans(*)  !
      integer(kind=4), intent(inout) :: np        !
    end subroutine sic_ctrans
  end interface
  !
  interface
    subroutine gag_setcleanlog (input,output,ispath)
      !---------------------------------------------------------------------
      ! @ private
      ! Perform a good cleaning on the Logical name definitions to 
      ! use the appropriate system dependent separators.
      !
      ! A better job can be done using the code marked !!BETTER
      ! but that does not seem to be required.
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: input
      character(len=*), intent(out) :: output
      logical,          intent(in)  :: ispath
    end subroutine gag_setcleanlog
  end interface
  !
  interface
    function sic_close_one(unit)
      !---------------------------------------------------------------------
      ! @ private
      ! This function closes a formatted file, and returns an error code.
      ! Following the Fortran norm, default closing STATUS:
      ! - is DELETE if unit has been opened with STATUS=SCRATCH,
      ! - is KEEP if unit has been opened with any other STATUS.
      !---------------------------------------------------------------------
      integer(kind=4)             :: sic_close_one  ! Close status (0=success)
      integer(kind=4), intent(in) :: unit           ! Logical unit to close
    end function sic_close_one
  end interface
  !
  interface
    subroutine gag_stalun_print(unit)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Print out status of a single lun
      ! NB: the lun can be one not reserved by SIC_GETLUN
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: unit  ! Unit to stat
    end subroutine gag_stalun_print
  end interface
  !
  interface
    subroutine putmsg (name,ier)
      !---------------------------------------------------------------------
      ! @ private
      ! UTIL  Internal routine
      !       Print system message corresponding to code IER on SYS$OUTPUT.
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: name  ! Facility name
      integer(kind=4),  intent(in) :: ier   ! 32-bit system message code
    end subroutine putmsg
  end interface
  !
  interface
    subroutine win32_iostat (msg,ier)
      !---------------------------------------------------------------------
      ! @ private
      ! Get system message corresponding to IO error code IER
      !     Version for WIN32 Dec/Compaq compiler
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: msg  ! Returned message
      integer(kind=4),  intent(in)  :: ier  ! 32-bit system message code
    end subroutine win32_iostat
  end interface
  !
  interface
    subroutine g95_iostat (msg,ier)
      !---------------------------------------------------------------------
      ! @ private
      ! Get system message corresponding to IO error code IER
      !     Version for G95 Gnu compiler.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: msg  ! Returned message
      integer(kind=4),  intent(in)  :: ier  ! 32-bit system message code
    end subroutine g95_iostat
  end interface
  !
  interface
    subroutine gfc_iostat (msg,ier)
      !---------------------------------------------------------------------
      ! @ private
      ! Get system message corresponding to IO error code IER
      !     Version for GFortran Gnu compiler.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: msg  ! Returned message
      integer(kind=4),  intent(in)  :: ier  ! 32-bit system message code
    end subroutine gfc_iostat
  end interface
  !
  interface
    subroutine ifort_iostat(msg,ier)
      !---------------------------------------------------------------------
      ! @ private
      ! Get system message corresponding to IO error code IER
      !     Version for Intel Fortran compiler.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: msg  ! Returned message
      integer(kind=4),  intent(in)  :: ier  ! 32-bit system message code
    end subroutine ifort_iostat
  end interface
  !
  interface
    subroutine gag_cflab (chrstr,x,w,d)
      !---------------------------------------------------------------------
      ! @ private
      !  Convert floating point value to a display of the form of the
      ! "Babylonian" ddd mm ss.s, where each field represents a sexagesimal
      ! increment over its successor. The value X must be in the units of
      ! the rightmost field.  For instance, X must be in seconds of time for
      ! hours, minutes, seconds display.
      !---------------------------------------------------------------------
      character(len=*), intent(out)   :: chrstr  ! Formatted string
      real(kind=8),     intent(in)    :: x       ! Input number
      integer(kind=4),  intent(inout) :: w       ! Length of string
      integer(kind=4),  intent(in)    :: d       ! Number of decimals
    end subroutine gag_cflab
  end interface
  !
  interface
    subroutine blank_fill(oct,long)
      !---------------------------------------------------------------------
      ! @ private
      ! Blank the input string along its 'long' first chars. Work with
      ! integer*1 values instead of characters.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: long       ! Length of string
      integer(kind=1), intent(out) :: oct(long)  ! String retrieved as a I*1 array
    end subroutine blank_fill
  end interface
  !
  interface
    subroutine mtskip(chan,nskip,ncoun,end_tape,err)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! FITS  Internal routine
      !       Skip tape-marks and return count and status
      !       This entry should only be called when END_OF_FILE is
      !       already .TRUE.
      ! Arguments :
      !       CHAN     I      I/O Channel
      !       NSKIP    I      Number of files to skip         Input
      !       NCOUN    I      Number of tape mark skipped     Output
      !       END_TAPE L      End-of-Tape reached             Output
      !       ERR      L      Logical error flag              Output
      !---------------------------------------------------------------------
      integer(kind=4) :: chan           !
      integer(kind=2) :: nskip          !
      integer(kind=4) :: ncoun          !
      logical         :: end_tape       !
      logical         :: err            !
    end subroutine mtskip
  end interface
  !
  interface
    subroutine mtmoun (tape,dens,chan,err)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! UTIL  Internal routine
      !       Tries to mount a tape on device "TAPE", which
      !       must be assigned to a generic name of tape devices.
      ! Arguments :
      !       TAPE    C*(*)   Tape device logical name        Input
      !       CHAN    I       I/O channel assigned            Output
      !       ERR     L       Logical error flag              Input
      !---------------------------------------------------------------------
      character(len=*) :: tape          !
      integer(kind=4)  :: dens          !
      integer(kind=4)  :: chan          !
      logical          :: err           !
    end subroutine mtmoun
  end interface
  !
end module gsys_interfaces_private

subroutine write_sdm_scan(error)
  !---------------------------------------------------------------------
  !     Write the  Scan & Subscan  table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_Scan
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (ScanRow) :: sRow
  type (ScanKey) :: sKey
  type (ScanOpt) :: sOpt
  character, parameter :: sdmTable*4 = 'Scan'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !
  ! now allocate
  sRow%numIntent = 1
  call allocScanRow(sRow, error)
  if (error) return
  !
  sRow%flagRow = .false.
  !     *TBD* Why fieldName???
  !CC SS2 Now its SourceName ...
  !CC SourceName now optional (2006-11-22)
  !      sRow%sourceName = r_sourc //char(0)
  !     Write the PREVIOUS scan and reset startTime, numSubScan:
  sRow%startTime = scan_startTime
  sRow%endTime = scan_endTime
  sKey%execBlockId = execBlock_Id
  sKey%scanNumber = scan_Number
  sRow%numSubScan = num_SubScan
  sRow%scanIntent(1) = scan_Intent
  sRow%calDataType(1) = data_type
  sRow%calibrationOnLine = .true.
  call addScanRow(sKey, sRow, error)
  if (error) return
  !
  ! one field for each scan...
  sOpt%numField = 1
  call allocScanOpt(sRow, sOpt, error)
  !     add source name,( not agreed on long term solution)
  sOpt%sourceName = r_sourc //char(0)
  call addscanSourceName(sKey, sOpt, error)
  if (error) return
  sOpt%fieldName(1) = field_name//char(0)
  call addscanFieldName(sKey, sOpt, error)
  if (error) return
  !
  !     Note: should possibly add the fieldName ( a vector).
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
end subroutine write_sdm_scan
!
subroutine write_sdm_subscan(holodata, error)
  !---------------------------------------------------------------------
  !     Write the  Scan & Subscan  table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_Subscan
  use sdm_Enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical :: error, holodata
  ! Local
  type (SubscanRow) :: ssRow
  type (SubscanKey) :: ssKey
  character, parameter :: sdmTable*16 = 'Scan & Subscan'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !
  ssRow%StartTime = time_Interval(1)
  ssRow%EndTime = time_Interval(1)+time_Interval(2)
  ! SS2 NOW OPTIONAL...      ssRow%subscanMode = '*TBD*'
  if (holodata) then
    ssRow%numberIntegration = r_ndump
  else
    ssRow%numberIntegration = 1
  endif
  call allocSubScanRow(ssRow, error)
  if (error) return
  if (holodata) then
    ssRow%numberSubintegration = 0
  else
    if (r_nswitch.gt.0) then
      ssRow%numberSubintegration = r_ndump/r_nswitch
    else
      ssRow%numberSubintegration = r_ndump
    endif
  endif
  ssRow%flagRow = .false.
  ssRow%fieldName = field_name //char(0)
  ssKey%execBlockId = execBlock_Id
  ssKey%scanNumber = scan_Number
  ssKey%subScanNumber = subscan_Number
  ssRow%subscanintent = subscan_Intent
  call addSubScanRow(ssKey, ssRow, error)
  if (error) return
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
end subroutine write_sdm_subscan
!---------------------------------------------------------------------
subroutine get_sdm_scan(error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !     Read the Source Scan  table.
  !
  !     Key: (execBlockId, scanNumber)
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_Scan
  use sdm_Subscan
  use sdm_State
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (ScanRow) :: sRow
  type (ScanKey) :: sKey
  type (SubscanRow) :: ssRow
  type (SubscanKey) :: ssKey
  type (StateRow) :: stRow
  type (StateKey) :: stKey
  integer, parameter :: mIntegration=256   !?
  integer lenz, maxIntent
  character, parameter :: sdmTable*16 = 'Scan & Subscan'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !
  ! now allocate
  !!maxIntent = 10
  sRow%numIntent = 10
  !!call allocScanRow(sRow, maxIntent, error)
  call allocScanRow(sRow, error)
  if (error) return
  sRow%flagRow = .false.
  ! *TBD* Why fieldName???
  !$$$      print *, 'execBlock_Id ', execBlock_Id
  sKey%execBlockId = execBlock_Id
  sKey%scanNumber = scan_Number
  call getScanRow(sKey, sRow, error)
  if (error) then
    print *, 'sKey ', sKey
  endif
  if (error) return
  num_SubScan = sRow%numSubScan
  r_scan = scan_Number
  ssRow%numberIntegration = mIntegration
  !call allocSubScanRow(ssRow, mIntegration, error)
  call allocSubScanRow(ssRow, error)
  if (error) return
  !
  ssKey%execBlockId = execBlock_Id
  ssKey%scanNumber = scan_Number
  ssKey%subScanNumber = subscan_Number
  !
  call getSubScanRow(ssKey, ssRow, error)
  if (error) return
  r_ndump  = ssRow%numberSubintegration(1)
  !
  ! NEED to get the STATE row
  call get_intent(srow%numIntent, srow%scanIntent,   &
    ssRow%subScanIntent, stRow%calDeviceName)
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
99 error = .true.
end subroutine get_sdm_scan
!---------------------------------------------------------------------
integer function lenz(c)
  character*(*) c
  integer i
  lenz = len(c)
  i = index(c,char(0))
  if (i.gt.0) lenz = min(lenz,i-1)
end function lenz
!---------------------------------------------------------------------
subroutine set_intent(scanIntent, subScanIntent, deviceName, calDataType, holodata)
  use sdm_Types
  use sdm_Enumerations
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  integer :: scanIntent, subScanIntent, deviceName, calDataType
  logical :: holodata
  ! CALIBRATION
  subscanIntent = SubscanIntent_UNSPECIFIED    
  scanIntent = ScanIntent_UNSPECIFIED  
  calDataType = CalDataOrigin_CHANNEL_AVERAGE_CROSS 
  deviceName = CalibrationDevice_NONE
  if (r_cproc.eq.'CALI') then
    scanIntent = ScanIntent_CALIBRATE_ATMOSPHERE 
    calDataType = CalDataOrigin_TOTAL_POWER 
    ! put in State ...
    if (r_scaty.eq.5) then
      deviceName = CalibrationDevice_NONE
    elseif (r_scaty.eq.7) then
      deviceName = CalibrationDevice_COLD_LOAD
    elseif (r_scaty.eq.4) then
      deviceName = CalibrationDevice_AMBIENT_LOAD
    endif
  elseif (r_cproc.eq.'SKYD') then
    scanIntent = scanintent_DO_SKYDIP 
    calDataType = CalDataOrigin_TOTAL_POWER 
    ! put in State ...
    if (r_scaty.eq.5) then
      deviceName = CalibrationDevice_NONE
    elseif (r_scaty.eq.4) then
      deviceName = CalibrationDevice_AMBIENT_LOAD
    endif
  elseif (r_cproc.eq.'FOCU') then
    scanIntent = scanintent_CALIBRATE_FOCUS 
    calDataType = CalDataOrigin_CHANNEL_AVERAGE_CROSS 
    if (r_scaty.eq.1) then
      scanIntent = scanintent_CALIBRATE_Focus    
    elseif (r_scaty.eq.11) then
      scanIntent = scanintent_CALIBRATE_Focus_X  
    elseif (r_scaty.eq.12) then
      scanIntent = scanintent_CALIBRATE_Focus_Y  
    endif
  elseif (r_cproc.eq.'POIN' .or. r_cproc.eq.'FIVE' ) then
    scanIntent = scanintent_CALIBRATE_POINTING   ! 
    calDataType = CalDataOrigin_CHANNEL_AVERAGE_CROSS 
  elseif (r_cproc.eq.'CORR') then
    calDataType = CalDataOrigin_CHANNEL_AVERAGE_CROSS 
    if (r_itype.eq.1) then
      scanIntent =  scanintent_OBSERVE_TARGET  ! 
    elseif (r_itype.eq.2) then
      scanIntent = scanintent_CALIBRATE_PHASE  ! 'Phase, Amplitude'
    endif
  end if
  !
  ! Holography (from ATF/OSF)
  if (holodata) then
    scanIntent = scanintent_MAP_ANTENNA_SURFACE 
    calDataType = CalDataOrigin_HOLOGRAPHY
    if (r_cproc.eq.'HOLO') then
      subscanIntent= subscanintent_SCANNING   
    elseif (r_cproc.eq.'CORR') then
      subscanIntent=  subscanintent_REFERENCE   
    elseif (r_cproc.eq.'POIN') then
      subscanIntent= subscanintent_SCANNING     
    endif
  endif
  return
end subroutine set_intent
!---------------------------------------------------------------------
subroutine get_intent(numIntent, scanIntent, subscanIntent,   &
    deviceName)
  use sdm_Types
  use sdm_Enumerations
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  integer :: scanIntent(numIntent), subScanIntent, deviceName
  logical :: isIntent
  integer :: numIntent, lenz, ls, lss
  character :: procname*4
  !
  ! TBD : this is not 100% full proof and tested...
  !     Calibration scans
  !
  if (isIntent(numIntent,scanIntent,scanintent_CALIBRATE_ATMOSPHERE)) then
    if (deviceName .eq. CalibrationDevice_NONE) then
      r_scaty = 5
    elseif (deviceName .eq. CalibrationDevice_COLD_LOAD) then
      r_scaty = 7
    elseif (deviceName .eq. CalibrationDevice_AMBIENT_LOAD) then
      r_scaty = 4
    endif
    r_cproc = 'CALI'
  elseif (isIntent(numIntent,scanIntent,scanintent_DO_SKYDIP)) then
    if (deviceName .eq. CalibrationDevice_NONE) then
      r_scaty = 5
    elseif (deviceName .eq. CalibrationDevice_AMBIENT_LOAD) then
      r_scaty = 4
    endif
    r_cproc = 'SKYD'
    r_itype = 2
  elseif (isIntent(numIntent,scanIntent,scanintent_CALIBRATE_FOCUS)) then
    r_scaty = 1
    r_cproc = 'FOCU'
    r_itype = 2
  elseif (isIntent(numIntent,scanIntent,scanintent_CALIBRATE_FOCUS_X)) then
    r_scaty = 11
    r_cproc = 'FOCU'
    r_itype = 2
  elseif (isIntent(numIntent,scanIntent,scanintent_CALIBRATE_FOCUS_Y)) then
    r_scaty = 12
    r_cproc = 'FOCU'
    r_itype = 2
  elseif (isIntent(numIntent,scanIntent,scanintent_CALIBRATE_POINTING))  then
    r_cproc = 'POIN'
    r_itype = 2
  elseif (isIntent(numIntent,scanIntent,scanintent_CALIBRATE_PHASE) .or.   &
    isIntent(numIntent,scanIntent,scanintent_CALIBRATE_ampli)) then
    if (r_lmode.ne.2) then
      r_cproc = 'CORR'
    else
      r_cproc = 'AUTO'
    endif
    r_itype = 2
  elseif (isIntent(numIntent,scanIntent,scanintent_MAP_ANTENNA_SURFACE)   &
       .or. isIntent(numIntent,scanIntent,scanintent_OBSERVE_TARGET)) &
       then
    if (subscanIntent .eq. subscanintent_SCANNING) then
       if (r_lmode.ne.2) then
          r_cproc = 'HOLO'
       else
          r_cproc = 'AUTO'
       endif
       r_itype = 2
    elseif  (subscanIntent.eq.  subscanintent_REFERENCE)   &
      then
       if (r_lmode.ne.2) then
          r_cproc = 'CORR'
       else
          r_cproc = 'AUTO'
       endif
       r_itype = 2
       !
       ! Dummy flux for calibration
       r_flux = 1.0
    endif
  else
    !
    !     source scans
    !
    r_itype = 1
    if (r_lmode.ne.2) then
      r_cproc = 'CORR'
    else
      r_cproc = 'AUTO'
    endif
  endif
  !
  r_proc = 23
  do while (r_proc.gt.0 .and. procname(r_proc).ne.r_cproc)
    r_proc = r_proc-1
  enddo
  return
end subroutine get_intent
!
logical*4 function isIntent(numIntent, scanIntent, intent)
  integer numIntent, i, scanIntent(numIntent), intent
  !
  isIntent = .false.
  do i=1, numIntent
    !         
    isIntent = isIntent .or. scanIntent(i).eq.intent
  enddo
  return
end function isIntent

!-----------------------------------------------------------------------
! Public API for interactive or non-interactive programs linked to
! the libclass, as described in the memo "Class Data Fillers".
!
!  Fortran entry points:
!   class_write_init: initialize the libclass for writing process,
!   class_write_clean: clean the libclass after writing process,
!   class_fileout_open: initialize/reopen a Class output file,
!   class_fileout_close: close the Class output file,
!   class_obs_init: initialize an observation variable,
!   class_obs_reset: zero-ify and resize an observation,
!   class_obs_write: write an observation to the output file,
!   class_obs_clean: clean/free an observation variable.
!-----------------------------------------------------------------------
!
subroutine class_write_init(error)
  use class_dependencies_interfaces
  use class_interfaces, except_this=>class_write_init
  !---------------------------------------------------------------------
  ! @ public (available to external programs)
  !   Public procedure suited for programs linked basically to the
  ! libclass, i.e. with no Gildas specific features like interpreter or
  ! initializations or so. See demo program classdemo-telwrite.f90
  !   Perform the basic initializations of the libclass needed for
  ! the writing process (e.g. stand-alone program at the telescope).
  !   Should be done once at program startup.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
   !
  ! libclassic/libclass initialization
  call classic_init(error)
  if (error)  return
  call allocate_class(error)
  if (error)  return
  !
end subroutine class_write_init
!
subroutine class_write_clean(error)
  use class_interfaces, except_this=>class_write_clean
  !---------------------------------------------------------------------
  ! @ public (available to external programs)
  !   Public procedure suited for programs linked basically to the
  ! libclass, i.e. with no Gildas specific features like interpreter or
  ! initializations or so. See demo program classdemo-telwrite.f90
  !   Perform the basic cleaning of the libclass needed after the
  ! writing process (e.g. stand-alone program at the telescope).
  !  Should be done once before leaving the program
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call class_exit(error)
  !
end subroutine class_write_clean
!
subroutine class_fileout_open(spec,lnew,lover,lsize,lsingle,error)
  use classic_api
  use class_dependencies_interfaces
  use class_setup
  !---------------------------------------------------------------------
  ! @ public (available to external programs)
  !  Public entry point to open a new or reopen an old output file.
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: spec     ! File name including extension
  logical,                    intent(in)    :: lnew     ! Should it be a new file or an old?
  logical,                    intent(in)    :: lover    ! If new, overwrite existing file or raise an error?
  integer(kind=entry_length), intent(in)    :: lsize    ! If new, maximum number of observations allowed
  logical,                    intent(in)    :: lsingle  ! If new, should spectra be unique?
  logical,                    intent(inout) :: error    ! Logical error flag
  !
  call classcore_fileout_open(set,spec,lnew,lover,lsize,lsingle,error)
  if (error)  return
  !
end subroutine class_fileout_open
!
subroutine class_fileout_close(error)
  use class_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ public (available to external programs)
  !  Close the output file without closing the input file if they are
  ! the same
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Error status
  !
  call classcore_fileout_close(error)
  if (error)  return
  !
end subroutine class_fileout_close
!
subroutine class_obs_write(obs,error)
  use class_dependencies_interfaces
  use class_setup
  use class_types
  !---------------------------------------------------------------------
  ! @ public (available to external programs)
  !  Write the observation to the currently opened output file
  !  See demo program classdemo-telwrite.f90
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs    !
  logical,           intent(inout) :: error  ! Logical error flag
  !
  call class_write(set,obs,error,sas_function)
  ! NB: this uses Class's global setup
  ! NB: no way to use a custom 'user_function', use class dummy one instead
  !
end subroutine class_obs_write
!
subroutine class_fold_obs(obs,keepblank,error)
  use class_dependencies_interfaces
  use class_setup
  use class_types
  !----------------------------------------------------------------------
  ! @ public (available to external programs)
  !   Fold an unfolded frequency switched observation.
  !  Each phase is assumed to be given a weight and a frequency change.
  !  The frequency change need not be an integer number of channels.
  !  The number of phases is not limited.
  !-----------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  logical,           intent(in)    :: keepblank  ! Keep blank channels at boundaries?
  logical,           intent(inout) :: error
  !
  call classcore_fold_obs(set,obs,keepblank,error)
  if (error)  return
  !
end subroutine class_fold_obs
!
subroutine class_modify_vdirection(head,error)
  use class_dependencies_interfaces
  use class_setup
  use class_types
  !---------------------------------------------------------------------
  ! @ public (available to external programs)
  ! Support routine for command:
  !  MODIFY VDIRECTION
  !---------------------------------------------------------------------
  type(header), intent(inout) :: head   !
  logical,      intent(inout) :: error  !
  !
  call modify_vdirection(set,head,error)
  if (error)  return
  !
end subroutine class_modify_vdirection

program uv_check
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS
  !	A dedicated task to check a UV table for non-constant weights
  !     as a function of channels
  !
  !---------------------------------------------------------------------
  ! Generic variables
  character(len=filename_length) :: cuvin
  logical :: error
  !
  ! Code:
  call gildas_open
  call gildas_char('UV_INPUT$',cuvin)
  call gildas_close
  !
  call sub_uv_check (cuvin, error)
  if (error) call sysexi(fatale)
end program uv_check
!
subroutine sub_uv_check (cuvin, error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! GILDAS
  !	A dedicated task to check a UV table for non-constant weights
  !     as a function of channels
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: cuvin
  logical, intent(out) :: error
  !
  type (gildas) :: uvin
  integer, allocatable :: cases(:)
  integer :: ier,ib
  character(len=*), parameter :: rname='UV_CHECK'
  character(len=80) :: mess
  integer :: ncase, nvisi, nblock
  !
  ! Simple checks 
  error = len_trim(cuvin).eq.0
  if (error) then
    call map_message(seve%e,rname,'No input UV table name')
    return
  endif
  !
  call gildas_null (uvin, type = 'UVT') 
  call gdf_read_gildas(uvin, cuvin, '.uvt', error, data=.false.)
  if (error) then
    call gagout('F-'//rname//',  Cannot read input UV table')
    return
  endif
  !
  ncase = uvin%gil%nchan
  allocate (cases(uvin%gil%nchan),stat=ier)
  !
  ! Define blocking factor, on largest data file, usually the input one
  ! but not always...  
  call gdf_nitems('SPACE_GILDAS',nblock,uvin%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,uvin%gil%dim(2))
  ! Allocate respective space 
  allocate (uvin%r2d(uvin%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',uvin%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  ! 
  ! Initialize
  ncase = 1
  cases(1) = 1
  !
  ! Loop over line table - 
  uvin%blc = 0
  uvin%trc = 0
  !
  do ib = 1,uvin%gil%dim(2),nblock
    write(mess,*) ib,' / ',uvin%gil%dim(2),nblock
    call map_message(seve%d,rname,mess) 
    uvin%blc(2) = ib
    uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock) 
    call gdf_read_data (uvin,uvin%r2d,error)
    !
    ! Here do the job
    nvisi = uvin%trc(2)-uvin%blc(2)+1
    call howmany_beams (uvin, nvisi, uvin%r2d, cases, ncase, error) 
    if (error) return
  enddo
  !
  ! Write the result
  if (ncase.eq.1) then
    call map_message(seve%i,rname,'Only one beam needed')
  else
    call map_message(seve%w,rname,'More than one beam needed, channels:')
    write(6,*) cases(1:ncase)
  endif
end subroutine sub_uv_check
!
subroutine howmany_beams(uvin, nvisi, din, cases, ncase, error)
  use image_def
  type(gildas), intent(in) :: uvin
  integer, intent(in) :: nvisi
  real, intent(in) :: din(uvin%gil%dim(1),nvisi)
  integer, intent(inout) :: cases(uvin%gil%nchan)
  integer, intent(inout) :: ncase
  logical, intent(out) :: error
  !
  real, allocatable :: wlast(:), wcur(:)
  logical, allocatable :: mask(:)
  !
  integer :: k,ic,ier
  !
  allocate (wlast(nvisi),wcur(nvisi),mask(nvisi),stat=ier)
  error = ier.ne.0
  if (error) return
  !
  wlast(:) = din(uvin%gil%fcol+2,:)
  !
  k = uvin%gil%fcol+2
  do ic = 2,uvin%gil%nchan
     k = k+3
     wcur(:) = din(k,:)
     mask(:) = wcur(:).ne.wlast(:) 
     if (any(mask)) then
        ncase = ncase+1
        cases(ncase) = ic ! Which channel
     endif
  enddo
  deallocate (wlast,wcur,mask)
end subroutine howmany_beams
     

subroutine sub_alma (   &
     &    l_method,l_hdirty,l_hresid,l_hclean,   &
     &    l_hbeam,l_hprim,l_tfbeam,l_list,   &
     &    c_method,c_hdirty,c_hresid,c_hclean,   &
     &    c_hbeam,c_hprim,c_tfbeam,c_list,   &
     &    error,tcc)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_alma
  use clean_def
  use image_def
  use gbl_message
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the Multi Resolution which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: l_method, c_method
  type (gildas), intent(inout)  :: l_hdirty, l_hbeam, l_hresid, l_hprim
  type (gildas), intent(inout)  :: l_hclean
  type (gildas), intent(inout)  :: c_hdirty, c_hbeam, c_hresid, c_hprim
  type (gildas), intent(inout)  :: c_hclean
  real, intent(inout) :: l_tfbeam(l_hbeam%gil%dim(2),l_hbeam%gil%dim(3),l_hbeam%gil%dim(1))
  real, intent(inout) :: c_tfbeam(c_hbeam%gil%dim(2),c_hbeam%gil%dim(3),c_hbeam%gil%dim(1))
  logical, intent(inout) :: error
  type (cct_par), intent(inout) :: tcc(l_method%m_iter)
  integer, intent(in) :: l_list(:)
  integer, intent(in) :: c_list(:)
  !
  real, pointer :: c_dirty(:,:)    ! Dirty map
  real, pointer :: c_resid(:,:)    ! Iterated residual
  real, pointer :: c_clean(:,:)    ! Clean Map
  real, pointer :: c_dprim(:,:,:)  ! Primary beam
  real, pointer :: c_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: c_atten(:,:)
  !
  real, pointer :: l_dirty(:,:)    ! Dirty map
  real, pointer :: l_resid(:,:)    ! Iterated residual
  real, pointer :: l_clean(:,:)    ! Clean Map
  real, pointer :: l_beam(:,:) ! Beam for fit
  real, pointer :: l_dprim(:,:,:)  ! Primary beam
  real, pointer :: l_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: l_atten(:,:)
  !
  real, allocatable :: w_fft(:) ! TF work area
  complex, allocatable :: w_work(:,:)  ! Work area
  complex, allocatable :: c_work(:,:)  ! Expansion of residual
  real, allocatable :: r_work(:,:) ! Expansion of residual
  type(cct_par), allocatable :: w_comp(:)
  real, allocatable, target :: sc_beam(:,:,:)
  real, allocatable :: w_resid(:,:)
  !
  character(len=*), parameter :: rname='SUB_ALMA'
  !
  integer iplane,ibeam
  integer nx,ny,np,mx,my,mp,nc,kx,ky
  integer ip, ier
  real l_max, c_max
  logical do_fft, ok
  character(len=80) :: chain
  character(len=2) ans
  integer nker,mker
  parameter (mker=11)
  real smooth
  real, allocatable :: kernel(:,:),kernels(:,:,:)
  real noise,value,scale,fhat,long,compact
  !
  error = .false.
  do_fft = .true.
  !
  ! Local variables
  nx = l_hclean%gil%dim(1)
  ny = l_hclean%gil%dim(2)
  np = l_hprim%gil%dim(1)
  mx = c_hbeam%gil%dim(1)
  my = c_hbeam%gil%dim(2)
  mp = c_hprim%gil%dim(1)
  nc = nx*ny
  !
  allocate (w_work(nx,ny),r_work(nx,ny),c_work(mx,my), &
       & w_fft(max(nx,ny)),w_comp(nc), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on ALMA arrays')
    error = .true.
    return
  endif
  !
  ! Smoothed version of the Compact images
  allocate (sc_beam(mx,my,mp),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on ACA arrays')
    error = .true.
    return
  endif
  ! Global residuals
  allocate (w_resid(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on residuals')
    error = .true.
    return
  endif
   !
  ! Some global pointers
  l_dprim => l_hprim%r3d
  l_dbeam => l_hbeam%r3d
  l_atten => l_method%atten(:,:,1)
  c_dprim => c_hprim%r3d
  c_dbeam => c_hbeam%r3d       ! To begin with
  c_atten => c_method%atten(:,:,1)
  !
  ! Relative noise contributions
  long = l_hdirty%gil%noise**2
  compact = c_hdirty%gil%noise**2
  scale = long+compact
  long = long/scale
  compact = compact/scale
  !
  ! Initialize the kernel
  smooth = c_method%smooth
  if (smooth.eq.0) then
     nker = 1
  else
     nker = mker
  endif
  allocate (kernels(nker,nker,mp),kernel(nker,nker),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on Kernels')
    error = .true.
    return
  endif
  call init_kernel(kernel,nker,nker,smooth)
  !
  ! Initialize smoothed beams
  do ip=1,mp
     call smooth_kernel (c_dbeam(:,:,ip),sc_beam(:,:,ip),   &
          &      mx,my,nker,nker,kernel)
  enddo
  !
  ! Renormalize the beams. Have some difficulty here, because the
  ! factor is not exactly the same for each primary beam...
  !
  kx = mx/2+1
  ky = my/2+1
  noise = 0.0
  do ip=1,mp
    value = 1.0/sc_beam(kx,ky,ip)
    noise = noise + value
    sc_beam(:,:,ip) = sc_beam(:,:,ip) * value
    kernels(:,:,ip) = kernel*value
  enddo
  scale = noise/float(mp)      ! Kernel scaling factor
  kernel= kernel * scale       ! Mean smoothing kernel ...
  noise = sqrt(scale*compact/long) ! Mean noise RATIO
  !!
  !!      CALL SMOOTH_MASK (SC_MASK,C_METHOD%MASK,MX,MY,KERNEL,NKER)
  !
  ! Move pointer towards the Smoothed Compact Beams
  ! This allow to perform a "normal" deconvolution with the Smoothed
  ! Compact Beam
  c_hbeam%r3d => sc_beam
  !
  ! Loop here if needed
  do iplane = l_method%first, l_method%last
    l_method%flux = 0.0
    c_method%flux = 0.0
    l_method%n_iter= 0
    c_method%n_iter= 0
    !
    l_method%iplane = iplane
    c_method%iplane = iplane
    call beam_plane(l_method,l_hbeam,l_hdirty)
    ibeam = l_method%ibeam
    !
    ! Local aliases
    l_dirty => l_hdirty%r3d(:,:,iplane)
    l_resid => l_hresid%r3d(:,:,iplane)
    l_clean => l_hclean%r3d(:,:,iplane)
    l_beam  => l_hbeam%r3d(:,:,ibeam)
    !
    c_dirty => c_hdirty%r3d(:,:,iplane)
    c_resid => c_hresid%r3d(:,:,iplane)
    c_clean => c_hclean%r3d(:,:,iplane)
    !
    ! Initialize to Dirty map
    l_resid = l_dirty
    !
    ! C_RESID is now the Smoothed Compact Residual
    call smooth_kernel(c_dirty,c_resid,mx,my,nker,nker,kernel)
    !NO!         CALL SMOOTH_MASKED(C_DIRTY,C_RESID,MX,MY,KERNEL,
    !!     $   NKER,C_METHOD%MASK)
    !
    ! Prepare beam parameters
    call get_clean (l_method, l_hbeam, l_beam, error)
    if (error) return
    call get_beam (l_method,l_hbeam,l_hresid,l_hprim,   &
        &        l_tfbeam,w_work,w_fft,fhat,error)
    if (error) return
    !
    call get_beam (c_method,c_hbeam,c_hresid,c_hprim,   &
        &        c_tfbeam,w_work,w_fft,fhat,error)
    if (error) return
    !
    ! Apply the Weight
    l_resid = l_resid * l_atten
    c_resid = c_resid * c_atten
    call mrc_plot(c_atten,mx,my,1,'Weight')
    !
    ! Performs decomposition into components:
    ! Only one major cycle per iteration, with a limited number
    ! of components ?
    !
    l_method%ngoal = 1000
    c_method%ngoal = 100
    call sic_get_inte ('C_GOAL',c_method%ngoal,error)
    !
    ! Locate the maximum of the Compact & Normal images
    l_max = amaxlst (l_method,l_list,l_resid,nx,ny)
    c_max = amaxlst (c_method,c_list,c_resid,mx,my)
    ok = l_max.gt.l_method%ares .or. c_max.gt.c_method%ares
    do while (ok)
      !
      ! Plot for debug
      if (l_method%pcycle) then
        call mrc_plot(c_resid,mx,my,2,'Compact')
        call mrc_plot(l_resid,nx,ny,3,'Long')
      endif
      !
      ! NOISE is the Noise RATIO (mean value over the beams)
      !
      if (l_max.gt.c_max/noise) then
        write(chain,*) 'LONG baselines ',   &
            &          l_max,c_max/noise,noise
        call gagout(chain)
        if (l_method%qcycle) then
          call sic_wpr('WAIT ? ',ans)
        endif
        !
        ! Find components in LONG baseline image
        call one_cycle90 (l_method,l_hclean,   &   !
            &          l_clean,   &   ! Final CLEAN image
            &          l_dbeam,   &   ! Dirty beams
            &          l_resid,nx,ny,   & ! Residual and size
            &          l_tfbeam, w_work,   &  ! FT of dirty beam + Work area
            &          w_comp, nc,         &  ! Component storage + Size
            &          l_method%beam0(1),l_method%beam0(2),   &   ! Beam center
            &          l_method%patch(1),l_method%patch(2),   &
            &          l_method%bgain,l_method%box,   &
            &          w_fft,   &     ! Work space for FFTs
            &          tcc,   &       ! Component table
            &          l_list, l_method%nlist,   & ! Search list
            &          np,   &        ! Number of fields
            &          l_dprim,   &   ! Primary beams
            &          l_atten,   &  ! Weight
            &          l_max)
        !
        ! Define component type
        tcc(c_method%n_iter+1:l_method%n_iter)%type = 0
        ! Remove from COMPACT baselines
        call remove_inother(c_method,c_resid,mx,my,   &
            &          c_tfbeam, w_fft,mp,c_dprim,c_atten,   &
            &          tcc,c_method%n_iter+1,l_method%n_iter,nx,ny,   &
            &          kernel, nker)
        ! Define number of iterations
        c_method%n_iter = l_method%n_iter
        c_method%flux = l_method%flux
      else
        write (chain,*) 'COMPACT baselines ',   &
            &          l_max,c_max/noise,noise
        call gagout(chain)
        if (l_method%qcycle) then
          call sic_wpr('WAIT ? ',ans)
        endif
        !
        ! Find components in COMPACT baseline image
        call one_cycle90 (c_method,c_hclean,   &   !
            &          c_clean,   &   ! Final CLEAN image
            &          sc_beam,   &   ! (Smoothed) Dirty beams
            &          c_resid,mx,my,          &    ! Residual and size
            &          c_tfbeam, w_work,       &    ! FT of dirty beam + Work area
            &          w_comp, nc,             &    ! Component storage + Size
            &          c_method%beam0(1),c_method%beam0(2),   &   ! Beam center
            &          c_method%patch(1),c_method%patch(2),   &   ! Patch
            &          c_method%bgain,c_method%box,   &
            &          w_fft,    &    ! Work space for FFTs
            &          tcc,      &     ! Component table
            &          c_list, c_method%nlist,   & ! Search list
            &          mp,       &    ! Number of fields
            &          c_dprim,  &    ! Primary beams
            &          c_atten, &    ! Weight
            &          c_max)
        ! Define component type
        tcc(l_method%n_iter+1:c_method%n_iter)%type = 1
        ! Remove from LONG baselines
        call remove_inother(l_method,l_resid,nx,ny,   &
            &          l_tfbeam, w_fft, np,l_dprim,l_atten,   &
            &          tcc,l_method%n_iter+1,c_method%n_iter,mx,my,   &
            &          kernel, nker)
        ! Define number of components
        l_method%n_iter = c_method%n_iter
        l_method%flux = c_method%flux
      endif
      ! Stop if done
      l_max = amaxlst (l_method,l_list,l_resid,nx,ny)
      c_max = amaxlst (c_method,c_list,c_resid,mx,my)
      ok = l_max.gt.l_method%ares .or. c_max.gt.c_method%ares
      if (l_method%n_iter.ge.l_method%m_iter) ok = .false.
    enddo
    !
    ! Add clean components and residuals to produce clean map
    ! Note that the Kernel is still scaled in the same way as before
    if (l_method%n_iter.ne.0) then
      call alma_make90 (l_method, l_hclean, c_hclean,   &
           &        tcc, kernel, nker)
    else
      l_clean = 0
    endif
    !
    ! Which residual should be added ?...
    ! We do not want to add noise, but to combine it properly...
    ! We may need to go to the full combined gridding business here...
    l_clean = l_clean + l_resid * l_atten * long
    c_clean = c_resid * c_atten * compact
    call expand (nx,ny,r_work,w_work,mx,my,c_clean,c_work,w_fft)
    l_clean = l_clean + r_work
  enddo
end subroutine sub_alma
!
function amaxlst (method,list,resid,nx,ny)
  use clean_def
  use imager_interfaces, only : maxlst
  !-----------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !-----------------------------------------------------
  real amaxlst      ! intent(out)
  type (clean_par), intent(inout) :: method
  integer, intent(in) :: nx,ny
  integer, intent(in) :: list(:)
  real, intent(in) :: resid(nx,ny)
  !
  real maxc, minc, maxabs
  integer imin,imax,jmin,jmax
  !
  call maxlst (resid,nx,ny,list,method%nlist,   &
       &    maxc,imax,jmax,minc,imin,jmin)
  if (method%n_iter.lt.method%p_iter) then
    maxabs=abs(maxc)
  elseif ( abs(maxc).lt.abs(minc) ) then
    maxabs=abs(minc)
  else
    maxabs=abs(maxc)
  endif
  amaxlst = maxabs
end function amaxlst
!
subroutine one_cycle90 (method,head,   &
     &    clean,beam,resid,nx,ny,tfbeam,fcomp,   &
     &    wcl,mcl,ixbeam,iybeam,ixpatch,iypatch,bgain,   &
     &    box, work, tcc, list, nl, nf, primary, weight, maxabs)
  use clean_def
  use image_def
  use gbl_message
  use imager_interfaces, except_this=>one_cycle90
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Major cycle loop according to B.Clark idea
  !----------------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: head
  !
  integer, intent(in) ::  nf,nx,ny,mcl,nl
  real, intent(inout) ::  clean(nx,ny)
  real, intent(inout) ::  resid(nx,ny)
  real, intent(in) ::     beam(nx,ny,nf)
  real, intent(inout) ::  tfbeam(nx,ny,nf)     ! T.F. du beam  Complex ?
  complex, intent(inout) :: fcomp(nx,ny)       ! T.F. du vecteur modification
  type(cct_par), intent(inout) ::  wcl(mcl)
  real, intent(in) ::  bgain                   ! Maximum sidelobe level
  integer, intent(in) ::  ixbeam, iybeam       ! Beam maximum position
  integer, intent(in) ::  ixpatch, iypatch     ! Beam patch radius
  integer, intent(in) ::  box(4)               ! Cleaning box
  real, intent(inout) ::  work(*)                 ! Work space for FFT
  type(cct_par), intent(inout) :: tcc(method%m_iter) ! Clean components array
  integer, intent(in) ::  list(nl)
  !
  real, intent(in) ::  primary(nf,nx,ny)       ! Primary beams
  real, intent(in) ::  weight (nx,ny)
  !
  real    maxabs     ! max and min of data, absolute max value
  real    borne                ! Fraction of initial data
  real    limite               ! Minimal intensity retained
  real    clarkl               ! Clark worry limit
  integer ncl                  ! Number of selected data points
  logical fini                 ! Stopping criterium 
  logical converge             ! Stop by flux convergence
  integer kcl
  character(len=message_length) :: chain
  character(len=*), parameter :: rname = 'CLARK'
  !
  ! Maximum residual is already located, MAXABS
  borne= max(method%fres*maxabs,method%ares)
  fini = maxabs.lt.borne
  !
  ! ONE Major cycle
  !
  ! Define minor cycle limit
  limite = max(maxabs*bgain,0.8*borne)
  clarkl = maxabs*bgain
  !!      PRINT *,'Limits ',MAXABS,LIMITE,CLARKL
  !
  kcl = mcl
  !
  ! Select points of maximum strength and load them in
  call choice (   &
       &    resid,   &           ! Current residuals
       &    nx,ny,   &           ! image size
       &    list, nl,   &        ! Search list
       &    limite,   &          ! Detection threshold
       &    kcl,   &             ! Maximum number of candidates
       &    wcl,   &             ! Selected candidate components
       &    ncl,   &             ! Selected Number of components
       &    maxabs, method%ngoal)
  !
  if (ncl.gt.0) then
     write(chain,100) 'Selected ',ncl,' points above ',limite
     call map_message(seve%i,rname,chain)
     !
     ! Make minor cycles
     call minor_cycle90 (method,   &
          &      wcl,          &    ! Original candidate components
          &      ncl,          &    ! Number of candidates
          &      beam,nx,ny,   &    ! Dirty beams and Size
          &      ixbeam,iybeam,   & ! Beam center
          &      ixpatch,iypatch,   &   ! Beam patch
          &      clarkl,limite,   &
          &      converge,   &      !
          &      tcc,   &           ! Cumulated components
          &      nf, primary, weight, method%trunca,   &
          &      method%flux,   &   ! Total Flux
          &      method%pflux, next_flux90)
     !
     ! Remove all components by FT : RESID = RESID - BEAM # WCL(*,4)
     call remisajour (nx*ny,   &    ! Total size
          &      clean,   &         ! CLEAN map used as work space
          &      resid,   &         ! Updated residuals
          &      tfbeam,   &        ! Beam TF
          &      fcomp,   &         ! Work space for Component TF
          &      wcl,     &         ! Clean flux values
          &      ncl,   &           ! Number of Clean Components
          &      nx,ny,   &         ! Map size
          &      work,   &          ! FFT work space
          &      nf, primary, weight, method%trunca)
     write (chain,101)  'Cleaned ',method%flux,' Jy with ',   &
          &      method%n_iter,' clean components'
     call map_message(seve%i,rname,chain)
  else
     ! No component found: finish...
     write(chain,101) 'No points selected above ',limite
     call map_message(seve%i,rname,chain)
  endif
  write(chain,102)  'CLEAN found ',method%flux,' Jy in ',   &
       &    method%n_iter,' clean components'
  call map_message(seve%i,'CLEAN',chain)
  !
100 format (a,i6,a,1pg10.3,a)
101 format (a,1pg10.3,a,i7,a)
102 format (a,1pg10.3,a,i7,a)
end subroutine one_cycle90
!
subroutine remove_inother(method,resid,nx,ny,tfbeam,wfft,   &
     &    np,primary,weight,   &
     &    tcc,first,last,mx,my,kernel,nker)
  use clean_def
  use gkernel_interfaces, only : fourt
  use imager_interfaces, except_this=>remove_inother
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for ALMA deconvolution
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  !
  integer, intent(in) ::  np,nx,ny,mx,my,nker,first,last
  real, intent(inout) ::  resid(nx,ny)
  real, intent(inout) ::  tfbeam(nx,ny,np)     ! T.F. du beam  Complex ?
  real, intent(in) :: primary(np,nx,ny)
  real, intent(in) :: weight(nx,ny)
  real, intent(inout) :: kernel(nker,nker)
  real, intent(inout) :: wfft(*)
  type(cct_par), intent(inout) :: tcc(last)
  !
  complex, allocatable :: icomp(:,:), ocomp(:,:)
  real, allocatable :: clean(:,:), prim(:,:), sky(:,:)
  real, allocatable :: ricomp(:,:),rocomp(:,:)
  real wtrun,val,fact
  integer k,ndim,nn(2),ip,ix,iy,ier
  integer jx,jy,xfact,yfact,firstx,lastx,firsty,lasty
  logical comp
  !
  wtrun = method%trunca
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  !
  allocate (ocomp(nx,ny),icomp(mx,my),clean(nx,ny),ricomp(mx,my) &
    & ,rocomp(nx,ny),sky(nx,ny),prim(nx,ny),stat=ier)
  if (ier.ne.0) return
  !
  comp = mx.gt.nx
  fact = float(mx*my)/float(nx*ny)
  xfact = nx/mx
  yfact = ny/my
  !
  ! Optimized by using CLEAN to store sum of components before multiplying
  ! by the weights to subtract from the Residuals
  clean = 0.0
  ricomp = 0.0
  do k=first,last
    ix = tcc(k)%ix
    iy = tcc(k)%iy
    val = tcc(k)%value * fact
    if (tcc(k)%type.eq.0) then
      ricomp(ix,iy) = ricomp(ix,iy) + val
    else
      call add_kernel (ricomp,mx,my,val,ix,iy,nker,nker,kernel)
    endif
  enddo
  !
  ! Add compression and/or expansion
  if (comp) then
    call compress(mx,my,ricomp,icomp,nx,ny,rocomp,ocomp,wfft)
  else
    !
    ! Expand by XFACT & YFACT
    rocomp = 0.0
    do k=first,last
      ix = tcc(k)%ix
      iy = tcc(k)%iy
      val = tcc(k)%value * fact
      lastx = xfact*ix
      lasty = yfact*iy
      firstx = lastx-xfact+1
      firsty = lasty-yfact+1
      do jy=firsty,lasty
        do jx=firstx,lastx
          rocomp(jx,jy) = rocomp(jx,jy)+val
        enddo
      enddo
      !!            CALL ADD_KERNEL (RICOMP,MX,MY,VAL,IX,IY,KERNEL,NKER)
    enddo
  endif
  sky = rocomp
  if (method%pcycle) then
    call mrc_plot(weight,nx,ny,1,'Weight')
    call mrc_plot(resid,nx,ny,2,'Resid')
    call mrc_plot(sky,nx,ny,3,'Sky')
    !         if (method%qcycle) call sic_wpr('Continue',ans)
  endif
  !
  ! Loop on the fields
  do ip=np,1,-1
    prim = primary(ip,:,:)
    if (method%pcycle) call mrc_plot(prim,nx,ny,1,'Primary')
    !
    ! Multiply by Complete Primary beam...
    rocomp = sky*prim
    !
    ! Convolve with dirty beam
    ocomp = cmplx(rocomp,0.0)
    call fourt(ocomp,nn,ndim,-1,0,wfft)
    rocomp = tfbeam(:,:,ip)
    ocomp = ocomp*rocomp
    call fourt(ocomp,nn,ndim,1,1,wfft)
    rocomp = real(ocomp)
    !
    ! Multiply by Truncated Primary beam now
    where (prim.lt.wtrun)
      prim = 0
    end where
    rocomp = rocomp*prim
    if (method%pcycle) call mrc_plot(rocomp,nx,ny,3,'Comp...')
    clean(:,:) = clean + rocomp
  enddo
  if (method%pcycle) then
    !         if (method%qcycle) call sic_wpr('Continue',ans)
    call mrc_plot(clean,nx,ny,3,'Clean')
    call mrc_plot(resid,nx,ny,1,'Residu')
  endif
  resid(:,:) = resid - clean*weight
end subroutine remove_inother
!
subroutine add_primker (clean,nx,ny,np,prim,value,kx,ky,kp,ker,nk)
  !-----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Smooth an array using a kernel, with Primary Beams
  !   For ALMA deconvolution
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx,ny,np             ! Image size
  real, intent(in) :: value                   ! Input value
  real, intent(inout) :: clean(nx,ny)         ! Summed output array
  real, intent(in) :: prim(np,nx,ny)
  integer, intent(in) :: kp                   ! Field
  integer, intent(in) :: kx,ky                ! Center of value
  integer, intent(in) :: nk                   ! Kernel size
  real, intent(in) :: ker(nk,nk)
  !
  integer i,j,lk,li,lj
  !
  if (nk.eq.1) then
    clean(kx,ky) = clean(kx,ky) + prim(kp,kx,ky)*value
  else
    lk = (nk-1)/2
    do j=ky-lk,ky+lk
      lj = j-ky+lk+1
      do i=kx-lk,kx+lk
        li = i-kx+lk+1
        clean(i,j) = clean(i,j) + prim(kp,i,j) *   &
              &          ker (li,lj) * value
      enddo
    enddo
  endif
end subroutine add_primker
!
subroutine alma_make90 (method, l_hclean, c_hclean,   &
     &    tcc, kernel,nker)
  use gkernel_interfaces, only : fourt
  use clean_def
  use image_def
  !-------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Make clean map
  !-------------------------------------------------------------
  integer, intent(in) :: nker
  real, intent(in) :: kernel(nker,nker)
  type (clean_par), intent(inout) :: method
  type (gildas), intent(inout) :: l_hclean, c_hclean
  type (cct_par), intent(in) :: tcc(method%n_iter)
  !
  real(8), parameter :: pi=3.141592653589793d0
  integer nx,ny,ix,iy,ic,ndim,nn(2),ier, iplane,mx,my
  real xinc, yinc,fact,val
  real, pointer :: l_clean(:,:), c_clean(:,:)
  real, allocatable :: wfft(:)
  complex, allocatable :: fcomp(:,:), c_work(:,:)
  !
  nx = l_hclean%gil%dim(1)
  ny = l_hclean%gil%dim(2)
  mx = c_hclean%gil%dim(1)
  my = c_hclean%gil%dim(2)
  iplane = method%iplane
  l_clean => l_hclean%r3d(:,:,iplane)
  c_clean => c_hclean%r3d(:,:,iplane)
  !
  allocate (wfft(2*max(nx,ny)),stat=ier)
  allocate (fcomp(nx,ny),stat=ier)
  allocate (c_work(mx,my),stat=ier)
  xinc = l_hclean%gil%convert(3,1)
  yinc = l_hclean%gil%convert(3,2)
  !
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  !
  ! First pass for Compact Baselines
  c_clean = 0.0
  fact = float(nx*ny)/float(mx*my)
  do ic=1,method%n_iter
    if (tcc(ic)%type.ne.0) then
      ix = tcc(ic)%ix
      iy = tcc(ic)%iy
      val = tcc(ic)%value * fact
      call add_kernel (c_clean,mx,my,val,ix,iy,   &
           &        nker,nker,kernel)
    endif
  enddo
  !
  ! Expand the Compact Clean Components
  call expand (nx,ny,l_clean,fcomp,mx,my,c_clean,c_work,wfft)
  !
  ! Add the Long Baseline components
  do ic=1,method%n_iter
    if (tcc(ic)%type.eq.0) then
      ix = tcc(ic)%ix
      iy = tcc(ic)%iy
      val = tcc(ic)%value
      l_clean(ix,iy) = l_clean(ix,iy) + val
    endif
  enddo
  !
  ! Convolve by Gaussian
  fcomp = cmplx(l_clean,0.0)
  call fourt(fcomp,nn,ndim,-1,0,wfft)
  fact = method%major*method%minor*pi/(4.0*log(2.0))   &
       &    /abs(xinc*yinc)/(nx*ny)
  call mulgau(fcomp,nx,ny,   &
       &    method%major,method%minor,method%angle,   &
       &    fact,xinc,yinc,-1)
  call fourt(fcomp,nn,ndim,1,1,wfft)
  l_clean = real(fcomp)
end subroutine alma_make90

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! (re)allocation routines
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine reallocate_fits_logi_1d(kind,n,fitsarray,error)
  use gkernel_interfaces
  use imbfits_interfaces, except_this=>reallocate_fits_logi_1d
  use imbfits_messaging
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  character(len=*),     intent(in)    :: kind
  integer(kind=4),      intent(in)    :: n
  type(fits_logi_1d_t), intent(inout) :: fitsarray
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>FITS>LOGI>1D'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (n.lt.0) then
    write(mess,'(A,I0,3A)')  'Array size can not be negative (got ',  &
      n,' for column ''',trim(kind),''')'
    call imbfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = n.gt.0  ! 0 rows in tables is tolerated
  if (associated(fitsarray%val)) then
     if (fitsarray%n.eq.n) then
        write(mess,'(a,a,i0)')  &
          kind,' already associated at the right size: ',n
        call imbfits_message(iseve%alloc,rname,mess)
        alloc = .false.
     else
        write(mess,'(a,a,a)') 'Pointer ',kind,  &
          ' already associated but with a different size => Freeing it first'
        call imbfits_message(iseve%alloc,rname,mess)
        call free_fits_logi_1d(fitsarray,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(fitsarray%val(n),stat=ier)
     if (failed_allocate(rname,kind,ier,error)) then
        call free_fits_logi_1d(fitsarray,error)
        return
     endif
     write(mess,'(a,a,a,i0)') 'Allocated ',kind,' fits_logi_1d of size: ',n
     call imbfits_message(iseve%alloc,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  fitsarray%key = kind
  fitsarray%n = n
  !
end subroutine reallocate_fits_logi_1d
!
subroutine reallocate_fits_inte_1d(kind,n,fitsarray,error)
  use gkernel_interfaces
  use imbfits_interfaces, except_this=>reallocate_fits_inte_1d
  use imbfits_messaging
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  character(len=*),     intent(in)    :: kind
  integer(kind=4),      intent(in)    :: n
  type(fits_inte_1d_t), intent(inout) :: fitsarray
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>FITS>INTE>1D'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (n.lt.0) then
    write(mess,'(A,I0,3A)')  'Array size can not be negative (got ',  &
      n,' for column ''',trim(kind),''')'
    call imbfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = n.gt.0  ! 0 rows in tables is tolerated
  if (associated(fitsarray%val)) then
     if (fitsarray%n.eq.n) then
        write(mess,'(a,a,i0)')  &
          kind,' already associated at the right size: ',n
        call imbfits_message(iseve%alloc,rname,mess)
        alloc = .false.
     else
        write(mess,'(a,a,a)') 'Pointer ',kind,  &
          ' already associated but with a different size => Freeing it first'
        call imbfits_message(iseve%alloc,rname,mess)
        call free_fits_inte_1d(fitsarray,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(fitsarray%val(n),stat=ier)
     if (failed_allocate(rname,kind,ier,error)) then
        call free_fits_inte_1d(fitsarray,error)
        return
     endif
     write(mess,'(a,a,a,i0)') 'Allocated ',kind,' fits_inte_1d of size: ',n
     call imbfits_message(iseve%alloc,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  fitsarray%key = kind
  fitsarray%n = n
  !
end subroutine reallocate_fits_inte_1d
!
subroutine reallocate_fits_real_1d(kind,n,fitsarray,error)
  use gkernel_interfaces
  use imbfits_interfaces, except_this=>reallocate_fits_real_1d
  use imbfits_messaging
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  character(len=*),     intent(in)    :: kind
  integer(kind=4),      intent(in)    :: n
  type(fits_real_1d_t), intent(inout) :: fitsarray
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>FITS>REAL>1D'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (n.lt.0) then
    write(mess,'(A,I0,3A)')  'Array size can not be negative (got ',  &
      n,' for column ''',trim(kind),''')'
    call imbfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = n.gt.0  ! 0 rows in tables is tolerated
  if (associated(fitsarray%val)) then
     if (fitsarray%n.eq.n) then
        write(mess,'(a,a,i0)')  &
          kind,' already associated at the right size: ',n
        call imbfits_message(iseve%alloc,rname,mess)
        alloc = .false.
     else
        write(mess,'(a,a,a)') 'Pointer ',kind,  &
          ' already associated but with a different size => Freeing it first'
        call imbfits_message(iseve%alloc,rname,mess)
        call free_fits_real_1d(fitsarray,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(fitsarray%val(n),stat=ier)
     if (failed_allocate(rname,kind,ier,error)) then
        call free_fits_real_1d(fitsarray,error)
        return
     endif
     write(mess,'(a,a,a,i0)') 'Allocated ',kind,' fits_real_1d of size: ',n
     call imbfits_message(iseve%alloc,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  fitsarray%key = kind
  fitsarray%n = n
  !
end subroutine reallocate_fits_real_1d
!
subroutine reallocate_fits_dble_1d(kind,n,fitsarray,error)
  use gkernel_interfaces
  use imbfits_interfaces, except_this=>reallocate_fits_dble_1d
  use imbfits_messaging
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  character(len=*),     intent(in)    :: kind
  integer(kind=4),      intent(in)    :: n
  type(fits_dble_1d_t), intent(inout) :: fitsarray
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>FITS>DBLE>1D'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (n.lt.0) then
    write(mess,'(A,I0,3A)')  'Array size can not be negative (got ',  &
      n,' for column ''',trim(kind),''')'
    call imbfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = n.gt.0  ! 0 rows in tables is tolerated
  if (associated(fitsarray%val)) then
     if (fitsarray%n.eq.n) then
        write(mess,'(a,a,i0)')  &
          kind,' already associated at the right size: ',n
        call imbfits_message(iseve%alloc,rname,mess)
        alloc = .false.
     else
        write(mess,'(a,a,a)') 'Pointer ',kind,  &
          ' already associated but with a different size => Freeing it first'
        call imbfits_message(iseve%alloc,rname,mess)
        call free_fits_dble_1d(fitsarray,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(fitsarray%val(n),stat=ier)
     if (failed_allocate(rname,kind,ier,error)) then
        call free_fits_dble_1d(fitsarray,error)
        return
     endif
     write(mess,'(a,a,a,i0)') 'Allocated ',kind,' fits_dble_1d of size: ',n
     call imbfits_message(iseve%alloc,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  fitsarray%key = kind
  fitsarray%n = n
  !
end subroutine reallocate_fits_dble_1d
!
subroutine reallocate_fits_char_1d(kind,n,fitsarray,error)
  use gkernel_interfaces
  use imbfits_interfaces, except_this=>reallocate_fits_char_1d
  use imbfits_messaging
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  character(len=*),     intent(in)    :: kind
  integer(kind=4),      intent(in)    :: n
  type(fits_char_1d_t), intent(inout) :: fitsarray
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>FITS>CHAR>1D'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (n.lt.0) then
    write(mess,'(A,I0,3A)')  'Array size can not be negative (got ',  &
      n,' for column ''',trim(kind),''')'
    call imbfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = n.gt.0  ! 0 rows in tables is tolerated
  if (associated(fitsarray%val)) then
     if (fitsarray%n.eq.n) then
        write(mess,'(a,a,i0)')  &
          kind,' already associated at the right size: ',n
        call imbfits_message(iseve%alloc,rname,mess)
        alloc = .false.
     else
        write(mess,'(a,a,a)') 'Pointer ',kind,  &
          ' already associated but with a different size => Freeing it first'
        call imbfits_message(iseve%alloc,rname,mess)
        call free_fits_char_1d(fitsarray,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(fitsarray%val(n),stat=ier)
     if (failed_allocate(rname,kind,ier,error)) then
        call free_fits_char_1d(fitsarray,error)
        return
     endif
     write(mess,'(a,a,a,i0)') 'Allocated ',kind,' fits_char_1d of size: ',n
     call imbfits_message(iseve%alloc,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  fitsarray%key = kind
  fitsarray%n = n
  !
end subroutine reallocate_fits_char_1d
!
subroutine reallocate_imbfits_data_val(nchan,npix,ntime,imbdata,error)
  use gkernel_interfaces
  use imbfits_interfaces, except_this=>reallocate_imbfits_data_val
  use imbfits_messaging
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocation routine specific for the DATA column
  !-------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: nchan
  integer(kind=4),      intent(in)    :: npix
  integer(kind=4),      intent(in)    :: ntime
  type(imbfits_data_t), intent(inout) :: imbdata
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>IMBFITS>DATA>VAL'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (nchan.le.0 .or. npix.le.0 .or. ntime.le.0) then
    write(mess,'(A,3(I0,A))')  &
      'Array size can not be zero nor negative (got nchan x npix x ntime = ',  &
      nchan,'x',npix,'x',ntime,')'
    call imbfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = .true.
  if (associated(imbdata%val)) then
     if (imbdata%nchan.eq.nchan .and.  &  ! Strict equality
         imbdata%npix .eq.npix  .and.  &  ! Strict equality
         imbdata%ntime.ge.ntime) then     ! Greater or equal
        write(mess,'(a,i0,a,i0,a,i0)')  &
          'DATAVAL already associated at an appropriate size: ',  &
          imbdata%nchan,' x ',imbdata%npix,' x ',imbdata%ntime
        call imbfits_message(iseve%alloc,rname,mess)
        alloc = .false.
     else
        write(mess,'(a,a,a)')  &
          'DATAVAL pointer already associated but with a different size => Freeing it first'
        call imbfits_message(iseve%alloc,rname,mess)
        call free_imbfits_data_val(imbdata,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     ! Nchan contiguous in memory, then Npix, then Ntime. Assume the weight
     ! array is allocated consistently.
     allocate(imbdata%val(nchan,npix,ntime),imbdata%wei(nchan),stat=ier)
     if (failed_allocate(rname,'DATA',ier,error)) then
        call free_imbfits_data_val(imbdata,error)
        return
     endif
     write(mess,'(a,i0,a,i0,a,i0)')  &
       'Allocated DATAVAL array of size: ',nchan,' x ',npix,' x ',ntime
     call imbfits_message(iseve%alloc,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  imbdata%nchan = nchan
  imbdata%npix  = npix
  imbdata%ntime = ntime
  !
end subroutine reallocate_imbfits_data_val
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Deallocation routines
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine free_fits_logi_1d(fitsarray,error)
  use gbl_message
  use imbfits_interfaces, except_this => free_fits_logi_1d
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(fits_logi_1d_t), intent(inout) :: fitsarray
  logical,              intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE>FITS>LOGI>1D'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  fitsarray%n = 0
  if (associated(fitsarray%val))  deallocate(fitsarray%val)
  ! Nullification is implicit with deallocate
  !
end subroutine free_fits_logi_1d
!
subroutine free_fits_inte_1d(fitsarray,error)
  use gbl_message
  use imbfits_interfaces, except_this => free_fits_inte_1d
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(fits_inte_1d_t), intent(inout) :: fitsarray
  logical,              intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE>FITS>INTE>1D'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  fitsarray%n = 0
  if (associated(fitsarray%val))  deallocate(fitsarray%val)
  ! Nullification is implicit with deallocate
  !
end subroutine free_fits_inte_1d
!
subroutine free_fits_real_1d(fitsarray,error)
  use gbl_message
  use imbfits_interfaces, except_this => free_fits_real_1d
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(fits_real_1d_t), intent(inout) :: fitsarray
  logical,              intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE>FITS>REAL>1D'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  fitsarray%n = 0
  if (associated(fitsarray%val))  deallocate(fitsarray%val)
  ! Nullification is implicit with deallocate
  !
end subroutine free_fits_real_1d
!
subroutine free_fits_dble_1d(fitsarray,error)
  use gbl_message
  use imbfits_interfaces, except_this => free_fits_dble_1d
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(fits_dble_1d_t), intent(inout) :: fitsarray
  logical,              intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE>FITS>DBLE>1D'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  fitsarray%n = 0
  if (associated(fitsarray%val))  deallocate(fitsarray%val)
  ! Nullification is implicit with deallocate
  !
end subroutine free_fits_dble_1d
!
subroutine free_fits_char_1d(fitsarray,error)
  use gbl_message
  use imbfits_interfaces, except_this => free_fits_char_1d
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(fits_char_1d_t), intent(inout) :: fitsarray
  logical,              intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE>FITS>CHAR>1D'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  fitsarray%n = 0
  if (associated(fitsarray%val))  deallocate(fitsarray%val)
  ! Nullification is implicit with deallocate
  !
end subroutine free_fits_char_1d
!
subroutine free_imbfits_data_val(imbdata,error)
  use gbl_message
  use imbfits_interfaces, except_this => free_imbfits_data_val
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private
  ! Free the 'val' array of the input imbfits_data_t instance.
  !-------------------------------------------------------------------
  type(imbfits_data_t), intent(inout) :: imbdata
  logical,              intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE>IMBFITS>DATA>VAL'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  imbdata%nchan = 0
  imbdata%npix  = 0
  imbdata%ntime = 0
  !
  if (associated(imbdata%val))  deallocate(imbdata%val)
  if (associated(imbdata%wei))  deallocate(imbdata%wei)
  ! Nullification is implicit with deallocate
  !
end subroutine free_imbfits_data_val

subroutine display_uv(chain,error)
  use clean_def
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   SHOW UV
  !     TIME-BASE sort the UV table before displaying it
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: chain
  logical, intent(out) :: error ! Logical error flag
  !
  ! Check data presence in buffer
  if (.not.associated(duv)) then
     call map_message(seve%e,'SHOW','No UV data')
     error = .true.
     return
  endif
  ! Sort buffer (TIME-BASE) when needed and create the associated SIC buffer
  if (.not.allocated(duvt)) then
     call uv_tri(2,error)
     if (error) return
  endif
  ! Plot SIC buffer
  call exec_program('@ p_uvshow_w.map w '//chain)
end subroutine display_uv
!
subroutine uv_sort_comm(line,error)
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Support routine for command
  !   UVSORT [TIME|BASE|UV]
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  ! Command line
  logical,          intent(out) :: error ! Logical error flag
  !
  ! Local variables
  integer code,na
  character(len=5) argu,vvoc
  character(len=5) voc1(3)
  data voc1/'BASE','TIME','FIELD'/ ! ,'UV'/ not needed here
  !
  ! Parse input line. Default argument is TIME
  argu = 'TIME'
  call sic_ke(line,0,1,argu,na,.false.,error)
  if (error) return
  call sic_ambigs('UV_SORT',argu,vvoc,code,voc1,3,error)
  if (error) return
  ! Sort uv buffer
  if (code.eq.3) then ! Sort UV table by field
     call uv_fsort(error) ! New by field
  else
     call uv_tri(code,error)
  endif
  if (error) return
  !
end subroutine uv_sort_comm
!
subroutine uv_fsort(error)
  use gkernel_interfaces
  use mapping_interfaces, except => uv_fsort
  use clean_def
  use clean_arrays
  use gbl_message
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING support routine for command UV_SORT
  ! Allows for sorting for fields using mosaic uv sorting routines
  !-----------------------------------------------------------------
  logical, intent(inout) :: error
  !
  character(len=7) :: rname='UV_SORT'
  logical :: warning,sorted
  logical, allocatable :: signv(:)
  integer(kind=4) :: ier,ncol,nv,nf,xoff,yoff,loff,moff,ixcol,iycol
  integer(kind=index_length) :: iv,ifi,fsize(1)
  integer(kind=4), allocatable :: it(:)
  real(kind=4) :: cs(2),uvmax,uvmin,xy(2)
  real(kind=4), allocatable :: uarr(:),varr(:),foff(:,:),newv(:)
  real(kind=8), allocatable :: farr(:)
  !
  if (.not.associated(duv)) then
     call map_message(seve%e,rname,'No UV data')
     error = .true.
     return
  endif
  ! Do we find pointing offsets?
  xoff = huv%gil%column_pointer(code_uvt_xoff)
  yoff = huv%gil%column_pointer(code_uvt_yoff)
  if ((xoff.ne.0).or.(yoff.ne.0)) then
     ! Yes => This is a mosaic
     if (yoff.ne.xoff+1) then
        ! Ill-defined mosaic
        call map_message(seve%e,rname,'Mosaic Y column does not follow the X column')
        error = .true.
        return
     endif
     ixcol = xoff
     iycol = yoff
  else
     ! No => Do we find phase offsets?
     loff = huv%gil%column_pointer(code_uvt_loff)
     moff = huv%gil%column_pointer(code_uvt_moff)
     if ((loff.ne.0).or.(moff.ne.0)) then
        ! Yes => This is a mosaic
        if (moff.ne.loff+1) then
           ! Ill-defined mosaic
           call map_message(seve%e,rname,'Mosaic M column does not follow the L column')
           error = .true.
           return
        endif
        ixcol = loff
        iycol = moff
     else
        ! No => This is a single-field
        error = .true.
        call map_message(seve%e,rname,'UV table contains a single field, cannot sort it by field')
        return
     endif
  endif  
  !
  ! Create Sorted UV data
  call sic_delvariable('UVS',.false.,warning)
  !
  ! Check if new UV Table (duvt) is already allocated
  if (allocated(duvt))  deallocate (duvt)
  !
  ! Copy header information
  call gildas_null(huvt)
  call gdf_copy_header(huv,huvt,error)
  if (error) return
  !
  ! Allocate duvt
  allocate(duvt(huvt%gil%dim(1),huvt%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
     call map_message(seve%e,rname,'Error allocating secondary UV buffer')
     error = .true.
     return
  endif
  call sic_def_real('UVS',duvt,huvt%gil%ndim,huvt%gil%dim,.false.,error)
  if (error) return
  !
  ! Start sorting using routines from Mosaic mode
  !
  nv = huv%gil%dim(2)
  ncol = huv%gil%dim(1)
  cs(1) = 1.0 ! no UV shift
  cs(2) = 0.0 ! no UV shift
  xy(1) = 0.0 ! no UV shift
  xy(2) = 0.0 ! no UV shift
  !
  allocate(uarr(nv), varr(nv), signv(nv), farr(nv), it(nv), stat=ier)
  if (ier.ne.0) then
     call map_message(seve%e,rname,'Error allocating work arrays')
     error = .true.
     return
  endif
  call loaduv(duv, ncol, nv, cs, uarr, varr, signv, uvmax, uvmin)
  ! Loading field numbers
  call loadfiuv(duv, ncol, nv, farr, it, sorted, ixcol, iycol, varr, nf, foff)
  !
  ! Proceed to sorting
  if (.not.sorted) then
     call gr8_trie (farr,it,nv,error) ! Actual sorting using quicksort
     deallocate (farr, stat=ier) ! Deallocate farr to save some memory
     allocate (newv(nv), stat=ier)
     if (ier.ne.0) then
        call map_message(seve%e,rname,'Error allocating work arrays')
        error = .true.
        return
     endif
     !
     ! v is sorted here so sortuv can be used later
     do iv=1,nv
        newv(iv) = varr(it(iv))
     enddo
     varr(:) = newv(:)
     deallocate (newv,stat=ier) ! Deallocate newv to save some memory
  else
     deallocate (farr,stat=ier) ! if data is already sorted dealocate farr since it will not be used
  endif
  ! Apply sorting to output visibilities
  call sortuv (duv, duvt, ncol, nv, huv%gil%ntrail, xy, uarr, varr, signv, it)
  !
  ! Deallocate reamining arrays to avoid leaks
  deallocate(uarr, varr, signv, it)
  !
  ! Adding field start and end info to Fields variable
  if (allocated(themap%ifields)) deallocate(themap%ifields)
  allocate(themap%ifields(nf+1))
  ifi = 1
  themap%ifields(ifi) = 1
  do iv=1,nv
     if ( (foff(1,ifi).ne.duvt(ixcol,iv)) .or. &
          &  (foff(2,ifi).ne.duvt(iycol,iv)) ) then
        ifi = ifi+1
        themap%ifields(ifi) = iv
     endif
  enddo
  themap%ifields(nf+1) = nv+1
  fsize(1) = nf+1  
  call sic_def_inte("FIELDS%ifields",themap%ifields,1,fsize,.true.,error)
  deallocate(foff)
  !
  error = .false.
end subroutine uv_fsort
!
subroutine uv_tri(code,error)
  use gkernel_interfaces
  use mapping_interfaces, only : uv_findtb
  use clean_def
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Support routine for command
  !   UVSORT [TIME|BASE|UV]
  !     BASE is code 1
  !     TIME is code 2
  !     UV is code 3
  !----------------------------------------------------------------------
  integer, intent(in)  :: code  ! Sorting code
  logical, intent(out) :: error ! Logical error flag
  !
  ! Local variables
  integer code_bt,code_tb
  parameter(code_bt=1)
  parameter(code_tb=2)
  integer ier,nd,nv,id,iv
  integer, allocatable :: it(:),ot(:)
  real(kind=8), allocatable :: order(:)
  character(len=7) :: rname = 'UV_SORT'
  logical sorted, warning, alloc
  !
  if (.not.associated(duv)) then
    call map_message(seve%e,rname,'No UV data')
    error = .true.
    return
  endif
  error = .false.
  !
  ! Create Sorted UV data
  call sic_delvariable('UVS',.false.,warning)
  !
  ! Check first if UVT is already matching UV
  alloc = .false.
  if (allocated(duvt)) then
    if ( (huv%gil%dim(2).ne.huvt%gil%dim(1)) .or. &
      & (huv%gil%dim(1)+3.ne.huvt%gil%dim(2)) ) then
      deallocate (duvt)
    else
      alloc = .true.
    endif
  endif
  !
  call gildas_null (huvt, type = 'TUV')
  call gdf_transpose_header(huv,huvt,'21  ',error)
  if (error)  return
  nd = huvt%gil%dim(2)
  nv = huvt%gil%dim(1)
  huvt%gil%dim(2) = nd+3
  !
  if (.not.alloc) then
    allocate(duvt(huvt%gil%dim(1),huvt%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Error getting UV memory ')
      error = .true.
      return
    endif
  endif
  call sic_def_real('UVS',duvt,huvt%gil%ndim,huvt%gil%dim,.false.,error)
  if (error) return
  !
  allocate(order(nv),it(nv),ot(nv),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Error getting memory ')
    error = .true.
    return
  endif
  !
  call uv_findtb(code,duv,nv,nd,order,it,ot,sorted)
  if (sorted) then
    Print *,'****  SHOW UV -- already sorted for code ',code
    do id=1,nd
      do iv=1,nv
        duvt(iv,id) = duv(id,iv)
      enddo
    enddo
  else
    do id=1,nd
      do iv=1,nv
        duvt(iv,id) = duv(id,it(iv))
      enddo
    enddo
  endif
  do iv=1,nv
    duvt(iv,nd+1) = 1.0
  enddo
  deallocate(order,it,ot)
end subroutine uv_tri
!
subroutine uv_findtb(code,uv,nv,nd,order,it,ot,sorted)
  use mapping_interfaces, only : triuv8
  !---------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for SHOW UV
  !---------------------------------------------------------------
  integer, intent(in)       :: code      ! Code for sort operation
  integer, intent(in)       :: nd,nv     ! Size of visibility table
  real, intent(in)          :: uv(nd,nv) ! Input UV data
  real(kind=8), intent(out) :: order(nv) ! Sorting array
  integer, intent(out)      :: it(nv)    ! Sort index
  integer, intent(out)      :: ot(nv)    ! Reverse order
  logical, intent(out)      :: sorted    ! Is already sorted
  !
  ! Local variables
  integer code_bt,code_tb
  parameter(code_bt=1)
  parameter(code_tb=2)
  real(kind=4) rdate
  real(kind=8) olast
  integer iv
  logical error
  !
  if (code.eq.code_bt) then
    ! Order BASE(primary) then TIME(secondary)
    rdate = uv(4,1)
    do iv=1,nv
      order(iv) = 1000.d0*86400.0d0*(100.0*uv(6,iv)+uv(7,iv))   &
           &        +(uv(4,iv)-rdate)*86400.d0 + uv(5,iv)
      it(iv) = iv
    enddo
  elseif (code.eq.code_tb) then
    ! Order TIME(primary) then BASE(secondary)
     rdate = uv(4,1)
    do iv=1,nv
      order(iv) =(uv(4,iv)-rdate)*86400.d0 + uv(5,iv) +   &
           &       (100.0d0*uv(6,iv)+uv(7,iv))*1.0d-4
      it(iv) = iv
    enddo
  endif
  !
  ! Check order... This is for dummy UV Tables produced by e.g. UV_CIRCLE
  ! which have no unique ordering...
  olast = order(1)
  sorted = .true.
  do iv=1,nv
    if (order(iv).lt.olast) then
      sorted = .false.
      exit
    endif
    olast = order(iv)
  enddo
  if (sorted) return
  !
  call triuv8(order,it,nv,error)
  if (error) return
  do iv=1,nv
    ot(it(iv)) = iv
  enddo
end subroutine uv_findtb
!
subroutine triuv8(x,it,n,error)
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !
  !   Sorting program that uses a quicksort algorithm.
  ! Applies for an input array of real*8 values, which are left
  ! unchanged. Returns an array of indexes sorted for increasing
  ! order of X. Use GR8_SORT to reorder X.
  !------------------------------------------------------------------------
  integer,      intent(in)    :: n     ! Array length
  real(kind=8), intent(inout) :: x(n)  ! Unsorted array
  integer,      intent(out)   :: it(n) ! Sort index
  logical,      intent(out)   :: error ! Logical return flag
  !
  ! Local variables
  integer mstack, nstop
  parameter(mstack=1000,nstop=15)
  integer i, j, k, itemp, l, r, m, lstack(mstack), rstack(mstack), sp
  real(kind=8) temp, key
  logical mgtl, lgtr, rgtm
  character(len=message_length) :: mess
  !
  ! Initial pointers are already loaded
  !
  if (n.le.nstop) goto 50
  sp = 0
  sp = sp + 1
  lstack(sp) = 1
  rstack(sp) = n
  !
  ! Sort a subrecord off the stack
  ! Set KEY = median of X(L), X(M), X(R)
  ! No! This is not reasonable, as systematic very inequal partitioning will
  ! occur in some cases(especially for nearly already sorted files)
  ! To fix this problem, I found(but I cannot prove it) that it is best to
  ! select the estimation of the median value from intermediate records. P.V.
1 l = lstack(sp)
  r = rstack(sp)
  sp = sp - 1
  m =(l + r) / 2
  !
  mgtl = x(m) .gt. x(l)
  rgtm = x(r) .gt. x(m)
  !
  ! Algorithm to select the median key. The original one from MONGO
  ! was completely wrong. P. Valiron, 24-Jan-84 .
  !
  !       MGTL  RGTM  LGTR  MGTL.EQV.LGTR MEDIAN_KEY
  !
  ! KL < KM < KR  T T * *   KM
  ! KL > KM > KR  F F * *   KM
  !
  ! KL < KM > KR  T F F F   KR
  ! KL < KM > KR  T F T T   KL
  !
  ! KL > KM < KR  F T F T   KL
  ! KL > KM < KR  F T T F   KR
  !
  if (mgtl .eqv. rgtm) then
     key = x(m)
  else
     lgtr = x(l) .gt. x(r)
     if (mgtl .eqv. lgtr) then
        key = x(l)
     else
        key = x(r)
     endif
  endif
  i = l
  j = r
  !
  ! Find a big record on the left
10 continue
  if (x(i).ge.key) goto 11
  i = i + 1
  goto 10
11 continue
  ! Find a small record on the right
20 if (x(j).le.key) goto 21
  j = j - 1
  goto 20
21 continue
  if (i.ge.j) goto 2
  !
  ! Exchange records
  temp = x(i)
  x(i) = x(j)
  x(j) = temp
  itemp = it(i)
  it(i) = it(j)
  it(j) = itemp
  i = i + 1
  j = j - 1
  goto 10
  !
  ! Subfile is partitioned into two halves, left .le. right
  ! Push the two halves on the stack
2 continue
  if (j-l+1 .gt. nstop) then
     sp = sp + 1
     if (sp.gt.mstack) then
        write(mess,*) 'Stack overflow ',sp
        call map_message(seve%e,'SORT',mess)
        error = .true.
        return
     endif
     lstack(sp) = l
     rstack(sp) = j
  endif
  if (r-j .gt. nstop) then
     sp = sp + 1
     if (sp.gt.mstack) then
        write(mess,*) 'Stack overflow ',sp
        call map_message(seve%e,'SORT',mess)
        error = .true.
        return
     endif
     lstack(sp) = j+1
     rstack(sp) = r
  endif
  !
  ! Anything left to process?
  if (sp.gt.0) goto 1
  !
50 continue
  !
  do j = n-1,1,-1
     k = j
     do i = j+1,n
        if (x(j).le.x(i)) goto 121
        k = i
     enddo
121  continue
     if (k.eq.j) goto 110
     temp = x(j)
     do i = j+1,k
        x(i-1) = x(i)
     enddo
     x(k) = temp
     itemp = it(j)
     do i = j+1,k
        it(i-1) = it(i)
     enddo
     it(k) = itemp
110  continue
  enddo
  error = .false.
end subroutine triuv8
!
subroutine uv_flag_comm(line,error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_flag_comm
  use clean_def
  use clean_arrays
  use clean_support
  use clean_types
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Support routine for command
  !     UV_FLAG [/ANTENNA] [/RESET]
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  ! Command line
  logical,          intent(out) :: error ! Logical error flag
  !
  integer :: iant
  integer, parameter :: O_RESET=2
  integer, parameter :: O_ANT=1
  !
  ! Parse input line
  if (sic_present(O_RESET,0)) then  ! /RESET
    ! Reset flag array
    call reset_uvflag(duvt,huvt%gil%dim(1),huvt%gil%dim(2))
  else if (sic_present(O_ANT,0) ) then  ! /ANTENNA
    call sic_i4(line,O_ANT,1,iant,.true.,error)
    if (error) return
    ! Plot data
    call sic_let_logi('uvshow%flag',.true.,error)
    call display_buffer_sub('UV_FLAG',2,line,error)
    if (error) return
    call get_uvflag_ant(duvt,huvt%gil%dim(1),huvt%gil%dim(2),iant)
  else
    ! Plot data
    call sic_let_logi('uvshow%flag',.true.,error)
    call display_buffer_sub('UV_FLAG',2,line,error)
    if (error) return
    ! Make user to define a polygon from cursor
    call greg_poly_define('UV_FLAG','',.false.,supportpol,supportvar,error)
    if (error)  return
    ! Get flag array
    call get_uvflag(duvt,huvt%gil%dim(1),huvt%gil%dim(2))
    call sic_let_logi('uvshow%flag',.false.,error)
  endif
  ! Apply flag array to buffer
  call apply_uvflag(duvt,huvt%gil%dim(1),huvt%gil%dim(2)-3,duv)
  do_weig = .true.
  optimize(code_save_uv)%lastnc = -1 !  means UV data.
end subroutine uv_flag_comm
!
subroutine get_uvflag_ant(uvs,nv,nd,iant)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Set uvflag array from antenna number
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd        ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)
  integer, intent(in) :: iant
  !
  ! Local variables
  integer ne,nf,i
  !
  ne = nd-1
  nf = nd-2
  do i=1,nv
    if (uvs(i,6).eq.iant .or. uvs(i,7).eq.iant) then
      uvs(i,nf) = 0.0
    endif
  enddo
  !
end subroutine get_uvflag_ant
!
subroutine get_uvflag(uvs,nv,nd)
  use gildas_def
  use clean_support
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Get uvflag array from polygon (0 => Flag, 1 => Keep)
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd        ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)
  !
  ! Local variables
  integer ne,nf
  !
  ne = nd-1
  nf = nd-2
  !
  ! Oh gosh, all that logic assumes the plotted stuff is in
  ! ne, nd, nf ...
  call gr4_inout(supportpol,uvs(1,ne),uvs(1,nd),uvs(1,nf),nv,.true.)
  !
end subroutine get_uvflag
!
!
subroutine reset_uvflag(uvs,nv,nd)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Reset uvflag array to 1
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd        ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)   ! UV data set
  !
  ! Local variables
  integer :: nf,i
  !
  nf = nd-2
  do i=1,nv
     uvs(i,nf) = 1.0
  enddo
end subroutine reset_uvflag
!
subroutine apply_uvflag(uvs,nv,nd,uv)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Apply uvflag array by making negative the weight of the flagged data
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd        ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)   ! UV data set
  real, intent(inout) :: uv(nd,nv)    ! Transposed version
  !
  ! Local variables
  real :: factor
  integer :: i,j
  !
  ! Loop on visibilities
  do i=1,nv
     ! Apply uvflag array
     factor = 2*uvs(i,nd+1)-1    ! 1 or -1 depending on selected option
     do j=10,nd,3
        uvs(i,j) = abs(uvs(i,j))*factor
     enddo
     ! Transpose uvs completely because uv and uvs may be ordered differently...
     do j=1,nd
        uv(j,i) = uvs(i,j)
     enddo
  enddo
end subroutine apply_uvflag
